<?php

    // ini_set("memory_limit","100M");
	// ini_set("max_execution_time","3600");

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit();

    if (user_level('news')<1){
        $page_content['main'].="<div class=\"cms-content\"><h3>Access Restricted</h3><p>You do not have the required user permissions to view this page.</p></div>";
        return;
    }

    $article = new Article();


    if ($article->getData($rvi_news)){

        $article_owner='Admin';
        // get the owner (if any)
        $user = new User;
        if ($owner = $user->getData($article->owner)){
            if (!empty($owner->name)) $article_owner=short_name($owner->name,2);
        }

        // use $breadcrumb_str in content template or use {cms-breadcrumbs} in page template
        $breadcrumb_str="";
        $breadcrumbs=breadcrumbs($article);
        include(theme_file_fn('includes/cms/breadcrumbs.php',display_theme)); // wrap breadcumbs or add extra styling (sounds like a recipe :))in theme include file

        $page->url=$article->getURL();

        $page->template=$article->getTemplate();

        // ensure links in content are using the active cms_protocol http:// or https://
        if (cms_protocol=='https://'){
            foreach ($article->content as $content_area_name => $value){
                $article->content[$content_area_name]=str_replace('http://'.strip_url_protocol(cms_root_url),cms_root_url,$value);
                $article->content[$content_area_name]=str_replace('http://'.strip_url_protocol(cms_url),cms_url,$value);
            }
        }
        else{
            foreach ($article->content as $content_area_name => $value){
                $article->content[$content_area_name]=str_replace('https://'.strip_url_protocol(cms_root_url),cms_root_url,$value);
                $article->content[$content_area_name]=str_replace('https://'.strip_url_protocol(cms_url),cms_url,$value);
            }
        }

        $page_content=$article->content;
        $page_content['main']="";

        if ($article->status<1){
            if (admin_level('news')<1){include(cms_root_dir.'includes/page_not_found.php');return;}
            else{$page_content['main'].="<div class=\"warning_box\">This article is currently set to Draft which means only admins can view it. To make this article puclic set it to Publish in the admin area.</div>";}
        }

        // show breadcrumbs
        $page_content['main'].=$breadcrumb_str;

		// check user access to news
		if ($article->user_group && admin_level('news')<1){
            $access_granted=false;
			foreach ($article->user_group as $user_group_id){
				if ($user_group_id==0){$access_granted=true;break;}
				if ($user_group_id==1 && isset($_SESSION[cms_key]['reg_user'])){$access_granted=true;break;}
                if ($user_group_id==2 && admin_level()>0){$access_granted=true;break;}
				if (isset($_SESSION[cms_key]['reg_user']->user_group)){
					foreach($_SESSION[cms_key]['reg_user']->user_group as $customer_user_group){
						if ($customer_user_group==$user_group_id){$access_granted=true;break;}
					}
					if ($access_granted) break;
				}
			}
            if (!$access_granted){
    			$page_content['main'].="<div class=\"cms-content\"><h3>Access Restricted</h3><p>You do not have the required user permissions to view this page.</p></div>";
                return;
		    }
		}


		// page meta tags
        $page->meta.="<link rel=\"canonical\" href=\"".$page->url."\" />";
		if ($article->short_description)
            $page->meta.="<meta name=\"description\" content=\"".htmlentities($article->short_description,ENT_COMPAT,'UTF-8')."\" />";
		if ($article->keywords)
            $page->meta.="<meta name=\"keywords\" content=\"".htmlentities($article->keywords,ENT_COMPAT,'UTF-8')."\" />";

		// output news detail
        $page->title=htmlentities($article->name,ENT_COMPAT,'UTF-8');
        $page->meta_title=$page->title;

        // calculate number of days since update
        /*
        // not using because of caching inaccurate today/yesterday text
        $modified_time_midnight=mktime(0, 0, 0, date('m',$article->date), date('d',$article->date), date('Y',$article->date));
        $num_of_days=(time()-$modified_time_midnight)/86400;
        if ($num_of_days<1){$post_time='Today';}
        elseif ($num_of_days<2){$post_time='Yesterday';}
        else {$post_time=date('jS F Y',$article->date);}
        $page_content['main'].="<div class=\"news_detail_date\">".$post_time." by ".$article_owner."</div>";
        */

        // facebook og code
        $og_data['title']=$article->name;
        if (isset($article->short_description) && $article->short_description!=''){$og_data['description']=htmlentities($article->short_description,ENT_COMPAT,'UTF-8');}
        $og_data['url']=$page->url;

        $comment_content="";
        $comment_form="";

        // display comments
        if ($article->comments_visible){

            $comment_count=0;

            $search_comments['article_id']=$article->id;

            if($comments=get_items('messages',null,1,null,null,$search_comments)){

                $comment_count=count($comments);

                $comment = new Message();
                $comment_owner = new User();

                for ($comment_num=0; $comment_num<$comment_count; $comment_num++){

                    if ($comment->getData($comments[$comment_num]['id'])){

                        $comment_content.="<div class=\"comment\">";
                        if ($comment_owner->getData($comment->owner)){
                            if (!empty($cmsSettings->user['profile_pages'])){
                                $comment_content.="<div class=\"comment_by\"><a href=\"".cms_url."?profile=".$comment_owner->id."\" class=\"comment_name\">".short_name($comment_owner->name)."</a> <span style=\"font-style: italic\">says</span>:</div>";
                            }
                            else{
                                if (isset($comment_owner->links['website']) && strlen($comment_owner->links['website'])>10){
                                    $comment_content.="<div class=\"comment_by\"><a href=\"".$comment_owner->links['website']."\" class=\"comment_name\" target=\"_blank\" rel=\"nofollow ugc\">".short_name($comment_owner->name)."</a> <span style=\"font-style: italic\">says</span>:</div>";
                                }
                                else{
                                    $comment_content.="<div class=\"comment_by\"><span class=\"comment_name\">".short_name($comment_owner->name)."</span> <span style=\"font-style: italic\">says</span>:</div>";
                                }

                            }
                        }else{
                            $comment_content.="<div class=\"comment_by\"><span class=\"comment_name\">Guest</span> <span style=\"font-style: italic\">says</span>:</div>";
                        }

                        $date=date("M d,Y",$comment->created_time);
                        $time=date("H:i",$comment->created_time);
                        $comment_content.='<div class="comment_date">'.$date.' at '.$time.'</div>';
                        $comment_content.=$comment->txt;
                        $comment_content.='</div>';

                    }

                }

            }


        }


		// display comment form
		if ($article->comment_form_enabled){

            if (!isset($_SESSION[cms_key]['reg_user']))
                $comment_form.="<hr /><h3><a href=\"".cms_url."?login\">Login</a> to post a comment</h3>";
            else{

                // check user access to comment form
                $access_comment_form_denied=false;
        		if ($article->commenting_user_group){
        			foreach ($article->commenting_user_group as $user_group_id){
        				if ($user_group_id==0 || admin_level()>0) break;
        				elseif($user_group_id==1 && isset($_SESSION[cms_key]['reg_user'])) break;
        				elseif(isset($_SESSION[cms_key]['reg_user']->user_group)){
        					foreach($_SESSION[cms_key]['reg_user']->user_group as $customer_user_group){
        						if ($customer_user_group==$user_group_id){
                                    $omit=0;
                                    break;
                                }
        					}
        					if ($omit<1) break;
        				}
        				else $access_comment_form_denied=true;
        			}
        		}

                if ($access_comment_form_denied){
                    if (in_array(1,$article->commenting_user_group) && (count($article->commenting_user_group)<2 || (count($article->commenting_user_group)<3 && in_array(0,$article->commenting_user_group))))
                        $page_content['main'].="<hr /><h3><a href=\"".cms_url."?login\">Login</a> to leave a comment</h3>";
                }
                else{

                    if (isset($_POST['comment'])){

                        $_SESSION[cms_key]['blog_comment'][$article->id]=sanitize_text_input($_POST['comment']);

        				if (strlen($rvi_comment)<10)
                            $_SESSION[cms_key]['form']['article_comment']['warning'][]="Your comment is too short.";
                        elseif ($spam_warning=IsSpam($rvi_comment))
                            $_SESSION[cms_key]['form']['article_comment']['warning'][]=$spam_warning;

        				if (!isset($_SESSION[cms_key]['form']['article_comment']['warning'])){

                            $message = new Message();

                            $message->status=0; // 0=awaiting moderation, 1=approved, 2=spam
                            $message->txt=$rvi_comment;
                            $message->article_id=$article->id;

                            if (isset($_SESSION[cms_key]['reg_user']->id))
                                $message->owner=$_SESSION[cms_key]['reg_user']->id;

                            if (isset($rvi_rating)) $message->rating=$rvi_rating;

                            if ($message->saveItem())
                                updateItemIndex('messages',array($message->id),'add');

                            if (isset($_SESSION[cms_key]['blog_comment'][$article->id])) unset($_SESSION[cms_key]['blog_comment'][$article->id]);
        					$enquiry_submitted=1;
                            $_SESSION[cms_key]['form']['article_comment']['warning_green'][]='<h2>Thank You</h2><p>Your comment has been submitted.';

                            update_admin_notify_log('New user comment');

        				}
                    }

                    $comment_form.="<hr />";

                    // display warnings
                    if (isset($_SESSION[cms_key]['form']['article_comment']['warning'])){$comment_form.=display_warnings($_SESSION[cms_key]['form']['article_comment']['warning']);}
                    elseif (isset($_SESSION[cms_key]['form']['article_comment']['warning_green'])){$comment_form.=display_warnings($_SESSION[cms_key]['form']['article_comment']['warning_green'],'green');}

        			if (!isset($enquiry_submitted)){

                        $comment_form.="<form action=\"".$page->url."#comment_form\" method=\"post\" id=\"comment_form\" class=\"comment_form\"><fieldset>
                        <legend>Leave a comment</legend>";

                        $comment_form.="<div class=\"form_row\" style=\"margin-top: 5px\"><div class=\"small_note\">Commenting as ".stripslashes(short_name($_SESSION[cms_key]['reg_user']->name))." (<a href=\"".cms_url."?logout\">logout</a>)</div><textarea name=\"comment\" class=\"comment_box\">".(isset($_SESSION[cms_key]['blog_comment'][$article->id]) ? $_SESSION[cms_key]['blog_comment'][$article->id] : "")."</textarea></div>
                        <div class=\"form_row form_row_footer\"><input type=\"submit\" value=\"Post Comment\" class=\"cms_btn\" /></div>";

                        $comment_form.="</fieldset></form>";

        			}


                }

            }

		}

        // get related articles html content for use in content template
        if ($article->related_article) $related_articles=displayCategory('2',1,null,$article->related_article);

        // include content template
        if ($ctemplate_fn=theme_file_fn('includes/cms/content/article/ct_'.$article->getCtemplate().'.php',display_theme,true))
            include($ctemplate_fn);
        else
            include(theme_file_fn('includes/cms/content/article/ct_default.php',display_theme));


	}else{include(cms_root_dir.'includes/page_not_found.php');}

?>
