<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit;

    $rvi_subject=cms_site_name." - Order Ref: ".$order->id;

    $status_options=array('Unpaid','Paid','Paid & Processed','Cancelled','Pending');

    if (!isset($rvi_mail_body)) $rvi_mail_body="Hi {first_name},\n\n";

/*
    if ($order->status<1){
        // unpaid
        $rvi_mail_body.="Thank you for your recent order.\n\nYou can view the invoice for this order by logging into your account using the link below.\n\n".user_login_link($user,"?myaccount&order=".$order->id)."\n\nIf you have not yet made payment and would like to do so now please go to\n".cms_url."?paynow=".$order->id;
    }
    */

    $invoice_age_days=0;
    if ($order->date)
        $invoice_age_days=(time()-$order->date)/86400;

    if ($order->due_date)
        $overdue_days=(time()-$order->due_date)/86400;
    else
        $overdue_days=0;

    if ($order->status<1 && $overdue_days>1){
        // unpaid - overdue
        $rvi_subject=cms_site_name." - Overdue Invoice ".$order->id;
        $rvi_mail_body.="Invoice ".$order->id." dated ".date("d/m/y",$order->date)." is now ".floor($overdue_days)." days overdue.\n\nTo view and pay this invoice please click the link below.\n\n".user_login_link($user,"?myaccount&order=".$order->id);
    }
    elseif ($order->status<1 && $invoice_age_days>10){
        // unpaid - more than 10 days old - reminder
        $rvi_subject=cms_site_name." - Invoice ".$order->id;
        $rvi_mail_body.="This is a courtesy email to remind you of order invoice ".$order->id;
        if ($order->date){$rvi_mail_body.=" dated ".date("d/m/y",$order->date);}
        if ($user->email) $rvi_mail_body.=".\n\nTo view and pay this invoice please click the link below.\n\n".user_login_link($user,"?myaccount&order=".$order->id);
    }
    elseif ($order->status<1){
        // unpaid
        $rvi_subject=cms_site_name." - Invoice ".$order->id;
        $rvi_mail_body.="This is a courtesy email to notify you of order invoice ".$order->id;
        if ($order->date){$rvi_mail_body.=" dated ".date("d/m/y",$order->date);}
        if ($user->email)
            $rvi_mail_body.=".\n\nTo view and pay this invoice please click the link below.\n\n".user_login_link($user,"?myaccount&order=".$order->id);
        else
            $rvi_mail_body.=".\n\nIf you have not already paid you can do so now by clicking the link below.\n\n".cms_url."?paynow=".$order->id;
    }
    elseif ($order->status==1){
        // paid
        $rvi_mail_body.="This is a courtesy email to notify you that payment for order ".$order->id." has been received and your order is now being processed.\n\n";
        if ($user->email) $rvi_mail_body.="You can view the invoice for this order by logging into your account using the link below.\n\n".user_login_link($user,"?myaccount&order=".$order->id)."\n\n";
        $rvi_mail_body.="Thank you for your custom.";
    }
    elseif ($order->status==2){
        // paid and processed
        $rvi_mail_body.="This is a courtesy email to notify you that your order ".$order->id." has been processed.\n\n";
        if ($user->email) $rvi_mail_body.="You can view the invoice for this order by logging into your account using the link below.\n\n".user_login_link($user,"?myaccount&order=".$order->id)."\n\n";
        $rvi_mail_body.="Thank you for your custom.";
    }
    elseif ($order->status==3){
        // cancelled
        $rvi_mail_body.="This is a courtesy email to notify you that your order ".$order->id." has been cancelled.";
    }
    elseif ($order->status==4){
        // pending order - generated automatically via listing/sub renewals and not listed to user in their account area
        $rvi_mail_body.="This is a courtesy email to notify you that a pending invoice has been generated for your order ".$order->id."\n\n";
        if ($user->email) $rvi_mail_body.="You can view the invoice for this order by logging into your account using the link below.\n\n".user_login_link($user,"?myaccount&order=".$order->id);
    }
    elseif ($order->status==5){
        // purchase order
        $rvi_mail_body.="This is a courtesy email to notify you of purchase order #".$order->id."\n\n";
        if ($user->email) $rvi_mail_body.="You can view this order by logging into your account using the link below.\n\n".user_login_link($user,"?myaccount&order=".$order->id);
    }
    elseif ($order->status==6){
        // pro-forma invoice
        $rvi_mail_body.="This is a courtesy email to notify you of pro-forma invoice #".$order->id."\n\n";
        if ($user->email) $rvi_mail_body.="You can view this pro-forma invoice by logging into your account using the link below.\n\n".user_login_link($user,"?myaccount&order=".$order->id);
    }
    else{
        // default
        $rvi_mail_body.="Thank you for your recent order.\n\nYour order ".$order->id." status is ".$status_options[$order->status];
    }

    $rvi_mail_body.="\n\n".cms_site_name."\n".cms_site_url;

    // privacy policy note
    $rvi_mail_body.="\n\n------------------------------------\nFor information on how we collect and use your data please read our privacy policy at ".cms_url."?terms#privacy";
        
?>
