<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit;

    // sometimes REQUEST_URI might not be set (iis)
    if (isset($_SERVER['REQUEST_URI'])){
        $URI=$_SERVER['REQUEST_URI'];
    }
    else{
        $URI = substr($_SERVER['PHP_SELF'],1 );
        if (isset($_SERVER['QUERY_STRING'])) $URI.='?'.$_SERVER['QUERY_STRING'];
    }

	$url=strtolower('http://'.$_SERVER['HTTP_HOST'].$URI);

    $parsed_url=parse_url($url);
    //if (admin_level()>9){echo "Count:".count($parsed_url)."<br><pre>";print_r($parsed_url);echo "</pre>";exit('debug');} // debug

    // bypass friendly url process if there is no path or we are explicitly loading index.php (index.php already handled in htaccess though?)
    if (!isset($parsed_url['path']) || $parsed_url['path']=='' || $parsed_url['path']=='/' || substr($parsed_url['path'],-9)=='index.php') return;

    // old code - bypass friendly url process if it is too short/blank
    //$check_uri=str_replace(cms_url,'',$url);
    //if (strlen($check_uri)<3){return;}
    // bypass friendly url process if it begins with a query
    //if (strpos(substr($check_uri,0,2),'?')!==false){return;}

    $url=$parsed_url['path'];

    // experimental to handle sub direcory cms urls
    $parsed_cms_url=parse_url(cms_url);
    $crop_char_count=strlen($parsed_cms_url['path']);
    if ($crop_char_count>0){$url=substr($url,$crop_char_count);}

    // bypass friendly url process if there is no url slug to lookup
    // this will allow a default dynamic url to be checked/processed
    if ($url=='' || $url=='/') return;

    // check if a dynamic page url is called and skip friendly url lookup if it is
    // we don't need this with simpler code above
    /*
    $dynamic_url_found=0;
    $dynamic_page_querys = array("register","login","logout","forgot_password","password_reset","myaccount","listing","news","print_invoice","paynow","thankyou","cart","cart_menu","download","order_stage","product","profile","report","terms","sitemap","cat");
    foreach($dynamic_page_querys as $query){
        $query_len=strlen($query);
        if (strtolower(substr($parsed_url['query'],0,$query_len))==$query){$dynamic_url_found=1;break;}
    }
    if ($dynamic_url_found>0){return;}
    */


    // old code - strip query
    /*
    if (strpos($url,'?')!==false){
        $url_pieces=explode('?',$url);
        $url=$url_pieces[0];
    }
    */

    // remove trailing slash if present
    if (substr($url,-1)=='/'){$url=substr($url,0,-1);}

    // remove leading slash if present
    if (substr($url,0,1)=='/'){$url=substr($url,1);}


    // dont parse admin page urls
    /*
    if (strpos($url,cms_root_url.'admin')!==false){return;}
    // dont parse urls to files within cms directories
    if (strpos($url,cms_root_url.'sys/backup')!==false){return;}
    if (strpos($url,cms_root_url.'sys/cache')!==false){return;}
    if (strpos($url,cms_root_url.'sys/data')!==false){return;}
    if (strpos($url,cms_root_url.'sys/images')!==false){return;}
    if (strpos($url,cms_root_url.'includes')!==false){return;}
    if (strpos($url,cms_root_url.'plugins')!==false){return;}
    if (strpos($url,cms_root_url.'scripts')!==false){return;}
    if (strpos($url,cms_root_url.'themes')!==false){return;}
    */

    // test friendly urls / used in admin friendly url settings page
    if (!friendly_urls){
        if ($url=='testfriendlyurl') exit("Friendly URLs are disabled.");
        return;
    }
    if ($url=='testfriendlyurl') exit("Friendly URLs are enabled and working!");

    if ($url=='login'){$rvi_login=1;return;}
    if ($url=='register'){$rvi_register=1;return;}
    if ($url=='forgot-password'){$rvi_forgot_password=1;return;}
    if ($url=='myaccount'){$rvi_myaccount=1;return;}
    if ($url=='cart'){$rvi_cart=1;return;}
    if ($url=='terms'){$rvi_terms=1;return;}
    if ($url=='subscribe'){$rvi_subscribe=1;return;}


    $slug_fn = sys_data_dir.'/urlslugs.txt';
    if (file_exists($slug_fn)){

        // look for exact match on slug
    	$handle=fopen($slug_fn,'r');
    	while (!feof($handle)){

    		$line = fgets($handle);
            if ($line=="") continue;
            $pieces=explode('|',$line);
            if ($pieces[2]==$url){
                if ($pieces[1]=='n') $rvi_news=$pieces[0];
                if ($pieces[1]=='p') $rvi_product=$pieces[0];
                if ($pieces[1]=='l') $rvi_listing=$pieces[0];
                if ($pieces[1]=='c') $rvi_cat=$pieces[0];
                $slug_found=1;
                break;
            }

        }
        fclose($handle);

        if (isset($slug_found)){unset($slug_fc);return;}
                    
        // check for category with numbered subpage
        $url_slugs=explode('/',$url);
        $url_slug_count=count($url_slugs);
        if ($url_slug_count>0 && is_numeric($url_slugs[($url_slug_count-1)])){

              $page_num=$url_slugs[($url_slug_count-1)];
              $url=substr($url,0,-(strlen($page_num)+1));

              if ($url==''){
                $rvi_cat=0;
                $rvi_page=$page_num;
                $slug_found=1;
              }
              else{

                // this code needs to check if numbered page actually exists (total num of pages in cat>=page_num)
            	$handle=fopen($slug_fn,'r');
            	while (!feof($handle)){

            		$line = fgets($handle);
                    $pieces=explode('|',$line);

                    if ($pieces[2]==$url  && $pieces[1]=='c'){
                        $rvi_cat=$pieces[0];
                        $rvi_page=$page_num;
                        $slug_found=1;
                        break;
                    }

                }
                fclose($handle);

              }

        }



    }

    if (!isset($slug_found)) $friendly_url_not_found=1;

?>