<?php

// make sure api does not run if cms already locked
if (isLocked('api')) return;

// generic api option - useful for basic connection tests
// api options must contain the folowing data
$api_details=array();
$api_details['item_type']='api_option'; // required - do not change or remove this

$api_details['id']="generic";  // required - each api option must have a unique id that matches it's folder name exactly
$api_details['admin_name']="Generic API Tester";  // display name in admin area
$api_details['admin_description']="Test connection to API and preview data. Does not import or change anything."; // description displayed in admin

$data_format_options = array(); //  available data format options for this api eg. 'json','xml'
$api_details['data_format']='json'; // the type of data the API outputs eg. text,json,csv
$api_details['data_type']=''; // the type of data updated by this api eg. none,products

$image_import_option = false;

// custom data specific to this api option
$api_details['value']['url']['name']="Request URL";
$api_details['value']['url']['admin_description']="Enter the request URL to connect to.";
$api_details['value']['url']['value']="";

$api_details['value']['username']['name']="Username";
$api_details['value']['username']['admin_description']="Enter username if required.";
$api_details['value']['username']['value']="";

$api_details['value']['password']['name']="Password";
$api_details['value']['password']['admin_description']="Enter password if required.";
$api_details['value']['password']['value']="";

$api_details['value']['token']['name']="Token";
$api_details['value']['token']['admin_description']="Enter access/bearer token if required.";
$api_details['value']['token']['value']="";

$api_details['value']['custom1_key']['name']="Custom Key 1";
$api_details['value']['custom1_key']['admin_description']="Enter a custom key and value if required.";
$api_details['value']['custom1_key']['value']="";

$api_details['value']['custom1_val']['name']="Custom Val 1";
$api_details['value']['custom1_val']['admin_description']="";
$api_details['value']['custom1_val']['value']="";

// get saved data for this shipping option if it exists
if ($saved_api_option_details=get_item_details('api_option',$api_details['id'])){
    if (function_exists('array_replace_recursive')){
        // php5.3.0 or higher
       $api_details=array_replace_recursive($api_details,$saved_api_option_details);
    }
    else{
        // legacy code for pre php5.3.0
        $api_details=$saved_api_option_details;
    }
}

// requested data is downloaded to files in the api's data directory
$api_data_dir=sys_backup_dir.'/api_data/'.$api_details['id'];

// requesting the data
if (isset($rvi_api_send)){

    // curl stream data to file then show small preview with link to view full file
    // https://stackoverflow.com/questions/17641073/how-to-set-a-maximum-size-limit-to-php-curl-downloads

    $url = $api_details['value']['url']['value'];

    if (empty($url)) $_SESSION[cms_key]['form']['api_request']['warning'][]="Request URL is required";

    if (!isset($_SESSION[cms_key]['form']['api_request']['warning'])){

        $post = array();
        if ($api_details['value']['username']['value']!="") $post['username'] = $api_details['value']['username']['value'];
        if ($api_details['value']['password']['value']!="") $post['password'] = $api_details['value']['password']['value'];

        if ($api_details['value']['custom1_key']['value']!="") $post[$api_details['value']['custom1_key']['value']] = $api_details['value']['custom1_val']['value'];

        if (!file_exists($api_data_dir)) mkdir($api_data_dir);

        $fp = fopen($api_data_dir.'/data_temp.php', 'w+');
        fwrite($fp,"<"."?php exit; ?".">");

        $curl = curl_init($url);

        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);

        curl_setopt($curl, CURLOPT_FILE, $fp);
        //Timeout if the file doesn't download after 20 seconds.
        //curl_setopt($ch, CURLOPT_TIMEOUT, 20);

        $headers = array();
        if ($api_details['value']['token']['value']) $headers[]="Authorization: Bearer ".trim($api_details['value']['token']['value']);

        if (!empty($headers))
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);

        // Passing an array to CURLOPT_POSTFIELDS will encode the data as multipart/form-data,
        // while passing a URL-encoded string will encode the data as application/x-www-form-urlencoded. ie. http_build_query($post)
        if (!empty($post))
            curl_setopt($curl, CURLOPT_POSTFIELDS,http_build_query($post));

        //for debug only!
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);

        $api_response = curl_exec($curl);
        curl_close($curl);

        fclose($fp);

        if ($api_response){
            rename($api_data_dir.'/data_temp.php',$api_data_dir.'/data.php'); // rename temp file if successful
            $_SESSION[cms_key]['form']['api_request']['warning_green'][]="Request completed in ".(time()-CMS_INIT_TIME)." seconds";
        }
        else
            $_SESSION[cms_key]['form']['api_request']['warning'][]="Request failed in ".(time()-CMS_INIT_TIME)." seconds";

    }


}

// importing the data
if (isset($rvi_api_import) && !empty($api_details['data_type'])){

    if (file_exists($api_data_dir.'/data.php')){

        $fc=file_get_contents($api_data_dir.'/data.php',false,null,14); // first 14 chars are php exit

        if ($api_details['data_format']=='json'){
            $api_data=json_decode($fc,true);
            // json error handling https://stackoverflow.com/questions/6041741/fastest-way-to-check-if-a-string-is-json-in-php
        }
        else
            $_SESSION[cms_key]['form']['api_import']['warning'][]="Invaild data format selected";

        if (!$_SESSION[cms_key]['form']['api_import']['warning']){
            // generic tester does not import any data but this is where we would import the data if it did
            admin_debug($api_data);
        }

    }
    else
        $_SESSION[cms_key]['form']['api_import']['warning'][]="Data not found - data must first be retreived from the remote server";

}

?>
