<?php

// make sure api does not run if cms already locked
if (isLocked('api')) return;

// generic api option - useful for basic connection tests
// api options must contain the folowing data
$api_details=array();
$api_details['item_type']='api_option'; // required - do not change or remove this

$api_details['id']="mysql-database";  // required - each api option must have a unique id that matches it's folder name exactly
$api_details['admin_name']="Generic (MySQL DB)";  // display name in admin area
$api_details['admin_description']="Import products from a MySQL database."; // description displayed in admin

$image_import_option = true;

// custom data specific to this api option
$api_details['value']['url']['name']="Request URL";
$api_details['value']['url']['admin_description']="Enter the request URL or IP to connect to.";
$api_details['value']['url']['value']="";

$api_details['value']['port']['name']="Port";
$api_details['value']['port']['admin_description']="Enter the port number to connect to.";
$api_details['value']['port']['value']="3306";

$api_details['value']['dbname']['name']="Database Name";
$api_details['value']['dbname']['admin_description']="Enter database name.";
$api_details['value']['dbname']['value']="";

$api_details['value']['username']['name']="Username";
$api_details['value']['username']['admin_description']="Enter username if required.";
$api_details['value']['username']['value']="root";

$api_details['value']['password']['name']="Password";
$api_details['value']['password']['admin_description']="Enter password if required.";
$api_details['value']['password']['value']="";

// get saved data for this api if it exists
if ($saved_api_option_details=get_item_details('api_option',$api_details['id'])){
    if (function_exists('array_replace_recursive')){
        // php5.3.0 or higher
       $api_details=array_replace_recursive($api_details,$saved_api_option_details);
    }
    else{
        // legacy code for pre php5.3.0
        $api_details=$saved_api_option_details;
    }
}

// requested data is downloaded to files in the api's data directory
$api_data_dir=sys_backup_dir.'/api_data/'.$api_details['id'];

// requesting the data
if (isset($rvi_api_send)){

    // curl stream data to file then show small preview with link to view full file
    // https://stackoverflow.com/questions/17641073/how-to-set-a-maximum-size-limit-to-php-curl-downloads

    $url = $api_details['value']['url']['value'];

    if (empty($url)) $_SESSION[cms_key]['form']['api_request']['warning'][]="Request URL is required";
    if (empty($api_details['value']['username']['value'])) $_SESSION[cms_key]['form']['api_request']['warning'][]="Username is required";
    if (empty($api_details['value']['password']['value'])) $_SESSION[cms_key]['form']['api_request']['warning'][]="Password is required";

    if (!isset($_SESSION[cms_key]['form']['api_request']['warning'])){

        $post = array();
        if ($api_details['value']['username']['value']!="") $post['username'] = $api_details['value']['username']['value'];
        if ($api_details['value']['password']['value']!="") $post['password'] = $api_details['value']['password']['value'];

        if ($api_details['value']['custom1_key']['value']!="") $post[$api_details['value']['custom1_key']['value']] = $api_details['value']['custom1_val']['value'];

        if (!file_exists($api_data_dir)) mkdir($api_data_dir);

        $unlock_key=lock_cms("","api");
        set_time_limit(180); // enough time to connect and retreive large data

        // Create connection
        $conn = new mysqli($api_details['value']['url']['value'], $api_details['value']['username']['value'], $api_details['value']['password']['value'], $api_details['value']['dbname']['value'], $api_details['value']['port']['value']);

        // Check connection
        if ($conn->connect_error)
            $_SESSION[cms_key]['form']['api_request']['warning'][]="Connection failed: " . $conn->connect_error;
        else{

            $fp = fopen($api_data_dir.'/data_temp.php', 'w+');
            fwrite($fp,"\"ID\",\"prodName\",\"Cat\",\"Subcat\",\"Stock\",\"SalePriceNett\"\n");

            $api_response = $conn->query("SELECT ID, prodName, Cat, Subcat, Stock, SalePriceNett FROM stock")->fetch_all();
            foreach ($api_response as $row) {
                fwrite($fp,"\"$row[0]\",\"$row[1]\",\"$row[2]\",\"$row[3]\",\"$row[4]\",$row[5]\n");
            }

            fclose($fp);

        }


        if ($api_response){
            rename($api_data_dir.'/data_temp.php',$api_data_dir.'/data.php'); // rename temp file if successful
            $_SESSION[cms_key]['form']['api_request']['warning_green'][]="Request completed in ".(time()-CMS_INIT_TIME)." seconds";
            update_log("API ".$api_details['id']." request completed in ".(time()-CMS_INIT_TIME)." seconds");
        }
        else{
            $_SESSION[cms_key]['form']['api_request']['warning'][]="Request failed in ".(time()-CMS_INIT_TIME)." seconds";
            update_log("API ".$api_details['id']." request failed in ".(time()-CMS_INIT_TIME)." seconds");
        }

        if (isset($unlock_key))
            unlock_cms($unlock_key);

    }

}

?>
