<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number") || !isset($_SESSION[cms_key]['cart'])) exit();

    if (!isset($product)){
        //if (empty($rvi_add_to_cart) && !empty($rvi_product)) $rvi_add_to_cart=$rvi_product; // not sure we need this?
        $product = new Product();
        if (!$product->getData($rvi_add_to_cart)) return;
    }

	if (!is_object($product) || $product->status < 1) return;

    // orderslot object used to contain ordered product will be added to cart session object if product successfully added to cart or qty incremented if it is already in cart
    $orderSlot = new OrderSlot();

    // check what product options if any are selected and will be stored in orderslot->product
    $options_chosen=null;
    foreach ($product->option as $option_name => $option_name_arr){

        if (!empty($rvi_product_option[$option_name]))
            $options_chosen[$option_name][$rvi_product_option[$option_name]]=$product->option[$option_name][$rvi_product_option[$option_name]];

        // set first option as default if none specified
        if (empty($options_chosen[$option_name]))
            $options_chosen[$option_name][key($option_name_arr)]=$product->option[$option_name][key($option_name_arr)]; // always set to first option by default

    }

    // check if note or file upload are required before adding to cart - note might want to use $_SESSION[cms_key]['form']['add_to_cart']['warning'] instead and display these on product_page.php etc.
    if (isset($product->note_form_enabled) && $product->note_form_enabled==2 && (!isset($rvi_customer_note) || strlen($rvi_customer_note)<1)){$_SESSION[cms_key]['form']['product_detail']['warning'][]="Please enter required text in the text box provided";}
    if (isset($product->file_upload_enabled) && $product->file_upload_enabled==2 && !is_uploaded_file($_FILES['uploaded_file']['tmp_name'])){$_SESSION[cms_key]['form']['product_detail']['warning'][]="A file must be uploaded to add to cart";}
    if (isset($_SESSION[cms_key]['form']['product_detail']['warning'])){
        // redirect after form submit so browser back and refresh work without browser resend form data warning
        header("Location: ".$product->itemURL(),true,303);
        exit;
    }
	else{

        if (!isset($rvi_dynamic_note)){$rvi_dynamic_note="";}

        $booking_time=null;
        if (!empty($rvi_booking_time) && isset($product->booking_slot)){
            $rvi_booking_time=intval(key($rvi_booking_time));
            $booking_time_slots=get_booking_slots($product);
            if (isset($booking_time_slots[$rvi_booking_time])){
                if ($rvi_dynamic_note==""){$rvi_dynamic_note.=date("l F dS @ g:ia",$rvi_booking_time);}
                else{$rvi_dynamic_note.=date("l F dS @ g:ia",$rvi_booking_time);}
                $booking_time=$rvi_booking_time;
            }
        }

        if (isset($rvi_customer_note)){
            $rvi_customer_note=sanitize_text_input($rvi_customer_note);
        }
        else{$rvi_customer_note='';}

        $rvi_customer_note.=sanitize_text_input($rvi_dynamic_note); // dynamic note can be added in addition to a customer note

        if (isset($_FILES['uploaded_file']) && is_uploaded_file($_FILES['uploaded_file']['tmp_name'])){
            if ($_FILES['uploaded_file']['size']>2097152 || ($_FILES['uploaded_file']['type']!="image/pjpeg" && $_FILES['uploaded_file']['type']!="image/jpeg")){$_SESSION[cms_key]['form']['product_detail']['warning'][]="Image upload error";}
            $uploaded_filename=$_FILES['uploaded_file']['name'];
        }else{$uploaded_filename='';}

        $add_qty=1;
        if (isset($rvi_qty) && $rvi_qty>1) $add_qty=$rvi_qty;

		if (!isset($_SESSION[cms_key]['form']['product_detail']['warning'])){
		    // add product to cart, returns orderslot_id if new unique product/orderslot, 1 if updated
            if ($orderslot_id=$_SESSION[cms_key]['cart']->addProduct($product,$add_qty,$options_chosen,$rvi_customer_note,$rvi_dynamic_note,$uploaded_filename,$booking_time)){

                // only done if orderslot new/added but maybe we don't care if orderslot added new or updated, maybe simplify and return orderslot_id even on update?
                // do we allow only one file per product? use uploadd filename or set?
                if (isset($_FILES['uploaded_file']) && is_uploaded_file($_FILES['uploaded_file']['tmp_name']))
            		move_uploaded_file($_FILES['uploaded_file']['tmp_name'],sys_data_dir.'/uploads/'.$product->id.$orderslot_id.'_'.$_FILES['uploaded_file']['name']);

            }

            // add to recently viewed items
            if (!isset($_SESSION[cms_key]['recently_viewed_products'][$product->id])){$_SESSION[cms_key]['recently_viewed_products'][$product->id]['priority']=1;}
            else{$_SESSION[cms_key]['recently_viewed_products'][$product->id]['priority']++;}

            // auto-apply coupons - for now coupons are only applied/shown on confirm order page
            //include_once(cms_root_dir.'includes/shop/coupon_auto_apply.php');

            // if add to cart is run via ajax output cart values and exit
            if (isset($rvi_ajax)){
                exit ($_SESSION[cms_key]['cart']->getProductCount()."|".formatPrice($_SESSION[cms_key]['cart']->getTotal($cmsSettings->b2b,false,true)));
            }

            $skip_cart=true;
            foreach($_SESSION[cms_key]['cart']->products as $order_slot_id => $order_slot){
                if ($order_slot->product->behaviour=='Add to Cart'){$skip_cart=false;break;}
            }
            if ($skip_cart){
                $_SESSION[cms_key]['order_stage']='checkout';
                // redirect after form submit so browser back and refresh work without browser resend form data warning
                header("Location: ".cms_url."?order_stage=checkout",true,303);
                exit;
            }

            // redirect after form submit so browser back and refresh work without browser resend form data warning
            header("Location: ".cms_url."?cart",true,303);
            exit;

        }else{
            // redirect after form submit so browser back and refresh work without browser resend form data warning
            header("Location: ".cms_url."?product=".$product->id,true,303);
            exit;
        }
	}

?>
