<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit();

    $page->title="Checkout";
    $page->meta_title=cms_site_name." - ".$page->title;
    $page->template=$cmsSettings->checkout['template_checkout'];

	$_SESSION[cms_key]['order_stage']='checkout';

	// redirect tocart if no items ordered
	if (empty($_SESSION[cms_key]['cart']->products)){
        // redirect to cart
        header("Location: ".cms_url."?cart",true,303);
        exit;
    }

    if (isset($_SESSION[cms_key]['reg_user']->id)){
        //$_SESSION[cms_key]['cart']->customer->id=$_SESSION[cms_key]['reg_user']->id;
           
        // we should populate empty fields with users stored data but only if blank  TODO: use setCustomer here?
        if (empty($_SESSION[cms_key]['cart']->customer->id)) $_SESSION[cms_key]['cart']->setCustomer($_SESSION[cms_key]['reg_user']);
        /*
        if (empty($_SESSION[cms_key]['cart']->customer->phone)) $_SESSION[cms_key]['cart']->customer->phone = $_SESSION[cms_key]['reg_user']->phone;
        if (empty($_SESSION[cms_key]['cart']->customer->addr)){
            $_SESSION[cms_key]['cart']->customer->addr->line1 = $_SESSION[cms_key]['reg_user']->addr->line1;
            $_SESSION[cms_key]['cart']->customer->addr->line2 = $_SESSION[cms_key]['reg_user']->addr->line2;
            $_SESSION[cms_key]['cart']->customer->addr->city = $_SESSION[cms_key]['reg_user']->addr->city;
            $_SESSION[cms_key]['cart']->customer->addr->postcode = $_SESSION[cms_key]['reg_user']->addr->postcode;
            $_SESSION[cms_key]['cart']->customer->addr->county = $_SESSION[cms_key]['reg_user']->addr->county;
            $_SESSION[cms_key]['cart']->customer->addr->country = $_SESSION[cms_key]['reg_user']->addr->country;
        }
        */

    }



    $require_address=false;
    foreach($_SESSION[cms_key]['cart']->products as $order_slot_id => $order_slot){
        if ($order_slot->product->behaviour=='Add to Cart'){$require_address=true;break;}
    }

    // this bypasses checkout and goes to confirm order page, this is a bit messy
    if (!isset($rvi_name) && !isset($rvi_edit) && !$require_address && !empty($_SESSION[cms_key]['cart']->customer->name) && !empty($_SESSION[cms_key]['cart']->customer->email)){
        $_SESSION[cms_key]['order_stage']='confirm_order';
        // redirect after form submit so browser back and refresh work without browser resend form data warning
        header("Location: ".cms_url."?order_stage=confirm_order",true,303);
        exit;
    }

    // load default country list first
    $fn_country_list_default=sys_data_dir.'/settings/country_list_default.txt';
    if (file_exists($fn_country_list_default)){
        $country_list_billing=file($fn_country_list_default);
        $country_list_delivery=$country_list_billing;
    }

    // load delivery countries
    $fn=sys_data_dir.'/settings/country_list_delivery.txt';
    $country_list_delivery[]='---';
    if (file_exists($fn)){
    	$fc=file($fn);
    	if (count($fc)>1){$country_list_delivery=array_merge($country_list_delivery,$fc);}elseif (count($fc)==1){$country_list_delivery=$fc;}
    }

    // load billing countries
    $fn=sys_data_dir.'/settings/country_list_billing.txt';
    $country_list_billing[]='---';
    if (file_exists($fn)){
    	$fc=file($fn);
    	if (count($fc)>1){$country_list_billing=array_merge($country_list_billing,$fc);}elseif (count($fc)==1){$country_list_billing=$fc;}
    }

    if (isset($rvi_name)){

    	$_SESSION[cms_key]['cart']->customer->name=sanitize_text_input($rvi_name);
        if (!isset($_SESSION[cms_key]['reg_user']))
            $_SESSION[cms_key]['cart']->customer->email=sanitize_text_input($rvi_email);

    	$_SESSION[cms_key]['cart']->customer->phone=sanitize_text_input($rvi_phone);

    	$_SESSION[cms_key]['cart']->customer->addr->line1=sanitize_text_input($rvi_address);
    	$_SESSION[cms_key]['cart']->customer->addr->line2=sanitize_text_input($rvi_address_2);
    	$_SESSION[cms_key]['cart']->customer->addr->city=sanitize_text_input($rvi_city);
    	$_SESSION[cms_key]['cart']->customer->addr->county=sanitize_text_input($rvi_county);
    	$_SESSION[cms_key]['cart']->customer->addr->postcode=sanitize_text_input($rvi_postcode);
    	$_SESSION[cms_key]['cart']->customer->addr->country=sanitize_text_input($rvi_country);

    	$_SESSION[cms_key]['cart']->customer->use_delivery_addr=$rvi_seperate_delivery_address;
    	if ($rvi_seperate_delivery_address<1){
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->name=$_SESSION[cms_key]['cart']->customer->name;
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->line1=$_SESSION[cms_key]['cart']->customer->addr->line1;
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->line2=$_SESSION[cms_key]['cart']->customer->addr->line2;
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->city=$_SESSION[cms_key]['cart']->customer->addr->city;
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->county=$_SESSION[cms_key]['cart']->customer->addr->county;
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->postcode=$_SESSION[cms_key]['cart']->customer->addr->postcode;
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->country=$_SESSION[cms_key]['cart']->customer->addr->country;
    	}else{
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->name=sanitize_text_input($rvi_delivery_name);
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->line1=sanitize_text_input($rvi_delivery_address);
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->line2=sanitize_text_input($rvi_delivery_address_2);
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->city=sanitize_text_input($rvi_delivery_city);
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->county=sanitize_text_input($rvi_delivery_county);
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->postcode=sanitize_text_input($rvi_delivery_postcode);
    		$_SESSION[cms_key]['cart']->customer->delivery_addr->country=sanitize_text_input($rvi_delivery_country);
    	}

        if ($cmsSettings->checkout['delivery_phone_field'])
            $_SESSION[cms_key]['cart']->customer->delivery_phone=sanitize_text_input($rvi_delivery_phone);

        if ($cmsSettings->checkout['scheduled_delivery'])
    		$_SESSION[cms_key]['cart']->customer->delivery_date=mktime(0,0,0,$rvi_delivery_date_month,$rvi_delivery_date_day,$rvi_delivery_date_year);

    	if ($cmsSettings->checkout['delivery_message'])
            $_SESSION[cms_key]['cart']->customer->delivery_message=sanitize_text_input($rvi_delivery_message);

        $_SESSION[cms_key]['checkout_create_acc']=true;
        if (empty($rvi_checkout_create_acc)) $_SESSION[cms_key]['checkout_create_acc']=false;


    	// check shipping address values
    	if (strlen($rvi_name)<3) $_SESSION[cms_key]['form']['checkout']['warning'][]='Please enter your name';
    	// check email address
        if (!isset($_SESSION[cms_key]['reg_user'])){
			require_once(cms_root_dir.'scripts/emailval.php');
			if (MailVal($rvi_email,2) || strlen($rvi_email)>128){$_SESSION[cms_key]['form']['checkout']['warning'][]="Please enter your email address";}
			//if (!isset($_SESSION[cms_key]['cart']->id)){ // not sure why registered email check is in this if statemtent
                if (!empty($rvi_checkout_create_acc) && email_registered($rvi_email)){$_SESSION[cms_key]['form']['checkout']['warning']['acc_exists']="A registered account exists under this email address. Login above or order as guest by unchecking the create account option.";}
			//}
        }
    	// check phone number
        if ($require_address){
    	    $clearchars=array('-',',',' ','-','+','(',')');
    	    if(intval(str_replace($clearchars,'',$rvi_phone))<10000){$_SESSION[cms_key]['form']['checkout']['warning'][]='Please enter your phone number';}
    	    // check billing details
    	    if (strlen($rvi_address)<3){$_SESSION[cms_key]['form']['checkout']['warning'][]='Please enter your billing address';}
    	    if (strlen($rvi_city)<3){$_SESSION[cms_key]['form']['checkout']['warning'][]='Please enter your town/city under billing address';}
    	    if (strlen($rvi_county)<3){$_SESSION[cms_key]['form']['checkout']['warning'][]='Please enter your county under billing address';}
    	    if ($rvi_country=='---'){$_SESSION[cms_key]['form']['checkout']['warning'][]='Please select your country under billing address';}
    	    // check delivery details
          	if($rvi_seperate_delivery_address>0){
          		if (strlen($rvi_delivery_name)<3){$_SESSION[cms_key]['form']['checkout']['warning'][]='Please enter name under delivery details';}
          		if (strlen($rvi_delivery_address)<2){$_SESSION[cms_key]['form']['checkout']['warning'][]='Please enter an address under delivery details';}
          		if (strlen($rvi_delivery_city)<2){$_SESSION[cms_key]['form']['checkout']['warning'][]='Please enter town/city under delivery details';}
          		if (strlen($rvi_delivery_county)<2){$_SESSION[cms_key]['form']['checkout']['warning'][]='Please enter county under delivery details';}
          		if ($rvi_delivery_country=='---'){$_SESSION[cms_key]['form']['checkout']['warning'][]='Please select a country under delivery details';}
          	}
          	else{
          		// check if billing country is a valid delivery country
          		foreach ($country_list_delivery as $line){
          			if (trim($rvi_country)==trim($line)){$valid_delivery_country=TRUE;break;}
          		}
          		if (!isset($valid_delivery_country) && $rvi_country!='---'){
                    $_SESSION[cms_key]['form']['checkout']['warning'][]=$rvi_country.' is not a valid delivery country';
                }

          	}
        }

    	// check greeting card message
    	if (isset($rvi_delivery_message) && strlen($rvi_delivery_message)>100){$_SESSION[cms_key]['form']['checkout']['warning'][]="Greeting card message is too long";}


        $_SESSION[cms_key]['checkout_create_acc_pass']="";
        if (!empty($rvi_checkout_create_acc) && isset($rvi_password)){
            if (!isset($_SESSION[cms_key]['form']['checkout']['warning']['acc_exists']) && strlen($rvi_password)<5) $_SESSION[cms_key]['form']['checkout']['warning'][]='Password is too short';
            $_SESSION[cms_key]['checkout_create_acc_pass']=$rvi_password;
        }


    	// check terms and conditions checkbox
    	if (empty($rvi_check_tos)){$_SESSION[cms_key]['tos_agree']=0;$_SESSION[cms_key]['form']['checkout']['warning'][]="You must agree to the terms of service to continue";}else{$_SESSION[cms_key]['tos_agree']=1;}

    	// go to next order stage if no warnings
    	if (!isset($_SESSION[cms_key]['form']['checkout']['warning'])){
            $_SESSION[cms_key]['order_stage']='shipping';
            // redirect after form submit so browser back and refresh work without browser resend form data warning
            header("Location: ".cms_url."?order_stage=shipping",true,303);
            exit;
        }
        else{
          // redirect after form submit so browser back and refresh work without browser resend form data warning
          header("Location: ".cms_url."?order_stage=checkout&edit",true,303);
          exit;
        }



    }

    //if ($_SESSION[cms_key]['order_stage']=="confirm_order"){include("confirm_order.php");}

  	// show hide javascript
  	$page->meta.="<script>
  	function show(id) {
  		var d=document.getElementById(id);
  		d.style.display='block';
  	}
  	function hide(id) {
  		var d=document.getElementById(id);
  		d.style.display='none';
  	}
    function toggle_create_acc() {
		var d=document.getElementById('checkout_create_account_password');
		if (document.getElementById('checkout_create_account').checked) d.style.display='block'; else d.style.display='none';
	}
  	function open_win(page,name){toswindow=window.open(page,name,'width=350,height=380,scrollbars=1');
  	setTimeout(\"toswindow.focus();\",10);}
  	</script>";

    // open page content div
  	$page_content['main'].="<div class=\"cms-content cms-checkout\">\n";
    $page_content['main'].="<h1 id=\"checkout_heading\">".$txt['Checkout']."</h1>";

  	// load checkout text/instructions
  	$checkout_text_fn=sys_data_dir.'/settings/checkout.html';
  	if (file_exists($checkout_text_fn)){
  		$text=file_get_contents($checkout_text_fn);
  		if ($text) $page_content['main'].="<div>".$text."</div>";
  	}


  		//$page_content['main'].='<table class=\"basic_table\">';

  		if (!isset($_SESSION[cms_key]['reg_user'])){

    		// display returning customer login
    		$page_content['main'].="<form class=\"cms_form cms_checkout_login\" name=\"customer_login_form\" method=\"post\" action=\"".cms_url."?order_stage=checkout\">
            <fieldset><legend>".$txt['checkout_returning_customer']."</legend>
    		<p class=\"small_note\">".$txt['Login_instruction']." <a href=\"".cms_url."?forgot_password\">Forgot Password</a></p>";
    		// display login warnings
      		if (isset($_SESSION[cms_key]['form']['login']['warning'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['login']['warning']);}

    		//if(!isset($rvi_email)){$rvi_email='';}
    		//if(!isset($rvi_password)){$rvi_password='';}

    		$page_content['main'].="<div class=\"form_row form_row_medium\"><div class=\"form_row\" style=\"flex: 0 1 21em\"><label for=\"email\">".$txt['Email'].":</label><input type=\"text\" id=\"email\" name=\"email\" value=\"".(isset($_SESSION[cms_key]['form']['login']['email']) ? $_SESSION[cms_key]['form']['login']['email'] : "")."\" ></div><div class=\"form_row\" style=\"flex: 0 1 21em\"><label for=\"password\">".$txt['Password'].":</label> <input type=\"password\" id=\"password\" name=\"password\" value=\"".(isset($rvi_password) ? $rvi_password : '')."\"></div></div>
            <div class=\"form_row\"><label><input type=\"checkbox\" name=\"remember_login\"".(isset($_SESSION[cms_key]['form']['login']['remember_me']) ? " checked" : "")." /> ".$txt['Remember_Me']."</label><input type=\"hidden\" name=\"ulogin[]\" /><button type=\"submit\" class=\"cms_btn cms_btn_login\">".$txt['btn_login']."</button></div>

    		</fieldset></form>
    		<div style=\"font-size: 1.5em; font-weight: bold; text-align:center;margin-top: 1em\">OR</div>";
    		$order_details_legend=$txt['checkout_new_customer'];
  		}
  		else{
  			$order_details_legend='Order Details';
            // display success login warnings
      		if (isset($_SESSION[cms_key]['form']['login']['warning_green'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['login']['warning_green'],'green');}
  		}


  		$page_content['main'].="<form id=\"checkout_form\" class=\"cms_form cms_checkout_details\" name=\"checkout_info\" action=\"".cms_url."?order_stage=checkout#checkout_heading\" method=\"post\">
        <fieldset><legend>$order_details_legend</legend>";

        if (isset($_SESSION[cms_key]['reg_user']))
            $page_content['main'].="<p>Welcome back ".short_name($_SESSION[cms_key]['reg_user']->name)." - ".$txt['Checkout_message']."</p>";
        else
  		    $page_content['main'].="<p>".$txt['Checkout_message']."</p>";

  		// display warnings
  		if (isset($_SESSION[cms_key]['form']['checkout']['warning'])) $page_content['main'].=display_warnings($_SESSION[cms_key]['form']['checkout']['warning']);

  		$page_content['main'].="<h3 id=\"contact_details\">Your Details</h3>
        <div class=\"form_row form_row_medium\"><label>Name:</label><input type=\"text\" name=\"name\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->name) ? $_SESSION[cms_key]['cart']->customer->name : "")."\"></div>";

        if (isset($_SESSION[cms_key]['reg_user'])){$page_content['main'].="<div class=\"form_row form_row_medium\"><label>Email:</label>".$_SESSION[cms_key]['reg_user']->email." (<a href=\"".cms_url."?logout\">Logout</a>)</div>";}
        else{$page_content['main'].="<div class=\"form_row form_row_medium\"><label>Email:</label><input type=\"text\" name=\"email\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->email) ? $_SESSION[cms_key]['cart']->customer->email : "")."\"></div>";}

    	$page_content['main'].="<div class=\"form_row form_row_medium\"><label>Phone:</label><input type=\"text\" name=\"phone\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->phone) ? $_SESSION[cms_key]['cart']->customer->phone : "")."\"></div>";

        $page_content['main'].="<br><h3>Billing Address</h3>
  		<div class=\"form_row form_row_medium\"><label>Address:</label><input type=\"text\" name=\"address\"  value=\"".(!empty($_SESSION[cms_key]['cart']->customer->addr->line1) ? $_SESSION[cms_key]['cart']->customer->addr->line1 : "")."\"></div>
        <div class=\"form_row form_row_medium\"><label>&nbsp;</label><input type=\"text\" name=\"address_2\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->addr->line2) ? $_SESSION[cms_key]['cart']->customer->addr->line2 : "")."\"></div>
        <div class=\"form_row form_row_medium\"><label>Town/City:</label><input type=\"text\" name=\"city\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->addr->city) ? $_SESSION[cms_key]['cart']->customer->addr->city : "")."\"></div>
  		<div class=\"form_row form_row_medium\"><label>County:</label><input type=\"text\" name=\"county\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->addr->county) ? $_SESSION[cms_key]['cart']->customer->addr->county : "")."\"></div>
  		<div class=\"form_row form_row_medium\"><label>Post Code:</label><input type=\"text\" name=\"postcode\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->addr->postcode) ? $_SESSION[cms_key]['cart']->customer->addr->postcode : "")."\"></div>
  		<div class=\"form_row form_row_medium\"><label>Country:</label><select style=\"max-width: 145px\" name=\"country\">";
  	    $option=$country_list_billing;
  	    $option_qty=count($option);
  	    for ($option_num=0;$option_num<$option_qty;$option_num++){
 		    $option[$option_num]=trim($option[$option_num]);
			if (!empty($_SESSION[cms_key]['cart']->customer->addr->country) && $_SESSION[cms_key]['cart']->customer->addr->country==$option[$option_num]){
				$page_content['main'].="<option selected>".$option[$option_num]."</option>";
			}
			else{
				$page_content['main'].="<option>".$option[$option_num]."</option>";
			}
		}
		$page_content['main'].="</select></div>
        <br>
		<h3 id=\"delivery_address\">Delivery Address</h3>
        <div style=\"margin: 1em\">
  		<input type=\"radio\" name=\"seperate_delivery_address\" value=\"0\" onclick=\"javascript:hide('delivery_details');\"".(empty($_SESSION[cms_key]['cart']->customer->use_delivery_addr) ? " checked" : "")."> Same as billing address<br>
  		<input type=\"radio\" name=\"seperate_delivery_address\" value=\"1\" class=\"extend_page\" onclick=\"javascript:show('delivery_details');\"".(!empty($_SESSION[cms_key]['cart']->customer->use_delivery_addr) ? " checked" : "")."> Specify delivery address
        </div>
  		<div id=\"delivery_details\" ".(empty($_SESSION[cms_key]['cart']->customer->use_delivery_addr) ? "style=\"display:none;\"" : "style=\"display:block;\"").">
  		<div class=\"form_row form_row_medium\"><label>Name:</label><input type=\"text\" name=\"delivery_name\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->delivery_addr->name) ? $_SESSION[cms_key]['cart']->customer->delivery_addr->name : "")."\"></div>
  		<div class=\"form_row form_row_medium\"><label>Address:</label><input type=\"text\" name=\"delivery_address\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->delivery_addr->line1) ? $_SESSION[cms_key]['cart']->customer->delivery_addr->line1 : "")."\"></div>
        <div class=\"form_row form_row_medium\"><label>&nbsp;</label><input type=\"text\" name=\"delivery_address_2\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->delivery_addr->line2) ? $_SESSION[cms_key]['cart']->customer->delivery_addr->line2 : "")."\"></div>
        <div class=\"form_row form_row_medium\"><label>Town/City:</label><input type=\"text\" name=\"delivery_city\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->delivery_addr->city) ? $_SESSION[cms_key]['cart']->customer->delivery_addr->city : "")."\"></div>
  		<div class=\"form_row form_row_medium\"><label>County:</label><input type=\"text\" name=\"delivery_county\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->delivery_addr->county) ? $_SESSION[cms_key]['cart']->customer->delivery_addr->county : "")."\"></div>
  		<div class=\"form_row form_row_medium\"><label>Post Code:</label><input type=\"text\" name=\"delivery_postcode\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->delivery_addr->postcode) ? $_SESSION[cms_key]['cart']->customer->delivery_addr->postcode : "")."\"></div>
  		<div class=\"form_row form_row_medium\"><label>Country:</label><select style=\"max-width: 145px\" name=\"delivery_country\">";
  	  $option=$country_list_delivery;
  	  $option_qty=count($option);
  	  for ($option_num=0;$option_num<$option_qty;$option_num++){
            $option[$option_num]=trim($option[$option_num]);
			if (!empty($_SESSION[cms_key]['cart']->customer->delivery_addr->country) && $_SESSION[cms_key]['cart']->customer->delivery_addr->country==$option[$option_num]){
				$page_content['main'].="<option selected>".$option[$option_num]."</option>";
			}
			else{
				$page_content['main'].="<option>".$option[$option_num]."</option>";
			}
		}
		$page_content['main'].="</select></div>
        </div>";

        if ($cmsSettings->checkout['delivery_phone_field']>0 || $cmsSettings->checkout['scheduled_delivery']>0 || $cmsSettings->checkout['delivery_message']){

            $page_content['main'].="<h3>Delivery Options</h3>";

            if ($cmsSettings->checkout['delivery_phone_field']>0){
      			$page_content['main'].="<p class=\"small_note\">Specify a contact phone number that may be used by the delivery person if needed when delivering your order.</p>
                <div class=\"form_row form_row_medium\"><label>Phone:</label><input type=\"text\" name=\"delivery_phone\" value=\"".(!empty($_SESSION[cms_key]['cart']->customer->delivery_phone) ? $_SESSION[cms_key]['cart']->customer->delivery_phone : "")."\"></div>";
      		}

           // todo class change make one single timestamp
      		if ($cmsSettings->checkout['scheduled_delivery']){

                // TODO: consider using calander instead of dropdowns
                $delivery_date['day']=null;
                $delivery_date['month']=null;
                $delivery_date['year']=null;

                if (!empty($_SESSION[cms_key]['cart']->customer->delivery_date)){
                    $delivery_date['day']=date("d",$_SESSION[cms_key]['cart']->customer->delivery_date);
                    $delivery_date['month']=date("m",$_SESSION[cms_key]['cart']->customer->delivery_date);
                    $delivery_date['year']=date("Y",$_SESSION[cms_key]['cart']->customer->delivery_date);
                }

                // we might replace this with a calendar in the future? or just a day/month 3/6 months into future?
      			$page_content['main'].="<p class=\"small_note\">If you have a desired delivery date please specify below otherwise leave blank and we'll deliver as soon as possible.</p>
                <div class=\"form_row form_row_mini\"><label>Date Required:</label><select name=\"delivery_date_month\">";
      			  $option=array("---","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
      			  $option_qty=count($option);
      			  for ($option_num=0;$option_num<$option_qty;$option_num++){
      					if ($delivery_date['month']==$option_num){
      						$page_content['main'].="<option value=\"$option_num\" selected>".$option[$option_num]."</option>";
      					}
      					else{
      						$page_content['main'].="<option value=\"$option_num\">".$option[$option_num]."</option>";
      					}
      				}
      				$page_content['main'].="</select>
      			<select name=\"delivery_date_day\">
                <option>---</option>";
      			  for ($option_num=1;$option_num<=31;$option_num++){
      					if ($delivery_date['day']==$option_num){
      						$page_content['main'].="<option selected>".$option_num."</option>";
      					}
      					else{
      						$page_content['main'].="<option>".$option_num."</option>";
      					}
      				}
      				$page_content['main'].="</select>
      			  <select name=\"delivery_date_year\">
                  <option>---</option>";
      			  $this_year=date("Y",time());
                  $next_year=$this_year + 1;
      			  for ($option_num=$this_year; $option_num<=$next_year; $option_num++){
      					if ($delivery_date['year']==$option_num){
      						$page_content['main'].="<option selected>".$option_num."</option>";
      					}
      					else{
      						$page_content['main'].="<option>".$option_num."</option>";
      					}
      				}
      		$page_content['main'].="</select></div>";
      		}

      		if ($_SESSION[cms_key]['cart']->customer->delivery_message){
      			$page_content['main'].="<p class=\"small_note\">If you would like to include a greeting card message please enter it below.</p>
                <div class=\"form_row form_row_medium\"><label>Greeting Card:</label><textarea name=\"delivery_message\" class=\"delivery_message\">".$_SESSION[cms_key]['cart']->customer->delivery_message."</textarea></div>";
      		}

        }

        // TODO: debug testing
        if (!isset($_SESSION[cms_key]['reg_user']->id)){
            $page_content['main'].="<br>
            <h3 id=\"delivery_address\">Create Account</h3>
            <p>For easy access to invoices and order history.</p>";
            /*
            $page_content['main'].="<div style=\"margin: 1em\">
        		<input type=\"radio\" name=\"create_account\" value=\"0\" onclick=\"javascript:hide('delivery_details');\"".(empty($_SESSION[cms_key]['cart']->customer->use_delivery_addr) ? " checked" : "")."> Create an account<br>
        		<input type=\"radio\" name=\"create_account\" value=\"1\" class=\"extend_page\" onclick=\"javascript:show('delivery_details');\"".(!empty($_SESSION[cms_key]['cart']->customer->use_delivery_addr) ? " checked" : "")."> Order as guest
            </div>";
            */
            $page_content['main'].="<div class=\"form_row form_row_medium\"><label><input type=\"checkbox\" id=\"checkout_create_account\" name=\"checkout_create_acc\" onclick=\"javascript:toggle_create_acc();\" value=\"checkbox\"".(!isset($_SESSION[cms_key]['checkout_create_acc']) || $_SESSION[cms_key]['checkout_create_acc'] ? " checked=\"checked\"" : "")." /> Create an account</label></div>";
            $page_content['main'].="<div id=\"checkout_create_account_password\"".(isset($_SESSION[cms_key]['checkout_create_acc']) && !$_SESSION[cms_key]['checkout_create_acc'] ? " style=\"display:none\"" : " style=\"display:block\"").">
            <div class=\"form_row form_row_medium\"><label for=\"password\">Password:</label><input type=\"password\" name=\"password\" value=\"".(!empty($_SESSION[cms_key]['checkout_create_acc_pass']) ? $_SESSION[cms_key]['checkout_create_acc_pass'] : "")."\" placeholder=\"Enter a password\"></div>
            </div>";
        }



  		$page_content['main'].="<div class=\"form_row\" style=\"border-top: dashed #ccc 1px;padding-top: 15px;margin-top: 30px;\"><label><input type=\"checkbox\" name=\"check_tos\" value=\"checkbox\"".(!empty($_SESSION[cms_key]['tos_agree']) ? " checked=\"checked\"" : "")." /> I have read and agree to the <a href=\"javascript:open_win('".cms_root_url."sys/data/tos.html','Terms')\">terms &amp; conditions</a></label> <button type=\"submit\" class=\"cms_btn cms_btn_checkout\">".$txt['btn_checkout']."</button></div>
  		</fieldset></form>
        </div>";



	?>