<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit;

    require(cms_root_dir.'includes/language/'.$cmsSettings->config['language'].'/shop_confirm_order.php'); // might look into adding this to the page class?

    $page->title=$txt['shop_confirm_order_page_title'];
    $page->meta_title=cms_site_name." - ".$page->title;
       
/*
    $tax_amount=0;
    foreach($_SESSION[cms_key]['cart']->products as $product_option_id => $product){

        $tax_group[$product['tax_rate']]=$product_option_id;

    }
*/

	// go to cart if no items ordered
	if (empty($_SESSION[cms_key]['cart']->products)){
        // redirect to cart
        header("Location: ".cms_url."?cart",true,303);
        exit;
    }

    // huh? not sure on this
    /*
    if (empty($_SESSION[cms_key]['cart']->customer->id) && email_registered($_SESSION[cms_key]['cart']->customer->email)){
		// go to checkout if email is registered but customer is not logged in
		$_SESSION[cms_key]['order_stage']="checkout";
		// redirect after form submit so browser back and refresh work without browser resend form data warning
        header("Location: ".cms_url."?order_stage=checkout",true,303);
        exit;
	}
    */

    // order total including shipping - this not used anymore?
    //$order_total=$_SESSION[cms_key]['cart']['shipping_total']+$_SESSION[cms_key]['cart']['subtotal'];

    $current_time=time();

    // apply a coupon to order
    if (!empty($rvi_coupon_code)){
        if ($coupons=get_items('coupons',null,1,null,null,null,null,null,array('type','code'))){
            $coupon_count=count($coupons);
            $rvi_coupon_code=strtolower(trim($rvi_coupon_code));
            for ($item_num=0; $item_num<$coupon_count; $item_num++){
               if (strtolower($coupons[$item_num]['code'])==$rvi_coupon_code){
                    //$coupon_details=get_item_details('coupon',$coupons[$item_num]['id']);

                    // clear session coupons if this coupon is a solo coupon or solo coupon already in session
                    $clear_session_coupons=0;
                    if ($coupons[$item_num]['type']==1){$clear_session_coupons=1;}
                    elseif(isset($_SESSION[cms_key]['applied_coupons'])){
                        foreach ($_SESSION[cms_key]['applied_coupons'] as $coupon_id => $value){
                            if ($coupon_details=get_item_details('coupon',$coupon_id)){
                                if ($coupon_details['type']==1){$clear_session_coupons=1;break;}
                            }

                        }
                    }
                    // clear session coupons if there is already a solo coupon
                    if ($clear_session_coupons>0) unset($_SESSION[cms_key]['applied_coupons']);

                    $_SESSION[cms_key]['applied_coupons'][$coupons[$item_num]['id']]=1;
                    break;
               }
            }
        }

        // redirect after form submit so browser back and refresh work without browser resend form data warning
        header("Location: ".cms_url."?order_stage=confirm_order",true,303);
        exit;
    }

    // auto-apply coupons
    include_once(cms_root_dir.'includes/shop/coupon_auto_apply.php');

    // display order details
    //$order_obj = new Order();
    $order = $_SESSION[cms_key]['cart'];
    //$edit_cart_link="- <a href=\"".cms_url."?cart\">Edit</a>";
    include(cms_root_dir.'includes/shop/order_details_table.php');

    if (isset($rvi_confirm)){

    	// save unverified user if not logged in
    	if ($_SESSION[cms_key]['checkout_create_acc'] && empty($_SESSION[cms_key]['cart']->customer->id)){

            $user = new User();

            // set password
            if (!empty($_SESSION[cms_key]['checkout_create_acc_pass'])){
                $password=$_SESSION[cms_key]['checkout_create_acc_pass'];
            }
            else $password=generate_password();
            $user->password=encrypt_password($password,$user->id);

            $user->status=1;
            if (!empty($_SESSION[cms_key]['referrer'])) $user->referrer=$_SESSION[cms_key]['referrer'];
            $user->name=$_SESSION[cms_key]['cart']->customer->name;
            $user->email=$_SESSION[cms_key]['cart']->customer->email;
            $user->phone=$_SESSION[cms_key]['cart']->customer->phone;

            $user->addr->line1=$_SESSION[cms_key]['cart']->customer->addr->line1;
            $user->addr->line2=$_SESSION[cms_key]['cart']->customer->addr->line2;
            $user->addr->city=$_SESSION[cms_key]['cart']->customer->addr->city;
            $user->addr->postcode=$_SESSION[cms_key]['cart']->customer->addr->postcode;
            $user->addr->county=$_SESSION[cms_key]['cart']->customer->addr->county;
            $user->addr->country=$_SESSION[cms_key]['cart']->customer->addr->country;

            $user->newsletterSub=true;

            if ($user->saveItem()){
                updateItemIndex('users',array($user->id),'add');

                update_item_log('user',$user->id,"New user account registered via order - ".$user->name." ".$user->id);

                login_user($user); // log new user in (still unverified until user logs in with emailed password)

                $send_new_user_email=1;
            }

    	}

        // set new order id
        $_SESSION[cms_key]['cart']->setId();
        $order_id=$_SESSION[cms_key]['cart']->id;
        // order status 0=unpaid, 1=paid, 2=paid and processed, 3=cancelled, 4=pending
    	$_SESSION[cms_key]['cart']->status=0;

        /*  todo come back to referrer code
        if (isset($_SESSION[cms_key]['referrer'])){
    		$_SESSION[cms_key]['cart']->referrer=$_SESSION[cms_key]['referrer'];
    		if ($referrer_details=get_item_details('customer',$_SESSION[cms_key]['referrer'])){
    			// write order number to referrers referred orders file
    			$fn=sys_data_dir.'/users/'.$referrer_details['id'].'/referrals.php';
    			$fo=fopen($fn,"a");
    			fwrite($fo,"order|".$order_id."||\n");
    			fclose($fo);
    		}
    	}
        */

        //$_SESSION[cms_key]['cart']->ip_address=$_SERVER['REMOTE_ADDR']; // handled in class now

        // check for subscriptions and add subscriptions
        foreach($_SESSION[cms_key]['cart']->products as $order_slot_id => $order_slot){
            if ($order_slot->product->subscription) $subscription_products[] = $order_slot_id;
        }

        // save new subscriptions
        $update_ids=array();
        if (isset($subscription_products)){
            $num=0;
            foreach ($subscription_products as $order_slot_id){

                $subscription = new Subscription();
                $subscription->product = $_SESSION[cms_key]['cart']->products[$order_slot_id]->product;
                $subscription->option = $_SESSION[cms_key]['cart']->products[$order_slot_id]->option;
                $subscription->owner = $_SESSION[cms_key]['cart']->customer->id;
                $subscription->setName();
                $subscription->setPrice();
                $subscription->setTaxRate();
                $subscription->setDays();
                $subscription->setSubUserGroups();
                $subscription->start_time=0;
                $subscription->status=0;

                if ($subscription->saveItem()){
                    $_SESSION[cms_key]['cart']->products[$order_slot_id]->subscription_id=$subscription->id;
                    $update_ids[]=$subscription->id;
                }
                $num++;

            }
            if ($update_ids){updateItemIndex('subscriptions',$update_ids,'add');}
        }
         //admin_debug($_SESSION[cms_key]['cart']->products);
        // check for bookings and add bookings
        foreach($_SESSION[cms_key]['cart']->products as $order_slot_id => $order_slot){
            if (!empty($_SESSION[cms_key]['cart']->products[$order_slot_id]->order_booking)){
                $update_ids=array();
                foreach ($_SESSION[cms_key]['cart']->products[$order_slot_id]->order_booking as $time_slot => $seats){

                    // check booking slot is still available
                    // get existing bookings for this product for checking for booked seats
                    if ($existing_product_bookings=get_items('bookings',null,null,null,null,array('product_id'=>$order_slot->product->id),null,null,array('time'))){
                        foreach ($existing_product_bookings as $key2 => $existing_product_booking){
                            if ($time_slot==$existing_product_booking['time']){
                                $_SESSION[cms_key]['form']['confirm_order']['warning']="Booking slot unavailable";
                                break;
                            }
                        }
                    }

                    if (!isset($_SESSION[cms_key]['form']['confirm_order']['warning'])){

                        $booking = new Booking();

                        $booking->status=0;
                        $booking->name=$order_slot->product->name;
                        $booking->time=$time_slot;
                        $booking->seats=$seats;
                        $booking->product_id=$order_slot->product->id;
                        $booking->owner=$_SESSION[cms_key]['cart']->customer->id;
                        $booking->order_id=$order_id;

                        if ($booking->saveItem()) $update_ids[]=$booking->id;

                    }

                    break; // only ever one time slot per ordered product

                }
                if (!empty($update_ids)) updateItemIndex('bookings',$update_ids,'add');
            }
        }


        if (!isset($_SESSION[cms_key]['form']['confirm_order']['warning'])){
                                             
            // set order slot prices
            foreach($_SESSION[cms_key]['cart']->products as $order_slot_id => $orderslot)
                $_SESSION[cms_key]['cart']->products[$order_slot_id]->setPrice();

            // save order details
            if (!empty($_SESSION[cms_key]['reg_user']->id)) $_SESSION[cms_key]['cart']->owner = $_SESSION[cms_key]['reg_user']->id;
            $_SESSION[cms_key]['cart']->currency_code = currency_code;
            if ($_SESSION[cms_key]['cart']->saveItem()){
                updateItemIndex('orders',array($_SESSION[cms_key]['cart']->id),'add');

                if (!empty($_SESSION[cms_key]['reg_user']->id))
                    update_item_log('user',$_SESSION[cms_key]['reg_user']->id,"New order via cart - ".$_SESSION[cms_key]['cart']->id." by ".short_name($_SESSION[cms_key]['reg_user']->name,2)." ".$_SESSION[cms_key]['reg_user']->id);
                else
                    update_log("New order via cart - ".$_SESSION[cms_key]['cart']->id." by ".short_name($_SESSION[cms_key]['cart']->customer->name,2)." [guest]");


                // write coupon codes to customers coupon file and check for use once only coupons and set to inactive
                if ($_SESSION[cms_key]['cart']->coupons){
                    // write coupon number to customers coupon file
                    $fn_customers_used_coupons=sys_data_dir.'/users/'.$_SESSION[cms_key]['cart']->customer->id.'/coupons.php';
                    //$customers_used_coupons=file_get_contents($fn_customers_used_coupons);
                    $fo=fopen($fn_customers_used_coupons,"a");
                    foreach ($_SESSION[cms_key]['cart']->coupons as $coupon_id => $coupon){
                        // check for use once only coupons and set status to inactive
                        $checkCoupon = new Coupon();
                        $checkCoupon->getData($coupon_id);
                        // TODO: should we check for deactivated coupons or just let it slide for now as very rare it could happen that same coupon used at same-ish time
                        if ($checkCoupon->uses==1){
                            $checkCoupon->status=0;
                            if ($checkCoupon->saveItem()) updateItemIndex('coupons',array($coupon_id));
                        }
                        fwrite($fo,$coupon_id."\n");
                    }
                    fclose($fo);
                }

            	// email customer order confirmation with payment link
            	require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

            	$mail = new PHPMailer();

                // send mail via smtp if set in config file
                if (smtp_host){
                    $mail->IsSMTP(); // send via SMTP
                    $mail->SMTPAuth = true; // turn on SMTP authentication
                    $mail->SMTPSecure = 'ssl';
                    $mail->Username = smtp_username; // SMTP username
                    $mail->Password = smtp_password; // SMTP password
                    $mail->Host       = smtp_host; // SMTP server
                    $mail->Port       = smtp_port; // SMTP server
                }

            	// send customer order confirmation email
            	$mail->ClearAddresses();
            	$mail->From = $cmsSettings->config['site_email'];
            	$mail->FromName = cms_site_name;
            	$mail->AddAddress($_SESSION[cms_key]['cart']->customer->email);

            	$mail->Subject = cms_site_name." - Order # ".$order_id;


            	$body_content="<p><b>Order # ".$order_id."</b></p>
            	<p><b>Customer Details</b><br>Name: ".$_SESSION[cms_key]['cart']->customer->name."<br>Email: ".$_SESSION[cms_key]['cart']->customer->email."<br>Phone: ".$_SESSION[cms_key]['cart']->customer->phone."</p>
            	<p><b>Billing Address</b>";
            	$body_content.="<br>".$_SESSION[cms_key]['cart']->customer->addr->line1.",";
            	if (strlen($_SESSION[cms_key]['cart']->customer->addr->line2)>0){$body_content.="<br>".$_SESSION[cms_key]['cart']->customer->addr->line2.",";}
            	$body_content.="<br>".$_SESSION[cms_key]['cart']->customer->addr->city.",<br>".$_SESSION[cms_key]['cart']->customer->addr->county.",";
            	if (strlen($_SESSION[cms_key]['cart']->customer->addr->postcode)>0){$body_content.="<br>".$_SESSION[cms_key]['cart']->customer->addr->postcode.",";}
            	$body_content.="<br>".$_SESSION[cms_key]['cart']->customer->addr->country."</p>";

                if ($_SESSION[cms_key]['cart']->customer->use_delivery_addr<1){$body_content.="<p><b>Delivery Address</b><br>Same as billing address</p>";}
            	else{$body_content.="<p><b>Delivery Address</b><br>".stripslashes($_SESSION[cms_key]['cart']->customer->delivery_addr->name)."<br>".$_SESSION[cms_key]['cart']->customer->delivery_addr->line1.",";
            	if (strlen($_SESSION[cms_key]['cart']->customer->delivery_addr->line2)>0){$body_content.="<br>".$_SESSION[cms_key]['cart']->customer->delivery_addr->line2.",";}
            	$body_content.="<br>".$_SESSION[cms_key]['cart']->customer->delivery_addr->city.",<br>".$_SESSION[cms_key]['cart']->customer->delivery_addr->county.",";
            	if (strlen($_SESSION[cms_key]['cart']->customer->delivery_addr->postcode)>0){$body_content.="<br>".$_SESSION[cms_key]['cart']->customer->delivery_addr->postcode.",";}
            	$body_content.="<br>".$_SESSION[cms_key]['cart']->customer->delivery_addr->country."</p>";}

            	if ($_SESSION[cms_key]['cart']->customer->delivery_phone) $body_content.="<p><b>Delivery Tel:</b> ".$_SESSION[cms_key]['cart']->customer->delivery_phone."</p>";
            	if ($_SESSION[cms_key]['cart']->customer->delivery_date) $body_content.="<p><b>Requested Delivery Date:</b> ".timeFormatDate($_SESSION[cms_key]['cart']->customer->delivery_date)."</p>";
            	if ($_SESSION[cms_key]['cart']->customer->delivery_message) $body_content.="<div style=\"width: 200px;\"><b>Greeting Card:</b> ".$_SESSION[cms_key]['cart']->customer->delivery_message."</div>";

                $body_content.=$order_details_table;

            	$mail->Body    = str_replace('{order_id}',$order_id,$txt['shop_confirm_order_email'])."<hr>".$body_content;
            	$mail->IsHTML(TRUE);

                if ($cmsSettings->checkout['email_customer']){
            	    if($mail->Send()){update_item_log('user',$_SESSION[cms_key]['reg_user']->id,"Order ".$order_id." notification email sent to ".short_name($_SESSION[cms_key]['cart']->customer->name,2));}
                    else{update_item_log('user',$_SESSION[cms_key]['reg_user']->id,"Warning: order ".$order_id." notification email to ".short_name($_SESSION[cms_key]['cart']->customer->name,2)." could not be sent");}
                }
                else
                    update_log("Warning: checkout customer emails disabled");


            	// email order notification to shop owner
            	$mail->ClearAddresses();
            	$mail->From = $cmsSettings->config['site_email'];
            	$mail->FromName = cms_site_name;
            	$mail->AddAddress($cmsSettings->config['site_email']);
            	$mail->AddReplyTo($_SESSION[cms_key]['cart']->customer->email, $_SESSION[cms_key]['cart']->customer->name);

            	$mail->Subject = cms_site_name." - Order # ".$order_id;
            	$mail->Body="<p>An order has been placed on your website and it's details can be viewed below..</p><p>** Please note this email is not confirmation of payment. **</p><p><a href=\"".cms_root_url."admin/?modify_order=".$order_id."\">Login to the website</a> to modify this order or update it's status.</p> Customer IP Address: ".$_SERVER['REMOTE_ADDR'].$body_content;
            	$mail->IsHTML(TRUE);

                if ($cmsSettings->checkout['email_admin']){
            	    if(!$mail->Send()) update_log("Warning: order ".$order_id." notification email to admin could not be sent");
                }
                else
                    update_log("Warning: checkout admin emails disabled");

            	// send customer registration email if they're not already registered
            	if (isset($send_new_user_email)){

            		// send confirmation email to user
            		$mail->ClearAddresses();
            		$mail->From = $cmsSettings->config['site_email'];
            		$mail->FromName = cms_site_name;
            		$mail->AddAddress($_SESSION[cms_key]['cart']->customer->email);

            		$mail->Subject = cms_site_name." - New Account Registration";
            		$mail->Body    = "Hi ".short_name($user->name).",\n\nThank you for registering with ".cms_site_name." - Your new login password is ".$password."\n\nClick on the link below to login.\n\n".user_login_link($user)."\n\nThis is an automated email; if you received it in error, no action is required.\n\n".cms_site_name."\n".cms_site_url;
            		$mail->IsHTML(FALSE);

            		if(!$mail->Send()){update_item_log('user',$_SESSION[cms_key]['reg_user']->id,"Warning: user registration email could not be sent");}

            	}

                // we keep track of orders placed during session so payment page options can securely output customer details
                $_SESSION[cms_key]['session_orders'][]=$_SESSION[cms_key]['cart']->id;
            	// clear checkout variables
                // we want to keep customer details in session for further orders etc.
                $customerObj = new Customer($_SESSION[cms_key]['cart']->customer);
                unset($_SESSION[cms_key]['cart']); // we need a reset function? or constructer or destructer? for now unset entire object
                $_SESSION[cms_key]['cart'] = new Order();
                $_SESSION[cms_key]['cart']->customer = $customerObj;

                if (isset($_SESSION[cms_key]['applied_coupons'])) unset($_SESSION[cms_key]['applied_coupons']);

            	$_SESSION[cms_key]['order_stage']='checkout';
            	// redirect after form submit so browser back and refresh work without browser resend form data warning
                header("Location: ".cms_url."?paynow=".$order_id,true,303);
                exit;
            }
            else
                update_log("Error: could not save checkout order");
        }

    }
    else{
        $include_font_icons=1;
        include(theme_file_fn('includes/cms/shop/confirm_order.php',display_theme));
    }

?>
