<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    // clear coupons and discount from order
    if ($_SESSION[cms_key]['cart']->coupons) unset($_SESSION[cms_key]['cart']->coupons);
    $_SESSION[cms_key]['cart']->discount = 0;

    if (empty($_SESSION[cms_key]['cart']->products)) return;

    // get active coupons
    $coupon_count=0;

    //get auto apply coupons
    $coupon_search['type']=2;
    if ($auto_coupons=get_items('coupons',null,1,null,null,$coupon_search)){
        $coupon_count=count($auto_coupons);
    }

    // merge any user added coupons
    if (!empty($_SESSION[cms_key]['applied_coupons'])){
        $item_num=$coupon_count;
        foreach($_SESSION[cms_key]['applied_coupons'] as $coupon_id => $value){
            $auto_coupons[$item_num]['id']=$coupon_id;
            $item_num++;
        }
        $coupon_count=count($auto_coupons);
    }

    // if no auto coupons and no applied coupons return
    if ($coupon_count<1) return;
                             
    $coupon = new Coupon();

    for ($item_num=0; $item_num<$coupon_count; $item_num++){

        if ($coupon->getData($auto_coupons[$item_num]['id'])){

            // check spend and date validity
            if ($coupon->min_spend > 0 && $_SESSION[cms_key]['cart']->getTotal($cmsSettings->b2b,false,true) < $coupon->min_spend) continue;
            if ($coupon->start_date > 0 && CMS_INIT_TIME < $coupon->start_date) continue;
            if ($coupon->end_date > 0 && CMS_INIT_TIME > $coupon->end_date) continue;

            // check usergroup validity
            if (!empty($coupon->user_group)){
                $valid_user_group=0;
                foreach ($coupon->user_group as $user_group_id){
                    if ($user_group_id=="0"){$valid_user_group=1; break;}
                    elseif($user_group_id=="1" && isset($_SESSION[cms_key]['reg_user'])){$valid_user_group=1; break;}
                    elseif(isset($_SESSION[cms_key]['reg_user']->user_group) && in_array($user_group_id,$_SESSION[cms_key]['reg_user']->user_group)){$valid_user_group=1; break;}
                }
                if ($valid_user_group<1) continue;
            }

            // if coupon has categories applied check validity against products in cart
            // if any products in the order are in coupon specified categories then it will apply the discount to the order as long as the cost of those products is greater than the discount
            // to apply a discount to each product on the order set a Discount amount on the products themselves by editing the products.
            $invalid_category=0;
            $multibuy_product_prices=array();
            if (!empty($coupon->category)){
                $invalid_category=1;
                foreach($_SESSION[cms_key]['cart']->products as $order_slot_id => $order_slot){
                    foreach ($order_slot->product->getProduct()->category as $category_id => $value2){
                        if (in_array($category_id,$coupon->category)){
                           $invalid_category=0;
                           for ($i=0; $i<$order_slot->qty; $i++){
                              $multibuy_product_prices[]=$order_slot->getPrice($cmsSettings->b2b);
                           }
                           break;
                        }
                    }
                }
            }
            if ($invalid_category>0) continue;

            // apply coupon to cart/order
            $_SESSION[cms_key]['cart']->addCoupon($coupon);
            //$_SESSION[cms_key]['cart']->coupons[$coupon->id]=$coupon;
            //$_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount=0;

            // old calculate coupon discount value
            /*
            if (isset($multibuy_product_prices)){
                if ($coupon->multibuy_qty<1){$coupon->multibuy_qty=1;}
                $multibuy_batches=floor(count($multibuy_product_prices)/$coupon->multibuy_qty);
                if ($multibuy_batches>0){
                    $multibuy_product_count=$multibuy_batches*$coupon->multibuy_qty;
                    $multibuy_price_total=0;
                    for ($i=0; $i<$multibuy_product_count; $i++){
                        $multibuy_price_total=$multibuy_price_total+$multibuy_product_prices[$i];
                    }

                    if ($coupon->value_type<1){
                      // multibuy - multiple products for a particular price
                      $new_price=$multibuy_batches*$coupon->value;
                      $_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount=$multibuy_price_total-$new_price;
                    }
                    else
                    {
                      // multibuy - percent discount
                      $_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount=($multibuy_price_total*$coupon->value)/100;
                    }


                }
                unset($multibuy_product_prices);
            }
            */

            // calculate coupon discount value
            if (!empty($multibuy_product_prices)){
                if ($coupon->multibuy_qty<2){
                    $multibuy_product_count=count($multibuy_product_prices);
                    $multibuy_price_total=0;
                    for ($i=0; $i<$multibuy_product_count; $i++)
                        $multibuy_price_total+=$multibuy_product_prices[$i];

                    if ($coupon->value_type<1 && $multibuy_price_total>=$coupon->value)
                        $_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount=$coupon->value; // apply amount discount
                    elseif($coupon->value_type>0){
                        // apply percent discount
                        $percent_discount_price=($multibuy_price_total*$coupon->value)/100;
                        if ($multibuy_price_total>=$percent_discount_price)
                            $_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount=$percent_discount_price;
                    }
                }
                else{
                    $multibuy_batches=floor(count($multibuy_product_prices)/$coupon->multibuy_qty);
                    $multibuy_product_count=$multibuy_batches*$coupon->multibuy_qty;
                    $multibuy_price_total=0;
                    for ($i=0; $i<$multibuy_product_count; $i++){
                        $multibuy_price_total=$multibuy_price_total+$multibuy_product_prices[$i];
                    }

                    if ($coupon->value_type<1){
                      // multibuy - multiple products for a particular price
                      $new_price=$multibuy_batches*$coupon->value;
                      $_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount=$multibuy_price_total-$new_price;
                    }
                    else
                    {
                      // multibuy - percent discount
                      $_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount=($multibuy_price_total*$coupon->value)/100;
                    }
                }

            }
            elseif ($coupon->value_type<1){$_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount=$coupon->value;}
            elseif ($coupon->value_type==1)
                 $_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount = ($_SESSION[cms_key]['cart']->getTotal($cmsSettings->b2b,false,true)*$coupon->value)/100;

            // update total order discount
            //if (isset($_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount)){
                // ensure discount amount is never less than 0
                if ($_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount<0){$_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount=0;}
                else{$_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount=round($_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount,2);}
                $new_discount_total=$_SESSION[cms_key]['cart']->discount+$_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount;

                // check if total discount is exceeds order total
                if ($new_discount_total>$_SESSION[cms_key]['cart']->getSubTotal()){
                    // cancel this coupon and any subsequent coupons
                    //if (isset($_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount)){unset($_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount);}
                    //if (isset($_SESSION[cms_key]['cart']->coupons[$coupon->id]->discount)){unset($_SESSION[cms_key]['cart']->coupons[$coupon->id]);}
                    unset($_SESSION[cms_key]['cart']->coupons[$coupon->id]);
                    break;
                }
                else{$_SESSION[cms_key]['cart']->discount=$new_discount_total;}

            //}

        }

    }

    // cancel order discount and all coupons if total discount is equal to or greater than order total
    /*
    if ($_SESSION[cms_key]['cart']->discount>=$_SESSION[cms_key]['cart']->getSubTotal()){
       $_SESSION[cms_key]['cart']->discount=0;
       unset($_SESSION[cms_key]['cart']->coupons);
    }
    */


?>
