<?php
// exit if php file is loaded directly and not included
if (!defined("cms_version_number")){exit();}

    if ($order->currency_code){
        $currency_code=$order->currency_code;
        $currency_symbol=get_currency_symbol($order->currency_code);
    }
    else{
        $currency_code=currency_code;
        $currency_symbol=currency_symbol;
    }

    if (!empty($order->products))
        $tax_heading="Tax";
    else
        $tax_heading="";

    // cart_items_heading as variable so it can be replaced with an edit cart link on confirm order page
    $cart_items_heading="<span class=\"cart_items_heading\" style=\"font-weight: bold\">".$txt['invoice_items_heading']."</span>";

    $order_details_table="<table width=\"100%\" cellpadding=\"2\" class=\"table_no_border\" style=\"margin-bottom: 10px\">\n
    <tr><td colspan=\"2\" >".$cart_items_heading."</td><td width=\"50\" align=\"center\" style=\"padding: 6px 10px 6px 10px\"><b>".$tax_heading."</b></td><td width=\"80\" align=\"right\" style=\"padding-left:10px\"><b>Total</b></td></tr>\n";

    $subtotal=0;
    if (!empty($order->products)){
    //admin_debug($order);
    //admin_debug($order->products);
    	foreach($order->products as $order_slot_id => $order_slot){

            if (empty($order_slot->product)) continue; // incase some boo-boo leads to no product in orderslot

    		if (!empty($order_slot->product->code))
                $product_code="(".$order_slot->product->code.") ";
            else
                $product_code="";

            if ($order_slot->isCancelled())
                $style_cancelled=" text-decoration: line-through";
            else
                $style_cancelled="";

    		$order_details_table.="<tr><td valign=\"top\" width=\"30\" nowrap><span style=\"".$style_cancelled."\">".$order_slot->qty." x</span></td><td><span style=\"font-weight: bold;".$style_cancelled."\">".$product_code.htmlentities($order_slot->product->name)."</span>";

            // todo after class changes
            if (cms_interface=='back' && admin_level('orders')>1){
                $order_details_table.=" <a href=\"?modify_order=".$order->id."&amp;eproduct=".$order_slot_id."\" title=\"Edit item\"><i class=\"cms-fi-edit\"></i></a>";
                if (!$order_slot->isCancelled())
                    $order_details_table.=" <a href=\"?modify_order=".$order->id."&amp;cproduct=".$order_slot_id."\" title=\"Cancel item\"><i class=\"cms-fi-toggle-on\"></i></a>";
                else
                    $order_details_table.=" <a href=\"?modify_order=".$order->id."&amp;restoreproduct=".$order_slot_id."\" title=\"Restore item\"><i class=\"cms-fi-toggle-off\"></i></a>";

                $order_details_table.=" <a href=\"?modify_order=".$order->id."&amp;rproduct=".$order_slot_id."\" title=\"Remove item\" onclick=\"return confirm('Are you sure you want to remove this item from the order?')\"><i class=\"cms-fi-trash\"></i></a>";
            }

            if (cms_interface=='back' && !empty($order_slot->product->id)){
                $order_details_table.="<div style=\"font-size: 12px;".$style_cancelled."\"><span>PID: <a href=\"?editProduct=".$order_slot->product->id."\">".$order_slot->product->id."</a></span></div>";
            }
            if (!empty($order_slot->product->options)){
                $order_details_table.="<div style=\"font-size: 12px;".$style_cancelled."\">";
                foreach ($order_slot->product->options as $option => $value){
                    $order_details_table.=$option.": ".key($value)."<br />";
                }
                $order_details_table.="</div>";
            }
    		if (!empty($order_slot->customer_note)) $order_details_table.="<div style=\"font-size: 12px;\"><span style=\"".$style_cancelled."\">Instructions/Notes: ".$order_slot->customer_note."</span></div>";
    		if (!empty($order_slot->uploaded_file)) $order_details_table.="<div style=\"font-size: 12px;\"><span style=\"".$style_cancelled."\">File: ".$order_slot->uploaded_file."</span></div>";

            if (!empty($order_slot->note)){$order_details_table.="<div style=\"font-size: 11px; color: #333\"><span style=\"".$style_cancelled."\">".nl2br($order_slot->note)."</span></div>";}

            if (admin_level()>0 && !isset($rvi_print_invoice)){
                if (!empty($order_slot->listing_id)){$order_details_table.='<div>'.$txt['Listing'].' Ref: <a href="'.item_url('listing',$order_slot->listing_id).'" target="_blank">'.$order_slot->listing_id.'</a> - <a href="?modify_listing='.$order_slot->listing_id.'">Modify</a></div>';}
                if (!empty($order_slot->subscription_id)){$order_details_table.='<div>'.$txt['Subscription'].' Ref: <a href="?modify_subscription='.$order_slot->subscription_id.'">'.$order_slot->subscription_id.'</a></div>';}
            }
            else{
                if (!empty($order_slot->listing_id)){$order_details_table.='<div>'.$txt['Listing'].' Ref: '.$order_slot->listing_id.'</div>';}
                if (!empty($order_slot->subscription_id)){$order_details_table.='<div>'.$txt['Subscription'].' Ref: '.$order_slot->subscription_id.'</div>';}
            }

            // calculate tax amount
    		if ($order_slot->tax_rate && !$order_slot->isCancelled()){
      			$tax=$order_slot->getTotal()-$order_slot->getTotal(true);
                if (isset($tax_amounts[$order_slot->tax_rate]))
                    $tax_amounts[$order_slot->tax_rate] += $tax;
                else
                    $tax_amounts[$order_slot->tax_rate]=$tax;
    		}

    		$order_details_table.="</td><td align=\"center\" valign=\"top\" style=\"padding: 2px 10px 2px 10px\"><span style=\"".$style_cancelled."\">".floatval($order_slot->product->tax_rate)."%</span></td><td align=\"right\" valign=\"top\" style=\"padding-left:10px\"><span style=\"".$style_cancelled."\">".formatPrice($order_slot->getTotal($cmsSettings->b2b),false,$currency_symbol)."</span></td></tr>\n";

    	}
    }
    elseif(isset($rvi_invoice) || isset($rvi_print_invoice)){$order_details_table.="<tr><td colspan=\"4\" style=\"line-height: 22px\"><hr style=\"color: #cccccc\"><br><hr style=\"color: #cccccc;\"><br><hr style=\"color: #cccccc\"><br><hr style=\"color: #cccccc\"><br><hr style=\"color: #cccccc\"><br><hr style=\"color: #cccccc\"><br><hr style=\"color: #cccccc\"><br><hr style=\"color: #cccccc\"><br></td></tr>\n";}

    $order_details_table.="<tr><td colspan=\"4\"><hr></td></tr>\n";

    if ((isset($rvi_invoice) || isset($rvi_print_invoice)) && empty($order->products)){
        $order_details_table.="<tr><td colspan=\"3\" align=\"right\"><b>Sub-Total</b>:</td><td align=\"right\"><span style=\"color: #cccccc;line-height:24px\">___________________</span></td></tr>\n";
    }
    else{
        $order_details_table.="<tr><td colspan=\"3\" align=\"right\">Sub-Total:</td><td align=\"right\">".formatPrice($order->getSubTotal($cmsSettings->b2b),false,$currency_symbol)."</td></tr>\n";
    }

    if (!empty($tax_amounts)){
        foreach ($tax_amounts as $tax_rate => $value){
            $order_details_table.="<tr><td colspan=\"3\" align=\"right\">Tax @ ".floatval($tax_rate)."%:</td><td align=\"right\">".formatPrice($value,false,$currency_symbol)."</td></tr>\n";
        }
    }

    if ($order->shipping_option){
        $order_details_table.="<tr><td colspan=\"4\"><b>Shipping</b></td></tr>\n";

        $user_shipping_info="";
        if (isset($order->shipping_option['user_shipping_info'])){
            foreach ($order->shipping_option['user_shipping_info'] as $name => $value){
                if ($value!=""){
                    $user_shipping_info="<br>".$name.": ".$value;
                }
            }
        }

        $order_details_table.="<tr><td colspan=\"3\">".$order->shipping_option['name'].$user_shipping_info."</td><td align=\"right\" valign=\"top\" style=\"padding-left:10px\">".formatPrice($order->shipping_total,false,$currency_symbol)."</td></tr>\n";
        $order_details_table.="<tr><td colspan=\"4\"><hr /></td></tr>\n";
    }
    else{
        if ((isset($rvi_invoice) || isset($rvi_print_invoice)) && (!isset($order->products) || empty($order->products)))
           $order_details_table.="<tr><td colspan=\"3\" align=\"right\"><b>Shipping</b>:</td><td align=\"right\"><span style=\"color: #cccccc;line-height:24px\">___________________</span></td></tr>\n";
        else
            $order_details_table.="<tr><td colspan=\"3\" align=\"right\">Shipping:</td><td align=\"right\">".formatPrice($order->shipping_total,false,$currency_symbol)."</td></tr>\n";
    }

    if ($order->coupons){
        $order_details_table.="<tr><td colspan=\"3\" align=\"right\">Total:</td><td align=\"right\">".formatPrice($order->getTotal(false,true,false),false,$currency_symbol)."</td></tr>\n";
        $order_details_table.="<tr><td colspan=\"4\"><b>Discounts</b></td></tr>\n";
        foreach ($order->coupons as $coupon_id => $coupon){
            if ($coupon->discount>0){

                if ($coupon->status) $style_cancelled=""; else $style_cancelled=" text-decoration: line-through";

                $order_details_table.="<tr><td colspan=\"3\"><span style=\"".$style_cancelled."\">".($coupon->description ? $coupon->description : $coupon->code)."</span>";
                if (cms_interface=='back' && admin_level('orders')>1){
                    if ($coupon->status)
                        $order_details_table.=" <a href=\"?modify_order=".$order->id."&amp;cdiscount=".$coupon_id."\" title=\"Cancel coupon\"><i class=\"cms-fi-toggle-on\"></i></a>";
                    else
                        $order_details_table.=" <a href=\"?modify_order=".$order->id."&amp;restorediscount=".$coupon_id."\" title=\"Restore coupon\"><i class=\"cms-fi-toggle-off\"></i></a>";
                }
                $order_details_table.="</td><td align=\"right\" valign=\"top\" style=\"padding-left:10px\"><span style=\"".$style_cancelled."\">- ".formatPrice($coupon->discount,false,$currency_symbol)."</span></td></tr>\n";
            }
        }
        $order_details_table.="<tr><td colspan=\"4\"><hr /></td></tr>";
        // $order_details_table.="<tr><td colspan=\"3\" align=\"right\">Total Discount:</td><td align=\"right\">- ".formatPrice($order['discount'],false,$currency_symbol)."</td></tr>";

        $order_details_table.="<tr><td colspan=\"3\" align=\"right\" style=\"font-size: 14px\"><b>Total:</b></td><td align=\"right\" style=\"font-size: 14px\"><b>".formatPrice($order->getTotal(false,true,true),false,$currency_symbol)."</b></td></tr>\n";
    }
    else{

        if ((isset($rvi_invoice) || isset($rvi_print_invoice)) && (empty($order->products))){
           $order_details_table.="<tr><td colspan=\"3\" align=\"right\"><b>Total</b>:</td><td align=\"right\"><span style=\"color: #cccccc;line-height:24px\">___________________</span></td></tr>\n";
        }
        else{
            $order_details_table.="<tr><td colspan=\"3\" align=\"right\"><b>Total</b>:</td><td align=\"right\"><b>".formatPrice($order->getTotal(false,true,true),false,$currency_symbol)."</b></td></tr>\n";
        }
    }


    $payment_details_table="";
    if ($order->payments){
        foreach($order->payments as $payment_id => $payment){

            if ($payment->isCancelled()) $style_cancelled=" text-decoration: line-through"; else $style_cancelled="";

    		$payment_details_table.="<tr><td valign=\"top\" colspan=\"3\"><span style=\"".$style_cancelled."\">".date("d/m/Y",$payment->date)." ".$payment->description."</span>";

            if (cms_interface=='back' && admin_level('orders')>1){
                if ($payment->isCancelled())
                    $payment_details_table.=" <a href=\"?modify_order=".$order->id."&amp;restorepayment=".$payment_id."\" title=\"Restore payment\"><i class=\"cms-fi-toggle-off\"></i></a>";
                else
                    $payment_details_table.=" <a href=\"?modify_order=".$order->id."&amp;cpayment=".$payment_id."\" title=\"Cancel payment\"><i class=\"cms-fi-toggle-on\"></i></a>";

                $payment_details_table.=" <a href=\"?modify_order=".$order->id."&amp;rpayment=".$payment_id."\" title=\"Remove payment\" onclick=\"return confirm('Are you sure you want to remove this payment from the order?')\"><i class=\"cms-fi-trash\"></i></a>";
            }

            if (!empty($payment->note))
                $payment_details_table.="<div style=\"font-size: 12px;\"><span style=\"".$style_cancelled."\">".$payment->note."</span></div>";

    		$payment_details_table.="</td><td align=\"right\" valign=\"top\" style=\"padding-left:10px\"><span style=\"".$style_cancelled."\">".formatPrice($payment->amount,false,$currency_symbol)."</span></td></tr>\n";

    	}

        if ($payment_details_table!=""){
            $order_details_table.="<tr><td colspan=\"4\"><b>Payments</b></td></tr>\n".$payment_details_table;
            $order_details_table.="<tr><td colspan=\"3\" align=\"right\"><b>Balance Due</b>:</td><td align=\"right\"><b>".formatPrice($order->getBalance(),false,$currency_symbol)."</b></td></tr>\n";
        }

    }



    $order_details_table.="</table>";


?>