<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    // bank transfer payment option, displays IBAN and BIC/SWIFT for electronic/wire transfers

    // the payment option id must match the directory name of the payment option exactly
    $payment_option_details['id']="banktransfer";

    // admin name and description
    $payment_option_details['admin_name']="Bank Transfer";
    $payment_option_details['admin_description']="Accept bank transfer payments.";

    // front-end name and description
    $payment_option_details['name']="Pay by Bank Transfer";
    $payment_option_details['description']="Use the following bank account details when making an electronic/wire transfer.";

    // custom data specific to this payment option - for configuration in the admin area
    $payment_option_details['value']['merchant_name']['name']="Account Name";
    $payment_option_details['value']['merchant_name']['admin_description']="Enter the bank account details where electronic/wire transfers should be sent.";
    $payment_option_details['value']['merchant_name']['value']=$cmsSettings->config['site_name'];
    $payment_option_details['value']['iban']['name']="IBAN";
    $payment_option_details['value']['iban']['admin_description']="";
    $payment_option_details['value']['iban']['value']="";
    $payment_option_details['value']['bic']['name']="BIC/SWIFT";
    $payment_option_details['value']['bic']['admin_description']="";
    $payment_option_details['value']['bic']['value']="";

    // get saved data for this payment option if it exists (saved data can then be used in $payment_option_form)
    if ($saved_payment_option_details=get_item_details('payment_option',$payment_option_details['id'])){
        if (function_exists('array_replace_recursive')){
            // php5.3.0 or higher
           $payment_option_details=array_replace_recursive($payment_option_details,$saved_payment_option_details);
        }
        else{
            // legacy code for pre php5.3.0
            $payment_option_details=$saved_payment_option_details;
        }
    }

    if (!isset($rvi_paynow)){return;}

    // ------------- paynow front-end code goes below here -------------

    if (!empty($order->id)){$payment_option_details['description'].="<br><br>Please include your name and order number <span style=\"font-weight:bold\">".$order->id."</span> if prompted for a payment reference.";}
    else{$payment_option_details['description'].="<br><br>Please include your name if prompted for a payment reference.";}

    $payment_option_form="<div class=\"notranslate\" style=\"display: inline-block; text-align: left\">
    <p><span style=\"font-weight:bold\">IBAN:</span> ".$payment_option_details['value']['iban']['value']."</p>
    <p><span style=\"font-weight:bold\">BIC/SWIFT:</span> ".$payment_option_details['value']['bic']['value']."</p>
    </div>";


?>