<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    // beanstream payment option
    // payment options must contain the folowing data
    $payment_option_details=array();
    $payment_option_details['item_type']='payment_option'; // required - do not change or remove this

    $payment_option_details['id']="beanstream";  // required - each shipping option must have a unique id that matches the file name exactly minus the extension
    $payment_option_details['admin_name']="Beanstream";  // display name in admin area
    $payment_option_details['admin_description']="Accept payments via Beanstream."; // description displayed in admin
    $payment_option_details['name']="Beanstream"; // display name in checkout/front end
    $payment_option_details['description']="Upon clicking the Pay Now button you will be redirected to a secure payment page provided by Beanstream.";  // description displayed in checkout/front end

    // custom data specific to this payment option - can be modified in admin area
    $payment_option_details['value']['merchant_id']['name']="Merchant ID";
    $payment_option_details['value']['merchant_id']['admin_description']="Enter the Merchant ID for your Beanstream account.";
    $payment_option_details['value']['merchant_id']['value']="";

    // get saved data for this payment option if it exists
    if ($saved_payment_option_details=get_item_details('payment_option',$payment_option_details['id'])){
        if (function_exists('array_replace_recursive')){
            // php5.3.0 or higher
           $payment_option_details=array_replace_recursive($payment_option_details,$saved_payment_option_details);
        }
        else{
            // legacy code for pre php5.3.0
            $payment_option_details=$saved_payment_option_details;
        }
    }

    if (!isset($rvi_paynow) || !isset($payment_option_details['status']) || $payment_option_details['status']<1){return;}
    // ------------- paynow button code goes below here -------------

    $payment_option_form="<form action=\"https://www.beanstream.com/scripts/payment/payment.asp\" method=\"post\">
    <input type=\"hidden\" name=\"merchant_id\" value=\"".$payment_option_details['value']['merchant_id']['value']."\">
    <input type=\"hidden\" name=\"trnOrderNumber\" value=\"".$order->id."\">
    <input type=\"hidden\" name=\"trnAmount\" value=\"".$order_total."\">";

    // optional send customer information - this will be included insecurely on paynow page source code
    /*
    $payment_option_form.="<input type=\"hidden\" name=\"ordName\" value=\"".$order->customer->name."\">
    <input type=\"hidden\" name=\"ordEmailAddress\" value=\"".$order->customer->email."\">
    <input type=\"hidden\" name=\"ordPhoneNumber\" value=\"".$order->customer->phone."\">
    <input type=\"hidden\" name=\"ordAddress1\" value=\"".$order->customer->addr->line1."\">
    <input type=\"hidden\" name=\"ordAddress2\" value=\"".$order->customer->addr->line2."\">
    <input type=\"hidden\" name=\"ordCity\" value=\"".$order->customer->addr->city."\">
    <input type=\"hidden\" name=\"ordProvince\" value=\"".$order->customer->addr->county."\">
    <input type=\"hidden\" name=\"ordPostalCode\" value=\"".$order->customer->addr->postcode."\">
    <input type=\"hidden\" name=\"ordCountry\" value=\"".$order->customer->addr->country."\">";
    */

    // beanstream appends it's own query to url which prevents the dynamic ?thankyou page in cms from working properly
    $payment_option_form.="<input type=\"hidden\" name=\"approvedPage\" value=\"".cms_url."?thankyou=beanstream\">
    <input type=\"submit\" name=\"submit\" value=\"Pay Now\">
    </form>";


?>