<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    // paypal payment option
    // payment options must contain the folowing data
    $payment_option_details=array();
    $payment_option_details['item_type']='payment_option'; // required - do not change or remove this

    $payment_option_details['id']="mollie";  // required - each shipping option must have a unique id that matches the file name exactly minus the extension
    $payment_option_details['admin_name']="Mollie";  // display name in admin area
    $payment_option_details['admin_description']="Accept payments via Mollie."; // description displayed in admin
    $payment_option_details['name']="Mollie"; // display name in checkout/front end
    $payment_option_details['description']="Upon clicking the Pay Now button you will be redirected to a secure payment page provided by Mollie.";  // description displayed in checkout/front end

    // custom data specific to this payment option - can be modified in admin area
    $payment_option_details['value']['apikey']['name']='API-KEY';
    $payment_option_details['value']['apikey']['admin_description']='Enter your Mollie api-key for your website.';
    $payment_option_details['value']['apikey']['value']="";

    // get saved data for this payment option if it exists
    if ($saved_payment_option_details=get_item_details('payment_option',$payment_option_details['id'])){
        if (function_exists('array_replace_recursive')){
            // php5.3.0 or higher
           $payment_option_details=array_replace_recursive($payment_option_details,$saved_payment_option_details);
        }
        else{
            // legacy code for pre php5.3.0
            $payment_option_details=$saved_payment_option_details;
        }
    }

    if (!isset($rvi_paynow) || !isset($payment_option_details['status']) || $payment_option_details['status']<1){return;}
    // ------------- paynow button code goes below here -------------


    if (isset($_POST['submit_mollie'])){

        require_once cms_root_dir."includes/shop/payment_options/mollie/mollie-api-php-1.2.7/src/Mollie/API/Autoloader.php";

        /*
         * Initialize the Mollie API library with your API key.
         *
         * See: https://www.mollie.com/beheer/account/profielen/
         */
        $mollie = new Mollie_API_Client;
        $mollie->setApiKey($payment_option_details['value']['apikey']['value']);

    	/*
    	 * Payment parameters:
    	 *   amount        Amount in EUROs. This example creates a € 10,- payment.
    	 *   description   Description of the payment.
    	 *   redirectUrl   Redirect location. The customer will be redirected there after the payment.
         *   webhookURL    Use this and ignore any webhook set in your mollie website profile.
    	 *   metadata      Custom metadata that is stored with the payment.
    	 */
    	$payment = $mollie->payments->create(array(
    		"amount"       => $order_total,
    		"description"  => cms_site_name." Order",
    		"redirectUrl"  => cms_url."?thankyou=mollie",
            "webhookUrl"  => cms_root_url."includes/shop/payment_options/mollie/response.php",
    		"metadata"     => array(
    			"order_id" => $order->id,
    		),
    	));

    	/*
    	 * Send the customer off to complete the payment.
    	 */
    	header("Location: " . $payment->getPaymentUrl());

    }

    $payment_option_form="<form action=\"".cms_url."?paynow=".$order->id."\" method=\"post\">
    <input type=\"hidden\" name=\"submit_mollie\" value=\"1\">
    <input type=\"image\" src=\"".cms_root_url."includes/shop/payment_options/mollie/images/paynow.png\" border=\"0\" name=\"submit\" alt=\"Pay Now\">
    </form>";

?>