<?php
/*
 * Example 2 - How to verify Mollie API Payments in a webhook.
 */

$cron=1;
require("../../../../scripts/main.php");

require('paynow.php');

try
{
	/*
	 * Initialize the Mollie API library with your API key.
	 *
	 * See: https://www.mollie.com/beheer/account/profielen/
	 */
	require_once 'mollie-api-php-1.2.7/src/Mollie/API/Autoloader.php';
    $mollie = new Mollie_API_Client;
    $mollie->setApiKey($payment_option_details['value']['apikey']['value']);

	/*
	 * Retrieve the payment's current state.
	 */
	$payment  = $mollie->payments->get($_POST["id"]);
	$order_id = $payment->metadata->order_id;


  	if ($payment->isPaid() == TRUE)
  	{
  		/*
  		 * At this point you'd probably want to start the process of delivering the product to the customer.
  		 */
          // load order details
    	if ($order_details=get_item_details('order',$order_id)){

            // update order status to paid
            $order->status=1;
            $order_details['payment']['method']='Mollie';
            $order_details['payment']['time']=time();
            $order_details['payment']['amount']=0;


           if (is_array($order_details['products'])){
        		foreach($order_details['products'] as $product_option_id => $product){
                    // check if there are listings in the order and set them to active
                    if (isset($product['listing_id'])){
                        if ($listing_details=get_item_details('listing',$product['listing_id'])){
                            if ($listing_details['status']!=1){
                                $listing_details['status']=1;
                                save_item_details($listing_details);
                                update_item_list_file('listings',array($listing_details['id']));
                            }
                        }
                    }
        		}
    	    }

            save_item_details($order_details);
            update_item_list_file('orders',array($order->id));

            update_item_log('user',$order->owner,"Payment made via Mollie on order ".$order->id);

    		require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

    		// send email to customer
    		$mail = new PHPMailer();

            // send mail via smtp if set in config file
            if (smtp_host){
                $mail->IsSMTP(); // send via SMTP
                $mail->SMTPAuth = true; // turn on SMTP authentication
                $mail->SMTPSecure = 'ssl';
                $mail->Username = smtp_username; // SMTP username
                $mail->Password = smtp_password; // SMTP password
                $mail->Host       = smtp_host; // SMTP server
                $mail->Port       = smtp_port; // SMTP server
            }

    		$mail->From = $cmsSettings->config['site_email'];
    		$mail->FromName = cms_site_name;
    		$mail->AddAddress($order->customer->email);

    		$mail->Subject = "Order: ".$order_id.", Payment Received";
    		$mail->Body    = "Hi ".short_name($order->customer->name).",\n\nThank you for your payment. Your order is now being processed.\n\n".cms_site_name."\n".cms_url;


    		$mail->Send();

    		// send email to shop owner
    		$mail->ClearAddresses();
    		$mail->From = $cmsSettings->config['site_email'];
    		$mail->FromName = cms_site_name;
    		$mail->AddAddress($cmsSettings->config['site_email']);

    		$mail->Subject = "Order: $order_id, Payment Received";
    		$mail->Body    = "A payment was made via Mollie for order $order_id";


    		$mail->Send();

    	}
        else{
            update_log("Payment response from Mollie - warning: order ".$order_id." could not be found");
        }
  	}
  	elseif ($payment->isOpen() == FALSE)
  	{
  		/*
  		 * The payment isn't paid and isn't open anymore. We can assume it was aborted.
  		 */
         // do nothing
  	}

}
catch (Mollie_API_Exception $e)
{
	update_log("Mollie API call failed: " . htmlspecialchars($e->getMessage()));
}
