<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit;

    // paypal payment option
    // payment options must contain the folowing data
    $payment_option_details=array();
    $payment_option_details['item_type']='payment_option'; // required - do not change or remove this

    $payment_option_details['id']="paypal";  // required - each payment option must have a unique id that matches the file name exactly minus the extension
    $payment_option_details['admin_name']="PayPal";  // display name in admin area
    $payment_option_details['admin_description']="Accept payments via PayPal."; // description displayed in admin
    $payment_option_details['name']="PayPal"; // display name in checkout/front end
    $payment_option_details['description']="Upon clicking the Pay Now button you will be redirected to a secure payment page provided by PayPal.<br /><br />Once payment is complete you can click on the &quot;<b>Return to Merchant</b>&quot; button to return to the website.";  // description displayed in checkout/front end

    // custom data specific to this payment option - can be modified in admin area
    $payment_option_details['value']['email']['name']="Email";
    $payment_option_details['value']['email']['admin_description']="Enter the email address for your PayPal account.";
    $payment_option_details['value']['email']['value']="";
    $payment_option_details['value']['page_style']['name']='Page Style';
    $payment_option_details['value']['page_style']['admin_description']="Use a particular page style on your PayPal payment page or leave blank for default.";
    $payment_option_details['value']['page_style']['value']="";

    $payment_option_details['value']['no_shipping']['name']="No Shipping";
    $payment_option_details['value']['no_shipping']['admin_description']="Passing address from CMS to paypal: 0 - prompt for an address, but do not require one; 1 - do not prompt for an address; 2 - prompt for an address, and require one";
    $payment_option_details['value']['no_shipping']['value']="0";

    // get saved data for this payment option if it exists (saved data can then be used in $payment_option_form)
    if ($saved_payment_option_details=get_item_details('payment_option',$payment_option_details['id'])){
        if (function_exists('array_replace_recursive')){
            // php5.3.0 or higher
           $payment_option_details=array_replace_recursive($payment_option_details,$saved_payment_option_details);
        }
        else{
            // legacy code for pre php5.3.0
            $payment_option_details=$saved_payment_option_details;
        }
    }

    if (!isset($rvi_paynow) || !isset($payment_option_details['status']) || $payment_option_details['status']<1){return;}
    // ------------- paynow button code goes below here -------------

    $payment_option_form="<form action=\"https://www.paypal.com/cgi-bin/webscr\" method=\"post\">
    <input type=\"hidden\" name=\"cmd\" value=\"_xclick\">
    <input type=\"hidden\" name=\"business\" value=\"".$payment_option_details['value']['email']['value']."\">
    <input type=\"hidden\" name=\"item_name\" value=\"".cms_site_name." Order\">
    <input type=\"hidden\" name=\"item_number\" value=\"".$order->id."\">
    <input type=\"hidden\" name=\"amount\" value=\"".$order_total."\">
    <input type=\"hidden\" name=\"no_shipping\" value=\"".$payment_option_details['value']['no_shipping']['value']."\">";

    // IMPORTANT only output customer details to payment page if permitted ie. is owner, admin or is order made in same session
    if (canViewCustomerData($order)){
        if ($payment_option_details['value']['no_shipping']['value']!=1){
            if ($order->customer->delivery_addr->line1 || $order->customer->delivery_addr->line2!=""){
                // use address override or paypal will default to the address on the paypal account
                // note paypal seems to matchup with "CO Clare" but not "Clare" so prepend "CO " to county name TODO: igonre Dublin4 etc.
                $county = $order->customer->delivery_addr->county;
                if ($order->customer->delivery_addr->country=='Ireland' && strpos(strtolower($county),'dublin')!==true)
                    if (substr($county,0,3)!="Co ") $county="CO ".$county;

                $payment_option_form.="<input type=\"hidden\" name=\"address_override\" value=\"1\">
                <input type=\"hidden\" name=\"first_name\" value=\"".short_name($order->customer->delivery_addr->name)."\">
                <input type=\"hidden\" name=\"last_name\" value=\"".short_name($order->customer->delivery_addr->name,1)."\">
                <input type=\"hidden\" name=\"address1\" value=\"".$order->customer->delivery_addr->line1."\">
                <input type=\"hidden\" name=\"address2\" value=\"".$order->customer->delivery_addr->line2."\">
                <input type=\"hidden\" name=\"city\" value=\"".$order->customer->delivery_addr->city."\">
                <input type=\"hidden\" name=\"state\" value=\"".$county."\">
                <input type=\"hidden\" name=\"zip\" value=\"".$order->customer->delivery_addr->postcode."\">
                <input type=\"hidden\" name=\"country\" value=\"".country_name_to_code($order->customer->delivery_addr->country)."\">
                <input type=\"hidden\" name=\"email\" value=\"".$order->customer->email."\">";
            }
        }
    }

    $payment_option_form.="<input type=\"hidden\" name=\"return\" value=\"".cms_url."?thankyou=paypal\">
    <input type=\"hidden\" name=\"cancel_return\" value=\"".cms_url."?paynow=".$order->id."\">
    <input type=\"hidden\" name=\"no_note\" value=\"1\">
    <input type=\"hidden\" name=\"page_style\" value=\"".$payment_option_details['value']['page_style']['value']."\">
    <input type=\"hidden\" name=\"currency_code\" value=\"".$currency_code."\">
    <input type=\"hidden\" name=\"tax\" value=\"0\">
    <input type=\"hidden\" name=\"lc\" value=\"IE\">
    <input type=\"hidden\" name=\"bn\" value=\"PP-BuyNowBF\">";

    // load the button image locally or from PayPal
    //$payment_option_form.="<input type=\"image\" src=\"https://www.paypal.com/en_US/i/btn/btn_paynowCC_LG.gif\" border=\"0\" name=\"submit\" alt=\"PayPal - The safer, easier way to pay online!\">";
    $payment_option_form.="<input type=\"image\" src=\"".cms_root_url."includes/shop/payment_options/paypal/btn_paynowCC_LG.gif\" border=\"0\" name=\"submit\" alt=\"PayPal - The safer, easier way to pay online!\">";
    // comment out the PayPal tracking pixel - don't really need it
    //$payment_option_form.="<img alt=\"\" border=\"0\" src=\"https://www.sandbox.paypal.com/en_US/i/scr/pixel.gif\" width=\"1\" height=\"1\">";
    $payment_option_form.="</form>";


?>