<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    // paypal payment option
    // payment options must contain the folowing data
    $payment_option_details=array();
    $payment_option_details['item_type']='payment_option'; // required - do not change or remove this

    $payment_option_details['id']="paypalsubscription";  // required - each shipping option must have a unique id that matches the file name exactly minus the extension
    $payment_option_details['admin_name']="PayPal Annual Subscription";  // display name in admin area
    $payment_option_details['admin_description']="Accept annual recurring payments via PayPal."; // description displayed in admin
    $payment_option_details['name']="PayPal Subscription"; // display name in checkout/front end
    $payment_option_details['description']="Setup an annually recurring payment subscription with PayPal. Upon clicking the Pay Now button you will be redirected to a secure payment page provided by PayPal.<br /><br />Once payment is complete you can click on the &quot;<b>Return to Merchant</b>&quot; button to return to the website.";  // description displayed in checkout/front end

    // custom data specific to this payment option - can be modified in admin area
    $payment_option_details['value']['email']['name']='Email';
    $payment_option_details['value']['email']['admin_description']='Enter the email address for your PayPal account.';
    $payment_option_details['value']['email']['value']="";
    $payment_option_details['value']['page_style']['name']='Page Style';
    $payment_option_details['value']['page_style']['admin_description']='Use a particular page style on your PayPal payment page or leave blank for default.';
    $payment_option_details['value']['page_style']['value']="";

    // get saved data for this payment option if it exists
    if ($saved_payment_option_details=get_item_details('payment_option',$payment_option_details['id'])){
        if (function_exists('array_replace_recursive')){
            // php5.3.0 or higher
           $payment_option_details=array_replace_recursive($payment_option_details,$saved_payment_option_details);
        }
        else{
            // legacy code for pre php5.3.0
            $payment_option_details=$saved_payment_option_details;
        }
    }

    if (!isset($rvi_paynow) || !isset($payment_option_details['status']) || $payment_option_details['status']<1){return;}
    // ------------- paynow button code goes below here -------------

    // if there are non-subscription products in the order don't show this payment option
    if (isset($standard_product_count) && $standard_product_count>0){$payment_option_details['status']=0;return;}
    elseif (!isset($sub_product_count) || $sub_product_count<1){$payment_option_details['status']=0;return;}

    $payment_option_form="<form action=\"https://www.paypal.com/cgi-bin/webscr\" method=\"post\">
    <input type=\"hidden\" name=\"business\" value=\"".$payment_option_details['value']['email']['value']."\">
    <input type=\"hidden\" name=\"cmd\" value=\"_xclick-subscriptions\">
    <input type=\"hidden\" name=\"item_name\" value=\"".cms_site_name." Subscripiton Order\">
    <input type=\"hidden\" name=\"item_number\" value=\"".$order->id."\">
    <input type=\"hidden\" name=\"return\" value=\"".cms_url."?thankyou=paypal\">
    <input type=\"hidden\" name=\"cancel_return\" value=\"".cms_url."?paynow=".$order->id."\">";

    if ($payment_option_details['value']['page_style']['value']!=''){
        $payment_option_form.="<input type=\"hidden\" name=\"page_style\" value=\"".$payment_option_details['value']['page_style']['value']."\">";
    }

    $payment_option_form.="<!-- Set the terms of the regular subscription. -->
    <input type=\"hidden\" name=\"currency_code\" value=\"".$currency_code."\">
    <input type=\"hidden\" name=\"a3\" value=\"".$order_total."\">
    <input type=\"hidden\" name=\"p3\" value=\"1\">
    <input type=\"hidden\" name=\"t3\" value=\"Y\">

    <!-- Set recurring payments until canceled. -->
    <input type=\"hidden\" name=\"src\" value=\"1\">

    <input type=\"image\" src=\"https://www.paypalobjects.com/en_US/i/btn/btn_subscribeCC_LG.gif\" border=\"0\" name=\"submit\" alt=\"PayPal - The safer, easier way to pay online!\">
    <img alt=\"\" border=\"0\" src=\"https://www.paypalobjects.com/en_US/i/scr/pixel.gif\" width=\"1\" height=\"1\">
    </form>";


?>