<?php

$cron=1;
require("../../../../scripts/main.php");

require('paynow.php');


/*
Pay and Shop Limited (Realex Payments) - Licence Agreement.
© Copyright and zero Warranty Notice.


Merchants and their internet, call centre, and wireless application
developers (either in-house or externally appointed partners and
commercial organisations) may access Realex Payments technical
references, application programming interfaces (APIs) and other sample
code and software ("Programs") either free of charge from
www.realexpayments.com or by emailing info@realexpayments.com.

Realex Payments provides the programs "as is" without any warranty of
any kind, either expressed or implied, including, but not limited to,
the implied warranties of merchantability and fitness for a particular
purpose. The entire risk as to the quality and performance of the
programs is with the merchant and/or the application development
company involved. Should the programs prove defective, the merchant
and/or the application development company assumes the cost of all
necessary servicing, repair or correction.

Copyright remains with Realex Payments, and as such any copyright
notices in the code are not to be removed. The software is provided as
sample code to assist internet, wireless and call center application
development companies integrate with the payandshop.com service.

Any Programs licensed by Realex Payments to merchants or developers are
licensed on a non-exclusive basis solely for the purpose of availing
of the Realex Payments service in accordance with the
written instructions of an authorised representative ofRealex Payments.
Any other use is strictly prohibited.
--------------------------------------------------------------------
*/



/*
 Note:The below code is used to grab the fields Realex Payments POSTs back
 to this script after a card has been authorised. Realex Payments need
 to know the full URL of this script in order to POST the data back to this
 script. Please inform Realex Payments of this URL if they do not have it
 already.

 Look at the Realex Documentation to view all hidden fields Realex POSTs back
 for a card transaction.
*/


$timestamp = $_POST['TIMESTAMP'];
$result = $_POST['RESULT'];
$orderid = $_POST['ORDER_ID'];
$amount = $_POST['AMOUNT'];
$message = $_POST['MESSAGE'];
$authcode = $_POST['AUTHCODE'];
$pasref = $_POST['PASREF'];
if (isset($_POST['MD5HASH'])){$realexmd5 = $_POST['MD5HASH'];}
if (isset($_POST['SHA1HASH'])){$realexsha1 = $_POST['SHA1HASH'];}

//---------------------------------------------------------------
//Below is the code for creating the digital signature using the md5 algorithm.
//This digital siganture should correspond to the
//one Realex Payments POSTs back to this script and can therefore be used to verify the message Realex sends back.
$tmp = "$timestamp.".$payment_option_details['value']['realex_merchant_id']['value'].".$orderid.$result.$message.$pasref.$authcode";
if (isset($realexsha1)){
    $sha1hash = sha1($tmp);
    $tmp = $sha1hash.".".$payment_option_details['value']['realex_merchant_secret']['value'];
    $sha1hash = sha1($tmp);

    //Check to see if hashes match or not
    if ($sha1hash!=$realexsha1){echo "Warning: sha1 hash does not match - response cannot be authenticated";}
}
else{
    $md5hash = md5($tmp);
    $tmp = $md5hash.".".$payment_option_details['value']['realex_merchant_secret']['value'];
    $md5hash = md5($tmp);

    //Check to see if hashes match or not
    if ($md5hash!=$realexmd5){echo "Warning: md5 hash does not match - response cannot be authenticated";}
}

/* --------------------------------------------------------------
 send yourself an email or send the customer an email or update a database or whatever you want to do here.

 The next part is important to understand. The result field sent back to this
 response script will indicate whether the card transaction was successful or not.
 The result 00 indicates it was while anything else indicates it failed.
 Refer to the Realex Payments documentation to get a full list to response codes.


IMPORTANT: Whatever this response script prints is grabbed by Realex Payments
and placed in the template again. It is placed wherever the comment "<!--E-PAGE TABLE HERE-->"
is in the template you provide. This is the case so that from a customer's perspective, they are not suddenly removed from
a secure site to an unsecure site. This means that although we call this response script the
customer is still on Realex PAyemnt's site and therefore it is recommended that a HTML link is
printed in order to redirect the customrer back to the merchants site.
*/

if ($result=="00"){


	// load order details
	if ($order_details=get_item_details('order',$orderid)){

        // update order status to paid
        $order->status=1;
        $unique_identifier=time().rand(100,999);
        $order_details['payment'][$unique_identifier]['description']='Realex';
        $order_details['payment'][$unique_identifier]['note']="";
        $order_details['payment'][$unique_identifier]['date']=time();
        $order_details['payment'][$unique_identifier]['amount']=$amount/100;


       if (is_array($order_details['products'])){
    		foreach($order_details['products'] as $product_option_id => $product){
                // check if there are listings in the order and set them to active
                if (isset($product['listing_id'])){
                    if ($listing_details=get_item_details('listing',$product['listing_id'])){
                        if ($listing_details['status']!=1){
                            $listing_details['status']=1;
                            save_item_details($listing_details);
                            update_item_list_file('listings',array($listing_details['id']));
                        }
                    }
                }
    		}
	    }

        save_item_details($order_details);
        update_item_list_file('orders',array($order->id));

        update_item_log('user',$order->owner,"Payment made via Realex on order ".$order->id);

		require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

		// send email to customer
		$mail = new PHPMailer();

        // send mail via smtp if set in config file
        if (smtp_host){
            $mail->IsSMTP(); // send via SMTP
            $mail->SMTPAuth = true; // turn on SMTP authentication
            $mail->SMTPSecure = 'ssl';
            $mail->Username = smtp_username; // SMTP username
            $mail->Password = smtp_password; // SMTP password
            $mail->Host       = smtp_host; // SMTP server
            $mail->Port       = smtp_port; // SMTP server
        }

		$mail->From = $cmsSettings->config['site_email'];
		$mail->FromName = cms_site_name;
		$mail->AddAddress($order->customer->email);

		$mail->Subject = "Order: $orderid, Payment Received";
		$mail->Body    = "Hi ".short_name($order->customer->name).",\n\nThank you for your payment. Your order is now being processed.\n\n".cms_site_name."\n".cms_url;


		$mail->Send();

		// send email to shop owner
		$mail->ClearAddresses();
		$mail->From = $cmsSettings->config['site_email'];
		$mail->FromName = cms_site_name;
		$mail->AddAddress($cmsSettings->config['site_email']);

		$mail->Subject = "Order: $orderid, Payment Received";
		$mail->Body    = "A payment was made via Realex for order $orderid";


		$mail->Send();

	}

	echo "<h1>Thank you</h1><p>Your transaction has been completed and your order will be processed shortly. <a href=\"".cms_url."\">Click here</a> to return.</p>";

}
else{

    if ($orderid==""){echo "<p>There was an error processing your payment. <a href=\"".cms_url."\">Click here</a> to return.</p>";}
	else{echo "<p>There was an error processing your payment. <a href=\"".cms_url."?paynow=".$orderid."\">Click here</a> to return to the payment page.</p>";}

	/*
	NOTE: A link here should bring the customer back to a place where an new orderid is
	created so that they can try to use another card. It is important that a new orderid
	is created because if the same orderid is sent in a second time Realex Payments will
	reject it as a duplicate order even if the first transaction was declined.
	*/

}
?>