<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    // realex payment option
    // payment options must contain the folowing data
    $payment_option_details=array();
    $payment_option_details['item_type']='payment_option'; // required - do not change or remove this

    $payment_option_details['id']="realexepageredirect";  // required - each shipping option must have a unique id that matches the file name exactly minus the extension
    $payment_option_details['admin_name']="Realex Epage Redirect";  // display name in admin area
    $payment_option_details['admin_description']="Accept payments via Realex hosted payment page."; // description displayed in admin
    $payment_option_details['name']="Realex"; // display name in checkout/front end
    $payment_option_details['description']="All major Credit Cards accepted.<br /><br />Upon clicking the Pay Now button you will be redirected to a secure payment page provided by Realex Payments.";  // description displayed in checkout/front end

    // custom data specific to this payment option - can be modified in admin area
    $payment_option_details['value']['realex_merchant_id']['name']='Merchant ID';
    $payment_option_details['value']['realex_merchant_id']['admin_description']='Enter your merchant id.';
    $payment_option_details['value']['realex_merchant_id']['value']="";
    $payment_option_details['value']['realex_merchant_secret']['name']='Shared Secret';
    $payment_option_details['value']['realex_merchant_secret']['admin_description']='Enter your shared secret.';
    $payment_option_details['value']['realex_merchant_secret']['value']="";

    // get saved data for this payment option if it exists
    if ($saved_payment_option_details=get_item_details('payment_option',$payment_option_details['id'])){
        if (function_exists('array_replace_recursive')){
            // php5.3.0 or higher
           $payment_option_details=array_replace_recursive($payment_option_details,$saved_payment_option_details);
        }
        else{
            // legacy code for pre php5.3.0
            $payment_option_details=$saved_payment_option_details;
        }
    }

    if (!isset($rvi_paynow) || !isset($payment_option_details['status']) || $payment_option_details['status']<1){return;}
    // ------------- paynow button code goes below here -------------

    // set to 'sha1' or 'md5' realex recommends sha1 hash
    $hashtype='sha1';

    // The code below is used to create the timestamp format required by Realex Payments
    $realex_timestamp=strftime("%Y%m%d%H%M%S",time());
    $realex_order_amount=$order_total*100;

    $tmp = $realex_timestamp.".".$payment_option_details['value']['realex_merchant_id']['value'].".".$order->id.".".$realex_order_amount.".".currency_code;
    if ($hashtype=='sha1'){
        // sha1 hash
        $sha1hash = sha1($tmp);
        $tmp = $sha1hash.".".$payment_option_details['value']['realex_merchant_secret']['value'];
        $sha1hash = sha1($tmp);
    }
    else{
        // Create md5 hash
        $md5hash = md5($tmp);
        $tmp = $md5hash.".".$payment_option_details['value']['realex_merchant_secret']['value'];
        $md5hash = md5($tmp);
    }

    $payment_option_form="<form action=\"https://epage.payandshop.com/epage.cgi\" method=\"post\">
    <input type=\"hidden\" name=\"MERCHANT_ID\" value=\"".$payment_option_details['value']['realex_merchant_id']['value']."\">
    <input type=\"hidden\" name=\"ORDER_ID\" value=\"".$order->id."\">
    <input type=\"hidden\" name=\"AMOUNT\" value=\"".$realex_order_amount."\">
    <input type=\"hidden\" name=\"CURRENCY\" value=\"".$currency_code."\">
    <input type=\"hidden\" name=\"TIMESTAMP\" value=\"".$realex_timestamp."\">";

    if ($hashtype=='sha1'){$payment_option_form.="<input type=\"hidden\" name=\"SHA1HASH\" value=\"".$sha1hash."\">";}
    else{$payment_option_form.="<input type=\"hidden\" name=\"MD5HASH\" value=\"".$md5hash."\">";}

    $payment_option_form.="<input type=\"hidden\" name=\"AUTO_SETTLE_FLAG\" value=\"1\">
    <input type=\"image\" src=\"".cms_root_url."themes/default/images/shop/paynow_realex.png\" border=\"0\" name=\"submit\" alt=\"Realex - Secure Payments\">
    </form>";



?>