<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    // paypal payment option
    // payment options must contain the folowing data
    $payment_option_details=array();
    $payment_option_details['item_type']='payment_option'; // required - do not change or remove this

    $payment_option_details['id']="stripe";  // required - each shipping option must have a unique id that matches the file name exactly minus the extension
    $payment_option_details['admin_name']="Stripe";  // display name in admin area
    $payment_option_details['admin_description']="Accept payments via Stripe (PHP 5.6 or later)"; // description displayed in admin
    $payment_option_details['name']="Stripe"; // display name in checkout/front end
    $payment_option_details['description']="Enter you credit card details and Pay with Stripe";  // description displayed in checkout/front end

    // custom data specific to this payment option - can be modified in admin area
    $payment_option_details['value']['secret_key']['name']="Secret key";
    $payment_option_details['value']['secret_key']['admin_description']="Enter the Secret key for your Stripe account.";
    $payment_option_details['value']['secret_key']['value']="";
    $payment_option_details['value']['publishable_key']['name']="Publishable key";
    $payment_option_details['value']['publishable_key']['admin_description']="Enter the Publishable key for your Stripe account.";
    $payment_option_details['value']['publishable_key']['value']="";


    // get saved data for this payment option if it exists
    if ($saved_payment_option_details=get_item_details('payment_option',$payment_option_details['id'])){
        if (function_exists('array_replace_recursive')){
            // php5.3.0 or higher
           $payment_option_details=array_replace_recursive($payment_option_details,$saved_payment_option_details);
        }
        else{
            // legacy code for pre php5.3.0
            $payment_option_details=$saved_payment_option_details;
        }
    }

    if (!isset($rvi_paynow) || !isset($payment_option_details['status']) || $payment_option_details['status']<1){return;}
    // ------------- paynow button code goes below here -------------

    require_once('stripe-php-7.35.0/init.php');

    // Set your secret key. Remember to switch to your live secret key in production!
    // See your keys here: https://dashboard.stripe.com/account/apikeys
    \Stripe\Stripe::setApiKey($payment_option_details['value']['secret_key']['value']);


    $intent=\Stripe\PaymentIntent::create([
        'amount' => $order_total*100,
        'currency' => $currency_code,
        'payment_method_types' => ['card'],
        'receipt_email' => $order->customer->email,
        'description' => cms_site_name." order ".$order->id,
        // Verify your integration in this guide by including 'integration_check' => 'accept_a_payment'
        'metadata' => ['integration_check' => 'accept_a_payment', 'orderid' => strval($order->id)],
    ]);



    $page->meta.="<link rel=\"stylesheet\" href=\"".cms_root_url."includes/shop/payment_options/stripe/stripe-css/normalize.css\" />
    <link rel=\"stylesheet\" href=\"".cms_root_url."includes/shop/payment_options/stripe/stripe-css/global.css\" />
    <script src=\"https://js.stripe.com/v3/\"></script>
    <script>
    // Set your publishable key: remember to change this to your live publishable key in production
    // See your keys here: https://dashboard.stripe.com/account/apikeys
    var stripe = Stripe('".$payment_option_details['value']['publishable_key']['value']."');
    var elements = stripe.elements();
    </script>";

    $payment_option_form="<form id=\"payment-form\" class=\"sr-payment-form\">

    <div class=\"sr-combo-inputs-row\">
        <div class=\"sr-input sr-card-element\" id=\"card-element\"></div>
    </div>
    <div class=\"sr-field-error\" id=\"card-errors\" role=\"alert\"></div>

    <button id=\"submit\" class=\"cms_btn\">
        <div class=\"spinner hidden\" id=\"spinner\"></div>
        <span id=\"button-text\">Pay</span>
    </button>


</form>

<script>
// Set up Stripe.js and Elements to use in checkout form
var style = {
    base: {
        color: \"#32325d\",
    }
};

var card = elements.create(\"card\", { style: style });
card.mount(\"#card-element\");




var form = document.getElementById('payment-form');

var clientSecret =  '".$intent->client_secret."';

form.addEventListener('submit', function(ev) {
    ev.preventDefault();
    stripe.confirmCardPayment(clientSecret, {
        payment_method: {
            card: card,
            billing_details: {
                name: '".$order->customer->delivery_addr->name."'
            }
        }
    }).then(function(result) {
        if (result.error) {
            // Show error to your customer (e.g., insufficient funds)
            console.log(result.error.message);
        } else {
            // The payment has been processed!
            if (result.paymentIntent.status === 'succeeded') {
                // Show a success message to your customer
                // There's a risk of the customer closing the window before callback
                // execution. Set up a webhook or plugin to listen for the
                // payment_intent.succeeded event that handles any business critical
                // post-payment actions.
                window.location.replace(\"".cms_url."?thankyou=stripe\");
            }
        }
    });
});

</script>";


?>