<?php

$cron=1;
require("../../../../scripts/main.php");

require('paynow.php');

require_once('stripe-php-7.35.0/init.php');

// Set your secret key. Remember to switch to your live secret key in production!
// See your keys here: https://dashboard.stripe.com/account/apikeys
\Stripe\Stripe::setApiKey($payment_option_details['value']['secret_key']['value']);

$payload = @file_get_contents('php://input');
$event = null;

try {
    $event = \Stripe\Event::constructFrom(
        json_decode($payload, true)
    );
} catch(\UnexpectedValueException $e) {
    // Invalid payload
    http_response_code(400);
    exit();
}


// Handle the event
switch ($event->type) {
    case 'payment_intent.succeeded':
        $paymentIntent = $event->data->object; // contains a StripePaymentIntent
        handlePaymentIntentSucceeded($paymentIntent);
        break;
    case 'payment_method.attached':
        $paymentMethod = $event->data->object; // contains a StripePaymentMethod
        handlePaymentMethodAttached($paymentMethod);
        break;
    // ... handle other event types
    default:
        // Unexpected event type
        http_response_code(400);
        exit();
}

http_response_code(200);

function handlePaymentIntentSucceeded($paymentIntent){

    $amount_received=$paymentIntent -> amount_received;
    $orderid=$paymentIntent -> metadata -> orderid;

    // load order details
    $order = new Order();
    if ($order->getData($orderid)){

        // update order status to paid
        $order->status=1;
        $unique_identifier=CMS_INIT_TIME.rand(100,999);
        $order->payments[$unique_identifier]['description']="Stripe";
        $order->payments[$unique_identifier]['note']="";
        $order->payments[$unique_identifier]['date']=CMS_INIT_TIME;
        $order->payments[$unique_identifier]['amount']=$amount_received/100;

       if (!empty($order->products)){
    		foreach($order->products as $order_slot_id => $order_slot){
                // check if there are listings in the order and set them to active
                if (!empty($order_slot->listing_id)){
                    if ($listing_details=get_item_details('listing',$order_slot->listing_id)){
                        if ($listing_details['status']!=1){
                            $listing_details['status']=1;
                            save_item_details($listing_details);
                            update_item_list_file('listings',array($listing_details['id']));
                        }
                    }
                }
    		}
        }

        if ($order->saveItem())
            updateItemIndex('orders',array($order->id));

        update_item_log('user',$order->owner,"Payment made via Stripe on order ".$order->id);
       /*
        require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

        // send email to customer
        $mail = new PHPMailer();

        // send mail via smtp if set in config file
        if (smtp_host){
            $mail->IsSMTP(); // send via SMTP
            $mail->SMTPAuth = true; // turn on SMTP authentication
            $mail->SMTPSecure = 'ssl';
            $mail->Username = smtp_username; // SMTP username
            $mail->Password = smtp_password; // SMTP password
            $mail->Host       = smtp_host; // SMTP server
            $mail->Port       = smtp_port; // SMTP server
        }

        $mail->From = $cmsSettings->config['site_email'];
        $mail->FromName = cms_site_name;
        $mail->AddAddress($order->customer->email);  // get order owner->email instead of order->customer->email?

        $mail->Subject = "Order: $orderid, Payment Received";
        $mail->Body    = "Hi ".short_name($order->customer->name).",\n\nThank you for your payment. Your order is now being processed.\n\n".cms_site_name."\n".cms_url;


        $mail->Send();

        // send email to shop owner
        $mail->ClearAddresses();
        $mail->From = $cmsSettings->config['site_email'];
        $mail->FromName = cms_site_name;
        $mail->AddAddress($cmsSettings->config['site_email']);

        $mail->Subject = "Order: $orderid, Payment Received";
        $mail->Body    = "A payment was made via Stripe for order $orderid";


        $mail->Send();
       */
    }

}

function handlePaymentMethodAttached($paymentIntent){
    update_log("Stripe payment method attached");
}

?>