<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    // Note: worldnet won't work with an order id over 12 characters

    // worldnet payment option
    // payment options must contain the folowing data
    $payment_option_details=array();
    $payment_option_details['item_type']='payment_option'; // required - do not change or remove this

    $payment_option_details['id']="worldnettps";  // required - each shipping option must have a unique id that matches the file name exactly minus the extension
    $payment_option_details['admin_name']="WorldNet TPS";  // display name in admin area
    $payment_option_details['admin_description']="Accept payments via WorldNet TPS."; // description displayed in admin
    $payment_option_details['name']="WorldNet TPS"; // display name in checkout/front end
    $payment_option_details['description']="All major Credit Cards accepted accepted.";  // description displayed in checkout/front end

    // custom data specific to this payment option - can be modified in admin area
    $payment_option_details['value']['worldnet_terminal_id']['name']='Terminal ID';
    $payment_option_details['value']['worldnet_terminal_id']['admin_description']='Enter your terminal id.';
    $payment_option_details['value']['worldnet_terminal_id']['value']="";
    $payment_option_details['value']['worldnet_shared_secret']['name']='Shared Secret';
    $payment_option_details['value']['worldnet_shared_secret']['admin_description']='Enter your shared secret.';
    $payment_option_details['value']['worldnet_shared_secret']['value']="";

    // get saved data for this payment option if it exists
    if ($saved_payment_option_details=get_item_details('payment_option',$payment_option_details['id'])){
        if (function_exists('array_replace_recursive')){
            // php5.3.0 or higher
           $payment_option_details=array_replace_recursive($payment_option_details,$saved_payment_option_details);
        }
        else{
            // legacy code for pre php5.3.0
            $payment_option_details=$saved_payment_option_details;
        }
    }

    if (!isset($rvi_paynow) || !isset($payment_option_details['status']) || $payment_option_details['status']<1){return;}
    // ------------- paynow button code goes below here -------------

    // enter your worldnet details below
    define('RECEIPTPAGEURL',cms_url.'?thankyou=worldnet');
    define('VALIDATIONURL','');

    $datetime=date('d-m-Y:H:i:s:000',time());
    $hash=md5($payment_option_details['value']['worldnet_terminal_id']['value'].$order->id.$order_total.$datetime.RECEIPTPAGEURL.VALIDATIONURL.$payment_option_details['value']['worldnet_shared_secret']['value']);

    $payment_option_form="<form action=\"https://payments.worldnettps.com/merchant/paymentpage\" method=\"post\">
    <input type=\"hidden\" name=\"TERMINALID\" value=\"".$payment_option_details['value']['worldnet_terminal_id']['value']."\" />
    <input type=\"hidden\" name=\"ORDERID\" value=\"".$order->id."\" />
    <input type=\"hidden\" name=\"CURRENCY\" value=\"".$currency_code."\" />
    <input type=\"hidden\" name=\"AMOUNT\" value=\"".$order_total."\" />
    <input type=\"hidden\" name=\"DATETIME\" value=\"".$datetime."\" />
    <input type=\"hidden\" name=\"RECEIPTPAGEURL\" value=\"".RECEIPTPAGEURL."\" />
    <input type=\"hidden\" name=\"HASH\" value=\"".$hash."\" />
    <input type=\"submit\" value=\"Pay Now\" />
    </form>";


?>