<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit;
                             
    $page->title="Order Payment";
    $page->meta_title=cms_site_name." - ".$page->title;
    $page->template=$cmsSettings->checkout['template_paynow'];

    $order = new Order();
	if (!empty($rvi_paynow)) $order->getData($rvi_paynow);

    if (!$order->isLoaded() && empty($rvi_amount)){
        include(cms_root_dir.'includes/page_not_found.php');
        return;
    }

    if (!empty($order->currency_code)){
        $currency_code=$order->getCurrencyCode();
        $currency_symbol=get_currency_symbol($currency_code);
    }
    else{
        $currency_code=currency_code;
        $currency_symbol=currency_symbol;
    }

    $order_total=0;
    /*
    if ($cmsSettings->b2b>0){
        foreach($order_details['products'] as $product_option_id => $product){
            $order_total=$order_total+(($order_details['products'][$product_option_id]['price']+(($order_details['products'][$product_option_id]['price']/100)*$order_details['products'][$product_option_id]['tax_rate']))*$order_details['products'][$product_option_id]['qty']);
        }
        $order_total=$order_total+$order_details['shipping_total']-$order_details['discount'];
    }
    else{$order_total=$order_details['shipping_total']+$order_details['order_subtotal']-$order_details['discount'];}
    */
    if (isset($rvi_amount)){
        $order_total=unformatnum($rvi_amount);
    }
    elseif(isset($rvi_deposit) && !empty($order->deposit)){
        $pay_deposit=1;
        $order_total=$order->deposit;
        $order_total=round($order_total,2);
    }
    else{
        $order_total=$order->getBalance();
        $order_total=round($order_total,2);
    }

    if ($order_total<=0){
        $page_content['main'].="<div class=\"cms-content\"><h1>Order</h1><p>Order #: ".$order->id."</p><p>Please allow 24hrs for order to be processed.</p></div>";
        return;
    }

    // move these into product options
    $standard_product_count=$order->hasNonSubscriptionProducts();
    $sub_product_count=$order->hasSubscriptionProducts();


    $payment_options="";

    // by default payment page is public but if any payment option requires customer to be logged in it will put the payment page behind login
    // TODO: deal with no order but amount in url query, no customer data/email can lead to error eg. stripe
    $paynow_login_required=0;

    // get payment options  (use get items here instead?)
    $dir=cms_root_dir.'includes/shop/payment_options';
    if ($handle=opendir($dir)){
      while (false!==($file=readdir($handle))){
          if (substr($file,0,1)!='.' && substr($file,0,1)!='_' && is_dir($dir.'/'.$file)){
                $paynow_fn=$dir.'/'.$file.'/paynow.php';
                if (file_exists($paynow_fn)){
                    $payment_option_details=array();
                    include($paynow_fn);
                    if (empty($payment_option_details)){continue;}
                    // don't show payment option if it's disabled
                    if (!empty($payment_option_details['status'])){
                        // only show payment option if it is enabled or in testmode and main admin user
                        if ($payment_option_details['status']==1 || admin_level()>9){
                            $payment_options.="<div class=\"payment_option\"><div class=\"payment_option_desc\"><h3 class=\"payment_option_heading\">".$payment_option_details['name']."</h3><p>".$payment_option_details['description']."</p></div><div class=\"payment_option_action\">".$payment_option_form."</div></div><hr />";
                        }
                    }
                }
          }
      }
    }

    $page_content['main'].="<div class=\"cms-content\">";

    // display warnings
    if (isset($_SESSION[cms_key]['form']['paynow']['warning_green'])) $page_content['main'].=display_warnings($_SESSION[cms_key]['form']['paynow']['warning_green'],'green');


	if ($order_total>0){

		// show order sumary
		$page_content['main'].="<h1>Order Payment</h1><p>Order #: ".$order->id."<br>".(isset($pay_deposit) ? "Deposit " : "")."Amount: <b>".formatPrice($order_total,false,$currency_symbol)."</b></p>";

        if ($order->isLoaded() && !isset($_SESSION[cms_key]['reg_user']) && $order->status<3 && $order->owner)
            $page_content['main'].="<p><a href=\"".cms_url."?login\">Login</a> to view your order.</p>";


        // display payment options if unpaid
        if ($order->status==0 || $order->status>3){

			$page_content['main'].="<h2>Payment Options</h2><p>";

            // load payment_page_text
            $payment_page_text_fn=sys_data_dir.'/settings/payment_page_text.html';
            if (file_exists($payment_page_text_fn)) $page_content['main'].=file_get_contents($payment_page_text_fn);

            if ($payment_options) $page_content['main'].="<div class=\"payment_options\">".$payment_options."</div>";

		}
		elseif ($order->status==1 || $order->status==2) $page_content['main'].="This order has been paid.";
        elseif ($order->status==3) $page_content['main'].="This order has been cancelled.";



	}

    $page_content['main'].="</div>";

?>
