<?php

    // ini_set("memory_limit","100M");
	// ini_set("max_execution_time","3600");
        
	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit;

    if (user_level('products')<1){
        $page_content['main'].="<div class=\"cms-content\"><h3>Access Restricted</h3><p>You do not have the required user permissions to view this page.</p></div>";
        return;
    }

    $product = new Product();
	if (!$product->getData($rvi_product)){include(cms_root_dir.'includes/page_not_found.php');return;}

    // use $breadcrumb_str in content template or use {cms-breadcrumbs} in page template
    $breadcrumb_str="";
    $breadcrumbs=breadcrumbs($product);
    include(theme_file_fn('includes/cms/breadcrumbs.php',display_theme)); // wrap breadcumbs or add extra styling (sounds like a recipe :))in theme include file

    $page->url=$product->getURL();

    $page->template=$product->getTemplate();

    if ($product->status > 1){include(cms_root_dir.'includes/page_not_found.php');return;}

    // check user access to product
    /*
    if (!$product->canAccess()){
     $page_content['main'].="<div class=\"cms-content\"><h3>Access Restricted</h3><p>You do not have the required user permissions to view this page.</p></div>";
        return;
    }
    */

    if ($product->user_group && admin_level('products')<1){
        $access_granted=false;
        foreach ($product->user_group as $user_group_id){
            if ($user_group_id==0){$access_granted=true;break;}
            if ($user_group_id==1 && isset($_SESSION[cms_key]['reg_user'])){$access_granted=true;break;}
            if ($user_group_id==2 && admin_level()>0){$access_granted=true;break;}
            if (isset($_SESSION[cms_key]['reg_user']->user_group)){
                foreach($_SESSION[cms_key]['reg_user']->user_group as $customer_user_group){
                    if ($customer_user_group==$user_group_id){$access_granted=true;break;}
                }
                if ($access_granted) break;
            }
        }
        if (!$access_granted){
            $page_content['main'].="<div class=\"cms-content\"><h3>Access Restricted</h3><p>You do not have the required user permissions to view this page.</p></div>";
            return;
        }
    }

    // ensure links in content are using the active cms_protocol http:// or https://
    // might want to put this into cache
    if (cms_protocol=='https://'){
        foreach ($product->content as $content_area_name => $value){
            $product->content[$content_area_name]=str_replace('http://'.strip_url_protocol(cms_root_url),cms_root_url,$value);
            $product->content[$content_area_name]=str_replace('http://'.strip_url_protocol(cms_url),cms_url,$value);
        }
    }
    else{
        foreach ($product->content as $content_area_name => $value){
            $product->content[$content_area_name]=str_replace('https://'.strip_url_protocol(cms_root_url),cms_root_url,$value);
            $product->content[$content_area_name]=str_replace('https://'.strip_url_protocol(cms_url),cms_url,$value);
        }
    }

    $page_content=$product->content;
    $page_content['main']="";

    // output product detail
    $page->title=htmlentities($product->name,ENT_COMPAT,'UTF-8');
    $page->meta_title=$page->title;

    // cached product page content
    // not worth caching product detail page unless there are alot of custom lookups  - is it worthwhile ?

    $no_cache=1;
    if (cache_enabled>0 && $no_cache<1 && admin_level()>9){
        if (strpos($product->content['main'],'{cms-contact-form}')!==false){$no_cache=1;}
        else{
        	// cache key
        	$cache_key=serialize($product).display_type;
        	$cache_key=$product->id.'_'.md5($cache_key);
        	$cache_fn=sys_cache_dir.'/products/'.$cache_key.".cache";

        	// return cached content if it exists for faster page load
        	if (file_exists($cache_fn)){
                $cached_content=explode('|cache|',file_get_contents($cache_fn));
        		$page_content['main'].=$cached_content[0];
                $page->meta.=$cached_content[1];
                $page->body_end.=$cached_content[2];
        		return;
        	}
        }
    }

    // page meta tags
    $page->meta.="<link rel=\"canonical\" href=\"".$page->url."\" />";
    if ($product->short_description)
        $page->meta.="<meta name=\"description\" content=\"".htmlentities($product->short_description,ENT_COMPAT,'UTF-8')."\" />";
    if ($product->keywords)
        $page->meta.="<meta name=\"keywords\" content=\"".htmlentities($product->keywords,ENT_COMPAT,'UTF-8')."\" />";

    // format display price
    $display_price=$product->displayPrice();

    // output product options if there are any
    $product_options='';
    if (isset($product->option)){

    $product_options.="<div style=\"margin: 5px 0\">";
    foreach ($product->option as $option_name => $value){

            if (count($value)==1 && key($value)==''){
              $product_options.="<div class=\"form_row\"><label for=\"opt_".$option_name."\">".$option_name.":</label><input type=\"text\" id=\"opt_".$option_name."\" name=\"product_option[".$option_name."]\" value=\"\" /></div>";
            }
            else{
                $option_content='';
    		foreach ($value as $value_name => $value2){
                    if ($value_name==''){continue;}
    			$display_value=$value_name;

                 // displaying price modifiers beside the value
                    if  ($value2['price_mod_value']>0){
                        if ($value2['price_mod']==0)
                            $display_value=$value_name." ( + ".formatPrice($value2['price_mod_value'],true)." )";
                        elseif($value2['price_mod']==1)
                          $display_value=$value_name." ( - ".formatPrice($value2['price_mod_value'],true)." )";
                        elseif($value2['price_mod']==2){
                            if ($cmsSettings->b2b)
                                $amount=($product->getPrice(false,true)*$value2['price_mod_value'])/100;
                            else
                                $amount=($product->getPrice(true,true)*$value2['price_mod_value'])/100;

                            if ($value2['price_mod_value']>100)
                                $display_value=$value_name." ( + ".formatPrice($amount,true)." )";
                            else
                                $display_value=$value_name." ( - ".formatPrice($amount,true)." )";
                        }
                    }
                    if (!empty($rvi_product_option[$option_name]) && $rvi_product_option[$option_name]==$value_name)
    			    $option_content.='<option value="'.$value_name.'" selected>'.$display_value.'</option>';
                    else
                        $option_content.='<option value="'.$value_name.'">'.$display_value.'</option>';
    		}
                if (strlen($option_content)>1){
    	    	$product_options.="<div class=\"form_row\"><label for=\"opt_".$option_name."\">".$option_name.":</label><select class=\"product_option\" id=\"opt_".$option_name."\" name=\"product_option[".$option_name."]\">".$option_content."</select></div>";
                }
            }

    }
    $product_options.="</div>";
    }

    if (!empty($product->booking_slot)){
        if (empty($product->booking_end_date) || $product->booking_end_date>CMS_INIT_TIME){

            $booking_time_slots=get_booking_slots($product);

        }
    }

    // enquiry form
    $product_enquiry_form="";
    if ($product->enquiry_form_enabled) include(theme_file_fn('includes/cms/shop/product_enquiry_form.php',display_theme));

    // display related products
    $related_products="";
    if (!empty($product->related_product)) $related_products=displayCategory('2',1,null,$product->related_product);

    if (substr($product->behaviour,0,8)=='Listing '){

        // product option fields should be output within the listing submission form and not here
        // product content and display price should also be output within the listing file for more flexibilty
        //if ($display_price!=''){$page_content['main'].='<div class="product_price">'.$display_price.'</div>';}
        //if (!empty($product->content['main'])){$page_content['main'].="<div class=\"product_description\">".$product->content['main']."</div>";}

        $page_content['main'].="<div class=\"cms-content cms-product-page\">";

        $add_listing_fn=cms_theme_dir.'/includes/cms/user/listings/'.substr($product->behaviour,8).'_listing_add.php';
        if (file_exists($add_listing_fn))
            include($add_listing_fn);
        else
            $page_content['main'].="Error: File not found";

        $page_content['main'].="</div>";
    }
    elseif(substr($product->behaviour,0,11)=='Application'){

        // product option fields should be output within the appliation submission form and not here
        // product content and display price should also be output within the application file for more flexibilty
        //if ($display_price!=''){$page_content['main'].='<div class="product_price">'.$display_price.'</div>';}
        //if (!empty($product->content['main'])){$page_content['main'].="<div class=\"product_description\">".$product->content['main']."</div>";}

        $add_application_fn=cms_theme_dir.'/includes/cms/user/applications/application_add_'.substr($product->behaviour,12).'.php';
        if (file_exists($add_application_fn)){include($add_application_fn);}
        else{$page_content['main'].='Error: File not found';}
    }
    else{

        // include content template
        include($product->get_ctemplate_fn());

        // add to recently viewed items
        if (empty($_SESSION[cms_key]['recently_viewed_products'][$rvi_product]))
            $_SESSION[cms_key]['recently_viewed_products'][$rvi_product]['priority']=1;
        else
            $_SESSION[cms_key]['recently_viewed_products'][$rvi_product]['priority']++;

    }

    // save cached page content
    // caching product page not worthwhile ?
    /*
    if (cache_enabled>0 && $no_cache<1){
        $fo=fopen($cache_fn,'w');
        fwrite($fo,$page_content['main']."|cache|".$page->meta."|cache|".$page->body_end);
        fclose($fo);
    }
    */




?>
