<?php

// exit if php file is loaded directly and not included
if (!defined("cms_version_number")){exit();}
              
// flat rate shipping option - apply a simple flat rate for shipping to all orders

$shipping_option_details['id']="by_spend";  // required - each shipping option must have a unique id that matches the file name exactly minus the extension
$shipping_option_details['admin_name']="By Spend";  // display name in admin area
$shipping_option_details['admin_description']="Delivery charges based on amount spent."; // description displayed in admin
$shipping_option_details['name']="Standard Delivery"; // display name in checkout/front end
$shipping_option_details['description']="Standard delivery charge.";  // description displayed in checkout/front end

// custom data specific to this shipping option
$shipping_option_details['value']['min_charge']['name']='Minimum Charge';
$shipping_option_details['value']['min_charge']['admin_description']='Minimum delivery charge.';
$shipping_option_details['value']['min_charge']['type']='num'; // txt or num
$shipping_option_details['value']['min_charge']['value']=15.0;
$shipping_option_details['value']['spend_1']['name']='Spend 1';
$shipping_option_details['value']['spend_1']['admin_description']='Amount spent on order.';
$shipping_option_details['value']['spend_1']['type']='num'; // txt or num
$shipping_option_details['value']['spend_1']['value']=500.0; // applied if order amount is > this
$shipping_option_details['value']['charge_1']['name']='Charge 1';
$shipping_option_details['value']['charge_1']['admin_description']='Delivery charge applied if order amount is > corresponding spend';
$shipping_option_details['value']['charge_1']['type']='num'; // txt or num
$shipping_option_details['value']['charge_1']['value']=65.0; // applied if order amount is > corresponding spend
$shipping_option_details['value']['spend_2']['name']='Spend 2';
$shipping_option_details['value']['spend_2']['admin_description']='Amount spent on order. (must be greater than previous spend value)';
$shipping_option_details['value']['spend_2']['type']='num'; // txt or num
$shipping_option_details['value']['spend_2']['value']=2500.0; // applied if order amount is > this
$shipping_option_details['value']['charge_2']['name']='Charge 2';
$shipping_option_details['value']['charge_2']['admin_description']='Delivery charge applied if order amount is > corresponding spend';
$shipping_option_details['value']['charge_2']['type']='num'; // txt or num
$shipping_option_details['value']['charge_2']['value']=130.0; // applied if order amount is > corresponding spend
$shipping_option_details['value']['spend_3']['name']='Spend 3';
$shipping_option_details['value']['spend_3']['admin_description']='Amount spent on order. (must be greater than previous spend value)';
$shipping_option_details['value']['spend_3']['type']='num'; // txt or num
$shipping_option_details['value']['spend_3']['value']=5000.0; // applied if order amount is > this
$shipping_option_details['value']['charge_3']['name']='Charge 3';
$shipping_option_details['value']['charge_3']['admin_description']='Delivery charge applied if order amount is > corresponding spend';
$shipping_option_details['value']['charge_3']['type']='num'; // txt or num
$shipping_option_details['value']['charge_3']['value']=195.0; // applied if order amount is > corresponding spend
$shipping_option_details['value']['free_shipping']['name']='Free Shipping';
$shipping_option_details['value']['free_shipping']['admin_description']='Orders greater than or equal to this amount will have free shipping.';
$shipping_option_details['value']['free_shipping']['type']='num'; // txt or num
$shipping_option_details['value']['free_shipping']['value']=999999; // free shipping if order above this value

// get saved data for this shipping option if it exists
if ($saved_shipping_option_details=get_item_details('shipping_option',$shipping_option_details['id'])){
    if (function_exists('array_replace_recursive')){
        // php5.3.0 or higher
       $shipping_option_details=array_replace_recursive($shipping_option_details,$saved_shipping_option_details);
    }
    else{
        // legacy code for pre php5.3.0
        $shipping_option_details=$saved_shipping_option_details;
    }
}

// code after this line is for front end only
if (cms_interface!="front") return;

// custom form fields or text for this shipping option can be added to shipping_option_form string
$shipping_option_details['form']="";

// code after this line is for front end calculation of shipping only
if (!isset($calc_shipping)) return;
// this is where the shipping total is calculated
$spend_amount=$_SESSION[cms_key]['cart']->getSubTotal(true);
if ($spend_amount > $shipping_option_details['value']['free_shipping']['value'])
    $shipping_total=0;
else{

    $shipping_total=$shipping_option_details['value']['min_charge']['value']; // apply minimum charge

    // apply charge if spend is greater than set values
    if ($spend_amount > $shipping_option_details['value']['spend_3']['value']) $shipping_total=$shipping_option_details['value']['charge_3']['value'];
    elseif ($spend_amount > $shipping_option_details['value']['spend_2']['value']) $shipping_total=$shipping_option_details['value']['charge_2']['value'];
    elseif ($spend_amount > $shipping_option_details['value']['spend_1']['value']) $shipping_total=$shipping_option_details['value']['charge_1']['value'];

}


?>
