<?php

// exit if php file is loaded directly and not included
if (!defined("cms_version_number")) exit;

// flat rate shipping option - apply a simple flat rate for shipping to all orders

$shipping_option_details['id']="flat_rate";  // required - each shipping option must have a unique id that matches the file name exactly minus the extension
$shipping_option_details['admin_name']="Flat Rate";  // display name in admin area
$shipping_option_details['admin_description']="Applies a flat rate shipping amount to the order regardless of product quantities and weights."; // description displayed in admin
$shipping_option_details['name']="Flat Rate"; // display name in checkout/front end
$shipping_option_details['description']="Flat rate delivery charge.";  // description displayed in checkout/front end

// custom data specific to this shipping option
$shipping_option_details['value']['flat_rate']=array(
    'name' => 'Flat Rate',
    'admin_description' => 'Specify flat rate price of shipping.',
    'type' => 'num', // txt or num
    'value' => 7.0 // flat rate shipping price
);
$shipping_option_details['value']['free_shipping']=array(
    'name' => 'Free Shipping',
    'admin_description' => 'Orders greater than or equal to this amount will have free shipping.',
    'type' => 'num', // txt or num
    'value' => 999999 // free shipping if order above this value
);

// get saved data for this shipping option if it exists
if ($saved_shipping_option_details=get_item_details('shipping_option',$shipping_option_details['id'])){
    if (function_exists('array_replace_recursive')){
        // php5.3.0 or higher
       $shipping_option_details=array_replace_recursive($shipping_option_details,$saved_shipping_option_details);
    }
    else{
        // legacy code for pre php5.3.0
        $shipping_option_details=$saved_shipping_option_details;
    }
}

// code after this line is for front end only
if (cms_interface!="front") return;

// custom form fields or text for this shipping option can be added to shipping_option_form string
$shipping_option_details['form']="";

// code after this line is for front end calculation of shipping only
if (!isset($calc_shipping)) return;
// this is where the shipping total is calculated
if ($_SESSION[cms_key]['cart']->getSubTotal() > $shipping_option_details['value']['free_shipping']['value'])
    $shipping_total=0;
else
    $shipping_total=$shipping_option_details['value']['flat_rate']['value'];


?>
