<?php

// calculates shipping based on number of parcels required - use product weight to specify how many parcels a product takes
// shipping options must contain the folowing data
$shipping_option_details=array();
$shipping_option_details['item_type']='shipping_option'; // required - do not change or remove this

$shipping_option_details['id']="parcel_qty";  // required - each shipping option must have a unique id that matches the file name exactly minus the extension
$shipping_option_details['admin_name']="Parcel Qty"; // display name in admin area
$shipping_option_details['admin_description']="Calculates shipping based on number of parcels required - use product weight to specify how many parcels a product takes"; // description displayed in admin
$shipping_option_details['name']="Parcel Qty"; // display name in checkout/front end
$shipping_option_details['description']="Shipping based on number of parcels required."; // description displayed in checkout/front end

// custom data specific to this shipping option
$shipping_option_details['value']['parcel_value']['name']='Parcel Value';
$shipping_option_details['value']['parcel_value']['admin_description']='Specify price of one parcel.';
$shipping_option_details['value']['parcel_value']['type']='num'; // txt or num
$shipping_option_details['value']['parcel_value']['value']=7.0; // price of one parcel
$shipping_option_details['value']['free_shipping']['name']='Free Shipping';
$shipping_option_details['value']['free_shipping']['admin_description']='Orders less than or equal to this amount will have free shipping.';
$shipping_option_details['value']['free_shipping']['type']='num'; // txt or num
$shipping_option_details['value']['free_shipping']['value']=250; // free shipping if order above this value

// get saved data for this shipping option if it exists
if ($saved_shipping_option_details=get_item_details('shipping_option',$shipping_option_details['id'])){
    if (function_exists('array_replace_recursive')){
        // php5.3.0 or higher
       $shipping_option_details=array_replace_recursive($shipping_option_details,$saved_shipping_option_details);
    }
    else{
        // legacy code for pre php5.3.0
        $shipping_option_details=$saved_shipping_option_details;
    }
}

// code after this line is for front end only
if (cms_interface!="front"){return;}

// custom form fields or text for this shipping option can be added to shipping_option_form string
$shipping_option_details['form']="";

if (!isset($calc_shipping)){return;}
// this is where the shipping total is calculated
$shipping_total=0;
if ($_SESSION[cms_key]['cart']->getSubTotal()<=$shipping_option_details['value']['free_shipping']['value']){

    foreach($_SESSION[cms_key]['cart']->products as $product_option_id => $product){
        $parcel_qty=$product['weight']*$product['order_qty']; // update to use ->attr['weight']
    }
    if ($parcel_qty>1){

        $shipping_total=ceil($parcel_qty)*$shipping_option_details['value']['parcel_value']['value'];
    }
    else {$shipping_total=$shipping_option_details['value']['parcel_value']['value'];}

}


?>