<?php

// calculates shipping based on the total order weight
// shipping options must contain the folowing data
$shipping_option_details=array();
$shipping_option_details['item_type']='shipping_option'; // required - do not change or remove this

$shipping_option_details['id']="weight_range";  // required - each shipping option must have a unique id that matches the file name exactly minus the extension
$shipping_option_details['admin_name']="By Weight Range"; // display name in admin area
$shipping_option_details['admin_description']="Calculates shipping based on the total weight of the order."; // description displayed in admin
$shipping_option_details['name']="Shipping"; // display name in checkout/front end
$shipping_option_details['description']="Shipping based on your order weight."; // description displayed in checkout/front end

// custom data specific to this shipping option
$shipping_option_details['value']['weight1_rate']['name']='Weight1 Rate ';
$shipping_option_details['value']['weight1_rate']['admin_description']='Enter the shipping rate for orders that weigh >= 0.';
$shipping_option_details['value']['weight1_rate']['type']='num'; // txt or num
$shipping_option_details['value']['weight1_rate']['value']=9.83;

$shipping_option_details['value']['weight2']['name']='Weight2';
$shipping_option_details['value']['weight2']['admin_description']='Enter an additional weight value or 0 to disregard.';
$shipping_option_details['value']['weight2']['type']='num'; // txt or num
$shipping_option_details['value']['weight2']['value']=2;
$shipping_option_details['value']['weight2_rate']['name']='Weight2 Rate ';
$shipping_option_details['value']['weight2_rate']['admin_description']='Enter the shipping rate for orders that weigh >= Weight2.';
$shipping_option_details['value']['weight2_rate']['type']='num'; // txt or num
$shipping_option_details['value']['weight2_rate']['value']=11.42;

$shipping_option_details['value']['weight3']['name']='Weight3';
$shipping_option_details['value']['weight3']['admin_description']='Enter an additional weight value or 0 to disregard.';
$shipping_option_details['value']['weight3']['type']='num'; // txt or num
$shipping_option_details['value']['weight3']['value']=4;
$shipping_option_details['value']['weight3_rate']['name']='Weight3 Rate ';
$shipping_option_details['value']['weight3_rate']['admin_description']='Enter the shipping rate for orders that weigh >= Weight3.';
$shipping_option_details['value']['weight3_rate']['type']='num'; // txt or num
$shipping_option_details['value']['weight3_rate']['value']=14.48;

$shipping_option_details['value']['weight4']['name']='Weight4';
$shipping_option_details['value']['weight4']['admin_description']='Enter an additional weight value or 0 to disregard.';
$shipping_option_details['value']['weight4']['type']='num'; // txt or num
$shipping_option_details['value']['weight4']['value']=8;
$shipping_option_details['value']['weight4_rate']['name']='Weight4 Rate ';
$shipping_option_details['value']['weight4_rate']['admin_description']='Enter the shipping rate for orders that weigh >= Weight4.';
$shipping_option_details['value']['weight4_rate']['type']='num'; // txt or num
$shipping_option_details['value']['weight4_rate']['value']=16;

$shipping_option_details['value']['free_shipping']=array(
'name' => 'Free Shipping',
'admin_description' => 'Orders greater than or equal to this amount will have free shipping.',
'type' => 'num', // txt or num
'value' => 250 // free shipping if order above this value
);

// get saved data for this shipping option if it exists
if ($saved_shipping_option_details=get_item_details('shipping_option',$shipping_option_details['id'])){
    if (function_exists('array_replace_recursive')){
        // php5.3.0 or higher
       $shipping_option_details=array_replace_recursive($shipping_option_details,$saved_shipping_option_details);
    }
    else{
        // legacy code for pre php5.3.0
        $shipping_option_details=$saved_shipping_option_details;
    }
}

// code after this line is for front end only
if (cms_interface!="front") return;

// custom form fields or text for this shipping option can be added to shipping_option_form string
$shipping_option_details['form']="";

if (!isset($calc_shipping)){return;}
// this is where the shipping total is calculated
$shipping_total=0;
if ($_SESSION[cms_key]['cart']->getSubTotal()<=$shipping_option_details['value']['free_shipping']['value']){

    $order_weight=0;
    // calculate the total weight of order
    foreach($_SESSION[cms_key]['cart']->products as $product_option_id => $product){
        $order_weight=$order_weight+($product['weight']*$product['order_qty']); // update to use ->attr['weight']
    }

    // check which shipping rate to apply
    if ($shipping_option_details['value']['weight4']['value']!=0 && $order_weight>=$shipping_option_details['value']['weight4']['value']){
        $shipping_total=$shipping_option_details['value']['weight4_rate']['value'];
    }
    elseif ($shipping_option_details['value']['weight3']['value']!=0 && $order_weight>=$shipping_option_details['value']['weight3']['value']){
        $shipping_total=$shipping_option_details['value']['weight3_rate']['value'];
    }
    elseif ($shipping_option_details['value']['weight2']['value']!=0 && $order_weight>=$shipping_option_details['value']['weight2']['value']){
        $shipping_total=$shipping_option_details['value']['weight2_rate']['value'];
    }
    else {$shipping_total=$shipping_option_details['value']['weight1_rate']['value'];}

}


?>