<?php

// weigtht and postode zonal shipping option - apply a shipping rate based on the order weight and the customers delivery postcode
// shipping options must contain the folowing data
$shipping_option_details=array();
$shipping_option_details['item_type']='shipping_option'; // required - do not change or remove this

$shipping_option_details['id']="weight_zones_by_postcode";  // required - each shipping option must have a unique id that matches the shipping option folder name exactly
$shipping_option_details['admin_name']="Weight Zonal Rates by Postcode";  // display name in admin area
$shipping_option_details['admin_description']="Applies a shipping amount based on the order weight and the customers delivery postcode."; // description displayed in admin
$shipping_option_details['name']="Shipping"; // display name in checkout/front end
$shipping_option_details['description']="Standard Shipping";  // description displayed in checkout/front end

// custom data specific to this shipping option
$shipping_option_details['value']['zone1_postcodes']['name']='Zone 1 Postcodes ';
$shipping_option_details['value']['zone1_postcodes']['admin_description']='Comma seperate postcodes for Zone 1 Rate.';
$shipping_option_details['value']['zone1_postcodes']['value']=""; // flat rate shipping price
$shipping_option_details['value']['zone1_rate']['name']='Zone 1 Rate ';
$shipping_option_details['value']['zone1_rate']['admin_description']='Enter the shipping rate per unit of weight for postcodes listed in Zone 1.';
$shipping_option_details['value']['zone1_rate']['value']=0.0; // flat rate shipping price

$shipping_option_details['value']['zone2_postcodes']['name']='Zone 2 Postcodes ';
$shipping_option_details['value']['zone2_postcodes']['admin_description']='Comma seperate postcodes for Zone 2 Rate.';
$shipping_option_details['value']['zone2_postcodes']['value']=""; // flat rate shipping price
$shipping_option_details['value']['zone2_rate']['name']='Zone 2 Rate ';
$shipping_option_details['value']['zone2_rate']['admin_description']='Enter the shipping rate per unit of weight for postcodes listed in Zone 2.';
$shipping_option_details['value']['zone2_rate']['value']=0.0; // flat rate shipping price

$shipping_option_details['value']['zone3_postcodes']['name']='Zone 3 Postcodes ';
$shipping_option_details['value']['zone3_postcodes']['admin_description']='Comma seperate postcodes for Zone 3 Rate.';
$shipping_option_details['value']['zone3_postcodes']['value']=""; // flat rate shipping price
$shipping_option_details['value']['zone3_rate']['name']='Zone 3 Rate ';
$shipping_option_details['value']['zone3_rate']['admin_description']='Enter the shipping rate per unit of weight for postcodes listed in Zone 3.';
$shipping_option_details['value']['zone3_rate']['value']=0.0; // flat rate shipping price

$shipping_option_details['value']['zone4_postcodes']['name']='Zone 4 Postcodes ';
$shipping_option_details['value']['zone4_postcodes']['admin_description']='Comma seperate postcodes for Zone 4 Rate.';
$shipping_option_details['value']['zone4_postcodes']['value']=""; // flat rate shipping price
$shipping_option_details['value']['zone4_rate']['name']='Zone 4 Rate ';
$shipping_option_details['value']['zone4_rate']['admin_description']='Enter the shipping rate per unit of weight for postcodes listed in Zone 4.';
$shipping_option_details['value']['zone4_rate']['value']=0.0; // flat rate shipping price

$shipping_option_details['value']['default_rate']['name']='Default Rate';
$shipping_option_details['value']['default_rate']['admin_description']='In situations where a postcode cannot be matched the default shipping rate per unit of weight will be applied.';
$shipping_option_details['value']['default_rate']['value']=0.0; // flat rate shipping price
$shipping_option_details['value']['free_shipping']['name']='Free Shipping';
$shipping_option_details['value']['free_shipping']['admin_description']='Orders greater than or equal to this amount will have free shipping.';
$shipping_option_details['value']['free_shipping']['value']=999999; // free shipping if order above this value

// get saved data for this shipping option if it exists
if ($saved_shipping_option_details=get_item_details('shipping_option',$shipping_option_details['id'])){
    if (function_exists('array_replace_recursive')){
        // php5.3.0 or higher
       $shipping_option_details=array_replace_recursive($shipping_option_details,$saved_shipping_option_details);
    }
    else{
        // legacy code for pre php5.3.0
        $shipping_option_details=$saved_shipping_option_details;
    }
}

// code after this line is for front end only
if (cms_interface!="front"){return;}

// custom form fields or text for this shipping option can be added to shipping_option_form string
$shipping_option_details['form']="";

if (!isset($calc_shipping)){return;}
// this is where the shipping total is calculated
if ($_SESSION[cms_key]['cart']->getSubTotal()>$shipping_option_details['value']['free_shipping']['value']){$shipping_total=0;}
else{

    $order_weight=0;
    // calculate the total weight of order
    foreach($_SESSION[cms_key]['cart']->products as $product_option_id => $product){
        $order_weight=$order_weight+($product['weight']*$product['order_qty']); // update to use ->attr['weight']
    }

    // apply default shipping rate first
    $shipping_total=$order_weight*$shipping_option_details['value']['default_rate']['value'];

    if (empty($_SESSION[cms_key]['cart']->customer->addr->postcode)) return;

    $customers_postcode=strtolower($_SESSION[cms_key]['cart']->customer->addr->postcode);

    // check for postcode match in zone 1 and apply zone 1 rate
    if ($shipping_option_details['value']['zone1_postcodes']['value']!=''){
        $postcodes=explode(",",$shipping_option_details['value']['zone1_postcodes']['value']);
        $postcodes=array_map('strtolower',$postcodes);
        $postcodes=array_map('trim',$postcodes);
        if (in_array($customers_postcode,$postcodes)){$shipping_total=$order_weight*$shipping_option_details['value']['zone1_rate']['value'];return;}
    }

    // check for postcode match in zone 2 and apply zone 2 rate
    if ($shipping_option_details['value']['zone2_postcodes']['value']!=''){
        $postcodes=explode(",",$shipping_option_details['value']['zone2_postcodes']['value']);
        $postcodes=array_map('strtolower',$postcodes);
        $postcodes=array_map('trim',$postcodes);
        if (in_array($customers_postcode,$postcodes)){$shipping_total=$order_weight*$shipping_option_details['value']['zone2_rate']['value'];return;}
    }

    // check for postcode match in zone 3 and apply zone 3 rate
    if ($shipping_option_details['value']['zone3_postcodes']['value']!=''){
        $postcodes=explode(",",$shipping_option_details['value']['zone3_postcodes']['value']);
        $postcodes=array_map('strtolower',$postcodes);
        $postcodes=array_map('trim',$postcodes);
        if (in_array($customers_postcode,$postcodes)){$shipping_total=$order_weight*$shipping_option_details['value']['zone3_rate']['value'];return;}
    }

    // check for postcode match in zone 4 and apply zone 4 rate
    if ($shipping_option_details['value']['zone4_postcodes']['value']!=''){
        $postcodes=explode(",",$shipping_option_details['value']['zone4_postcodes']['value']);
        $postcodes=array_map('strtolower',$postcodes);
        $postcodes=array_map('trim',$postcodes);
        if (in_array($customers_postcode,$postcodes)){$shipping_total=$order_weight*$shipping_option_details['value']['zone4_rate']['value'];return;}
    }

}


?>
