<?php

// country zonal shipping option - apply a shipping rate based on the customers delivery country
// shipping options must contain the folowing data
$shipping_option_details=array();
$shipping_option_details['item_type']='shipping_option'; // required - do not change or remove this

$shipping_option_details['id']="zones_by_country";  // required - each shipping option must have a unique id that matches the shipping option folder name exactly
$shipping_option_details['admin_name']="Zonal Rates by Country";  // display name in admin area
$shipping_option_details['admin_description']="Applies a shipping amount based on the cusomers delivery country."; // description displayed in admin
$shipping_option_details['name']="Shipping"; // display name in checkout/front end
$shipping_option_details['description']="Standard Shipping";  // description displayed in checkout/front end

// custom data specific to this shipping option
$shipping_option_details['value']['zone1_countries']['name']='Zone 1 Countries';
$shipping_option_details['value']['zone1_countries']['admin_description']='Comma seperate countries for Zone 1 Rate.';
$shipping_option_details['value']['zone1_countries']['value']=""; // flat rate shipping price
$shipping_option_details['value']['zone1_rate']['name']='Zone 1 Rate';
$shipping_option_details['value']['zone1_rate']['admin_description']='Enter the shipping rate for countries listed in Zone 1.';
$shipping_option_details['value']['zone1_rate']['value']=0.0; // flat rate shipping price

$shipping_option_details['value']['zone2_countries']['name']='Zone 2 Countries';
$shipping_option_details['value']['zone2_countries']['admin_description']='Comma seperate countries for Zone 2 Rate.';
$shipping_option_details['value']['zone2_countries']['value']=""; // flat rate shipping price
$shipping_option_details['value']['zone2_rate']['name']='Zone 2 Rate';
$shipping_option_details['value']['zone2_rate']['admin_description']='Enter the shipping rate for countries listed in Zone 2.';
$shipping_option_details['value']['zone2_rate']['value']=0.0; // flat rate shipping price

$shipping_option_details['value']['zone3_countries']['name']='Zone 3 Countries';
$shipping_option_details['value']['zone3_countries']['admin_description']='Comma seperate countries for Zone 3 Rate.';
$shipping_option_details['value']['zone3_countries']['value']=""; // flat rate shipping price
$shipping_option_details['value']['zone3_rate']['name']='Zone 3 Rate';
$shipping_option_details['value']['zone3_rate']['admin_description']='Enter the shipping rate for countries listed in Zone 3.';
$shipping_option_details['value']['zone3_rate']['value']=0.0; // flat rate shipping price

$shipping_option_details['value']['zone4_countries']['name']='Zone 4 Countries';
$shipping_option_details['value']['zone4_countries']['admin_description']='Comma seperate countries for Zone 4 Rate.';
$shipping_option_details['value']['zone4_countries']['value']=""; // flat rate shipping price
$shipping_option_details['value']['zone4_rate']['name']='Zone 4 Rate';
$shipping_option_details['value']['zone4_rate']['admin_description']='Enter the shipping rate for countries listed in Zone 4.';
$shipping_option_details['value']['zone4_rate']['value']=0.0; // flat rate shipping price

$shipping_option_details['value']['default_rate']['name']='Default Rate';
$shipping_option_details['value']['default_rate']['admin_description']='In situations where a country cannot be matched the default shipping rate will be applied.';
$shipping_option_details['value']['default_rate']['value']=0.0; // flat rate shipping price
$shipping_option_details['value']['free_shipping']['name']='Free Shipping';
$shipping_option_details['value']['free_shipping']['admin_description']='Orders greater than or equal to this amount will have free shipping.';
$shipping_option_details['value']['free_shipping']['value']=999999; // free shipping if order above this value

$shipping_option_details['value']['exempt_countries']['name']='Exempt Countries';
$shipping_option_details['value']['exempt_countries']['admin_description']='Comma seperate countries for exemption. This shipping option will not be available if the delivery country on checkout is exempted here.';
$shipping_option_details['value']['exempt_countries']['value']=""; // exempt countries, comma seperated

// get saved data for this shipping option if it exists
if ($saved_shipping_option_details=get_item_details('shipping_option',$shipping_option_details['id'])){
    if (function_exists('array_replace_recursive')){
        // php5.3.0 or higher
       $shipping_option_details=array_replace_recursive($shipping_option_details,$saved_shipping_option_details);
    }
    else{
        // legacy code for pre php5.3.0
        $shipping_option_details=$saved_shipping_option_details;
    }
}

// code after this line is for front end only
if (cms_interface!="front") return;
           
if (isset($_SESSION[cms_key]['cart']->customer->delivery_addr->country)){$customers_delivery_country=strtolower($_SESSION[cms_key]['cart']->customer->delivery_addr->country);}

// checkout delivery country must be specified
if (!isset($customers_delivery_country) || $customers_delivery_country==''){return;}

// change status to disabled if the checkout delivery country is listed as exempt
$exempt_countries=explode(",",$shipping_option_details['value']['exempt_countries']['value']);
$exempt_countries=array_map('strtolower',$exempt_countries);
$exempt_countries=array_map('trim',$exempt_countries);
if (in_array($customers_delivery_country,$exempt_countries)){$shipping_option_details['status']=0;return;}

// custom form fields or text for this shipping option can be added to shipping_option_form string
$shipping_option_details['form']="";

if (!isset($calc_shipping)){return;}
// this is where the shipping total is calculated
if ($_SESSION[cms_key]['cart']->getSubTotal()>$shipping_option_details['value']['free_shipping']['value']){$shipping_total=0;}
else{

    // apply default shipping rate first
    $shipping_total=$shipping_option_details['value']['default_rate']['value'];

    // check for country match in zone 1 and apply zone 1 rate
    if ($shipping_option_details['value']['zone1_countries']['value']!=''){
        $countries=explode(",",$shipping_option_details['value']['zone1_countries']['value']);
        $countries=array_map('strtolower',$countries);
        $countries=array_map('trim',$countries);
        if (in_array($customers_delivery_country,$countries)){$shipping_total=$shipping_option_details['value']['zone1_rate']['value'];return;}
    }

    // check for country match in zone 2 and apply zone 2 rate
    if ($shipping_option_details['value']['zone2_countries']['value']!=''){
        $countries=explode(",",$shipping_option_details['value']['zone2_countries']['value']);
        $countries=array_map('strtolower',$countries);
        $countries=array_map('trim',$countries);
        if (in_array($customers_delivery_country,$countries)){$shipping_total=$shipping_option_details['value']['zone2_rate']['value'];return;}
    }

    // check for country match in zone 3 and apply zone 3 rate
    if ($shipping_option_details['value']['zone3_countries']['value']!=''){
        $countries=explode(",",$shipping_option_details['value']['zone3_countries']['value']);
        $countries=array_map('strtolower',$countries);
        $countries=array_map('trim',$countries);
        if (in_array($customers_delivery_country,$countries)){$shipping_total=$shipping_option_details['value']['zone3_rate']['value'];return;}
    }

    // check for country match in zone 4 and apply zone 4 rate
    if ($shipping_option_details['value']['zone4_countries']['value']!=''){
        $countries=explode(",",$shipping_option_details['value']['zone4_countries']['value']);
        $countries=array_map('strtolower',$countries);
        $countries=array_map('trim',$countries);
        if (in_array($customers_delivery_country,$countries)){$shipping_total=$shipping_option_details['value']['zone4_rate']['value'];return;}
    }

}


?>
