<?php

    // exit if php file is loaded directly and not included
    if (!defined("cms_version_number")){exit();}

    $invoice="";

    if (empty($order) && isset($rvi_print_invoice)){
        $order = new Order();
        $order->getData($rvi_print_invoice);
        if (admin_level('orders')<1){
            if (!isset($_SESSION[cms_key]['reg_user']) || $order->customer->id!=$_SESSION[cms_key]['reg_user']->id){
                exit("<a href=\"".cms_url."?login\">Login</a> required to view this page.");
            }
        }
    }

    // log invoice viewed - need to change invoice to po pro-forma etc. for clarity traceability
    if (isset($_SESSION[cms_key]['reg_user']) && admin_level()<10)
        update_item_log('user',$_SESSION[cms_key]['reg_user']->id,'User '.short_name($_SESSION[cms_key]['reg_user']->name,2).' '.$_SESSION[cms_key]['reg_user']->id.' viewed invoice '.$order->id);


    if (!isset($order->id)){
        $invoice.='Order not found';
        return;
    }

    if (!isset($owner)){
        $owner = new User();
        $owner->getData($order->customer->id);
    }

    if ($order->currency_code){
        $currency_code=$order->currency_code;
        $currency_symbol=get_currency_symbol($order->currency_code);
    }
    else{
        $currency_code=currency_code;
        $currency_symbol=currency_symbol;
    }

    // get invoice address and footer
    $invoice_address_fn=sys_data_dir.'/settings/invoice_address.html';
    if (file_exists($invoice_address_fn)){$invoice_address=file_get_contents($invoice_address_fn);}else{$invoice_address="";}

    if ($order->status>3){$invoice_footer_fn=sys_data_dir.'/settings/pending_invoice_footer.html';}
    else{$invoice_footer_fn=sys_data_dir.'/settings/invoice_footer.html';}
    if (file_exists($invoice_footer_fn)){$invoice_footer=file_get_contents($invoice_footer_fn);}else{$invoice_footer="";}

	// display referrer if any, should only be displayed in admin
    $referrer_text="none";
	if ($order->referrer){

        $referrer = new User();

		if ($referrer->getData($order->referrer))
			$referrer_text="<a href=\"?user".$referrer->id."\">".$referrer->name."</a>";
	}

    if ($order->status==4) $invoice_num_text=$txt['pending']." Invoice<br />".$order->id;
    elseif ($order->status==5) $invoice_num_text="Purchase Order<br />".$order->id;
    elseif ($order->status==6) $invoice_num_text="Pro-Forma Invoice<br />".$order->id;
    else $invoice_num_text="Invoice ".$order->id;

    if (isset($rvi_print_invoice)) $invoice_max_width="700px"; else $invoice_max_width="770px";

    $invoice.="<div style=\"font-family: Arial, Helvetica, sans-serif; font-size: 13px; max-width: ".$invoice_max_width."; border: #cccccc solid 1px; padding: 20px;\">
    <div style=\"display: flex; flex-flow: row wrap;justify-content: space-between;\">
    <div style=\"margin-right: 15px\">";

        // display billing address
        $invoice.="<p>";
        if ($order->customer->use_delivery_addr) $invoice.="<b>Bill To:</b>"; else $invoice.="<b>To:</b>";
        if ($order->customer->bill_company && $order->customer->company){
            $invoice.="<br>".$order->customer->company;
            $attn=1;
        }
        else{
            $invoice.="<br>".$order->customer->name;
        }
        $invoice_billing_address=""; 
        if ($order->customer->addr->line1){
            if ($invoice_billing_address) $invoice_billing_address.=",";
            $invoice_billing_address.="<br>".$order->customer->addr->line1;
        }
        if ($order->customer->addr->line2){
            if ($invoice_billing_address) $invoice_billing_address.=",";
            $invoice_billing_address.="<br>".$order->customer->addr->line2;
        }
        if ($order->customer->addr->city){
            if ($invoice_billing_address) $invoice_billing_address.=",";
            $invoice_billing_address.="<br>".$order->customer->addr->city;
        }
        if ($order->customer->addr->county){
            if ($invoice_billing_address) $invoice_billing_address.=",";
            $invoice_billing_address.="<br>".$order->customer->addr->county;
        }
        if ($order->customer->addr->postcode){
            if ($invoice_billing_address) $invoice_billing_address.=",";
            $invoice_billing_address.="<br>".$order->customer->addr->postcode;
        }
        if ($order->customer->addr->country){
            if ($invoice_billing_address) $invoice_billing_address.=",";
            $invoice_billing_address.="<br>".$order->customer->addr->country;
        }
        // underscore lines if billing address is blank for printing Purchase Order purposes
        if ($invoice_billing_address==""){$invoice_billing_address="<br><span style=\"color: #cccccc;line-height:22px\">_________________________________<br>_________________________________<br>_________________________________<br>_________________________________<br>_________________________________</span>";}
        $invoice.=$invoice_billing_address;
        $invoice.="</p>";

        if (isset($attn)){$invoice.="<p>Attn: ".$order->customer->name."</p>";}

    	if ($order->customer->use_delivery_addr){
            $invoice.="<p><b>Deliver To:</b>";
            $invoice.="<br>".$order->customer->delivery_addr->name;
            $invoice_delivery_address="";
            if ($order->customer->delivery_addr->line1){
                if ($invoice_delivery_address!="") $invoice_delivery_address.=",";
                $invoice_delivery_address.="<br>".$order->customer->delivery_addr->line1;
            }
            if ($order->customer->delivery_addr->line2){
                if ($invoice_delivery_address!="") $invoice_delivery_address.=",";
                $invoice_delivery_address.="<br>".$order->customer->delivery_addr->line2;
            }
            if ($order->customer->delivery_addr->city){
                if ($invoice_delivery_address!="") $invoice_delivery_address.=",";
                $invoice_delivery_address.="<br>".$order->customer->delivery_addr->city;
            }
            if ($order->customer->delivery_addr->county){
                if ($invoice_delivery_address!="") $invoice_delivery_address.=",";
                $invoice_delivery_address.="<br>".$order->customer->delivery_addr->county;
            }
            if ($order->customer->delivery_addr->postcode){
                if ($invoice_delivery_address!="") $invoice_delivery_address.=",";
                $invoice_delivery_address.="<br>".$order->customer->delivery_addr->postcode;
            }
            if ($order->customer->delivery_addr->country){
                if ($invoice_delivery_address!="") $invoice_delivery_address.=",";
                $invoice_delivery_address.="<br>".$order->customer->delivery_addr->country;
            }
            // underscore lines if deliver address is blank for printing Purchase Order purposes
            if ($invoice_delivery_address==""){$invoice_delivery_address="<span style=\"color: #cccccc;line-height:22px\">_________________________________<br>_________________________________<br>_________________________________<br>_________________________________<br>_________________________________</span>";}
            $invoice.=$invoice_delivery_address;
        	$invoice.="</p>";
        }

        if (isset($rvi_modify_order) && admin_level('orders')>1){
            $invoice.="<p><a href=\"#\" title=\"Edit customer details\" onclick=\"javascript:hide('tab_content_order_invoice');javascript:hide('tab_content_order_details');javascript:show('tab_content_customer_details');\"><i class=\"cms-fi-edit\"></i></a>";
            //$invoice.=" <a href=\"?email_user&amp;order=".$order->id."\" title=\"".$order->customer->email."\"><i class=\"cms-fi-mail\"></i>".(display_type!='mobile' ? $order->customer->email : "")."</a>";
            //if ($order->customer->phone) $invoice.="&nbsp; <a href=\"tel:".$order->customer->phone."\" title=\"".$order->customer->phone."\"><i class=\"cms-fi-phone\"></i>".$order->customer->phone."</a>";
            $invoice.="</p>";
        }

        $invoice.="</div>";


    $invoice.="<div>".$invoice_address."<h3>".$invoice_num_text."</h3>".date("jS M Y",$order->getDate())."</div></div>";

        // display customer order notes
        if ($order->customer->delivery_phone || $order->customer->delivery_date || $order->customer->delivery_message){
            $invoice.="<tr><td colspan=\"2\"><h4>Notes:</h4>";
            if ($order->customer->delivery_phone) $invoice.="<p>Delivery Tel: ".$order->customer->delivery_phone."</p>";
    		if ($order->customer->delivery_date) $invoice.="<p>Delivery Date: ".$order->getDeliveryDate(true)."</p>";
    		if ($order->customer->delivery_message) $invoice.="<p>Greeting Card: ".$order->customer->delivery_message."</p>";
    		$invoice.="</td></tr>";
        }

		$invoice.="<div style=\"text-align: right; padding: 15px 0 15px 0\"><p>";

        // display due date if order has a due date and is not pending
        if ($order->due_date){
            if ($order->daysOverdue() > 0 && ($order->status < 1 || $order->status > 3)){
                $invoice.="<span style=\"color: #ff0000\">Overdue: ".$order->getDueDate(true)."</span><br>";}
            else{
                $invoice.="Due: ".$order->getDueDate(true)."<br>";
            }
        }

        if ($order->getTotal(true) > 0 && !isset($rvi_print_invoice)){
            if ($order->status<1 || $order->status>3){
                if (!$order->payments && $order->deposit){$status='<a href="'.cms_url.'?paynow='.$order->id.'&amp;deposit" class="pay_now_link">Pay Deposit</a> / <a href="'.cms_url.'?paynow='.$order->id.'" class="pay_now_link">In Full</a>';}
                else{$status='<a href="'.cms_url.'?paynow='.$order->id.'" class="pay_now_link">Pay Now</a>';}
            }
            elseif ($order->status==1){$status='<font color="green">Paid</font>';}
            elseif ($order->status==2){$status='<font color="green">Paid &amp; Processed</font>';}
            elseif($order->status==3){$status='<font color="orange">Cancelled</font>';}
        }
        else{$status='';}

        $invoice.="<span style=\"font-size: 18px; font-weight: bold; margin-top: 0\">".$status."</span></p></div>";
        // display order details
        include(cms_root_dir.'includes/shop/order_details_table.php');
        $invoice.=$order_details_table;

        // display deposit requirement if set
        if ($order->deposit){
            $invoice.="<div style=\"padding-top: 15px\"><b>".$txt['invoice_Deposit'].":</b> ".$currency_symbol.$order->deposit." ".$txt['invoice_Deposit_followtxt']."</div>";
        }

        // display signature space for purchase order and pro-forma
        if ($order->status==5 || $order->status==6){
        $invoice.="<div style=\"padding-top: 30px\"><b>Authorised by:</b> <span style=\"color: #cccccc\">____________________________________________________</span> <b>Date:</b> <span style=\"color: #cccccc\">______________</span></div>";
        }

        if ($invoice_footer!=""){$invoice.="<div style=\"font-size: 11px; padding-top: 15px\">".$invoice_footer."</div>";}

        $invoice.="</div>";

        if (isset($rvi_print_invoice)){
            echo "<!DOCTYPE HTML><html>";
            if ($order->status==5){echo "<head><title>Purchase Order ".$order->id."</title></head>";}
            elseif ($order->status==6){echo "<head><title>Pro-Forma Invoice ".$order->id."</title></head>";}
            else{echo "<head><title>Invoice ".$order->id."</title></head>";}
            echo "<body>".$invoice."</body></html>";
            exit();
        }


?>
