<?php

    // exit if php file is loaded directly and not included
    if (!defined("cms_version_number")){exit();}

    $invoice="";

    if (!isset($order->id) && isset($rvi_print_invoice)){
        $order_details=get_item_details('order',$rvi_print_invoice);
        if (admin_level('orders')<1){
            if (!isset($_SESSION[cms_key]['reg_user']) || $order_details['customer']['id']!=$_SESSION[cms_key]['reg_user']->id){
                exit("<a href=\"".cms_url."?login\">Login</a> required to view this page.");
            }
        }
    }

    // log invoice viewed - need to change invoice to po pro-forma etc. for clarity traceability
    if (isset($_SESSION[cms_key]['reg_user']) && admin_level()<10){
        update_item_log('user',$_SESSION[cms_key]['reg_user']->id,'User '.short_name($_SESSION[cms_key]['reg_user']->name,2).' '.$_SESSION[cms_key]['reg_user']->id.' viewed invoice '.$order->id);
    }

    if (!isset($order->id)){$invoice.='Order not found';return;}

    if (!isset($order_owner_details['id'])){$order_owner_details=get_item_details('customer',$order_details['customer']['id']);}

    if (isset($order_details['currency_code'])){
        $currency_code=$order_details['currency_code'];
        $currency_symbol=get_currency_symbol($order_details['currency_code']);
    }
    else{
        $currency_code=currency_code;
        $currency_symbol=currency_symbol;
    }

    // get invoice address and footer
    $invoice_address_fn=sys_data_dir.'/settings/invoice_address.html';
    if (file_exists($invoice_address_fn)){$invoice_address=file_get_contents($invoice_address_fn);}else{$invoice_address="";}

    if (isset($order_details['status']) && $order_details['status']>3){$invoice_footer_fn=sys_data_dir.'/settings/pending_invoice_footer.html';}
    else{$invoice_footer_fn=sys_data_dir.'/settings/invoice_footer.html';}
    if (file_exists($invoice_footer_fn)){$invoice_footer=file_get_contents($invoice_footer_fn);}else{$invoice_footer="";}

    if (isset($order_details['status'])){$order_status=$order_details['status'];}else{$order_status='';}

    if (isset($order_details['phone'])){$phone=$order_details['phone'];}else{$phone='';}

    if (isset($order_details['address'])){$address=$order_details['address'];}else{$address='';}
    if (isset($order_details['address_2'])){$address_2=$order_details['address_2'];}else{$address_2='';}
    if (isset($order_details['city'])){$city=$order_details['city'];}else{$city='';}
    if (isset($order_details['county'])){$county=$order_details['county'];}else{$county='';}
    if (isset($order_details['postcode'])){$postcode=$order_details['postcode'];}else{$postcode='';}
    if (isset($order_details['country']) && $order_details['country']!=="---"){$country=$order_details['country'];}else{$country='';}

    if (isset($order_details['dob_month'])){$dob_month=$order_details['dob_month'];}else{$dob_month='';}
    if (isset($order_details['dob_day'])){$dob_day=$order_details['dob_day'];}else{$dob_day='';}
    if (isset($order_details['dob_year'])){$dob_year=$order_details['dob_year'];}else{$dob_year='';}


    if (isset($order_details['delivery_seperate_details'])){$delivery_seperate_details=$order_details['delivery_seperate_details'];}else{$delivery_seperate_details=0;}

    if (isset($order_details['delivery_name'])){$delivery_name=$order_details['delivery_name'];}else{$delivery_name='';}
    if (isset($order_details['delivery_address'])){$delivery_address=$order_details['delivery_address'];}else{$delivery_address='';}
    if (isset($order_details['delivery_address_2'])){$delivery_address_2=$order_details['delivery_address_2'];}else{$delivery_address_2='';}
    if (isset($order_details['delivery_city'])){$delivery_city=$order_details['delivery_city'];}else{$delivery_city='';}
    if (isset($order_details['delivery_county'])){$delivery_county=$order_details['delivery_county'];}else{$delivery_county='';}
    if (isset($order_details['delivery_postcode'])){$delivery_postcode=$order_details['delivery_postcode'];}else{$delivery_postcode='';}
    if (isset($order_details['delivery_country']) && $order_details['delivery_country']!=="---"){$delivery_country=$order_details['delivery_country'];}else{$delivery_country='';}

    if (isset($order_details['delivery_phone'])){$delivery_phone=$order_details['delivery_phone'];}else{$delivery_phone='';}
    if (isset($order_details['delivery_date_month'])){$delivery_date_month=$order_details['delivery_date_month'];}else{$delivery_date_month='';}
    if (isset($order_details['delivery_date_day'])){$delivery_date_day=$order_details['delivery_date_day'];}else{$delivery_date_day='';}
    if (isset($order_details['delivery_date_year'])){$delivery_date_year=$order_details['delivery_date_year'];}else{$delivery_date_year='';}
    if (isset($order_details['delivery_message'])){$delivery_message=$order_details['delivery_message'];}else{$delivery_message='';}

	// display referrer if any
	if (isset($order_details['referrer'])){
		$referrer_details=get_item_details('customer',$order_details['referrer']);
		if (is_array($referrer_details)){
			$referrer_text="<a href=\"?user".$order_details['referrer']."\">".$referrer_details['name']."</a>";
		}
	}else{$referrer_text="none";}

    // legacy code for orders with no created/modified time details
    if (!isset($order_details['created_time'])){$order_details['created_time']=substr($order_id,0,-3);}
    if (!isset($order_details['modified_time'])){$order_details['modified_time']=$order_details['created_time'];}

    $order_date=$order_details['created_time'];
    if (isset($order_details['date']) && $order_details['date']>0){$order_date=$order_details['date'];}

    if ($order_details['status']==4){$invoice_num_text=$txt['pending']." Invoice<br />".$order->id;}
    elseif ($order_details['status']==5){$invoice_num_text="Purchase Order<br />".$order->id;}
    elseif ($order_details['status']==6){$invoice_num_text="Pro-Forma Invoice<br />".$order->id;}
    else{$invoice_num_text="Invoice ".$order->id;}
    $invoice.="<div style=\"font-family: Arial, Helvetica, sans-serif; font-size: 13px; max-width: 700px; border: #cccccc solid 1px; padding: 20px;\"><table class=\"basic_table\" style=\"width: 100%\"><tbody><tr><td>".$invoice_address."<h3>".$invoice_num_text."</h3>".date("jS M Y",$order_date)."</td></tr>
        <tr><td>";

        // display billing address
        $invoice.="<p>";
        if ($delivery_seperate_details<1){$invoice.="<b>To:</b>";}else{$invoice.="<b>Bill To:</b>";}
        if (isset($order_details['bill_company']) && $order_details['bill_company']>0 && $order_details['company']!=""){
            $invoice.="<br>".$order_details['company'];
            $attn=1;
        }
        else{
            $invoice.="<br>".$order_details['name'];
        }
        $invoice_billing_address="";
        if ($address!=""){
            if ($invoice_billing_address!=""){$invoice_billing_address.=",";}
            $invoice_billing_address.="<br>".$address;
        }
		if ($address_2!=""){
            if ($invoice_billing_address!=""){$invoice_billing_address.=",";}
            $invoice_billing_address.="<br>".$address_2;
        }
        if ($city!=""){
            if ($invoice_billing_address!=""){$invoice_billing_address.=",";}
            $invoice_billing_address.="<br>".$city;
        }
        if ($county!=""){
            if ($invoice_billing_address!=""){$invoice_billing_address.=",";}
            $invoice_billing_address.="<br>".$county;
        }
		if ($postcode!=""){
            if ($invoice_billing_address!=""){$invoice_billing_address.=",";}
            $invoice_billing_address.="<br>".$postcode;
        }
		if ($country!=""){
            if ($invoice_billing_address!=""){$invoice_billing_address.=",";}
            $invoice_billing_address.="<br>".$country;
        }
        // underscore lines if billing address is blank for printing Purchase Order purposes
        if ($invoice_billing_address==""){$invoice_billing_address="<span style=\"color: #cccccc;line-height:22px\">_________________________________<br>_________________________________<br>_________________________________<br>_________________________________<br>_________________________________</span>";}
        $invoice.=$invoice_billing_address;
        $invoice.="</p>";

        if (isset($attn)){$invoice.="<p>Attn: ".$order_details['name']."</p>";}


    	if ($delivery_seperate_details>0){
            $invoice.="<p><b>Deliver To:</b>";
            $invoice.="<br>".$delivery_name;
            $invoice_delivery_address="";
            if ($delivery_address!=""){
                if ($invoice_delivery_address!=""){$invoice_delivery_address.=",";}
                $invoice_delivery_address.="<br>".$delivery_address;
            }
            if ($delivery_address_2!=""){
                if ($invoice_delivery_address!=""){$invoice_delivery_address.=",";}
                $invoice_delivery_address.="<br>".$delivery_address_2;
            }
            if ($delivery_city!=""){
                if ($invoice_delivery_address!=""){$invoice_delivery_address.=",";}
                $invoice_delivery_address.="<br>".$delivery_city;
            }
            if ($delivery_county!=""){
                if ($invoice_delivery_address!=""){$invoice_delivery_address.=",";}
                $invoice_delivery_address.="<br>".$delivery_county;
            }
            if ($delivery_postcode!=""){
                if ($invoice_delivery_address!=""){$invoice_delivery_address.=",";}
                $invoice_delivery_address.="<br>".$delivery_postcode;
            }
            if ($delivery_country!=""){
                if ($invoice_delivery_address!=""){$invoice_delivery_address.=",";}
                $invoice_delivery_address.="<br>".$delivery_country;
            }
            // underscore lines if deliver address is blank for printing Purchase Order purposes
            if ($invoice_delivery_address==""){$invoice_delivery_address="<span style=\"color: #cccccc;line-height:22px\">_________________________________<br>_________________________________<br>_________________________________<br>_________________________________<br>_________________________________</span>";}
            $invoice.=$invoice_delivery_address;
        	$invoice.="</p>";
        }
        $invoice.="</td></tr>";

        // display customer order notes
        if ($delivery_phone!="" || $delivery_date_month>0 || $delivery_message!=""){
            $invoice.="<tr><td><h4>Notes:</h4>";
            if ($delivery_phone!=""){$invoice.="<p>Delivery Tel: ".$delivery_phone."</p>";}
    		if ($delivery_date_month>0){$invoice.="<p>Delivery Date: ".$delivery_date_day."/".$delivery_date_month."/".$delivery_date_year."</p>";}
    		if ($delivery_message!=""){$invoice.="<p>Greeting Card:: ".$delivery_message."</p>";}
    		$invoice.="</td></tr>";
        }

		$invoice.="<tr><td align=\"right\"><p>";

        // display due date if order has a due date and is not pending
        if (isset($order_details['due_date']) && $order_details['due_date']>0){
            $days_to_due=($order_details['due_date']-time())/86400;
            if ($days_to_due<1 && ($order_details['status']<1 || $order_details['status']>3)){
                $invoice.="<span style=\"color: #ff0000\">Overdue: ".date("d/m/Y",$order_details['due_date'])."</span><br>";}
            else{
                $invoice.="Due: ".date("d/m/Y",$order_details['due_date'])."<br>";
            }
        }

        $order_total=$order_details['shipping_total']+$order_details['order_subtotal'];
        if (($order_total-$order_details['discount'])>0 && !isset($rvi_print_invoice)){
            if ($order_details['status']<1 || $order_details['status']>3){$status='<a href="'.cms_url.'?paynow='.$order->id.'" class="pay_now_link">'.$txt['pay_now'].'</a>';}
            elseif ($order_details['status']==1){$status='<font color="green">Paid</font>';}
            elseif ($order_details['status']==2){$status='<font color="green">Paid &amp; Processed</font>';}
            elseif($order_details['status']==3){$status='<font color="orange">Cancelled</font>';}
        }
        else{$status='';}

        $invoice.="<span style=\"font-size: 18px; font-weight: bold; margin-top: 0\">".$status."</span></p></td></tr>
        <tr><td>";
        // display order details
        include(cms_root_dir.'includes/shop/order_details_table.php');
        $invoice.=$order_details_table;

		$invoice.="</td></tr>";

        // display deposit requirement if set
        if (isset($order_details['deposit']) && $order_details['deposit']!=""){
            $invoice.="<tr><td colspan=\"2\" style=\"padding-top: 15px\"><b>".$txt['invoice_Deposit'].":</b> ".$currency_symbol.$order_details['deposit']." ".$txt['invoice_Deposit_followtxt']."</td></tr>";
        }
        if ($invoice_footer!=""){$invoice.="<tr><td style=\"font-size: 11px; padding-top: 10px\">".$invoice_footer."</td></tr>";}

        $invoice.="</tbody></table></div>";

        if (isset($rvi_print_invoice)){
            echo "<!DOCTYPE HTML><html>";
            if ($order_details['status']==5){echo "<head><title>Purchase Order ".$order->id."</title></head>";}
            elseif ($order_details['status']==6){echo "<head><title>Pro-Forma Invoice ".$order->id."</title></head>";}
            else{echo "<head><title>Invoice ".$order->id."</title></head>";}
            echo "<body>".$invoice."</body></html>";
            exit();
        }


?>
