<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit;

    if (isset($rvi_passreset))
        $page->title="Password Reset";
    else
        $page->title="Forgot Password";
        
    $page->meta_title=cms_site_name." - ".$page->title;
    $page->template=$cmsSettings->user['template_fpass'];

	if (isset($_POST['fp_email'])){

        $fp_email=trim($_POST['fp_email']);

        $_SESSION[cms_key]['form']['forgot_password']['email']=$fp_email;

		// check values
		require(cms_root_dir."scripts/emailval.php");
		if (strlen($fp_email)<4 || strlen($fp_email)>200 || MailVal($fp_email,2))
            $_SESSION[cms_key]['form']['forgot_password']['warning'][]=$txt['Warning_enter_registered_email'];

		if (!isset($_SESSION[cms_key]['form']['forgot_password']['warning'])){

            // check user list file for email and password match
			if ($users=get_items('users',null,null,null,null,array('email' => $fp_email),null,null,array('email'))){

                $count=count($users);
                if ($count==1){
                    $user = new User();
                    if ($user->getData($users[0]['id'])) $account_found=$user;
                }
                else
                    $_SESSION[cms_key]['form']['forgot_password']['warning'][]="Login error";

            }

            // check if email matches main admin only check this from backend view
            if (cms_interface=="back" && !isset($account_found) ){
                if (strtolower($cmsSettings->config['admin_email'])==strtolower($fp_email)){
                    $account_found->id=0;
                    $account_found->email=$cmsSettings->config['admin_email'];
                }
            }

            // send reset password email if account found
            if (isset($account_found)){

               	require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

                $mail = new PHPMailer();

                // send mail via smtp if set in config file
                if (smtp_host){
                    $mail->IsSMTP(); // send via SMTP
                    $mail->SMTPAuth = true; // turn on SMTP authentication
                    $mail->SMTPSecure = 'ssl';
                    $mail->Username = smtp_username; // SMTP username
                    $mail->Password = smtp_password; // SMTP password
                    $mail->Host       = smtp_host; // SMTP server
                    $mail->Port       = smtp_port; // SMTP server
                }

                // send confirmation email to user
                $mail->From = $cmsSettings->config['site_email'];
                $mail->FromName = cms_site_name;
                $mail->AddAddress($account_found->email);
                $mail->AddReplyTo($cmsSettings->config['site_email'], cms_site_name);

                $mail->Subject = cms_site_name." - Password Reset";

                if ($account_found->id==0){$mail->Body    = "Hi ,\n\nA request was made to reset the admin password for your website. If you did not issue this request then please ignore this email.\n\nTo reset the password please click on the link below. You can also copy and paste this link into your browsers address bar.\n\n".admin_resetpass_link()."\n\n\n".cms_site_name."\n".cms_site_url;}
                else{$mail->Body    = "Hi ".short_name($account_found->name).",\n\nA request was made to reset your password. If you did not issue this request then please ignore this email.\n\nTo reset your password please click on the link below. You can also copy and paste this link into your browser's address bar.\n\n".user_resetpass_link($account_found)."\n\n\n".cms_site_name."\n".cms_site_url;}

                if($mail->Send()){
                    $_SESSION[cms_key]['form']['forgot_password']['warning_green'][]=$txt['Forgot_password_submitted'];
                    if ($account_found->id)
                        update_item_log('user',$account_found->id,'Reset password email sent to '.short_name($account_found->name,2).' '.$account_found->id);
                    else
                        update_log("Reset admin password email sent");
                }
                else{
                    if ($account_found->id>0)
                        update_item_log('user',$account_found->id,'Sending Failed: Reset password email to '.short_name($account_found->name,2).' '.$account_found->id);
                    else
                        update_log("Warning: Reset admin password email failed to send");
                }

    		}else{
                $_SESSION[cms_key]['form']['forgot_password']['warning'][]=$txt['Warning_account_not_found']." ".$txt['Warning_enter_registered_email'];
                sleep(3); // anti-brute-force measure on failed email lookup
            }

        }

        // redirect after form submit so browser back and refresh work without browser resend form data warning
        header("Location: ".cms_url."?forgot_password",true,303);
        exit;

	}

    include(theme_file_fn('includes/cms/user/forgot_password.php',display_theme));

?>
