<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit();

    if (isset($rvi_signup) && $cmsSettings->user['close_registration']<1){

		// clean input values
		$rvi_name=sanitize_text_input($rvi_name);
		$rvi_email=trim($rvi_email);

		// check values
		if (strlen($rvi_name)<2 || strlen($rvi_name)>100){$_SESSION[cms_key]['form']['register']['warning'][]=$txt['Warning_enter_name'];}
		require(cms_root_dir."scripts/emailval.php");
		if (strlen($rvi_email)<4 || strlen($rvi_email)>200 || MailVal($rvi_email,2)){$_SESSION[cms_key]['form']['register']['warning'][]=$txt['Warning_enter_email'];}
		elseif (email_registered($rvi_email)){$_SESSION[cms_key]['form']['register']['warning']=array($txt['Warning_email_registered']);}

        // security checks on registration
        if (isset($rvi_register)){

            // security question check
            if (isset($_SESSION[cms_key]['secq']) && $_SESSION[cms_key]['secq']>=0){
                if (isset($cmsSettings->user['security_answers'][$_SESSION[cms_key]['secq']])){
                    if (isset($_POST['security_answer'])){
                        $security_answer=trim(strtolower($_POST['security_answer']));
                        if ($security_answer==trim(strtolower($cmsSettings->user['security_answers'][$_SESSION[cms_key]['secq']])))
                            $_SESSION[cms_key]['secq']=-1; // answered correctly so don't ask again this session
                        else
                            $_SESSION[cms_key]['form']['register']['warning'][]="Please answer the security question correctly.";
                    }
                    else
                         $_SESSION[cms_key]['form']['register']['warning'][]="Please answer the security question correctly.";
                }
            }
            // google recaptcha check
            if ($cmsSettings->captcha_is_enabled('register')){
                if (isset($_POST['g-recaptcha-response'])){
                    $response = $_POST['g-recaptcha-response'];
                    $remoteIp = $_SERVER['REMOTE_ADDR'];

                    $reCaptchaValidationUrl = file_get_contents("https://www.google.com/recaptcha/api/siteverify?secret=".$cmsSettings->user['captcha_secretkey']."&response=$response&remoteip=$remoteIp");
                    $result = json_decode($reCaptchaValidationUrl, TRUE);

                    if ($result['success']!=1) $_SESSION[cms_key]['form']['register'][]="There was a problem validating the form.";
                }
                else
                    $_SESSION[cms_key]['form']['register'][]="There was a problem validating the form.";
            }

        }

		if (isset($_SESSION[cms_key]['form']['register']['warning'])){
		    $_SESSION[cms_key]['form']['name']=$rvi_name;
		    $_SESSION[cms_key]['form']['email']=$rvi_email;
            if (isset($rvi_newsletter)){$_SESSION[cms_key]['form']['newsletter']=$rvi_newsletter;}
        }
        else{

            $user = new User();

            // generate a random password
            $password=generate_password();
            $user->password=encrypt_password($password,$user->id);

			if (!empty($_SESSION[cms_key]['referrer'])){$user->referrer=$_SESSION[cms_key]['referrer'];}
			$user->name=$rvi_name;
			$user->email=$rvi_email;

			if ($user->saveItem()){
                updateItemIndex('users',array($user->id),'add');

                update_item_log('user',$user->id,'New user account registered - '.$user->name.' '.$user->id);

    			require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

    			$mail = new PHPMailer();

                // send mail via smtp if set in config file
                if (smtp_host){
                    $mail->IsSMTP(); // send via SMTP
                    $mail->SMTPAuth = true; // turn on SMTP authentication
                    $mail->SMTPSecure = 'ssl';
                    $mail->Username = smtp_username; // SMTP username
                    $mail->Password = smtp_password; // SMTP password
                    $mail->Host       = smtp_host; // SMTP server
                    $mail->Port       = smtp_port; // SMTP server
                }

    			// send confirmation email to user
    			$mail->From = $cmsSettings->config['site_email'];
    			$mail->FromName = cms_site_name;
    			$mail->AddAddress($rvi_email);

    			$mail->Subject = cms_site_name." - New Account Registration";
    			$mail->Body    = "Hi $rvi_name,\n\nThank you for registering with ".cms_site_name." - Your new login password is ".$password."\n\nClick on the link below to verify your account and login.\n\n".user_login_link($user)."\n\nThis is an automated email; if you received it in error, no action is required.\n\n".cms_site_name."\n".cms_site_url;

    			if($mail->Send()){

                    update_item_log('user',$user->id,'Registration email sent to '.$user->name.' '.$user->id);
    				$_SESSION[cms_key]['form']['register']['warning_green'][]="<h2>".$txt['Thank_You']."</h2><p>".$txt['Registration_submitted_text']."</p>";
    			}
                else{
                    if (smtp_host){update_item_log('user',$user->id,'Sending failed via smtp '.smtp_host.' of registration email to user '.$user->id);}
                    else {update_item_log('user',$user->id,'Sending failed of Registration email to user '.$user->id);}
                }

            }else{update_item_log("Warning: could not create new user account");}
		}

        if (isset($_SESSION[cms_key]['form']['register']['warning'])){
            // redirect after form submit so browser back and refresh work without browser resend form data warning
            header("Location: ".cms_url."?register",true,303);
            exit;
        }

	    // redirect after form submit so browser back and refresh work without browser resend form data warning
        header("Location: ".cms_url."?myaccount",true,303);
        exit;

	}

    // warnings can be outputted using the variable or by using the template tags
    if (!empty($_SESSION[cms_key]['form']['register']['warning'])){$warnings_register=display_warnings($_SESSION[cms_key]['form']['register']['warning']);}
    if (!empty($_SESSION[cms_key]['form']['login']['warning'])){$warnings_login=display_warnings($_SESSION[cms_key]['form']['login']['warning']);}

    if (isset($rvi_register)){
        $page->title=$txt['Register'];
        $page->meta_title=cms_site_name." - ".$page->title;
        $page->template=$cmsSettings->user['template_login'];
        if ($cmsSettings->user['close_registration']>0){$page_content['main'].="<p>".$txt['Warning_registration_closed']."</p>";return;}
        include(theme_file_fn('includes/cms/user/register.php',display_theme));
    }
    else{
        $page->title=$txt['Login'];
        $page->meta_title=cms_site_name." - ".$page->title;
        $page->template=$cmsSettings->user['template_login'];
        include(theme_file_fn('includes/cms/user/login.php',display_theme));
    }


?>
