<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit;

    if (cms_interface=='front'){
        $page->title=$txt['my_account'];
        $page->meta_title=cms_site_name." - ".$page->title;
        $page->template=$cmsSettings->user['template_acc'];
    }

    if (isset($_SESSION[cms_key]['form']['register']['warning_green'])){
        $page_content['main'].=display_warnings($_SESSION[cms_key]['form']['register']['warning_green'],'green');
        return;
    }

    $user = new User();

    // on front end we always show user account page for the active registered user
    if (cms_interface=='front' && isset($_SESSION[cms_key]['reg_user']->id)) $user_id=$_SESSION[cms_key]['reg_user']->id;

	if (!empty($user_id) && $user->getData($user_id)){

        $search['owner']=$user_id;
        $users_orders=get_items('orders',null,null,'id',1,$search);
        $user_order_count=count($users_orders);

        $users_subscriptions=get_items('subscriptions',null,null,null,null,$search);
        $user_subscription_count=count($users_subscriptions);

        $users_listings=get_items('listings',null,null,null,null,$search);
        $user_listing_count=count($users_listings);

        $users_applications=get_items('applications',null,null,null,null,$search);
        $user_application_count=count($users_applications);

        $users_bookings=get_items('bookings',null,null,null,null,$search);
        $user_booking_count=count($users_bookings);

        if (admin_level('users')>1){$disable="";}
        elseif (admin_level()>0 || $cmsSettings->user['account_details_access']<1){$disable=" disabled ";}

        if (cms_interface=="back"){$help_page="modify-user.htm";}

        if (cms_interface=="back" && !isset($rvi_myaccount)){$rvi_myaccount='details';}

        if (!isset($rvi_myaccount)){$rvi_myaccount='';}

        if ($rvi_myaccount=='' && $cmsSettings->listings_enabled>0 && !isset($rvi_order) && !isset($rvi_modify_listing)){
            if (isset($cmsSettings->user['profile_pages']) && $cmsSettings->user['profile_pages']>0){$rvi_myaccount='profile';}
            else{$rvi_myaccount='listings';}
        }

        if (cms_interface=="front"){$page_content['main'].="<div class=\"cms-content\">";}

        if (cms_interface=="back"){

            // display user joined and last online info
            $last_login_txt="";
            if ($user->last_login){
                // calculate number of days since update
                /*
                $modified_time_midnight=mktime(0, 0, 0, date('m',$user->last_login), date('d',$user->last_login), date('Y',$user->last_login));
                $num_of_days=(time()-$modified_time_midnight)/86400;
                if ($num_of_days<1){$last_online='today';}
                elseif ($num_of_days<2){$last_online='yesterday';}
                elseif ($num_of_days<6) $last_online=$num_of_days.' days ago';
                else {$last_online=date('jS F Y',$user->last_login);}
                */

                $last_login_txt=" and last online ".$user->lastOnline()." at ".date('H:i',$user->last_login);

            }
            if ($user->ip_address) $last_login_txt.=" (".$user->ip_address.")";

            $page_content['main'].="<h1>User ".$user->id."<span class=\"sub-head\">joined ".date("d/m/y",$user->created_time)." at ".date('H:i',$user->created_time).$last_login_txt."<span></h1>";

            $page_content['main'].="<div class=\"owner_bar\"><a href=\"?user=".$user->id."\" title=\"".$user->name."\"><i class=\"cms-fi-user\"></i>".$user->name."</a>&nbsp; <a href=\"?email_user=".$user->id."\" title=\"".$user->email."\"><i class=\"cms-fi-mail\"></i>".(display_type!='mobile' ? $user->email : "")."</a>";
            if ($user->phone!=''){$page_content['main'].="&nbsp; <a href=\"tel:".$user->phone."\" title=\"".$user->phone."\"><i class=\"cms-fi-phone\"></i>".$user->phone."</a>";}
            $page_content['main'].="</div>";


            $page_content['main'].="<form class=\"ctrl_bar\" method=\"post\">";
            if (admin_level('orders')>1){$page_content['main'].="<button type=\"submit\" formaction=\"?modify_order&new&user=".$user->id."\"><i class=\"cms-fi-doc-new\"></i>New Order</button>";}
            if (admin_level('subs')>1){$page_content['main'].="<button type=\"submit\" formaction=\"?modify_subscription&new&user=".$user->id."\"><i class=\"cms-fi-doc-new\"></i>New Subscription</button>";}
            $page_content['main'].="<button type=\"submit\" formaction=\"?users\" name=\"delete_customer[]\" value=\"".$user->id."\" onclick=\"return confirm('Warning: Are you sure you want to delete this user?');\" style=\"background-color: #eaa1a1\"><i class=\"cms-fi-times-circle\"></i>Delete User</button>";
            if (admin_level()>9 && display_type!='mobile'){
                $page_content['main'].="<button type=\"button\" onclick=\"javascript:open_win('?viewdata=user&amp;id=".$user->id."','Raw Data')\"><i class=\"cms-fi-database\"></i>Data</button>";
            }
            $page_content['main'].="</form>";

        }
        elseif (isset($_SESSION[cms_key]['reg_user']->id) && $_SESSION[cms_key]['reg_user']->id==$user_id){
            // display successful login warning
            if (isset($_SESSION[cms_key]['form']['login']['warning_green'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['login']['warning_green'],'green');}
            $page_content['main'].='<h1>'.$txt['my_account'].'</h1>';
        }


/*       if (isset($cmsSettings->user['profile_pages']) && $cmsSettings->user['profile_pages']>0){$page_content['main'].="<div class=\"txt_link_bar\"><a href=\"".cms_url."?myaccount=profile\">My Profile</a> | <a href=\"".cms_url."?myaccount=details\">Account Details</a> | <a href=\"".cms_url."?myaccount=orders\">".$txt['Orders']."</a> | <a href=\"".cms_url."?myaccount=subscriptions\">Subscriptions</a> |$listings_link <a href=\"".cms_url."?myaccount=preferences\">Preferences</a> | <a href=\"".cms_url."?logout\">Logout</a></div>";}
        else {$page_content['main'].="<div class=\"txt_link_bar\"><a href=\"".cms_url."?myaccount=details\">My Details</a> | <a href=\"".cms_url."?myaccount=orders\">Order History</a> | <a href=\"".cms_url."?myaccount=subscriptions\">Subscriptions</a> |$listings_link <a href=\"".cms_url."?myaccount=preferences\">Preferences</a> | <a href=\"".cms_url."?logout\">Logout</a></div>";}*/


        // display account nav menu
        $txt_links=array();
        if (cms_interface=="back"){
            if (isset($cmsSettings->user['profile_pages']) && $cmsSettings->user['profile_pages']>0){$txt_links[]="<a href=\"".cms_url."?profile=".$user_id."\" target=\"_blank\">View Profile</a> | ";}
            $txt_links[]="<a href=\"?user=".$user_id."\">User Details</a>";
            if (admin_level('orders')) $txt_links[]="<a href=\"?user=".$user_id."&amp;myaccount=orders\">Orders [".$user_order_count."]</a>";
            if (admin_level('subs')) $txt_links[]="<a href=\"?user=".$user_id."&amp;myaccount=subscriptions\">Subscriptions [".$user_subscription_count."]</a>";
            if (admin_level('applications')) $txt_links[]="<a href=\"?user=".$user_id."&amp;myaccount=applications\">Applications [".$user_application_count."]</a>";
            if (admin_level('bookings')) $txt_links[]="<a href=\"?user=".$user_id."&amp;myaccount=bookings\">Bookings [".$user_booking_count."]</a>";
            if (admin_level('listings')) $txt_links[]="<a href=\"?user=".$user_id."&amp;myaccount=listings\">Listings [".$user->itemCount('listings')."]</a>";
            if (admin_level('users')>1){
                $txt_links[]="<a href=\"?user=".$user_id."&amp;myaccount=settings\">Settings</a>";
                $txt_links[]="<a href=\"?user=".$user_id."&amp;myaccount=log\">Log</a>";
            }
        }
        else{
            if (isset($cmsSettings->user['profile_pages']) && $cmsSettings->user['profile_pages']>0){$txt_links[]="<a href=\"".cms_url."?myaccount=profile\">My Profile</a>";}
            if (isset($cmsSettings->user['account_details_access']) || $cmsSettings->user['account_details_access']>0){$txt_links[]="<a href=\"".cms_url."?myaccount=details\">My Details</a>";}
            if (user_level('orders')>0){$txt_links[]="<a href=\"".cms_url."?myaccount=orders\">".$txt['Orders']."</a>";}
            if (user_level('subs')>0){$txt_links[]="<a href=\"".cms_url."?myaccount=subscriptions\">".$txt['Subscriptions']."</a>";}
            if (user_level('listings')>0){$txt_links[]="<a href=\"".cms_url."?myaccount=listings\">".$txt['Listings']."</a>";}
            $txt_links[]="<a href=\"".cms_url."?myaccount=settings\">Settings</a>";
            $txt_links[]="<a href=\"".cms_url."?logout\">Logout</a>";
        }
        if (!empty($txt_links)){
            $page_content['main'].="<div class=\"txt_link_bar\">";
            $link_count=0;
            foreach($txt_links as $txt_link){
                if ($link_count>0){$page_content['main'].=" <span>|</span> ";}
                $page_content['main'].=$txt_link;
                $link_count++;
            }
            $page_content['main'].="</div>";
        }

        $account_summary="";

        // display customers orders
        $order_table_front_end="";
        if ($user_order_count){

            $order = new Order();

            $account_balance=0;

            $order_table_front_end="<table cellspacing=\"1\" cellpadding=\"4\" class=\"cms_table\" style=\"width: 100%\"><thead><tr><th style=\"text-align:left\">Date</th><th style=\"text-align:left\">".$txt['order_id']."</th><th style=\"text-align: center\">Balance</th></tr></thead><tbody>\n";
            $alternate_rowcol='';
            for ($item_num=0; $item_num<$user_order_count; $item_num++){

    	        $order_id=$users_orders[$item_num]['id'];

    	        if ($order->getData($order_id)){

                        if ($order->status>3) continue;

                        if (isset($order->currency_code)){
                            $currency_code=$order->currency_code;
                            $currency_symbol=get_currency_symbol($order->currency_code);
                        }
                        else{
                            $currency_code=currency_code;
                            $currency_symbol=currency_symbol;
                        }

                        // only show orders with total greater than zero
                       if ($order->getTotal()>0){

                            if ($order->status<1){

                                $order_balance = $order->getBalance();

                                $account_balance=$account_balance+$order_balance;
                                $order_status="<div style=\"color: #ff0000\">".formatPrice($order_balance,false,$currency_symbol)."</div>";

                                // display overdue notice
                                if ($order->due_date){
                                    $days_to_due=($order->due_date-time())/86400;
                                    if ($days_to_due<1){
                                        $order_status.="<div style=\"color: #ff0000\">Overdue</div>";
                                    }
                                }

                                $order_status.="<div><a href=\"".cms_url."?paynow=".$order->id."\">".$txt['pay_now']."</a></div>";
                            }
                            elseif ($order->status==1 || $order->status==2){$order_status='<font color="green">Paid</font>';}
                            elseif ($order->status==3){$order_status='Cancelled';}
                            elseif ($order->status>3){$order_status="<a href=\"".cms_url."?paynow=".$order->id."\">".$txt['pending']."</a>";}

                            if ($order->date){$order_date=$order->date;}else{$order_date=substr($order->id,0,-3);}

    		                //$order_table_front_end.="<tr".$alternate_rowcol."><td>".date("d/m/y",substr($order->id,0,-3))."</td><td><a href=\"".cms_url."?myaccount&amp;order=".$order_id."\">".$order_id."</a></td><td align=\"right\" style=\"padding-left: 15px\">".formatPrice($order_total,false,$currency_symbol)."</td><td align=\"right\" style=\"padding-left: 15px\">".formatPrice($order_total_balance,false,$currency_symbol)."</td><td style=\"text-align: center\">$order_status</td></tr>";
                            $order_table_front_end.="<tr".$alternate_rowcol."><td style=\"padding: 5px\">".date("d/m/y",$order_date)."</td><td><a href=\"".cms_url."?myaccount&amp;order=".$order->id."\">".$order->id."</a></td><td style=\"text-align: center\">".$order_status."</td></tr>\n";
                            if ($alternate_rowcol==''){$alternate_rowcol=' class="altrowcol"';}else{$alternate_rowcol='';}
                        }
    	        }

            }
            $order_table_front_end.="</tbody></table>";

            // todo we might want to add different account balances based on different order currencies here
            if (cms_interface=="back"){
                $account_summary.=" - Account balance is <b>".formatPrice($account_balance)."</b>";
                if ($account_balance>0){
                    $account_summary.=" <span style=\"color: #999;margin: 0 2px\">-</span> <a href=\"".cms_url."?paynow&amp;amount=".number_format($account_balance,2)."\">".$txt['pay_now']."</a> <span style=\"color: #999;margin: 0 2px\">-</span> <a href=\"?orders&amp;search[owner]=".$user_id."\">View Orders</a> <span style=\"color: #999;margin: 0 2px\">-</span> <a href=\"?email_user=".$user_id."&amp;account_summary=balance\">Remind</a>";
                }
            }
            elseif ($cmsSettings->order['show_balance']){
                $account_summary.=" - Your account balance is <b>".formatPrice($account_balance)."</b>";
                if ($account_balance>0){
                    $account_summary.=" <span style=\"color: #999;margin: 0 2px\">-</span> <a href=\"".cms_url."?paynow&amp;amount=".number_format($account_balance,2)."\">".$txt['pay_now']."</a> <span style=\"color: #999;margin: 0 2px\">-</span> <a href=\"".cms_url."?myaccount=orders\">View Orders</a>";
                }
            }

        }

        if ($rvi_myaccount=='') $rvi_myaccount='subscriptions';

        $subscriptions_table_front_end="";
        if ($user_subscription_count){

            $subscription = new Subscription();

            $subscriptions_table_front_end.="<form method=\"post\" action=\"\">";
            $subscriptions_table_front_end.="<table width=\"100%\" cellspacing=\"1\" cellpadding=\"4\" class=\"cms_table\">";
            $subscriptions_table_front_end.="<tr><th style=\"text-align: left\">Subscription</th><th style=\"text-align: center\">Price".($cmsSettings->b2b>0 ? " (".$txt['excl_tax'].")" : "")."</th><th width=\"80\" style=\"text-align: center\">Renew</th></tr>";
            /*
            if (defined('display_type') && display_type=='mobile'){
                $subscriptions_table_front_end.="<table width=\"100%\" cellspacing=\"1\" cellpadding=\"4\" class=\"cms_table\"><tr><th align=\"left\">Subscription</th><th>Price".($cmsSettings->b2b>0 ? " (".$txt['excl_tax'].")" : "")."</th><th width=\"80\">Renew</th></tr>";
            }
            else{
                $subscriptions_table_front_end.="<table width=\"100%\" cellspacing=\"1\" cellpadding=\"4\" class=\"cms_table\"><tr><th align=\"left\">Subscription</th><th>Price".($cmsSettings->b2b>0 ? " (".$txt['excl_tax'].")" : "")."</th><th>Expires</th><th>Status</th><th width=\"80\">Renew</th></tr>";
            }
            */
            $alternate_rowcol='';
            $expiring_soon_count=0;
            for ($item_num=0; $item_num<$user_subscription_count; $item_num++){

                if (!$subscription->getData($users_subscriptions[$item_num]['id'])) continue;

                // only show subscriptions with start time greater than zero
                if ($subscription->start_time){

                    $expire_time=$subscription->start_time+((($subscription->days*24)*60)*60);
                    $expire_date=date("d/m/y",$expire_time);

                    $expires_in_time=($subscription->start_time+($subscription->days*86400)-time());
                    if ($expires_in_time>0 && $expires_in_time<86400){$expiring_soon_count++;$expires_in_time='<span style="color: #ff0000">'.$expire_date.' (in '.intval(($expires_in_time/60)/60).' hrs)</span>';}
                    elseif($expires_in_time>0 && $expires_in_time<2592000){$expiring_soon_count++;$expires_in_time='<span style="color: #ff0000">'.$expire_date.' (in '.intval($expires_in_time/86400).' days)</span>';}
                    elseif($expires_in_time>0){$expires_in_time=$expire_date.' (in '.intval($expires_in_time/86400).' days)';}
                    else{$expiring_soon_count++;$expires_in_time='<span style="color: #ff0000">'.$expire_date.' (expired)</span>';}

                }
                else{$expires_in_time="NA";}

                if ($subscription->status>0){$status='Active';}else{$status='<span style=\"color: #ff0000\">Inactive</span>';}

                //$renew_form='<input type="hidden" name="add_to_cart" value="'.$subscription->product['id'].'" /> <input type="hidden" name="subscription_id" value="'.$subscription->id.'" />';

                $subscription_name_text=$subscription->name;
                /*
                if (isset($subscription->product->options)){
                    $subscription_name_text.="<div style=\"font-size: 12px;\">";
                    foreach ($subscription->product->options as $option => $value){
                        $subscription_name_text.=$option.': '.$value.'<br />';
                        //$renew_form.=' <input type="hidden" name="product_option['.$option.']" value="'.$value.'" />';
                    }
                    $subscription_name_text.="</div>";
                }
                */
                if (isset($subscription->product->customer_note)){
                    $subscription_name_text.="<div style=\"font-size: 12px;\">".$subscription->product->customer_note."</div>";
                    //$renew_form.=' <input type="hidden" name="customer_note" value="'.$subscription->product->customer_note.'" />';
                }

                $sub_renewal_price="";         
                if ($subscription->price_net){
                    if ($cmsSettings->b2b>0){
                        $sub_renewal_price=$subscription->price_net / (($subscription->tax_rate / 100) + 1);
                    }
                    else{$sub_renewal_price=$subscription->price_net;}

                    if (isset($subscription->currency_code)){
                        $currency_code=$subscription->currency_code;
                        $currency_symbol=get_currency_symbol($subscription->currency_code);
                    }
                    else{
                        $currency_code=currency_code;
                        $currency_symbol=currency_symbol;
                    }

                    $sub_renewal_price=formatPrice($sub_renewal_price,false,$currency_symbol);

                }

                if (defined('display_type') && display_type=='mobile'){
                    $subscriptions_table_front_end.='<tr'.$alternate_rowcol.'><td><div style="width: 200px; word-wrap: break-word">'.$subscription_name_text.'</div><div style=\"font-size: 0.813em\">Expires: '.$expires_in_time.'<br>Status: '.$status.'</div></td><td style="text-align: center">'.$sub_renewal_price.'</td><td style="text-align: center"><input type="checkbox" name="renew_sub_ids[]" value="'.$subscription->id.'" style=\"transform: scale(1.5)\" /></td></tr>';
                }
                else{
                    $subscriptions_table_front_end.='<tr'.$alternate_rowcol.'><td><div>'.$subscription_name_text.'</div><div style=\"font-size: 0.813em\">Expires: '.$expires_in_time.'<br>Status: '.$status.'</div></td><td style="text-align: center">'.$sub_renewal_price.'</td><td style="text-align: center"><input type="checkbox" name="renew_sub_ids[]" value="'.$subscription->id.'" style=\"transform: scale(1.2)\" /></td></tr>';
                    //$subscriptions_table_front_end.='<tr'.$alternate_rowcol.'><td valign="top">'.$subscription_name_text.'</td><td valign="top" align="center">'.$sub_renewal_price.'</td><td valign="top" align="center">'.$expires_in_time.'</td><td valign="top" align="center">'.$status.'</td><td valign="top" align="center"><input type="checkbox" name="renew_sub_ids[]" value="'.$subscription->id.'" /></td></tr>';
                }

                if ($alternate_rowcol==''){$alternate_rowcol=' class="altrowcol"';}else{$alternate_rowcol='';}


            }

            $subscriptions_table_front_end.="<tr><td colspan=\"5\" style=\"text-align: right; padding: 5px\"><input type=\"submit\" name=\"renew_subs\" value=\"Renew Selected\" class=\"cms_btn\" /></td></tr></table>";

            //if ($cmsSettings->b2b>0){$txt['my_account_subscriptions_text_bottom']="Prices shown exclude tax. ".$txt['my_account_subscriptions_text_bottom'];}

            $subscriptions_table_front_end.="<div style=\"margin-top: 15px\">".$txt['my_account_subscriptions_text_bottom']."</div>";

            if ($expiring_soon_count>0){
                if (cms_interface=="back"){
                    $account_summary.="<div style=\"color: #ff0000;border: dashed #ff0000 1px;padding: 5px 10px;margin: 5px auto;\"><a href=\"?subscriptions&amp;search[owner]=".$user_id."\" style=\"color: #ff0000; text-decoration: none\"><span style=\"color: #ff0000;text-decoration: underline\">".$expiring_soon_count." subscriptions</span> expired or expiring soon</a></div>";
                }
                else{
                    $account_summary.="<div style=\"color: #ff0000;border: dashed #ff0000 1px;padding: 5px 10px;margin: 5px auto;\"><a href=\"".cms_url."?myaccount=subscriptions\" style=\"color: #ff0000;text-decoration: none\"><span style=\"color: #ff0000;text-decoration: underline\">".$expiring_soon_count." subscriptions</span> expired or expiring soon</a></div>";
                }
            }
        }
        else{$subscriptions_table_front_end.='No active subscriptions found.';}

        // display account summary text
        if (isset($account_summary)){
            $page_content['main'].="<hr /><div class=\"acc_summary\">";
            if (cms_interface=="back"){$page_content['main'].=$user->name;}
            else{$page_content['main'].="Welcome ".short_name($user->name);}
            $page_content['main'].=$account_summary."</div><hr />";
        }

		if ($rvi_myaccount=='details'){

			if (isset($rvi_save)){

				$user->name = sanitize_text_input($rvi_name);
				$user->phone = sanitize_text_input($rvi_phone);

				if (isset($rvi_dob['m'])) $user->dob['m']=$rvi_dob['m'];
				if (isset($rvi_dob['d'])) $user->dob['d']=$rvi_dob['d'];
				if (isset($rvi_dob['y'])) $user->dob['y']=$rvi_dob['y'];

				$user->addr->line1=sanitize_text_input($rvi_address);
				$user->addr->line2=sanitize_text_input($rvi_address_2);
				$user->addr->city=sanitize_text_input($rvi_city);
				$user->addr->county=sanitize_text_input($rvi_county);
				$user->addr->postcode=sanitize_text_input($rvi_postcode);
				$user->addr->country=sanitize_text_input($rvi_country);

                $user->company=sanitize_text_input($rvi_company);
                if (isset($rvi_bill_company)) $user->bill_company=1; else $user->bill_company=0;

                if (isset($rvi_bio)){
                    $user->bio=sanitize_text_input($rvi_bio);
                    if (strlen($user->bio)>260){$_SESSION[cms_key]['form']['myaccount_details']['warning'][]='About Me text is too long.';}
                }

                $user->links = array();
                if (!empty($rvi_links)){
                    foreach ($rvi_links as $link_name => $link_url){
                        $user->links[$link_name] = sanitize_text_input($link_url);

                        if ($user->links[$link_name] && substr($link_url,0,8)!='https://' && substr($link_url,0,7)!='http://' && substr($link_url,0,2)!='//'){
                            $_SESSION[cms_key]['form']['myaccount_details']['warning'][] = "Invalid URL in profile links. Link URLs must begin with https:// or http://";
                            break;
                        }

                    }
                }

			
				// check values
				if (strlen($user->name)<2){$_SESSION[cms_key]['form']['myaccount_details']['warning'][]='Please enter your name';}

                // check image
            	if (is_uploaded_file($_FILES['image_file']['tmp_name'])){
                    if ($_FILES['image_file']['size']>MAX_UPLOAD_IMAGE_SIZE || ($_FILES['image_file']['type']!="image/pjpeg" && $_FILES['image_file']['type']!="image/jpeg" && $_FILES['image_file']['type']!="image/png" && $_FILES['image_file']['type']!="image/gif")){$_SESSION[cms_key]['form']['myaccount_details']['warning'][]="Error uploading image file. Invalid file type.";}
                    else{
                        // get size of uploaded image
                		$image_size=getimagesize($_FILES['image_file']['tmp_name']);
                        if ($image_size[2]!=IMAGETYPE_JPEG && $image_size[2]!=IMAGETYPE_PNG && $image_size[2]!=IMAGETYPE_GIF){$_SESSION[cms_key]['form']['myaccount_details']['warning'][]="Error uploading image file. Invalid file type.";}
                        elseif ($image_size[0]>MAX_UPLOAD_IMAGE_DIM || $image_size[1]>MAX_UPLOAD_IMAGE_DIM){$_SESSION[cms_key]['form']['myaccount_details']['warning'][]="Error uploading image file. Image dimensions (".$image_size[0]."x".$image_size[1].") are too big.";}
                        else{
                            //$image_fn=safe_file_name($_FILES['image_file']['name']);
                            $image_fn=$_FILES['image_file']['name'];
                            createthumb($_FILES['image_file']['tmp_name'],sys_image_dir.'/temp.jpg',100,100,1);
                            if (!file_exists(sys_image_dir.'/temp.jpg')){$_SESSION[cms_key]['form']['myaccount_details']['warning'][]="Error uploading image file. Image file must be a jpeg.";}
                            else{
                                $user->profile_image=$image_fn;
                            }
                        }
                    }
            	}

				if (!isset($_SESSION[cms_key]['form']['myaccount_details']['warning'])){

                    // saving image
            		if (is_uploaded_file($_FILES['image_file']['tmp_name']) && isset($user->profile_image)){
                        $save_dir=sys_data_dir.'/users/'.$user->id.'/';
            			if ($image_size[0]>MAX_UPLOADED_IMAGE_SIZE_X || $image_size[1]>MAX_UPLOADED_IMAGE_SIZE_Y){
                            // resize orignal image if bigger than max uploaded image sizes
                            createthumb($_FILES['image_file']['tmp_name'],$save_dir.$image_fn,MAX_UPLOADED_IMAGE_SIZE_X,MAX_UPLOADED_IMAGE_SIZE_Y,1);
            			}
                        elseif ($_FILES['image_file']['size']>MAX_UPLOADED_IMAGE_SIZE){
                            // resize orignal image if filesize is over MAX_UPLOADED_IMAGE_SIZE
                            createthumb($_FILES['image_file']['tmp_name'],$save_dir.$image_fn,$image_size[0],$image_size[1],1);
                        }
                        else{
                            // store original image as uploaded without resizing
            				move_uploaded_file($_FILES['image_file']['tmp_name'],$save_dir.$image_fn) or die ("Error - Could not copy Image File");
            			}
            		}

                    // back end only, user groups and admin note
                    if (cms_interface=="back"){
                        // first we clear out the user_groups for the user then we will add in the selected ones
                        $old_user_groups=$user->user_group;
                        $user->user_group=array();
                        $usergroup = new Usergroup();
                        if ($old_user_groups){
                            foreach ($old_user_groups as $user_group_id){
                                if ($usergroup->getData($user_group_id)){
                                    // always keep admin type usergroups as not shown unless main admin
                                    if (admin_level()<10 && $usergroup->admin) $user->user_group[]=$user_group_id;
                                }
                            }
                            unset($old_user_groups);
                        }

                        // add any selected usergroups for the user
            			if (!empty($_POST['user_groups'])){
            				foreach ($_POST['user_groups'] as $user_group_id)
            					$user->user_group[]=$user_group_id;
            			}

                        $user->admin_note=$_POST['admin_note'];

                    }
                         //debug($user->user_group,0);
					// update customers details file
					if ($user->saveItem())
                        updateItemIndex('users',array($user->id));

                    // log customer back in with new details
                    if (isset($_SESSION[cms_key]['reg_user']->id) && $_SESSION[cms_key]['reg_user']->id==$user_id)
                        login_user($user);

                    if (cms_interface=="back")
                        $_SESSION[cms_key]['form']['myaccount_details']['warning_green'][]='User details have been updated.';
                    else
					    $_SESSION[cms_key]['form']['myaccount_details']['warning_green'][]='Your account details have been updated.';
				}
			
			}

            $page_content['main'].="<h3>".(cms_interface=="back" ? "Account Details" : "My Details")."</h3>";

            if (cms_interface=="back"){
			    $page_content['main'].="<p>Update account details for this user below. Users can update their own details at any time by logging into their <a href=\"".cms_url."?myaccount=details\" target=\"_blank\">user account page</a> and can also reset their password using the <a href=\"".cms_url."?forgot_password\" target=\"_blank\">forgot password page</a>.</p>";
            }else{
                $page_content['main'].="<p>Update your account details below.</p>";
            }

            // display warnings
            if (isset($_SESSION[cms_key]['form']['myaccount_details']['warning'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['myaccount_details']['warning']);}
            elseif (isset($_SESSION[cms_key]['form']['myaccount_details']['warning_green'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['myaccount_details']['warning_green'],'green');}

			// show hide javascript
            if (cms_interface=='front'){
			$page->meta.='<script type="text/javascript" src="'.cms_root_url.'/plugins/jquery.qtip/jquery.qtip.min.js"></script>
            <link type="text/css" rel="stylesheet" href="'.cms_root_url.'/plugins/jquery.qtip/jquery.qtip.min.css" />
            <script type="text/javascript">
            $(document).ready(function(){

                $(\'.tooltip\').qtip();

            });

            function restrict(mytextarea) {

    var maxlength = 255; // specify the maximum length

    if (mytextarea.value.length > maxlength){

    mytextarea.value = mytextarea.value.substring(0,maxlength);
    mytextarea.scrollTop = mytextarea.scrollHeight;

    }

    } // --> </script>';
    }




			$page_content['main'].="<form action=\"\" class=\"cms_form\" method=\"post\" enctype=\"multipart/form-data\" autocomplete=\"off\">
            <a name=\"contact_details\"></a>
			<div class=\"form_row form_row_medium\"><label>Name:</label><input type=\"text\" name=\"name\" value=\"".$user->name."\" ".$disable."/></div>";
            if (cms_interface=="back"){
                if (admin_level()>9){
                    $page_content['main'].="<div class=\"form_row form_row_medium\"><label>Email:</label><div><a href=\"?email_user=".$user->id."\">".$user->email."</a>".($user->verified>0 ? " (Verified)" : " (Unverified)" )." <a href=\"?user=".$user_id."&amp;myaccount=email\">Change</a></div></div>";
                }
                else{
                    $page_content['main'].="<div class=\"form_row form_row_medium\"><label>Email:</label><div><a href=\"?email_user=".$user->id."\">".$user->email."</a>".($user->verified>0 ? " (Verified)" : " (Unverified)" )."</div></div>";
                }
            }
            else{
               $page_content['main'].="<div class=\"form_row form_row_medium\"><label>Email:</label>".$user->email."</div>";
            }
			$page_content['main'].="<div class=\"form_row form_row_medium\"><label>Phone:</label><input type=\"text\" name=\"phone\" value=\"".(isset($user->phone) ? $user->phone : "")."\" ".$disable."/></div>
            <hr />";

            $page_content['main'].="<div class=\"form_row\"><label>Address:</label><input type=\"text\" name=\"address\" value=\"".$user->addr->line1."\" ".$disable."/></div>
            <div class=\"form_row\" style=\"margin: 0\"><label class=\"zero_height\"></label><input type=\"text\" name=\"address_2\" value=\"".$user->addr->line2."\" ".$disable."/></div>";

            $page_content['main'].="<div class=\"form_row form_row_medium\"><label>Town/City:</label><input type=\"text\" name=\"city\" value=\"".(isset($user->addr->city) ? $user->addr->city : '')."\" ".$disable."/></div>
			<div class=\"form_row form_row_medium\"><label>County:</label><input type=\"text\" name=\"county\" value=\"".(isset($user->addr->county) ? $user->addr->county : '')."\" ".$disable."/></div>";
			$page_content['main'].="<div class=\"form_row form_row_medium\"><label>Post Code:</label><input type=\"text\" name=\"postcode\" value=\"".(isset($user->addr->postcode) ? $user->addr->postcode : '')."\" ".$disable."/></div>";
			$page_content['main'].="<div class=\"form_row form_row_medium\"><label>Country:</label><select name=\"country\"".$disable."><option value=\"\">---</option>";
            if ($countries=getCountries()){
                foreach ($countries as $country){
                    if (isset($user->addr->country) && $user->addr->country==$country)
                        $page_content['main'].="<option selected>".$country."</option>";
                    else
                        $page_content['main'].="<option>".$country."</option>";
                }
            }
			$page_content['main'].="</select></div>";

            //if (isset($cmsSettings->user['profile_pages']) && $cmsSettings->user['profile_pages']>0){
                $page_content['main'].="<hr />
                <div class=\"form_row\"><label>Company:</label><input type=\"text\" name=\"company\" value=\"".(isset($user->company) ? $user->company : '')."\" ".$disable."/></div>
                <div class=\"form_row\"><label>Bill Company:</label><div><input type=\"checkbox\" name=\"bill_company\" ".((isset($user->bill_company) && $user->bill_company>0) ? 'checked="checked"' : '')." ".$disable."/> <span class=\"small_note\">bill orders to company</span></div></div>
                <hr />
                <div class=\"form_row\"><label>Profile Pic:</label><input type=\"file\" name=\"image_file\"".$disable."/></div>
                <hr />
                <div class=\"form_row\"><label>About Me:</label><textarea name=\"bio\" id=\"bio\" onkeyup=\"restrict(this.form.bio)\" style=\"width: 100%; height: 100px\"".$disable.">".(isset($user->bio) ? $user->bio : '')."</textarea></div>";

                $page_content['main'].="<hr />
                <div class=\"form_row form_row_small\"><label>Date of Birth:</label><select name=\"dob[m]\"".$disable." style=\"margin-left: 10px;\"><option value=\"\">---</option>";
    			$months=array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
    			foreach ($months as $month){
    				if ($user->dob['m']==$month)
    					$page_content['main'].="<option selected=\"selected\">".$month."</option>";
    				else
    					$page_content['main'].="<option>".$month."</option>";
    			}
    			$page_content['main'].="</select>
    			<select name=\"dob[d]\"".$disable." style=\"margin-left: 10px;\"><option value=\"\">---</option>";
    			for ($day=1; $day<=31; $day++){
    				if ($user->dob['d']==$day)
    					$page_content['main'].="<option selected=\"selected\">".$day."</option>";
    				else
    					$page_content['main'].="<option>".$day."</option>";
    			}
    			$page_content['main'].="</select>
    			<select name=\"dob[y]\"".$disable." style=\"margin-left: 10px;\"><option value=\"\">---</option>";
                $min_age = 1; // could add a min age cms setting in the future
                $start_year = date("Y",time())-$min_age;
                $end_year = $start_year - 110;
    			for ($year=$start_year; $year>=$end_year; $year--){
    				if ($user->dob['y']==$year)
    					$page_content['main'].="<option selected=\"selected\">".$year."</option>";
    				else
    					$page_content['main'].="<option>".$year."</option>";
    			}
    			$page_content['main'].="</select></div>

                <hr />
                <div class=\"form_row\"><label>Website:</label><input type=\"text\" name=\"links[website]\" value=\"".(isset($user->links['website']) ? $user->links['website'] : "")."\" ".$disable."/></div>
                <div class=\"form_row\"><label>Facebook:</label><input type=\"text\" name=\"links[facebook]\" value=\"".(isset($user->links['facebook']) ? $user->links['facebook'] : "")."\" ".$disable."/></div>
                <div class=\"form_row\"><label>LinkedIn:</label><input type=\"text\" name=\"links[linkedin]\" value=\"".(isset($user->links['linkedin']) ? $user->links['linkedin'] : "")."\" ".$disable."/></div>
                <div class=\"form_row\"><label>Twitter:</label><input type=\"text\" name=\"links[twitter]\" value=\"".(isset($user->links['twitter']) ? $user->links['twitter'] : "")."\" ".$disable."/></div>
                <div class=\"form_row\"><label>Youtube:</label><input type=\"text\" name=\"links[youtube]\" value=\"".(isset($user->links['youtube']) ? $user->links['youtube'] : "")."\" ".$disable."/></div>";

            //}



            if (cms_interface=="back"){

                // jquery multiselect javascript
                $page_meta.="<link rel=\"stylesheet\" href=\"../plugins/jquery-ui-multiselect-widget-2.0.1/jquery.multiselect.css\" type=\"text/css\" />
                <link rel=\"stylesheet\" href=\"../plugins/jquery-ui-multiselect-widget-2.0.1/jquery.multiselect.filter.css\" type=\"text/css\" />
                <link rel=\"stylesheet\" type=\"text/css\" href=\"../plugins/jquery/jquery-ui-1.12.1/jquery-ui.min.css\" />
                <script src=\"../plugins/jquery/jquery-ui-1.12.1/jquery-ui.min.js\"></script>
                <script src=\"../plugins/jquery-ui-multiselect-widget-2.0.1/src/jquery.multiselect.js\" ></script>
                <script src=\"../plugins/jquery-ui-multiselect-widget-2.0.1/src/jquery.multiselect.filter.js\" ></script>";

                $page_meta.="<script>
                	$(document).ready(function(){
                		$(\"#user_groups_select\").multiselect({
                            noneSelectedText: \"Select User Groups\",
                            selectedText: \"# User Groups Selected\",
                            selectedList: 1,
                            minWidth: 50
                        }).multiselectfilter();
                  });
                  </script>";


                $page_content['main'].="<hr />

<div class=\"form_row\"><p class=\"small_note\">Select the user groups for this user below.</p>";

        		// display user groups
                $usergroup_text="";
                if ($usergroups=get_items('usergroups',null,null,'id',null,null,null,null,array('name','admin'))){
                    foreach ($usergroups as $usergroup_num => $value){
                        if ($value['id']<2) continue;
                            if ($value['admin']>0){
                            if (admin_level()<10){continue;}
                            $value['name']="admin: ".$value['name'];
                        }
        				$usergroup_text.="<option value=\"".$value['id']."\" ".(in_array($value['id'],$user->user_group) ? "selected=\"selected\"" : "").">".$value['name']."</option>";
        			}
        		}
                if ($usergroup_text==""){
                    $page_content['main'].="<p class=\"small_note\">No user groups found".(admin_level('users')>1 ? " - <a href=\"?settings=add_usergroup\">Add new usergroup</a>" : ".")."</p>";
                }
                else{$page_content['main'].="<div><select name=\"user_groups[]\" id=\"user_groups_select\" multiple=\"multiple\">".$usergroup_text."</select></div>";}


               $page_content['main'].="</div>";
                // get subscribed user groups
                $search_for_user['customer_id']=$user_id;
                $user_subscription_count=0;
                if ($users_subscriptions=get_items('subscriptions',null,null,null,null,$search_for_user)){$user_subscription_count=count($users_subscriptions);}

                if ($user_subscription_count>0){

                    for ($item_num=0; $item_num<$user_subscription_count; $item_num++){
                        if ($subscription->getData($users_subscriptions[$item_num]['id'])){
                            if ($subscription->status>0 && !empty($subscription->subUserGroups))
                                $subscribed_user_groups[$subscription->id]=$subscription;
                        }
                    }
                    // display subscribed user groups
                    if (isset($subscribed_user_groups)){
                        $page_content['main'].="<p class=\"small_note\">This user currently has ".count($subscribed_user_groups)." active subscription(s) to the user groups below.</p>";

                        foreach ($subscribed_user_groups as $subscription_id => $subscription_details){
                            $expires_in_time=($subscription->start_time+($subscription->days*86400)-time());
                            if ($expires_in_time>0 && $expires_in_time<86400){$expires_in_time='<span style="color: #ff0000">expires in '.intval(($expires_in_time/60)/60).' hrs</span>';}
                            elseif($expires_in_time>0 && $expires_in_time<2592000){$expires_in_time='<span style="color: #ff0000">expires in '.intval($expires_in_time/86400).' days</span>';}
                            elseif($expires_in_time>0){$expires_in_time='expires in '.intval($expires_in_time/86400).' days';}
                            else{$expires_in_time='expired';}
                            $page_content['main'].="<div style=\"padding-bottom: 4px\">Subscription: <a href=\"?modify_subscription=".$subscription_id."\">".$subscription->name."</a> (".$expires_in_time.")<br />User Groups: ";
                            $counter=0;
                            foreach ($subscription->product['subscription_user_group'] as $user_group_id){
                                if (!isset($user_groups[$user_group_id])){continue;}
                                if ($counter>0){$page_content['main'].=', ';}
                                $page_content['main'].=$user_groups[$user_group_id]['name'];
                                $counter++;
                            }
                            $page_content['main'].="</div>";
                        }
                    }
                }


                $page_content['main'].="<hr />";
                $page_content['main'].="<h3>Admin Notes</h3><p>These notes are only visible to admin users.</p>
                <div class=\"form_row\"><textarea name=\"admin_note\"".$disable.">".(isset($user->admin_note) ? $user->admin_note : "")."</textarea></div>";

            }



            if($disable=="" || (isset($_SESSION[cms_key]['reg_user']->id) && $_SESSION[cms_key]['reg_user']->id==$user_id)){$page_content['main'].="<div class=\"form_row_footer\"><input class=\"cms_btn\" type=\"submit\" name=\"save\" value=\"".(cms_interface=='back' ? "Save Account Details" : "Save My Details")."\" /></div>";}
            $page_content['main'].="</form>";
		
		}
        elseif ($rvi_myaccount=='profile'){

            $rvi_profile=$user_id;
            include('user_profile.php');

        }
		elseif ($rvi_myaccount=='referrals'){
            /*
			$page_content['main'].="<h3>Referrals</h3>";
						
			$referrals=get_refferals($_SESSION[cms_key]['reg_user']->id);

			// display this customers referred orders
			$referred_order_count=0;
			if (isset($referrals['order'])){
				foreach ($referrals['order'] as $order_id => $vaule){
					$order_details=get_item_details('order',$order_id);
					if (is_array($order_details) && substr($order_details['status'],0,4)=="paid"){$referred_order_count++;}
				}
			}
			
			// display this customers referred customers
			$referred_customer_count=0;
			if (isset($referrals['member'])){
				foreach ($referrals['member'] as $member_id => $vaule){
					$user_details=get_item_details('customer',$member_id);
					if (is_array($user_details)){$referred_customer_count++;}
				}
			}
			$page_content['main'].="<p>You have referred <b>".$referred_order_count." orders</b> and <b>".$referred_customer_count." members</b>.</p>
			<p>To refer people to ".cms_site_name." simply append your member id <b>ref=".$_SESSION[cms_key]['reg_user']->id."</b> to your links. You may link directly to any page URL (eg. a particular product/category) that begins with <b>".cms_url."?</b><br /><br />Example Link: ".cms_url."?ref=".$_SESSION[cms_key]['reg_user']->id."</p>";
            */
		}
		elseif ($rvi_myaccount=='settings'){

            if (cms_interface=="back"){
                $page_content['main'].="<h3>Settings</h3><p><span style=\"color: #ff0000 \">Important:</span> Never change a users email preferences without their consent. Sending unsolicited emails can lead to emails being flagged as spam and potential blacklisting.</p>";
            }
            else{
			    $page_content['main'].="<h3>Settings</h3>";
            }

			if (isset($rvi_save_settings)){

				if (empty($rvi_newsetter_subscription))
                    $user->newsletterSub=false;
				else
                    $user->newsletterSub=true;

				// update customers details file
				$user->saveItem();
				
				$settings_updated=TRUE;
				
			}

			if (isset($settings_updated)){$page_content['main'].=display_warnings(array('Settings Saved'),'green');}

			$page_content['main'].="<form method=\"post\" action=\"\">
				<table class=\"basic_table\"><tbody>";

                if (cms_interface=="back"){
                    /*
                    $page_content['main'].="<tr><td>New Password:</td><td><input type=\"password\" name=\"new_password\" value=\"\"></td></tr>
                    <tr><td>Re-Type:</td><td><input type=\"password\" name=\"confirm_new_password\" value=\"\"></td></tr>";
                    */
                    if ($disable==""){
                        $page_content['main'].="<tr><td>Password:</td><td><a href=\"?user=".$user_id."&amp;myaccount=password\">Change password</a></td></tr>";
                        $page_content['main'].="<tr><td colspan=\"2\"><hr /></td></tr>";
                    }
                }
                else{
                    $page_content['main'].="<tr><td>Password:</td><td><a href=\"".cms_url."?myaccount=password\">Change my password</a></td></tr>";
                    $page_content['main'].="<tr><td colspan=\"2\"><hr /></td></tr>";
                }


				$page_content['main'].="<tr><td valign=\"top\">Receive Newsletter: </td><td><input type=\"checkbox\" name=\"newsetter_subscription\" "; if($user->newsletterSub){$page_content['main'].="checked=\"checked\" ";} $page_content['main'].="/><br /><span class=\"small_note\">Check this box to receive our newsletter emails.<br />Uncheck if you do not want to receive our newsletter.</span></td></tr>
				<tr><td align=\"right\" colspan=\"2\"><button type=\"submit\" name=\"save_settings\" class=\"cms_btn\">Save Settings</button></td></tr>
				<tbody></table>
				</form>";
			
			
		}
		elseif ($rvi_myaccount=="password"){

			if (isset($rvi_change_password_submit)){

				// check old password match
                if (cms_interface=="front" && check_password($user->password,$rvi_old_password,$user_id)!=true)
                    $_SESSION[cms_key]['form']['myaccount_changepass']['warning'][]="Current password is not correct";
				if (strlen($rvi_new_passsword)<4)
                    $_SESSION[cms_key]['form']['myaccount_changepass']['warning'][]="New password is too short (min 4 characters)";
				if ($rvi_new_passsword!=$rvi_confirm_passsword)
                    $_SESSION[cms_key]['form']['myaccount_changepass']['warning'][]="Confirm password does match";

				if (!isset($_SESSION[cms_key]['form']['myaccount_changepass']['warning'])){
					// update password in session
					$user->password=encrypt_password($rvi_new_passsword,$user_id);
					// update customers details file
					if ($user->saveItem()){
                        update_item_log('user',$user->id,short_name($user->name,2)." ".$user->id." changed password");

                        // we only really want to send email if admin specifies, user doesn't really need the email if they change it themselves
                        //if (cms_interface=="front" || isset($rvi_admin_send_email)){
                        if (isset($rvi_admin_send_email)){

                            require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

            			    $mail = new PHPMailer();

                            // send mail via smtp if set in config file
                            if (smtp_host){
                                $mail->IsSMTP(); // send via SMTP
                                $mail->SMTPAuth = true; // turn on SMTP authentication
                                $mail->SMTPSecure = 'ssl';
                                $mail->Username = smtp_username; // SMTP username
                                $mail->Password = smtp_password; // SMTP password
                                $mail->Host       = smtp_host; // SMTP server
                                $mail->Port       = smtp_port; // SMTP server
                            }

            				// send confirmation email to user
            				$mail->From = $cmsSettings->config['site_email'];
            				$mail->FromName = cms_site_name;
            				$mail->AddAddress($user->email);

            				$mail->Subject = cms_site_name.' - Password Changed';
                            if ($user->verified<1){$verify_text='Click on the link below to verify your account and login.';}else{$verify_text='Click on the link below to login.';}
                            $mail->Body    = "Hi ".$user->name.",\n\nYour new login password is ".$rvi_new_passsword."\n\n".$verify_text."\n\n".user_login_link($user,"?myaccount=password")."\n\n\n".cms_site_name."\n".cms_site_url;
                            $mail->IsHTML(FALSE);

            				if(!$mail->Send()){
                                update_item_log('user',$user->id,"Warning: reset password email could not be sent");
                            }
                        }

                        $_SESSION[cms_key]['form']['myaccount_changepass']['warning_green'][]="Password changed successfully";

                    }


				}

			}

			$page_content['main'].="<h3>Change Password</h3>";

            if (cms_interface=="back"){
                $page_content['main'].="<p>Change the login password for this user below.</p>";
            }
            else{
                $page_content['main'].="<p>Enter your current password and new password below.</p>";
            }

            // display warnings
            if (isset($_SESSION[cms_key]['form']['myaccount_changepass']['warning'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['myaccount_changepass']['warning']);}
            if (isset($_SESSION[cms_key]['form']['myaccount_changepass']['warning_green'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['myaccount_changepass']['warning_green'],'green');}

            $page_content['main'].="<form method=\"post\" action=\"\" class=\"cms_form\">
            ";
            if (cms_interface=="front"){
                $page_content['main'].="<div class=\"form_row form_row_medium\"><label>Current:</label><input type=\"password\" name=\"old_password\"></div>
                <hr />";
            }
            $page_content['main'].="<div class=\"form_row form_row_medium\"><label>New Pass:</label><input type=\"password\" name=\"new_passsword\"></div>
            <div class=\"form_row form_row_medium\"><label>Confirm:</label><input type=\"password\" name=\"confirm_passsword\"></div>";

            if (cms_interface=="back"){
                $page_content['main'].="<div class=\"small_note\"><hr /><input type=\"checkbox\" name=\"admin_send_email\" ".(isset($_SESSION[cms_key]['form']['no_email']) ? 'checked="checked" ' : '')." /> Check to send new password email to user</div>";
            }
            $page_content['main'].="<div class=\"form_row\"><button type=\"submit\" name=\"change_password_submit\" class=\"cms_btn\">Change Password</button></div>

            </form>";


		}
        elseif ($rvi_myaccount=="email" && cms_interface=="back"){

			if (isset($rvi_change_email_submit)){

                $rvi_new_email=trim($rvi_new_email);

				// check email
				require(cms_root_dir."scripts/emailval.php");
		        if (strlen($rvi_new_email)<4 || strlen($rvi_new_email)>200 || MailVal($rvi_new_email,2)){$_SESSION[cms_key]['form']['myaccount_change_email']['warning'][]="Email address not valid";}
		        elseif (email_registered($rvi_new_email)){$_SESSION[cms_key]['form']['myaccount_change_email']['warning'][]=$txt['Warning_email_registered'];}

				if (!isset($_SESSION[cms_key]['form']['myaccount_change_email']['warning'])){
                    update_item_log('user',$user->id,"Email address changed, user ".$user->id);
                    if (!isset($user->admin_note)){$user->admin_note="";}
					$user->admin_note=$user->admin_note."\n\n".date('d/m/y H:i:s',time())." "."Email address changed from ".$user->email;
					$user->email=$rvi_new_email;
                    $user->verified=0;
					// update customers details file
					if ($user->saveItem())
                        updateItemIndex('users',array($user->id));

					$email_change_success=TRUE;
				}

			}

			$page_content['main'].="<h3>Change Email Address</h3>";

            $page_content['main'].="<p>Change the email address for this user below. <b>Important:</b> This user will need to use the new email address to login and the owner of the new email address will be granted full access to this user account including any subscriptions, listings or orders associated with the account.</p>";

			if (isset($email_change_success)){$page_content['main'].=display_warnings(array('Email changed successfully'),'green');}
			else{

                // display warnings
                if (isset($_SESSION[cms_key]['form']['myaccount_change_email']['warning'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['myaccount_change_email']['warning']);}

				$page_content['main'].="<form method=\"post\" action=\"\">
				<table>";

                $page_content['main'].="<tr><td>Old Email: </td><td>".$user->email."</td></tr>
                <tr><td colspan=\"2\"><hr /></td></tr>";

                $page_content['main'].="<tr><td>New Email: </td><td><input type=\"text\" name=\"new_email\"></td></tr>";

				$page_content['main'].="<tr><td align=\"right\" colspan=\"2\"><input type=\"submit\" name=\"change_email_submit\" value=\"Change Email\"></td></tr></table>

				</form>";
			}

		}
        elseif (isset($rvi_modify_listing)){
            $page_content['main'].="<h3>Edit ".$txt['Listing']."</h3>";
            include(cms_root_dir.'includes/users/listings/listing_modify.php');
        }
        elseif (isset($rvi_order)){

            $page_content['main'].="<h3>Order ".$rvi_order."</h3>";

			// display order detail
			if ($order->getData($rvi_order)){

                $page_content['main'].="<p>For a print friendly version of this invoice <a href=\"".cms_url."?print_invoice=".$rvi_order."\" target=\"_blank\">click here</a>.";

                if ($order->status<1 || $order->status>3){$page_content['main'].=' To pay this invoice <a href="'.cms_url.'?paynow='.$order->id.'">click here</a>.';}

                $page_content['main'].="</p>";

                // display order invoice
                if (defined('display_type') && display_type=='mobile'){include(cms_root_dir.'includes/shop/view_invoice_mobile.php');}
                else{include(cms_root_dir.'includes/shop/view_invoice.php');}
                $page_content['main'].=$invoice;

			}else{$page_content['main'].='Order details not found.';}


		}
        elseif ($rvi_myaccount=="listings" && user_level('listings')>0){

            if (cms_interface=="back"){
                $rvi_search['owner']=$user->id;
                include(cms_root_dir.'admin/includes/users/listings/listings.php');
            }
            else{

                // show hide javascript
    			$page->meta.="<script language=\"javascript\">
    			function checker(message){return confirm(message);}
    			</script>";

                // delete selected listings
            	if (isset($rvi_delete_listings) && !empty($rvi_select_listing_ids)){
                    $del_listing= new Listing();
                    $update_index=false;
                    foreach ($rvi_select_listing_ids as $listing_id){
                        if ($del_listing->getData($listing_id)){
                            $del_listing->setStatus(0);
                            if ($del_listing->saveItem()) $update_index=true;
                        }
                    }
                    if ($update_index) updateItemIndex('listings',$rvi_select_listing_ids);
                }

                // renewing listings
                if (isset($rvi_renew_listings) && !empty($rvi_select_listing_ids)){

                    $order = new Order();

                    $order->owner=$user->id;
                    $order->setCustomer($user);
                    // order status 0=unpaid, 1=paid, 2=paid and processed, 3=cancelled, 4=pending
          			$order->setStatus(4);

                    $listing = new Listing();
                    $listing_2 = new Listing();

                    foreach ($rvi_select_listing_ids as $listing_id){

                        if ($listing->getData($listing_id)){

                            // save product details in order
                            $order_slot_id=$order->addProduct($listing->product);
                            $order->products->$order_slot_id->name.=" (Renew Listing Ref:".$listing_id.")";
                            $order->products->$order_slot_id->listing_id=$listing_id;

                            // update renewed listing details only if current status is active or expired
                            if ($listing->status==1 || $listing->status==5){

                                // move renewed listings to top only if they are currently expired
                                if ($listing->status==5){
                                    foreach ($listing->category as $category_id => $value){
                                        if ($items=get_items('listings',$category_id,null,'priority',null,null,null,array(($listing->category[$category_id]['priority']+1)))){$item_count=count($items);}else{$item_count=0;}
                                        if ($item_count>0){
                                            $listing->category[$category_id]['priority']=$items[0]['priority'];
                                            // save_item_details($listing_details);
                                            // $update_item_ids[]=$listing_details_1['id'];
                                            for ($item_num=0; $item_num<$item_count; $item_num++){
                                               if ($listing_2->getData($items[$item_num]['id'])){
                                                   $listing_2->category[$category_id]['priority']=$listing_2->category[$category_id]['priority']-1;
                                                   $listing_2->saveItem();
                                                   $update_listing_ids[]=$listing_2->id;
                                               }
                                            }
                                        }
                                    }
                                }

                                // set status to awaiting approval if product price is 0 - otherwise awaiting payment
                                if ($listing->status!=1){
                                    if ($listing->product['price']>0){$listing->status=2;}
                                    else{$listing->status=3;}
                                }
                                $listing->subscription_start_time=time();

                                if ($listing->saveItem()) $update_listing_ids[]=$listing->id;
                            }


                        }

                    }

                    if (isset($update_listing_ids)) updateItemIndex('listings',$update_listing_ids);

                    //$order_details['expire']=30;

                    // only save orders with amount greater than zero
                    if ($order->getSubTotal(true)>0){
                        if ($order->saveItem()){
                            updateItemIndex('orders',array($order->id),'add');
                            update_item_log('user',$user->id,'Order '.$order->id.' created by user '.$user->id.' for listing renewal');
                        }

                    	// redirect after form submit so browser back and refresh work without browser resend form data warning
                        header("Location: ".cms_url."?paynow=".$order->id,true,303);
                        exit;
                    }else{
                        $_SESSION[cms_key]['form']['myaccount_listings']['warning_green'][]="Thank You - Renewed listings will become active again shortly after review.";
                        update_item_log('user',$user->id,'Listing renewal by user '.$user->id);
                    }

                }


			    $page_content['main'].="<h3>".$txt['Listings']."</h3>";
                if (strlen($txt['my_listings_description'])>0){$page_content['main'].='<p>'.$txt['my_listings_description'].'</p>';}

                // display warnings
                if (isset($_SESSION[cms_key]['form']['myaccount_listings']['warning'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['myaccount_listings']['warning']);}
                elseif (isset($_SESSION[cms_key]['form']['myaccount_listings']['warning_green'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['myaccount_listings']['warning_green'],'green');}

    			// display customer listings

                if ($user_listing_count){

                    $active_listing_count=0;

                    $listing_table="<form method=\"post\" action=\"\">
                    <table width=\"100%\" cellspacing=\"1\" cellpadding=\"4\" class=\"cms_table\">
                    <thead><tr><th width=\"110\" align=\"left\"></th><th align=\"left\">".$txt['Listing']."</th><th>Status</th><th width=\"60\">Edit</th><th width=\"60\">Select</th></tr></thead>
                    <tbody>";
                    $alternate_rowcol='';

                    $listing = new Listing();

                    for ($item_num=0; $item_num<$user_listing_count; $item_num++){

                        $listing_id=$users_listings[$item_num]['id'];

                        if ($listing->getData($listing_id)){

                            if ($listing->status==1) $active_listing_count++;

                            if ($listing->status<1 && admin_level()<9) continue;

                            if ($listing->status==1){$listing_status='<font color="green">Active</font>';}
                            elseif ($listing->status==2){
                                //$listing_status='<font color="red"><a href="'.cms_url.'?paynow='.$listing->order_id.'">'.$txt['pay_now'].'</a></font>';
                                $listing_status="Pending";
                            }
                            elseif ($listing->status==3){$listing_status='<font color="red">Awaiting Review</font>';}
                            elseif ($listing->status==4){$listing_status='<font color="red">Rejected</font>';}
                            elseif ($listing->status==5){$listing_status='<font color="red">Expired</font>';}
                            else{$listing_status='<font color="red">Inactive</font>';}

                            $image_html="";
                            if ($listing->image){
                                foreach ($listing->image as $image_fn => $value){break;}
                                // check if correct size image exists and create one if it doesn't
                                $listing_path=sys_data_dir.'/listings/'.$listing->id.'/';
                                $tn_size_x=110;
                                $tn_size_y=90;
                                $aspect_ratio=0;
                                $thumbnail_fn=$tn_size_x."x".$tn_size_y.'_'.$aspect_ratio.'_l'.$listing->id.'_'.$image_fn;
                                if (!file_exists(sys_image_dir.'/'.$thumbnail_fn)){
                                    createthumb($listing_path.$image_fn,sys_image_dir.'/'.$thumbnail_fn,$tn_size_x,$tn_size_y,$aspect_ratio);
                                }
                                $image_html='<a href="'.item_url('listing',$listing->id,$listing->slug).'"><img src="'.cms_image_url.$thumbnail_fn.'" width="'.$tn_size_x.'" height="'.$tn_size_y.'" /></a>';
                            }

                            $listing_table.="<tr".$alternate_rowcol."><td>".$image_html."</td><td><a href=\"".item_url('listing',$listing->id,$listing->slug)."\">".$listing->name."</a></td><td align=\"center\">".$listing_status."</td><td align=\"center\"><a title=\"Edit\" href=\"".cms_url."?myaccount&amp;modify_listing=".$listing_id."\" style=\"text-decoration: none\"><i class=\"cms-fi-edit\" style=\"text-decoration: none\"></i></a></td><td align=\"center\"><input type=\"checkbox\" name=\"select_listing_ids[]\" value=\"".$listing->id."\" /></td></tr>";
                            if ($alternate_rowcol==''){$alternate_rowcol=' class="altrowcol"';}else{$alternate_rowcol='';}
                        }

                    }

                    $listing_table.="<tr><td colspan=\"5\" align=\"right\"><button type=\"submit\" name=\"renew_listings\" class=\"cms_btn cms_btn_small\">Renew Selected</button></td></tr>";
                    $listing_table.="</tbody></table></form>";

                    $page_content['main'].="<p>".$active_listing_count." active ".strtolower($txt['Listings'])."</p>".$listing_table;
                }
                
            }

		}
        elseif ($rvi_myaccount=="subscriptions" || $rvi_myaccount=="subs"){

            // renewing subscriptions
            if (isset($rvi_renew_subs) && isset($rvi_renew_sub_ids)){

                $order = new Order();

                $order->owner=$user_id;
                $order->setCustomer($user);
                // order status 0=unpaid, 1=paid, 2=paid and processed, 3=cancelled, 4=pending
      			$order->setStatus(4);

                foreach ($rvi_renew_sub_ids as $sub_id){

                    if ($subscription->getData($sub_id)){

                        $order_slot_id=$order->addProduct($subscription->product);
                        $order->products->$order_slot_id->name.=" (Renew Subscription Ref:".$subscription->id.")";
                        $order->products->$order_slot_id->subscription_id=$subscription->id;

                    }

                }

                //$order_details['expire']=30;

                if ($order->saveItem()){
                    updateItemIndex('orders',array($order->id),'add');
                    update_item_log('user',$user_id,'Order '.$order->id.' created by user '.$user_id.' for subscription renewal');
                }

            	// redirect after form submit so browser back and refresh work without browser resend form data warning
                header("Location: ".cms_url."?paynow=".$order->id,true,303);
                exit;

            }



            // display users subscriptions
            if (cms_interface=="back"){
                $rvi_search['owner']=$user->id;
                include(cms_root_dir.'admin/includes/users/subscriptions.php');
            }
            else{

                $page_content['main'].="<h3>".$txt['Subscriptions']."</h3>";

                if (!empty($txt['my_subscriptions_description'])) $page_content['main'].="<p>".$txt['my_subscriptions_description']."</p>";

                $page_content['main'].=$subscriptions_table_front_end;
            }

        }
        elseif ($rvi_myaccount=="bookings"){

            // display users subscriptions
            if (cms_interface=="back"){
                $rvi_search['owner']=$user->id;
                include(cms_root_dir.'admin/includes/users/bookings/bookings.php');
            }

        }
        elseif ($rvi_myaccount=="applications"){

            // display users subscriptions
            if (cms_interface=="back"){
                $rvi_search['owner']=$user->id;
                include(cms_root_dir.'admin/includes/users/applications/applications.php');
            }

        }
        elseif($rvi_myaccount=='log' && admin_level()>0){
            include(cms_root_dir.'admin/includes/log.php');
        }
		else{

            if (cms_interface=="back"){
                $rvi_search['owner']=$user->id;
                include(cms_root_dir.'admin/includes/shop/orders.php');
            }
            else{
			    $page_content['main'].="<h3>".$txt['Orders']."</h3>";

                if ($order_table_front_end){

                    if (isset($txt['my_orders_description']) && $txt['my_orders_description']!=""){$page_content['main'].="<p>".$txt['my_orders_description']."</p>";}

                    $page_content['main'].=$order_table_front_end;
                }
                else{
                    if (cms_interface=="back"){
                        $page_content['main'].="<p>No orders found for this user.</p>";
                    }
                    else{
                        $page_content['main'].="<p>Invoices for any orders or renewals you make will be listed here.</p>";
                    }
                }

            }


		}

        if (cms_interface=="front"){
            $page_content['main'].="</div>";
            $include_font_icons=true;
        }

	}
    else{
        if (cms_interface=="front"){
            // auto logout if customer details are not accessbile
            logout_user();
            include("login.php");
            $page_content['main'].=$login_form;
        }
        else
            $page_content['main'].="Error: User details could not be found";
    }

?>
