<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit;

    // seperate login string
    $rvi_passreset=trim($rvi_passreset);
    $pieces=explode("s",$rvi_passreset);
    $user_id=$pieces[0];
    $token_name=$pieces[1];

    $user = new User();

    if ($user->getData($user_id)){
        if ($token_details=check_security_token($token_name,"resetpass".$user->id.$user->email.$user->password)){

            // verify account incase it's not already
            $user->verified=1;

            // generate a new random password
			$password=generate_password();
			$user->password=encrypt_password($password,$user_id);
			$user->saveItem();

            // log user in - maybe we use a login function here instead
            unset($user->password);
            $_SESSION[cms_key]['reg_user']=$user;

            // send login details email
			require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

			$mail = new PHPMailer();

            // send mail via smtp if set in config file
            if (smtp_host){
                $mail->IsSMTP(); // send via SMTP
                $mail->SMTPAuth = true; // turn on SMTP authentication
                $mail->SMTPSecure = 'ssl';
                $mail->Username = smtp_username; // SMTP username
                $mail->Password = smtp_password; // SMTP password
                $mail->Host       = smtp_host; // SMTP server
                $mail->Port       = smtp_port; // SMTP server
            }

			$mail->From = $cmsSettings->config['site_email'];
			$mail->FromName = cms_site_name;
			$mail->AddAddress($user->email);

			$mail->Subject = cms_site_name." - New Password";
			$mail->Body    = "Hi ".short_name($user->name).",\n\nYour password has been reset.\n\nYour new password is: ".$password."\n\nYou can change your password at any time in your account settings.\n\n\n".cms_site_name."\n".cms_site_url;

			if(!$mail->Send()){update_item_log('user',$user->id,"Warning: reset password email could not be sent");}

            $_SESSION[cms_key]['form']['myaccount_changepass']['warning_green'][]="Your password has been reset and you have been logged in automatically. Your new password is <b>".$password."</b> which has also been emailed to you. You can change your password below or at any time by going to your account settings and clicking on <a href=\"".cms_url."?myaccount=password\">change my password</a>.";

            // redirect after form submit so browser back and refresh work without browser resend form data warning
            header("Location: ".cms_url."?myaccount=password",true,303);
            exit;

        }
    }

    $_SESSION[cms_key]['form']['forgot_password']['warning'][]="Password reset failed. The link may have expired, please submit your email again. If you still have difficulty logging into your account please contact us.";

    include(cms_root_dir.'includes/users/forgot_password.php');
    //include(cms_root_dir.'includes/users/login.php');
    //$page_content['main'].=$login_form;
    /*
    // redirect after form submit so browser back and refresh work without browser resend form data warning
    header("Location: ".cms_url."?login",true,303);
    exit;
    */
	
?>
