<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    // display login if not logged in
    if (!$_SESSION[cms_key]['reg_user']){
        include(cms_root_dir.'includes/users/login.php');
        $page_content['main'].=$login_form;
        return;
    }

	$page->title="Report";
    $page->meta_title=cms_site_name." - ".$page->title;

    if (isset($rvi_submit_message)){

        require_once(cms_root_dir.'scripts/emailval.php');

        $rvi_name=sanitize_text_input($rvi_name);
        $rvi_message_text=sanitize_text_input($rvi_message_text);

        if (strlen($rvi_message_text)<3){$_SESSION[cms_key]['form']['report_user']['warning'][]="Please give a reason for this report";}
        else{
            // check for spam in message
            $spam_words=array('cialis','viagra','xanax','tramadol','replicawatch','freeringtone','[/url]','lesbian','porn','penis');
            foreach ($spam_words as $spam_word){
                if (strpos(strtolower($rvi_message_text),$spam_word)!==FALSE){$_SESSION[cms_key]['form']['report_user']['warning'][]='Message contains spam filtered words. Please remove the word &quot;'.$spam_word.'&quot;.';break;}
            }
            $swear_words=array('fuck');
            foreach ($swear_words as $swear_word){
                if (strpos(strtolower($rvi_message_text),$swear_word)!==FALSE){$_SESSION[cms_key]['form']['report_user']['warning'][]='Message contains offensive words. Please edit your message.';break;}
            }
            $limit_words=array('@','http','www','.com','.net','.biz','.info','.org','.ru');
            foreach ($limit_words as $limit_word){
                if (substr_count($rvi_message_text,$limit_word)>2){$_SESSION[cms_key]['form']['report_user']['warning'][]='Spam filter found too many &quot;'.$limit_word.'&quot; in message. Please edit your message.';break;}
            }
        }

        if (!isset($_SESSION[cms_key]['form']['report_user']['warning'])){

            $message = new Message();

            $message->txt=$rvi_message_text;

            if (isset($rvi_message_id)) $message->report_message=$rvi_message_id;
            if (isset($rvi_listing_id)) $message->report_listing=$rvi_listing_id;

            if ($message->saveItem())
                updateItemIndex('messages',array($message->id),'add');

    		$_SESSION[cms_key]['form']['submitted']=1;
            $_SESSION[cms_key]['form']['report_user']['warning_green'][]="Thank you. Your report has been sent.";

            // redirect after form submit so browser back and refresh work without browser resend form data warning
            if (isset($rvi_message_id)) header("Location: ".cms_url."?report&message_id=".$rvi_message_id,true,303);
            elseif (isset($rvi_listing_id)) header("Location: ".cms_url."?report&listing_id=".$rvi_listing_id,true,303);
            exit;
        }


    }


    // populate fields if user is logged in
    if (!isset($rvi_message_text)){$rvi_message_text='';}

    $page_content['main'].='<h3>Report Spam/Abuse</h3>';

    // display warnings
    if (isset($_SESSION[cms_key]['form']['report_user']['warning_green'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['report_user']['warning_green'],'green');}
    else{

        if (isset($_SESSION[cms_key]['form']['report_user']['warning'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['report_user']['warning']);}

        $page_content['main'].="<form action=\"#message_form\" method=\"post\"><table>";
        if (isset($rvi_message_id)){$page_content['main'].="<tr><td>Reporting Message Ref: <input type=\"text\" name=\"message_id\" disabled=\"disabled\" value=\"".$rvi_message_id."\" /></td></tr>";}
        if (isset($rvi_listing_id)){$page_content['main'].="<tr><td>Reporting Listing Ref: <input type=\"text\" name=\"listing_id\" disabled=\"disabled\" value=\"".$rvi_listing_id."\" /></td></tr>";}

        if (isset($rvi_message_id)){
          $page_content['main'].="<tr><td>Please give your reason for this message reporting below.</td></tr>";
        }
        elseif (isset($rvi_listing_id)){
          $page_content['main'].="<tr><td>Please give your reason for reporting this listing below.</td></tr>";
        }

        $page_content['main'].="<tr><td><textarea name=\"message_text\" cols=\"45\" rows=\"5\">".$rvi_message_text."</textarea></td></tr>
        <tr><td align=\"right\"><input type=\"submit\" value=\"Send Report\" name=\"submit_message\" /></td></tr>
        </table></form>";
    }


?>
