<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit;

    // ini_set("memory_limit","100M");
	// ini_set("max_execution_time","3600");

    if (empty($cmsSettings->user['profile_pages'])) return;

    $user = new User();

	if ($user->getData($rvi_profile)){

        // $page->template='???????';
        $last_message_fn=sys_data_dir.'/users/'.$user->id.'/last_message.txt';

		// page meta tags
        $page->meta.="<link rel=\"canonical\" href=\"".item_url('customer',$rvi_profile)."\" />";

		$page->title='Profile page of '.htmlentities($user->name,ENT_COMPAT,'UTF-8');;
        $page->meta_title=$page->title;

		$page_content['main'].="<div class=\"cms-content profile_frame\"><div class=\"profile_detail\">";

        $tn_size_x=220;
        $tn_size_y=220;

        $image_content='<div class=\"img_group\" style="max-width: '.($tn_size_x+40).'px">';

        if (empty($user->profile_image) || !file_exists(sys_data_dir.'/users/'.$user->id.'/'.$user->profile_image)){
            $image_fn='no-profile-pic.png';
            $image_path=cms_theme_dir.'/images/users/';
            if (!file_exists($image_path.$image_fn)){$image_path=cms_root_dir.'themes/default/images/users/';}
        }
        else{
            $image_fn=$user->profile_image;
            $image_path=sys_data_dir.'/users/'.$user->id.'/';
        }

		// check if correct size image exists and create one if it doesn't
		$thumbnail_fn=$tn_size_x."x".$tn_size_y.'_p'.$user->id.'_'.safe_file_name($image_fn);
		if (!file_exists(sys_image_dir.'/'.$thumbnail_fn)){
			createthumb($image_path.$image_fn,sys_image_dir.'/'.$thumbnail_fn,$tn_size_x,$tn_size_y,1);
		}

        if (file_exists(sys_image_dir.'/'.$thumbnail_fn)){

            // check if correct size zoom-in image exists and create one if it doesn't
            $tn_size_zoom_x=$cmsSettings->img['zoom_width_tn'];
            $tn_size_zoom_y=$cmsSettings->img['zoom_height_tn'];
            // override thumbnail sizes if original file is smaller (half difference in size so not too big and not too small)
            $image_size=getimagesize($image_path.$image_fn);
            if ($image_size[0]<$tn_size_zoom_x && $image_size[1]<$tn_size_zoom_y){
                $tn_size_zoom_x=intval(($tn_size_zoom_x-$image_size[0])/2);
                $tn_size_zoom_y=intval(($tn_size_zoom_y-$image_size[1])/2);
            }
            $thumbnail_zoom_fn=$tn_size_zoom_x."x".$tn_size_zoom_y.'_p'.$user->id.'_'.$image_fn;
            if (!file_exists(sys_image_dir.'/'.$thumbnail_zoom_fn)){
                createthumb($image_path.$image_fn,sys_image_dir.'/'.$thumbnail_zoom_fn,$tn_size_zoom_x,$tn_size_zoom_y,1);
            }

            // get size of thumbnail image
            $image_size=getimagesize(sys_image_dir.'/'.$thumbnail_fn);

            $link_title='Profile Pic - '.$user->name;
            $image_content.="<div class=\"main_img\"><img src=\"".cms_image_url.$thumbnail_fn."\" alt=\"".htmlentities($link_title,ENT_COMPAT,'UTF-8')."\" width=\"".$image_size[0]."\" height=\"".$image_size[1]."\" /></div>";

        }

        // display link icons
        if (isset($user->links['website']) || isset($user->links['facebook']) || isset($user->links['twitter']) || isset($user->links['youtube'])){
            $image_content.='<div style="text-align: center; margin: 8px 0 8px 0">';
            if (isset($user->links['website']) && strlen($user->links['website'])>2){$image_content.='<a href="'.$user->links['website'].'" rel="external nofollow" target="_blank"><img src="'.theme_file_url('images/users/link_web.png',display_theme).'" width="38" height="38" alt=\"Website Link\" /></a>';}
            if (isset($user->links['facebook']) && strlen($user->links['facebook'])>2){$image_content.='<a href="'.$user->links['facebook'].'" rel="external nofollow" target="_blank"><img src="'.theme_file_url('images/users/link_facebook.png',display_theme).'" width="38" height="38" alt=\"Facebook Link\" /></a>';}
            if (isset($user->links['twitter']) && strlen($user->links['twitter'])>2){$image_content.='<a href="'.$user->links['twitter'].'" rel="external nofollow" target="_blank"><img src="'.theme_file_url('images/users/link_twitter.png',display_theme).'" width="38" height="38" alt=\"Twitter Link\" /></a>';}
            if (isset($user->links['youtube']) && strlen($user->links['youtube'])>2){$image_content.='<a href="'.$user->links['youtube'].'" rel="external nofollow" target="_blank"><img src="'.theme_file_url('images/users/link_youtube.png',display_theme).'" width="38" height="38" alt=\"Yutube Link\" /></a>';}
            $image_content.='</div>';
        }


        $image_content.='</div>';

        // display image content
        //$page_content['main'].=$image_content;


        // get messages for this user
        $message_status=1;
        $search_messages['recipient_id']=$user->id;
        if (!isset($_SESSION[cms_key]['reg_user']) || $_SESSION[cms_key]['reg_user']->id!=$user->id || !isset($rvi_myaccount)){$search_messages['rating']='any';}
        elseif ($_SESSION[cms_key]['reg_user']->id==$user->id && isset($rvi_messages) && $rvi_messages=='sent'){
            unset($search_messages['recipient_id']);
            $search_messages['customer_id']=$user->id;
            // any status for sent messages
            $message_status=null;
        }
        if ($messages=get_items('messages',null,$message_status,null,null,$search_messages,null,null,array('rating'))){$messages_count=count($messages);}else{$messages_count=0;}

        // calculate average feedback score
        $total_feedback_score=0;
        $feedback_qty=0;
        for ($item_num=0; $item_num<$messages_count; $item_num++){
            if (isset($messages[$item_num]['rating']) && $messages[$item_num]['rating']>0){
                $total_feedback_score=$total_feedback_score+$messages[$item_num]['rating'];
                $feedback_qty++;
            }
        }
        if ($feedback_qty>0){$total_feedback_score=ceil($total_feedback_score/$feedback_qty);}

        // calculate number of days since update
        if(!empty($user->last_login)){
            $modified_time_midnight=mktime(0, 0, 0, date('m',$user->last_login), date('d',$user->last_login), date('Y',$user->last_login));
            $num_of_days=intval((time()-$modified_time_midnight)/86400);
            if ($num_of_days<1){$last_online='Today';}
            elseif ($num_of_days<2){$last_online='Yesterday';}
            elseif ($num_of_days<6){$last_online=$num_of_days.' days ago';}
            else {$last_online=date('jS F Y',$user->last_login);}
        }else{$last_online='N/A';}

        $location='';
        if ($user->addr->city){$location.=$user->addr->city;}
        if ($user->addr->county){
            if ($location!='')
                $location.=', '.$user->addr->county;
            else
                $location=$user->addr->county;
        }
        if ($location=='' && $user->addr->country && $user->addr->country!='---') $location=$user->addr->country;
        if ($location=='') $location='Unknown';

        $page_content['main'].='<div style=\"display:flex;flex-flow: row wrap;\">'.$image_content.'<div><h1>'.htmlentities($user->name,ENT_COMPAT,'UTF-8').'</h1>
        <div><span style="font-weight: bold; color: #4b6172">Joined:</span> '.date('d M Y',$user->created_time).'<br />
        <span style="font-weight: bold; color: #4b6172">Last Online:</span> '.$last_online.'<br />
        <span style="font-weight: bold; color: #4b6172">Location:</span> '.$location.'</div>';

        if (isset($_SESSION[cms_key]['reg_user']) && $_SESSION[cms_key]['reg_user']->id!=$user->id){
            $page_content['main'].='<div style="margin: 8px 0 8px 0"><a href="'.cms_url.'?profile='.$user->id.'&amp;message=feedback"><img src="'.theme_file_url('images/stars'.$total_feedback_score.'.png',display_theme).'" width="140" height="30" alt="Feedback score of '.$total_feedback_score.'" /></a></div>';
            $page_content['main'].="<div>";
            if ($cmsSettings->listings_enabled) $page_content['main'].='<a href="'.cms_url.'?search[owner]='.$user->id.'">View Listings</a> - ';
            $page_content['main'].='<a href="'.cms_url.'?profile='.$user->id.'&amp;message=feedback">Give Feedback</a> - <a href="'.cms_url.'?profile='.$user->id.'&amp;message">Private Message</a>';
            $page_content['main'].="</div>";
        }
        elseif (isset($_SESSION[cms_key]['reg_user']) && $_SESSION[cms_key]['reg_user']->id==$user->id){
            $page_content['main'].='<div style="margin: 4px 0 4px 0"><img src="'.theme_file_url('images/stars'.$total_feedback_score.'.png',display_theme).'" width="140" height="30" alt="Feedback score of '.$total_feedback_score.'" /></div>';
            $page_content['main'].="<div>";
            if ($cmsSettings->listings_enabled) $page_content['main'].="<a href=\"".cms_url."?search[owner]=".$user->id."\">View My Active Listings</a> - <a href=\"".cms_url."?myaccount=listings\">My Account Listings</a>";
            $page_content['main'].="</div>";
        }
        else{
            $page_content['main'].="<div style=\"margin: 4px 0 4px 0\"><img src=\"".theme_file_url('images/stars'.$total_feedback_score.'.png',display_theme)."\" width=\"140\" height=\"30\" alt=\"Feedback score of ".$total_feedback_score."\" /></div>";
            $page_content['main'].="<div>";
            if ($cmsSettings->listings_enabled) $page_content['main'].='<a href="'.cms_url.'?search[owner]='.$user->id.'">View Listings</a> - ';
            $page_content['main'].='<a href="'.cms_url.'?login">Give Feedback</a> - <a href="'.cms_url.'?login">Private Message</a>';
            $page_content['main'].="</div>";
        }

        if (isset($user->bio) && strlen($user->bio)>0){$page_content['main'].='<div style="margin-top: 8px"><span style="font-weight: bold; color: #4b6172">About Me:</span> '.$user->bio.'</div>';}

  	   $page_content['main'].='</div></div><br /><hr />';


        if (isset($rvi_message) && isset($_SESSION[cms_key]['reg_user']) && $_SESSION[cms_key]['reg_user']->id!=$user->id){

           if (isset($rvi_submit_message)){

                $rvi_message_text=sanitize_text_input($rvi_message_text);

    		    if (strlen($rvi_message_text)<10)
                    $_SESSION[cms_key]['form']['user_profile']['warning'][]="Message is too short.";
                elseif ($spam_warning=IsSpam($rvi_message_text))
                    $_SESSION[cms_key]['form']['user_profile']['warning'][]=$spam_warning;

    		    if (!isset($_SESSION[cms_key]['form']['user_profile']['warning'])){

                    $message = new Message();

                    $message->status=new_message_status; // 0=awaiting moderation, 1=approved, 2=spam
                    $message->txt=$rvi_message_text;
                    $message->recipient_id=$user->id;
                    if (isset($rvi_rating)) $message->rating=$rvi_rating;

                    if ($message->saveItem())
                        updateItemIndex('messages',array($message->id),'add');

                    // send new message email to user
                    if ($message->status){

                        // update new messages file
                        if (file_exists($last_message_fn)){$last_message_timestamp=trim(file_get_contents($last_message_fn));}

                        // only send one email notification per 24hrs unless recipient has logged in and checked messages and then reset
                        if (!isset($last_message_timestamp) || $message->created_time-$last_message_timestamp>86400){

                            $fo=fopen($last_message_fn,'w');
                            fwrite($fo,$message->created_time);
                            fclose($fo);

                            require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

                            $mail = new PHPMailer();

                            // send mail via smtp if set in config file
                            if (smtp_host){
                                $mail->IsSMTP(); // send via SMTP
                                $mail->SMTPAuth = true; // turn on SMTP authentication
                                $mail->SMTPSecure = 'ssl';
                                $mail->Username = smtp_username; // SMTP username
                                $mail->Password = smtp_password; // SMTP password
                                $mail->Host       = smtp_host; // SMTP server
                                $mail->Port       = smtp_port; // SMTP server
                            }

                            // send confirmation email to user
                            $mail->From = $cmsSettings->config['site_email'];
                            $mail->FromName = cms_site_name;
                            $mail->AddAddress($user->email);

                            $mail->Subject = cms_site_name." - You have new messages";
                            $mail->Body    = "Hi ".$user->name.",\n\nYou have new unread messages! Use the link below to login and read your messages.\n\n".cms_url."?myaccount=profile\n\n".cms_site_name."\n".cms_url;

                            if ($mail->Send())
                                update_log('New message notification email sent to user '.$user->id);
                            else
                                update_log('Sending Failed: New message notification email to user '.$user->id);

                        }
                    }

                    $_SESSION[cms_key]['form']['user_profile']['warning_green'][]='Your message has been sent</p>';

                    update_admin_notify_log('New user message');

                    // redirect after form submit so browser back and refresh work without browser resend form data warning
                    header("Location: ".cms_url."?profile=".$user->id."&message",true,303);
                    exit;

    		    }
            }

            if ($rvi_message=='feedback'){

                $page_content['main'].="<h3>Leave feedback for ".$user->name."</h3>";

                // display warnings
                if (isset($_SESSION[cms_key]['form']['user_profile']['warning'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['user_profile']['warning']);}
                elseif (isset($_SESSION[cms_key]['form']['user_profile']['warning_green'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['user_profile']['warning_green'],'green');}

  				$page_content['main'].="<form action=\"#message_form\" method=\"post\"><table>
                <tr><td width=\"80\"><b>From:</b></td><td width=\"160\"><input type=\"text\" name=\"\" value=\"".$_SESSION[cms_key]['reg_user']->name." (".$_SESSION[cms_key]['reg_user']->email.")\" disabled=\"disabled\" /> (<a href=\"".cms_url."?logout\">Logout</a>)</td></tr>
                <tr><td><b>Rating:</b></td><td><select name=\"rating\"><option value=\"5\">5 - Great</option><option value=\"4\">4</option><option value=\"3\">3</option><option value=\"2\">2</option><option value=\"1\">1 - Poor</option></select></td></tr>
  				<tr><td valign=\"top\"><b>Feedback:</b></td><td><textarea name=\"message_text\" cols=\"45\" rows=\"5\">".(isset($rvi_message_text) ? $rvi_message_text : '')."</textarea></td></tr>
  				<tr><td colspan=\"2\" align=\"right\"><input type=\"submit\" value=\"Post My Feedback\" name=\"submit_message\" /></td></tr>
  				</table></form><hr />";
            }
            else{

                $page_content['main'].="<h3>Send a private message to ".$user->name."</h3>";

                // display warnings
                if (isset($_SESSION[cms_key]['form']['user_profile']['warning'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['user_profile']['warning']);}
                elseif (isset($_SESSION[cms_key]['form']['user_profile']['warning_green'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['user_profile']['warning_green'],'green');}

                $page_content['main'].="<form action=\"#message_form\" method=\"post\"><table>
                <tr><td  width=\"80\"><b>From:</b></td><td width=\"160\"><input type=\"text\" name=\"\" value=\"".$_SESSION[cms_key]['reg_user']->name." (".$_SESSION[cms_key]['reg_user']->email.")\" disabled=\"disabled\" /> (<a href=\"".cms_url."?logout\">Logout</a>)</td></tr>
                <tr><td valign=\"top\"><b>Message:</b></td><td><textarea name=\"message_text\" cols=\"45\" rows=\"5\">".(isset($rvi_message_text) ? $rvi_message_text : '')."</textarea></td></tr>
                <tr><td colspan=\"2\" align=\"right\"><input type=\"submit\" value=\"Send\" name=\"submit_message\" /></td></tr>
                </table></form><hr />";
            }

        }



        $messages_content='<table width="100%" cellpadding="4" cellspacing="3">';

            if (isset($rvi_myaccount) && isset($_SESSION[cms_key]['reg_user']) && $_SESSION[cms_key]['reg_user']->id==$user->id){

                if (file_exists($last_message_fn)){unlink($last_message_fn);}

                if (isset($rvi_messages) && $rvi_messages=='sent'){
                    $messages_content.='<tr><td colspan="2"><h2>Sent Messages</h2><p><a href="'.cms_url.'?myaccount=profile">Message Inbox</a> - <a href="'.cms_url.'?myaccount=profile&amp;messages=sent">Sent Messages</a></p></td></tr>';
                    if ($messages_count<1){$messages_content.='<tr><td colspan="2"><p>You have no sent messages.</p></td></tr>';}
                }
                else{
                    $messages_content.='<tr><td colspan="2"><h2>Message Inbox</h2><p><a href="'.cms_url.'?myaccount=profile">Message Inbox</a> - <a href="'.cms_url.'?myaccount=profile&amp;messages=sent">Sent Messages</a></p></td></tr>';
                    if ($messages_count<1){$messages_content.='<tr><td colspan="2"><p>You have no messages.</p></td></tr>';}
                }



            }else{
                if ($messages_count>0){$messages_content.='<tr><td colspan="2"><h2>Feedback</h2><p>View other users feedback on this user below.</p></td></tr>';}
                else{$messages_content.='<tr><td colspan="2"><h2>Feedback</h2><p>This user has not received any feedback yet.</p></td></tr>';}
            }



            if ($messages_count>0){

			    $items_per_page=7;

			    $number_of_pages=ceil($messages_count/$items_per_page);

			    if (isset($rvi_page)){$display_page_num=$rvi_page;}
			    if (!isset($display_page_num) || $display_page_num<1){$display_page_num=1;}
			    if ($display_page_num>$number_of_pages){$display_page_num=$number_of_pages;}

                $start_item=($display_page_num-1)*$items_per_page;
			    $end_item=$start_item+$items_per_page;

                $message = new Message();

              for ($item_num=$start_item; ($item_num<$end_item && $item_num<$messages_count); $item_num++){

                  if ($message->getData($messages[$item_num]['id'])){

                        // items loaded per status above so no need to check again
                      //if ($message->status!=1) continue;

                      if ($message->owner==$user->id){
                        if ($correspondant_details=get_item_details('customer',$message->recipient_id))
                            $sender_text='Sent to <a href="'.cms_url.'?profile='.$correspondant_details['id'].'">'.$correspondant_details['name'].'</a>';
                      }
                      elseif ($correspondant_details=get_item_details('customer',$message->owner))
                            $sender_text='From <a href="'.cms_url.'?profile='.$correspondant_details['id'].'">'.$correspondant_details['name'].'</a>';
                      elseif ($message->sender['name'])
                            $sender_text='<b>'.$message->sender['name'].'</b> (Guest)';
                      else
                            $sender_text='Guest';

                      $sender_text.='<div style="float: right; text-align: right">'.date("d/m/y H:i",$message->created_time).'</div>';

                      $tn_size_x=110;
                      $tn_size_y=110;

                      if (!isset($correspondant_details['profile_image']) || !file_exists(sys_data_dir.'/users/'.$correspondant_details['id'].'/'.$correspondant_details['profile_image'])){
                          $image_fn='no-profile-pic.png';
                          $image_path=cms_theme_dir.'/images/users/';
                      }
                      else{
                          $image_fn=$correspondant_details['profile_image'];
                          $image_path=sys_data_dir.'/users/'.$correspondant_details['id'].'/';
                      }

              	      // check if correct size image exists and create one if it doesn't
              		  $thumbnail_fn=$tn_size_x."x".$tn_size_y.'_p'.$user->id.'_'.safe_file_name($image_fn);
              		  if (!file_exists(sys_image_dir.'/'.$thumbnail_fn)){
              	        createthumb($image_path.$image_fn,sys_image_dir.'/'.$thumbnail_fn,$tn_size_x,$tn_size_y,1);
              		  }

                      if (file_exists(sys_image_dir.'/'.$thumbnail_fn)){

                          // get size of thumbnail image
                          $image_size=getimagesize(sys_image_dir.'/'.$thumbnail_fn);

                          if (isset($correspondant_details)){
                            $link_title='Profile Pic - '.$correspondant_details['name'];
                            $sender_image_content="<a href=\"".cms_url."?profile=".$correspondant_details['id']."\" title=\"".htmlentities($link_title,ENT_COMPAT,'UTF-8')."\"><img src=\"".cms_image_url.$thumbnail_fn."\" alt=\"".htmlentities($link_title,ENT_COMPAT,'UTF-8')."\" width=\"".$image_size[0]."\" height=\"".$image_size[1]."\" /></a>";
                          }
                          else {
                            $link_title='No Profile';
                            $sender_image_content="<img src=\"".cms_image_url.$thumbnail_fn."\" alt=\"".htmlentities($link_title,ENT_COMPAT,'UTF-8')."\" width=\"".$image_size[0]."\" height=\"".$image_size[1]."\" />";
                          }

                      }

                      $messages_content.='<tr><td valign="top" width="'.$tn_size_x.'">'.$sender_image_content.'</td><td><div style="border-bottom: #b7a586 solid 1px; padding-bottom: 4px; margin-bottom: 4px">'.$sender_text.'</div>';

                      if ($message->listing_id && $listing_details=get_item_details('listing',trim($message->listing_id))){
                          $messages_content.='<div style="margin-bottom: 4px">In response to: <a href="'.item_url('listing',$message->listing_id).'">'.$listing_details['name'].'</a></div>';
                      }
                      if ($message->rating){$messages_content.='<div style="margin-bottom: 4px"><img src="'.$display_theme_url.'images/stars'.$message->rating.'small.png" width="105" height="23" alt="Feedback score of '.$total_feedback_score.'" /></div>';}


                      if ($message->status==2){
                        $messages_content.='<div style="border-bottom: #b7a586 solid 1px; padding: 8px 0 8px 0; margin-bottom: 4px">*** SPAM FILTERED ***</div>';
                      }
                      else{
                        $messages_content.='<div style="border-bottom: #b7a586 solid 1px; padding: 8px 0 8px 0; margin-bottom: 4px">'.$message->txt.'</div>';
                      }

                      if ($message->file){

                        $messages_content.='<div style="border-bottom: #b7a586 solid 1px; padding: 8px 0 8px 0; margin-bottom: 4px">';
                        $count=0;
                        foreach ($message->file as $file_name => $value){
                            if ($count>0) $messages_content.=" | ";
                            $messages_content.="<a href=\"".cms_url."?download=".$file_name."&amp;message_id=".$message->id."\" title=\"".convert($value['size'])."\">".$file_name." (".convert($value['size']).")</a>";
                            $count++;
                        }

                        $messages_content.='</div>';

                      }

                      $messages_content.='<div style="text-align: right">';

                      if (isset($_SESSION[cms_key]['reg_user']) && $_SESSION[cms_key]['reg_user']->id==$user->id && isset($rvi_myaccount) && $message->owner!=$user->id){
                        $messages_content.='<a href="'.cms_url.'?profile='.$message->owner.'&amp;message">Reply</a> - ';
                      }

                      if (!isset($rvi_messages) || $rvi_messages!='sent'){
                        $messages_content.='<a href="'.cms_url.'?report&amp;message_id='.$message->id.'">Report</a>';
                      }

                      $messages_content.='</div>';

                      $messages_content.='</td></tr>
                      <tr><td colspan="2"><hr style="height: 1px; color: #b7a586; background-color: #b7a586; border: none;"/></td></tr>';
                  }

              }

                // display page links if more than one page
    			if ($number_of_pages>1){

                    $query_text='';
                    if (isset($rvi_messages) && $rvi_messages=='sent'){$query_text='&amp;messages=sent';}

    				// display previous page link
    				$messages_content.='<tr><td colspan="2"><div style="text-align: center">';
    				if ($display_page_num>1){
    					$prev_page_num=$display_page_num-1;
    					$messages_content.='<a href="'.cms_url.'?myaccount=profile&amp;page='.$prev_page_num.$query_text.'">&lt;&lt; Prev</a>';
    				}
    				// display page numbers
    				if ($display_page_num>10){$start_page_num=$display_page_num-10;}else{$start_page_num=1;}
    				$end_page_num=$display_page_num+10;
    				if ($end_page_num>$number_of_pages){$end_page_num=$number_of_pages;}
    				for ($page_num=$start_page_num; $page_num<=$end_page_num; $page_num++){
    					if ($page_num==$display_page_num){$messages_content.=' '.$page_num.' ';}
    					else{$messages_content.=' <a href="'.cms_url.'?myaccount=profile&amp;page='.$page_num.$query_text.'">'.$page_num.'</a> ';}
    				}
    				// display next page link
    				if ($display_page_num<$number_of_pages){
    					$next_page_num=$display_page_num+1;
    					$messages_content.=' <a href="'.cms_url.'?myaccount=profile&amp;page='.$next_page_num.$query_text.'">Next &gt;&gt;</a>';
    				}
    				$messages_content.='</div></td></tr>';
    			}
            }



        $messages_content.='</table>';

        $page_content['main'].=$messages_content.'</div></div>';









	}else{$page_content['main'].="<div class=\"product_detail\">User profile not found.</div>";}


?>
