<?php
// exit if php file is loaded directly and not included
if (!defined("cms_version_number")) exit;

// set tinymce version 3(legacy), 4(new default) or 5(needs work) or 0(off)
$tinymce_use_version=4;

// tinymce v5
if ($tinymce_use_version==5){
    $page_end.="<script src=\"../plugins/tinymce/v5/tinymce.min.js\"></script>";
    if (display_type=='mobile'){
        $page_end.="<script>
            tinyMCE.init({
                selector : \".cmsmce\",
                plugins: 'lists,hr,link,image,charmap,code',
                menubar: false,
                toolbar: [\"undo redo | styleselect | link image | hr charmap\"],
                relative_urls : false,
                remove_script_host : false,
                document_base_url : \"".cms_root_url."\"
            });


            function toggleEditor(textarea_id){
                tinymce.EditorManager.execCommand('mceToggleEditor', false, textarea_id);
            }

        </script>";
    }
    else{
        $page_end.="<script>
        tinyMCE.init({
            selector : \".cmsmce\",
            plugins: 'lists,hr,link,image,charmap',
            menubar: false,
            toolbar: [\"undo redo | styleselect | bold italic | link image | hr bullist numlist | alignleft aligncenter alignright | charmap code\"],
            relative_urls : false,
            remove_script_host : false,
            document_base_url : \"".cms_root_url."\"
        });


        function toggleEditor(textarea_id){
            tinymce.EditorManager.execCommand('mceToggleEditor', false, textarea_id);
        }

        </script>";
    }
    return;
}

if ($tinymce_use_version==4){
    // tinymce v4
    /*
    for absolute urls use the following, for relative just omit
    relative_urls : false,
    remove_script_host : false,
    document_base_url : \"".cms_root_url."\"

    to convert absolute to relative urls use the following
    relative_urls : true,
    document_base_url : \"".cms_root_url."\"
    */
    $page_end.="<script src=\"../plugins/tinymce/v4/tinymce.min.js\"></script>";
    if (display_type=='mobile'){
        $page_end.="<script>
            tinyMCE.init({
                selector : \".cmsmce\",
                plugins: 'lists,hr,link,image,charmap',
                menubar: false,
                toolbar: [\"undo redo | styleselect | link image | hr charmap\"],
                relative_urls : false,
                remove_script_host : false,
                document_base_url : \"".cms_root_url."\"
            });


            function toggleEditor(textarea_id){
                tinymce.EditorManager.execCommand('mceToggleEditor', false, textarea_id);
            }

        </script>";
    }
    else{
        $page_end.="<script>
            tinyMCE.init({
                selector : \".cmsmce\",
                plugins: 'lists,hr,link,image,charmap,code',
                menubar: false,
                toolbar: [\"undo redo | styleselect | bold italic | link image | hr bullist numlist | alignleft aligncenter alignright | removeformat charmap code\"],
                style_formats: [
                    {title: 'Image', items: [
                        {title: 'Default 220w', selector: 'img', styles: {'width':'220px','min-width':'','height':'','max-height':'','object-fit': '','float':'','margin':'20px'}},
                        {title: 'Float Right', selector: 'img', styles: {'width':'50%','min-width':'220px','height': '','max-height':'','object-fit': '','float':'right','margin':'0 0 20px 20px'}},
                        {title: 'Float Left', selector: 'img', styles: {'width':'50%','min-width':'220px','height': '','max-height':'','object-fit': '','float':'left','margin':'0 20px 20px 0'}},
                        {title: 'Banner 160h', selector: 'img', styles: {'width':'100%','min-width':'','height': '160px','max-height':'','object-fit': 'cover','float':'','margin':'20px 0'}},
                        {title: 'Banner 240h', selector: 'img', styles: {'width':'100%','min-width':'','height': '240px','max-height':'','object-fit': 'cover','float':'','margin':'20px 0'}},
                        {title: 'Banner 320h', selector: 'img', styles: {'width':'100%','min-width':'','height': '320px','max-height':'','object-fit': 'cover','float':'','margin':'20px 0'}},
                        {title: 'Full Size', selector: 'img', styles: {'width':'100%','min-width':'','height': '','max-height':'','object-fit': '','float':'','margin':'20px 0'}}
                    ]}
                ],
                style_formats_merge: true,
                relative_urls : false,
                remove_script_host : false,
                document_base_url : \"".cms_root_url."\"
            });


            function toggleEditor(textarea_id){
                tinymce.EditorManager.execCommand('mceToggleEditor', false, textarea_id);
            }

        </script>";
    }
    return;
}

if ($tinymce_use_version==3){
$page_meta.="<script src=\"../plugins/tinymce/v3/tiny_mce.js\"></script>";
if (display_type=='mobile'){
$page_meta.="<script>
        tinyMCE.init({
            // General options
            relative_urls : false,
            convert_urls : false,
            remove_script_host : false,
            document_base_url : \"".cms_url."\",
            mode : \"textareas\",
            editor_deselector : \"mceNoEditor\",
            theme : \"advanced\",
            plugins : \"advimage,safari,style,inlinepopups,paste,table\",
                        extended_valid_elements : \"iframe[src|width|height|name|align|scrolling|frameborder|style|allowtransparency],object[width|height|classid|codebase|id|class|type|data],param[name|value],embed[src|type|width|height|flashvars|wmode],script[language|type|src]\",

            // Theme options
            theme_advanced_buttons1 : \"bold,italic,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,bullist,numlist,|,hr,charmap\",
            theme_advanced_buttons2 : \"\",
            theme_advanced_buttons3 : \"\",
            theme_advanced_buttons4 : \"\",
            theme_advanced_toolbar_location : \"top\",
            theme_advanced_toolbar_align : \"left\",
            theme_advanced_statusbar_location : \"bottom\",
            theme_advanced_resizing : false,
            theme_advanced_resizing_max_width : 960,
            theme_advanced_resizing_use_cookie : false
        });

        function toggleEditor(id) {
            if (!tinyMCE.get(id))
            tinyMCE.execCommand('mceAddControl', false, id);
            else
            tinyMCE.execCommand('mceRemoveControl', false, id);
        }

    </script>";

}
else{

    $page_meta.="<script>
        tinyMCE.init({
            // General options
            relative_urls : false,
            convert_urls : false,
            remove_script_host : false,
            document_base_url : \"".cms_url."\",
            mode : \"textareas\",
            editor_deselector : \"mceNoEditor\",
            theme : \"advanced\",
            plugins : \"advimage,safari,style,inlinepopups,paste,table\",
            extended_valid_elements : \"iframe[src|width|height|name|align|scrolling|frameborder|style|allowtransparency],object[width|height|classid|codebase|id|class|type|data],param[name|value],embed[src|type|width|height|flashvars|wmode],script[language|type|src],pre\",

            // Theme options
            theme_advanced_buttons1 : \"cut,copy,paste,pastetext,pasteword,|,undo,redo,|,bold,italic,strikethrough,|,forecolor,backcolor,|,justifyleft,justifycenter,justifyright,justifyfull,|,formatselect,|,bullist,numlist,|,charmap\",
            theme_advanced_buttons2 : \"tablecontrols,|,visualaid,|,hr,outdent,indent,blockquote,|,link,unlink,anchor,image,|,removeformat,cleanup,code\",
            theme_advanced_buttons3 : \"\",
            theme_advanced_buttons4 : \"\",
            theme_advanced_toolbar_location : \"top\",
            theme_advanced_toolbar_align : \"left\",
            theme_advanced_statusbar_location : \"bottom\",
            theme_advanced_resizing : true,
            theme_advanced_resizing_max_width : 960,
            theme_advanced_resizing_use_cookie : false,

        });

        function toggleEditor(id) {
            if (!tinyMCE.get(id))
            tinyMCE.execCommand('mceAddControl', false, id);
            else
            tinyMCE.execCommand('mceRemoveControl', false, id);
        }

    </script>";
}
}

?>
