<?php $config=array(

    // leave blank and set the protocol in the admin area or override below - set to http:// or https:// if SSl cert is active on domain
    // if changing protocol theme and cache must be resfreshed in the admin area
    'CMS_PROTOCOL' => '',

    // leave blank and the cms will auto-detect the root directory or manually override it here (should end with a trailing slash)
    'CMS_ROOT_DIR' => '',

    // backup method
    // 0 use phar backup if available (php5.3) with fall back to shell_exec tar method
    // 1 force shell_exec tar with gzip method (smaller file size and runs quicker but requires shell_exec and tar)
    'BACKUP_METHOD' => 0,
    'MAX_BACKUPS' => 5, // the maximum number of backups allowed (to save space on server)

    // max upload limits that will generate an error if exceeded - note bigger images require more storage space and memory to process
    'MAX_UPLOAD_IMAGE_DIM' => 4000, // Max width and height dimension
    'MAX_UPLOAD_IMAGE_SIZE' => 2097152, // Max file size, 2097152 = 2MB
    'MAX_UPLOAD_FILE_SIZE' => 2048000, // Max file size, 2048000 = 2MB
    // if uploaded images are bigger than those below a smaller resized version will be saved instead of original
    'MAX_UPLOADED_IMAGE_SIZE_X' => 1280,
    'MAX_UPLOADED_IMAGE_SIZE_Y' => 720,
    'MAX_UPLOADED_IMAGE_SIZE' => 512000, // Max file size, 512000 = 500KB

    // apply image watermarks - uses theme_dir/images/watermark.png
    'WATERMARK_CATEGORIES' => 0,
    'WATERMARK_ARTICLES' => 0,
    'WATERMARK_PRODUCTS' => 0,
    'WATERMARK_LISTINGS' => 0,
    'WATERMARK_APPLICATIONS' => 0,

    // category limitations
    'CATEGORY_MAX_COLS' => 10,
    'CATEGORY_MAX_ROWS' => 50,

    // enable/disable cache 0=off 1=on
    'CACHE_ENABLED' => 0,
    // auto clear cache interval in seconds 0=off - should not need to be enabled except in special circumstances
    'CLEAR_CACHE_INTERVAL' => 0,

    // enable/disable listing expiry check  0=off or interval in seconds (86400 to check every 24hrs)
    'CHECK_EXPIRED_LISTINGS' => 0,
    // email expiry notifications for user listings - 0 to disable, 1 to email just on expiration, any number greater than 1 will send advance email(s) for listings that have less than this values number of days left
    'EXPIRED_LISTINGS_EMAIL_REMINDER' => 0,
    // interval in days between email reminders - minimum value of 3 - expired_listings_email_reminder must be set to a value greater than 1
    'EXPIRED_LISTINGS_EMAIL_REMINDER_INTERVAL' => 15,

    // enable/disable subscription expiry check  0=off or interval in seconds (86400 to check every 24hrs)
    'CHECK_EXPIRED_SUBSCRIPTIONS' => 0,
    // email expiry notifications for subscriptions - 0 to disable, 1 to email just on expiration, any number greater than 1 will send advance email(s) for subscriptions that have less than this values number of days left
    'EXPIRED_SUBSCRIPTIONS_EMAIL_REMINDER' => 30,
    // interval in days between email reminders - minimum value of 3 - expired_subscriptions_email_reminder must be set to a value greater than 1
    'EXPIRED_SUBSCRIPTIONS_EMAIL_REMINDER_INTERVAL' => 10,

    // number of upload files allowed per message - 0=disable
    'MESSAGE_MAX_UPLOAD_FILES' => 0,

    // email system activity notifications to admin users - 1=enabled, 0=disabled
    'ADMIN_EMAIL_NOTIFICATIONS' => 0,

    // type of email sent for messages
    // 0=email notification with timer/login reset - login to read/reply via website
    // 1=email every message imidiately with reply to sender
    'MESSAGE_EMAIL_TYPE' => 1,
    // status for new messages 0=awaiting moderation, 1=approved, 2=spam
    'NEW_MESSAGE_STATUS' => 0,

    // you can override the theme that has been set in the admin area for admin previewing of a new theme, only admins will be able to see the preview theme
    // enter the name of the theme folder and set the minimum admin level for previewing - leave blank to display the selected theme in admin area
    'PREVIEW_THEME' => '',
    'PREVIEW_THEME_ADMINLEVEL' => 10,

    // setting this to 1 will remove the XT-CMS branding from the admin footer
    'WHITE_LABEL_FOOTER' => 0

); ?>