<?php

    // each navmenu content template file must have a unique namespace
    // the namespace must be navmenu\[content template filename] all lower-case using backslash to seperate and without file extension
    // this allows the CMS to use multiple content templates that use the same function names
    namespace navmenu\ct_default;

    // example navmenu template tag {cms-navmenu-123456789-mylayout} where -mylayout is optional

    function navlinks_wrapper($navlinks_html,$navmenu_name,$layout=""){

        $html="<h3>".$navmenu_name."</h3>";

        if (!empty($navlinks_html))
            $html.="<ul>\n".$navlinks_html."</ul>\n";

        return $html;

    }

    function navlinks_html($navlinks,$level=0,$layout=""){

        $html="";

        // output existing navlinks menu on page
        if (!empty($navlinks)){

            foreach ($navlinks as $navlink => $value){
                if (isset($value['name'])){
                    $html.="<li><a href=\"".$value['link']."\">".$value['name']."</a>";
                    if ($child_html=navlinks_html($value,($level+1))) $html.="\n<ul>\n".$child_html."</ul>\n";
                    $html.="</li>\n";
                }
            }

        }

        return $html;

    }


?>
