<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")) exit;

    $variant_color_options=array();
    $variant_size_options=array();

    // display product variants
    $variant_output_2="";
    if ($variants=$product->getVariants()){

        $custom_attributes=get_custom_attributes('product');

        $show_variant_attributes=array('colour','size','wheel_size');

        $tn_size_x=120;
    	$tn_size_y=95;

        $variant_output="";

        $variant_num=0;
        foreach($variants as $variant_id => $val){

            if ($variant_id==$product->id) continue; // don't show current product as varient

            $variant= new Product();
            if ($variant->getData($variant_id)){

                if (!$variant->canShow()) continue; // don't show inactive product variants

                // get attribute differences - really this should be in the product name already
                $attr_diff_str="<h4>".$variant->name."</h4>";
                if (!empty($variant->attr)){
                    $attr_diffs_max = 2;
                    $attr_diffs_count = 0;
                    $attr_diff_str.="<ul>";
                    foreach ($variant->attr as $attr_name => $attr_val){
                        if (empty($custom_attributes[$attr_name]['status']) || !$custom_attributes[$attr_name]['vis']) continue; // skip hidden attributes
                        if (!in_array($attr_name,$show_variant_attributes)) continue;

                        // attribute differences as selectable variant options
                        if (!empty($variant->attr[$attr_name][0]) && !empty($product->attr[$attr_name][0]) && $product->attr[$attr_name][0]!=$variant->attr[$attr_name][0]){

                            if ($attr_name=='colour' && $custom_attributes[$attr_name]['type']=='Color'){
                                // todo color option should prefer other attributes to be the same (check if size is same and update)
                                $preference=$product->countAttrMatches($variant->attr);
                                if (!isset($variant_color_options[$variant->attr[$attr_name][0]]['preference']) || $preference>$variant_color_options[$variant->attr[$attr_name][0]]['preference']){
                                    $variant_color_options[$variant->attr[$attr_name][0]]['variant_id']=$variant->id;
                                    $variant_color_options[$variant->attr[$attr_name][0]]['colorname']=$attr_val[0];
                                    $variant_color_options[$variant->attr[$attr_name][0]]['color1']=$attr_val['color1'];
                                    $variant_color_options[$variant->attr[$attr_name][0]]['color2']=$attr_val['color2'];
                                    $variant_color_options[$variant->attr[$attr_name][0]]['preference']=$preference;
                                }

                            }
                            elseif ($attr_name=='size'){
                                // todo color option should prefer other attributes to be the same (check if size is same and update)
                                $preference=$product->countAttrMatches($variant->attr);

                                if (!isset($variant_size_options[$variant->attr[$attr_name][0]]['preference']) || $preference>$variant_size_options[$variant->attr[$attr_name][0]]['preference']){
                                    $variant_size_options[$variant->attr[$attr_name][0]]['variant_id']=$variant->id;
                                    $variant_size_options[$variant->attr[$attr_name][0]]['size']=$attr_val[0];
                                    $variant_size_options[$variant->attr[$attr_name][0]]['preference']=$preference;
                                }

                            }

                           $attr_diff_str.="<li>".capsTxt($attr_name).": ".$variant->attr[$attr_name][0]."</li>";
                           $attr_diffs_count++;
                           if  ($attr_diffs_count>=$attr_diffs_max) break;
                        }
                    }
                    //$attr_diff_str=implode(" ",array_slice($attr_diff,0,$max_attr_diffs));
                    //$variant_txt_output.="<div id=\"variant_".$variant_num."\" style="hidden">".$attr_diff_str."</div>";

                    $attr_diff_str."</ul>";
                }


                if ($image=$variant->getImage()){

                    $image_fn=key($image);

                    $image_mod_time=filemtime($variant->itemDir().'/'.$image_fn);

    				// check if correct size image exists and create one if it doesn't
    				$thumbnail_fn=$tn_size_x."x".$tn_size_y.'_'.$image_mod_time.'p'.$product->id.'_'.safe_file_name($image_fn);
    				if (!file_exists(sys_image_dir.'/'.$thumbnail_fn) || filemtime(sys_image_dir.'/'.$thumbnail_fn)<=$image_mod_time){
    					createthumb($variant->itemDir().'/'.$image_fn,sys_image_dir.'/'.$thumbnail_fn,$tn_size_x,$tn_size_y,1,watermark_products);
    				}

                    $variant_output.="<a href=\"".$variant->getURL()."\" title=\"".$variant->name."\"><div class=\"variant\" style=\"height: ".$tn_size_y."px;\"><img src=\"".cms_image_url.$thumbnail_fn."\" alt=\"".$variant->name."\" style=\"min-width: ".$tn_size_x."px\"><div style=\"padding: 5px;\">".$attr_diff_str."</div></div></a>";
                }
                else
                    $variant_output.="<a href=\"".$variant->getURL()."\" title=\"".$variant->name."\"><div class=\"variant\" style=\"height: ".$tn_size_y."px;\"><div style=\"min-width: ".$tn_size_x."px\"></div><div style=\"padding: 5px;\">".$attr_diff_str."</div></div></a>";

                $variant_num++;

            }

        }

        if ($variant_num>0){

            $variant_output_2.="<div style=\"flex-basis: 40%;flex-grow: 1; min-width: 280px;\"><fieldset class=\"product_variants\"><legend>Variants</legend>";

            if ($variant_output)
                $variant_output_2.="<div class=\"product_variants_div\">".$variant_output."</div>";

            $variant_output_2.="</fieldset></div>";
        }

    }

    // open content div
    $page_content['main'].="<div class=\"cms-content cms-product-page\" style=\"display:flex;flex-flow:row wrap;justify-content:center\">";

    $page_content['main'].="<div style=\"width: 100%; max-width: 650px;flex 1 1 100%;margin: 0 20px 0 20px\">"; // img and variant container div

    $gallery_html = "";
    if ($product->image || $product->youtube_video){

        // jquery galleria includes
        $jquery_required=1;
        $page->body_end.="<link href=\"".cms_root_url."plugins/fotorama-4.6.4/fotorama.css\" rel=\"stylesheet\"><script src=\"".cms_root_url."plugins/fotorama-4.6.4/fotorama.js\"></script>";
        // css hack for image click to fullscreen
        /*
        $page->body_end.="<style>.fotorama__fullscreen-icon {
        width: 100%;
        height: 100%;
        background: none;
        z-index:2;
        }</style>";
        */

        $img_main_width=1280;
        $img_main_height=720;
        $img_zoom_width=1280;
        $img_zoom_height=720;
        $img_thumb_width=100;
        $img_thumb_height=100;

        if ($product->image){
        	foreach ($product->image as $image_filename => $value){

                $item_path = $product->itemDir().'/';

                $image_fn = $item_path.$image_filename;

                if (!file_exists($image_fn)) continue;

                $image_mod_time=filemtime($image_fn);

                // check if correct size image exists and create one if it doesn't
                $img_main_filename = $img_main_width."x".$img_main_height.'_'.$image_mod_time.'p'.$product->id.'_'.safe_file_name($image_filename);
                $img_main_fn = sys_image_dir.'/'.$img_main_filename;
                if (!file_exists($img_main_fn) || filemtime($img_main_fn) <= $image_mod_time)
                	createthumb($image_fn,$img_main_fn,$img_main_width,$img_main_height,1,watermark_products);


                // check if correct size zoom-in image exists and create one if it doesn't
                $img_zoom_filename = $img_zoom_width."x".$img_zoom_height.'_'.$image_mod_time.'p'.$product->id.'_'.safe_file_name($image_filename);
                $img_zoom_fn = sys_image_dir.'/'.$img_zoom_filename;
                if (!file_exists($img_zoom_fn) || filemtime($img_zoom_fn)<=$image_mod_time)
                	createthumb($image_fn,$img_zoom_fn,$img_zoom_width,$img_zoom_height,1,watermark_products);

                // check if correct size image exists and create one if it doesn't
                $img_thumb_filename=$img_thumb_width."x".$img_thumb_height.'_'.$image_mod_time.'p'.$product->id.'_'.safe_file_name($image_filename);
                $img_thumb_fn = sys_image_dir.'/'.$img_thumb_filename;
                if (!file_exists($img_thumb_fn) || filemtime($img_thumb_fn)<=$image_mod_time)
                	createthumb($image_fn,$img_thumb_fn,$img_thumb_width,$img_thumb_height,1,watermark_products);


                $alt_txt=$product->name;
        		if ($value['alt_tag']!="" && $value['alt_tag']!=$product->name){$alt_txt.=' - '.$value['alt_tag'];}

                $gallery_html.="<a href=\"".cms_image_url.$img_main_filename."\"  data-full=\"".cms_image_url.$img_zoom_filename."\"><img src=\"".cms_image_url.$img_thumb_filename."\" alt=\"".$alt_txt."\"></a>\n";

                // page meta for facebook
                if (!isset($og_thumb_fn)){

                    // image size should be minimum recommended by fb
                    // 1200x630 recommended - 600x315 recommended - 200x200 minimum
                    $og_thumb_width=600;
                    $og_thumb_height=315;

        		// check facebook sharing image exists and create one if it doesn't
        		$og_thumb_filename=$og_thumb_width."x".$og_thumb_height.'_'.$image_mod_time.'p'.$product->id.'_'.safe_file_name($image_filename);
                    $og_thumb_fn=sys_image_dir.'/'.$og_thumb_filename;
        	  	if (!file_exists($og_thumb_fn))
        		    createthumb($image_fn,$og_thumb_fn,$og_thumb_width,$og_thumb_height,1,watermark_products);

                    if (file_exists($og_thumb_fn)){

                        $image_size=getimagesize($og_thumb_fn);

                        $og_data['image']=cms_image_url.$og_thumb_filename;
                        $og_data['image_width']=$image_size[0];
                        $og_data['image_height']=$image_size[1];

                    }

                }

            }
        }

        if ($product->youtube_video)
            $gallery_html.="<a href=\"http://www.youtube.com/watch?v=".$product->youtube_video."\">Watch Video</a>";


        if ($gallery_html)
            $gallery_html="<div class=\"fotorama\" data-width=\"100%\" data-fit=\"contain\" data-maxheight=\"350px\" data-ratio=\"800/600\" data-allowfullscreen=\"native\" data-loop=\"true\" data-nav=\"thumbs\" data-thumbwidth=\"".$img_thumb_width."\" data-thumbheight=\"".$img_thumb_height."\">".$gallery_html."</div>";

        // facebook og code
        $og_data['title']=$product->name;
        if ($product->short_description) $og_data['description']=htmlentities($product->short_description,ENT_COMPAT,'UTF-8');
        $og_data['url']=$page->getCurrentURL(true);

    }

    // display image gallery
    if ($gallery_html)
        $page_content['main'].="<div class=\"img_group\" >".$gallery_html."</div>";

    if ($variant_output_2)
        $page_content['main'].=$variant_output_2;

    $page_content['main'].="</div>"; // close img and variant container div

    // main content div
    $page_content['main'].="<div style=\"flex: 1 1 280px;max-width: 650px\"><h1>".htmlentities($product->name,ENT_COMPAT,'UTF-8')."</h1>";
    if ($product->code) $page_content['main'].="<div class=\"product_code\">(".htmlentities($product->code,ENT_COMPAT,'UTF-8').")</div>";

    if ($display_price) $page_content['main'].='<div class="product_price">'.$display_price.'</div>';

	$page_content['main'].="<form id=\"productform\" class=\"cms_product_form\" method=\"post\" action=\"".$page->url."#productform\" enctype=\"multipart/form-data\">";

    $page_content['main'].=$product_options;

    // display add to cart button if enabled
    if ($product->status==1){

        if (!empty($product->booking_slot)){
            $no_scpu=1; // no shopping cart popup
            if (empty($booking_time_slots)){
                $page_content['main'].="<div class=\"warning_box\">Sorry, no booking slots currently available for ".$product->name."</div>";
            }
            elseif (!empty($product->booking_end_date) && $product->booking_end_date<CMS_INIT_TIME){
                $page_content['main'].="Booking period for this product/event has ended.";
            }
            else{

                $booking_slots="";
                foreach($booking_time_slots as $slot_time => $key){
                    foreach($key as $key2 => $value){
                        if ($value['seats']!="" && $value['booked_seats']>=$value['seats']){
                            $booked_txt="Booked"; // booked, booked out, fully booked, taken, reserved
                            if ($value['seats']>1){$booked_txt="Fully Booked";}
                            $booking_slots.="<li class=\"booking_slot_unavailable\"><div style=\"display: flex;\"><div class=\"slot_date\">".date("d",$slot_time)."</div><div class=\"slot_month\">".date("M",$slot_time)."<br>".date("Y",$slot_time)."</div><div class=\"slot_time\"><div>".date("D",$slot_time)."&nbsp;</div><div style=\"min-width: 5em\">".date("g:ia",$slot_time)."</div></div></div><button type=\"submit\" name=\"booking_time[".$slot_time."]\" class=\"cms_btn\" disabled=\"disabled\">".$booked_txt."</button></li>";
                        }
                        else{
                            $seats_txt="";
                            //if ($value['seats']>1){$seats_txt="<div class=\"booking_slot_availability\">".$value['seats']." available</div>";}
                            $booking_slots.="<li><div style=\"display: flex;\"><div class=\"slot_date\">".date("d",$slot_time)."</div><div class=\"slot_month\">".date("M",$slot_time)."<br>".date("Y",$slot_time)."</div><div class=\"slot_time\"><div>".date("D",$slot_time)."&nbsp;</div><div style=\"min-width: 5em\">".date("g:ia",$slot_time).$seats_txt."</div></div></div><button type=\"submit\" name=\"booking_time[".$slot_time."]\" class=\"cms_btn\">Book Now</button><input type=\"hidden\" name=\"add_to_cart\" value=\"".$rvi_product."\" /></li>";
                        }
                    }
                }

                if($booking_slots!=""){$page_content['main'].="<ul class=\"product-booking-times\">".$booking_slots."</ul>";}
            }

        }
        else{

            if (empty($rvi_qty)) $rvi_qty=1;
    		if ($product->behaviour=='Add to Cart' && !$product->note_form_enabled && !$product->file_upload_enabled){

                $page_content['main'].="<div class=\"product_buy\">";
                if ($product->subscription>0)
                    $page_content['main'].="<input type=\"hidden\" name=\"qty\" value=\"0\" /> ";
                else
                    $page_content['main'].="<span class=\"product_qty\"><label for=\"qty\">Qty:</label> <input type=\"text\" id=\"qty\" name=\"qty\" value=\"$rvi_qty\" /></span> ";

                $page_content['main'].="<button type=\"submit\" name=\"add_to_cart\" value=\"".$rvi_product."\" class=\"cms_btn cms_btn_add_to_cart\">".$txt['btn_add_to_cart']."</button></div>";
    		}
        }

        // we want to include add to cart popup
        // no longer needed as cms_front now checks all content areas for add_to_cart and includes popup if found
        // if ($product->behaviour=='Add to Cart' && $product->note_form_enabled<1 && $product->file_upload_enabled<1){$include_cart_popup=1;}

    }else{$page_content['main'].="<div class=\"outofstock\">Out of Stock</div>";}


    // display variant color options
    if ($variant_color_options){

        $page_content['main'].="<fieldset class=\"product_variant_options\"><legend>Colour Variants</legend><ul>";

        // show current product color as selected variant option
        $page_content['main'].="\n<li class=\"variant_option_current variant_option_disc\" style=\"color: #".$product->attr['colour']['color1']."\"><svg height=\"100%\" width=\"100%\"><circle cx=\"50%\" cy=\"50%\" r=\"50%\" stroke=\"#333\" stroke-width=\"0\" fill=\"#".$product->attr['colour']['color1']."\"><title>".$product->attr['colour'][0]."</title></circle></svg></li>";

        foreach ($variant_color_options as $color_name => $variant_color_option){

            $variant_color_option_product= new Product();
            if ($variant_color_option_product->getData($variant_color_option['variant_id'])){

                $page_content['main'].="\n<li class=\"variant_option variant_option_disc\" style=\"color: #".$variant_color_option['color1']."\"><a href=\"".$variant_color_option_product->getURL()."\" title=\"".$color_name."\"><svg height=\"100%\" width=\"100%\"><circle cx=\"50%\" cy=\"50%\" r=\"50%\" stroke=\"#333\" stroke-width=\"0\" fill=\"#".$variant_color_option['color1']."\" /></svg></a></li>";
            }
        }

        $page_content['main'].="</ul></fieldset>";

    }


    // display variant size options
        if ($variant_size_options){

                $page_content['main'].="<fieldset class=\"product_variant_options\"><legend>Size Variants</legend><ul>";

                // show current product color as selected variant option
                $page_content['main'].="<li class=\"variant_option_current\"><button type=\"button\">".$product->attr['size'][0]."</button></li>";

                foreach ($variant_size_options as $size_name => $variant_size_option){

                        $variant_size_option_product= new Product();
                        if ($variant_size_option_product->getData($variant_size_option['variant_id'])){
                            $page_content['main'].="<li class=\"variant_option\"><a href=\"".$variant_size_option_product->getURL()."\" title=\"".$size_name."\"><button type=\"button\">".$size_name."</button></a></li>";
                        }
                }

                $page_content['main'].="</ul></fieldset>";

        }


    // display main description
    if (!empty($product->content['main'])){

        if (strlen($product->content['main'])>1400){

            $see_more=1;

            $page_content['main'].="<div id=\"product_description\" class=\"product_description sm_content\">".$product->content['main'];
            $page_content['main'].="<p id=\"sm_fade_product_description\" class=\"sm_fade\"></p>";
            $page_content['main'].="</div>";
            $page_content['main'].="<div style=\"margin: 0 0 20px 0\"><button type=\"button\" class=\"sm_btn\" onclick=\"javascript:see_more(this,'product_description')\"><i class=\"cms-fi-chevron-down\"></i> SEE MORE</button></div>";

            // $include_font_icons=1;
        }
        else
            $page_content['main'].="<div class=\"product_description\">".$product->content['main']."</div>";
    }

    // display attributes here
    if (!empty($product->attr)){


        if ($attributes=get_custom_attributes('product',1)){

            $attributes_html="";
            foreach ($product->attr as $attribute => $value){

                if (empty($attributes[$attribute]['status']) || empty($attributes[$attribute]['vis'])) continue;
                if (!empty($attributes[$attribute]) && $value[0]){
                    $attributes_html.="<li style=\"margin-bottom: 11px;\"><span style=\"font-weight: bold\">".capsTxt($attributes[$attribute]['name'])."</span>: ".$value[0]."</li>";
                }
            }
            if ($attributes_html){

                if (strlen($attributes_html)>400){

                    $see_more=1;

                    $page_content['main'].="<hr><h2>Product Attributes</h2><div id=\"product_attributes\" class=\"product_attributes sm_content\"><ul>".$attributes_html."</ul>";
                    $page_content['main'].="<p id=\"sm_fade_product_attributes\" class=\"sm_fade\"></p>";
                    $page_content['main'].="</div>";
                    $page_content['main'].="<div style=\"margin: 0 0 20px 0\"><button type=\"button\" class=\"sm_btn\" onclick=\"javascript:see_more(this,'product_attributes')\"><i class=\"cms-fi-chevron-down\"></i> SEE MORE</button></div>";

                }
                else
                    $page_content['main'].="<hr><h2>Product Attributes</h2><div class=\"product_attributes\"><ul>".$attributes_html."</ul></div>";

            }
        }
    }

    // display checkout warnings
    if (isset($_SESSION[cms_key]['form']['product_detail']['warning'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form']['product_detail']['warning']);}

    // dynamic note and customer note form
    if ($product->behaviour=='Add to Cart'){
        // dynaimc note can be used to add custom text information to the ordered product - it appends to any customer note
        $page_content['main'].="<input type=\"hidden\" name=\"dynamic_note\" value=\"\" />";
        if ($product->note_form_enabled>0){
            $page_content['main'].="<div style=\"margin: 20px 0\"><h3>Order Notes</h3>";

            if ($product->note_form_enabled)
                $page_content['main'].="<p>Use the text box below to provide required text/special instructions when ordering this product.</p>";
            else
                $page_content['main'].="<p>Use the text box below to provide any notes or special instructions when ordering this product.</p>";

            $page_content['main'].="<div class=\"form_row\"><textarea name=\"customer_note\" style=\"height: 4em\">".(isset($rvi_customer_note) ? $rvi_customer_note : "")."</textarea></div>";
            $no_scpu=1; // no shopping cart popup
            $page_content['main'].="</div>";
        }
    }

    // display file upload form
    if ($product->behaviour=='Add to Cart' && $product->file_upload_enabled){
        $page_content['main'].="<div style=\"margin: 20px 0\"><h3>Upload File</h3><p>Upload a file for this product.</p><input type=\"file\" name=\"uploaded_file\" /><p>Please allow time for file to upload when adding to cart.</p>";
        $no_scpu=1; // no shopping cart popup
        $page_content['main'].="</div>";
    }

    // display add to cart button if enabled
    if ($product->status==1){

        if (isset($no_scpu)){$page_content['main'].="<input type=\"hidden\" name=\"no_scpu\" value=\"1\" />";}

		if ($product->behaviour=='Add to Cart' && ($product->note_form_enabled || $product->file_upload_enabled)){
			$page_content['main'].="<div class=\"product_buy\">";
            if ($product->subscription>0){
                $page_content['main'].="<input type=\"hidden\" name=\"qty\" value=\"0\" /> ";
            }else{$page_content['main'].="<span class=\"product_qty\">Qty: <input type=\"text\" name=\"qty\" value=\"$rvi_qty\" /></span> ";}
            //$page_content['main'].="<input type=\"hidden\" name=\"add_to_cart\" value=\"".$rvi_product."\" /><input type=\"image\" src=\"".theme_file_url('images/shop/add_to_cart.png',display_theme)."\" style=\"vertical-align: middle; padding-left: 5px\" /></div>";
            $page_content['main'].="<input type=\"hidden\" name=\"add_to_cart\" value=\"".$rvi_product."\" /><button type=\"submit\" class=\"cms_btn cms_btn_add_to_cart\">".$txt['btn_add_to_cart']."</button></div>";

		}
    }

    $page_content['main'].="</form>";

    // display enquiry form
    if ($product_enquiry_form){

        $page_content['main'].="<hr />\n";
        $page_content['main'].="<div class=\"product-enquiry-form\">\n"; // open contact form container div
        $page_content['main'].="<h3>Enquire about ".$product->name."</h3>";

        $subject="Product enquiry - ".$product->name;
        $page_content['main'].=$product_enquiry_form;
        $page_content['main'].="</div>\n"; // close contact form container div
    }

    // close product detail main content div
    $page_content['main'].="</div>";

    // close content div
    $page_content['main'].="</div>";

    // display related products - ensure the related products category in the admin area has listings set to visible and the appropriate templates set
    if (!empty($related_products['content']['main'])) $page_content['main'].="<hr style=\"margin: 20px 0;\" />".$related_products['content']['main'];





?>
