<?php

    // exit if php file is loaded directly and not included
    if (!defined("cms_version_number")) exit;

    // google reCAPTCHA - https://developers.google.com/recaptcha/intro
    // to use captcha go to Admin -> Settings and enter your SiteKey and SecretKey provided by Google
    // todo - add reCAPTCHA v3 suppport - use enable key to allow version switching
    if ($cmsSettings->captcha_is_enabled('contact')){
        $page->meta.="<script src='https://www.google.com/recaptcha/api.js'></script>
        <script>
        function onSubmit(token) {
            document.getElementById(\"contactForm\").submit();
        }
        </script>";
    }

    $product_enquiry_form_anchor_id="product_enquiry_form";
    $product_enquiry_form="<div id=\"".$product_enquiry_form_anchor_id."\" class=\"cms_contact_form\">";

    if (isset($_SESSION[cms_key]['form']['contact_warning_green']))
        $product_enquiry_form.=display_warnings($_SESSION[cms_key]['form']['contact_warning_green'],'green');
    else{

        // display warnings
        if (isset($_SESSION[cms_key]['form']['contact_warning']))
            $product_enquiry_form.=display_warnings($_SESSION[cms_key]['form']['contact_warning']);

        $product_enquiry_form.="<form id=\"contactForm\" action=\"".$page->url."#".$product_enquiry_form_anchor_id."\" method=\"post\" class=\"cms_form\">

        <div class=\"form_row\"><label for=\"name\">Name:</label>
        <input name=\"name\" id=\"name\" type=\"text\" maxlength=\"120\" value=\"".(isset($_POST['name']) ? $_POST['name'] : "")."\" /></div>

        <div class=\"form_row\"><label for=\"phone\">Phone:</label>
        <input name=\"phone\" id=\"phone\" type=\"text\" maxlength=\"120\"  value=\"".(isset($_POST['phone']) ? $_POST['phone'] : "")."\" /></div>

        <div class=\"form_row\"><label for=\"email\">Email:</label>
        <input name=\"email\" id=\"email\" type=\"email\" maxlength=\"120\"  value=\"".(isset($_POST['email']) ? $_POST['email'] : "")."\" /></div>";

        // to send additional information via text field or select/dropdown eg. name="custom[myCustomName]"
        /*
        $product_enquiry_form.="<div class=\"form_row\"><label for=\"email\">Test:</label>
        <input name=\"custom[Testing]\" type=\"text\" maxlength=\"120\"  value=\"".(isset($_POST['custom']['Testing']) ? $_POST['custom']['Testing'] : "")."\" /></div>";
        $product_enquiry_form.="<div class=\"form_row\"><label for=\"email\">TestSel:</label>
        <select name=\"custom[TestingSel]\" />";
        $options=array('TestOption1','TestOption2','TestOption3');
        foreach ($options as $option){
            if (isset($_POST['custom']['TestingSel']) && $_POST['custom']['TestingSel']==$option)
                $product_enquiry_form.="<option selected>".$option."</option>";
            else
                $product_enquiry_form.="<option>".$option."</option>";
        }
        $product_enquiry_form.="</select></div>";
        */

        $product_enquiry_form.="<div class=\"form_row\"><label for=\"message\">Message:</label><textarea name=\"message\" id=\"message\">".(isset($_POST['message']) ? $_POST['message'] : "")."</textarea></div>";

        // policy consent text and checkboxes
        $policy_consent_txt="";

        if ($cmsSettings->gdpr==1){$policy_consent_txt="<div style=\"margin: 5px\">By submitting this form you give <span style=\"font-weight: bold\">".cms_site_name."</span> consent to collect and store your details and to send email to the email address provided by you.</div>";}
        elseif($cmsSettings->gdpr==2){$policy_consent_txt="<div style=\"margin: 5px\"><input type=\"checkbox\" id=\"gdpr_consent\" name=\"gdpr_consent\"".(isset($rvi_gdpr_consent) ? "checked=\"checked\"" : "")."> <label for=\"gdpr_consent\" class=\"contact_form_policy\" style=\"font-weight: normal\">I agree to allow <span style=\"font-weight: bold\">".cms_site_name."</span> to collect and store my details under <span style=\"font-weight: bold\">GPDR</span> guidelines and to send email to the email address I have provided.</label></div>";}

        if ($cmsSettings->newsletter_consent)
            $policy_consent_txt.="<div style=\"margin: 5px\"><input type=\"checkbox\" id=\"newsletter_consent\" name=\"newsletter_consent\"".(isset($rvi_newsletter_consent) ? "checked=\"checked\"" : "")."> <label for=\"newsletter_consent\" class=\"contact_form_policy\" style=\"font-weight: normal\">I agree to receive newsletter emails periodically from <span style=\"font-weight: bold\">".cms_site_name."</span>.</label></div>";

        $policy_consent_txt.="<div style=\"margin: 5px\">View our <a href=\"".cms_url."?terms#privacy\" target=\"_blank\">privacy policy</a>.</div>";

        if ($security_question && $cmsSettings->user['secq_product']){
            $contact_form.="<hr><p class=\"small_note\">Please answer the following question to verify you are not a spam-bot.</p>
                <div class=\"small_note\">".$security_question."</div><hr>";
        }

        if ($cmsSettings->captcha_is_enabled('product'))
            $product_enquiry_form.="<div class=\"form_row_footer\"><input type=\"hidden\" name=\"contact_form_submit\"><button class=\"g-recaptcha\" data-sitekey=\"".$google_invisible_captcha_sitekey."\" data-callback=\"submitCaptchaForm\" style=\"padding: 10px 20px 10px 20px\">Send</button></div>";
        else
            $product_enquiry_form.="<div class=\"form_row_footer\"><div class=\"contact_form_policy\">".$policy_consent_txt."</div><button type=\"submit\" name=\"contact_form_submit\" class=\"cms_btn\">".$txt['btn_send']."</button></div>";

        $product_enquiry_form.="</form>";
    }

    $product_enquiry_form.="</div>";

?>
