<?php

    // this file is used for custom form application
    // it can create an order if product price not zero and register new user

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}
    //ini_set("memory_limit","64M");
    ini_set("max_execution_time","120");

    // set the maximum number of this application a customer can have at any one time 0 for infinite
    $max_applications=0;
    // application settings for new application
    if (!isset($application_details)){

        $application_details['item_type']='application';
        // set the maximum number images 0 for none
        $application_details['max_image_qty']=1;
        $application_details['max_file_qty']=1;
        // status (usually set else status as 1 or 3) 0=inactive, 1=active(for free applications without moderation), 2=awaiting payment(for paid applications if price is>0 or same as 3 if product price is 0), 3=awaiting approval(for free applications with moderation), 4=reviewed and rejected, 5=expired
        if ($product_details['price']>0){$application_details['status']=2;}
        else{$application_details['status']=3;}
        // application type should be X in the filename of this script application_add_X.php
        $application_details['application_type']='taxrebate';
        // subscription time limit in days, 0 for no limit
        $application_details['subscription']=$product_details['subscription'];
        $application_details['label']='Tax Rebate';
        $application_details['class']='taxrebate';
        $application_details['product_id']=$product_details['id'];
        $application_details['template']=$product_details['template'];
        $application_details['enquiry_form_enabled']=0;

        $session_form_id=$application_details['product_id'].'a';

        // custom variables
        $application_details['address']="";
        $application_details['address_2']="";
        $application_details['city']="";
        $application_details['county']="";
        $application_details['postcode']="";
        $application_details['country']="";
        $application_details['marital_status']="";
        $application_details['occupation']="";
        $application_details['ppsnum']="";
        $application_details['medical_card']="";



    }else{
        $session_form_id=$application_details['product_id'].'m';
    }


    // load default country list first
    $fn_country_list_default=sys_data_dir.'/settings/country_list_default.txt';
    if (file_exists($fn_country_list_default)){
        $country_list_billing=file($fn_country_list_default);
        $country_list_delivery=$country_list_billing;
    }

    // load billing countries
    $fn=sys_data_dir.'/settings/country_list_billing.txt';
    $country_list_billing[]='---';
    if (file_exists($fn)){
    	$fc=file($fn);
    	if (count($fc)>1){$country_list_billing=array_merge($country_list_billing,$fc);}elseif (count($fc)==1){$country_list_billing=$fc;}
    }

    if (!isset($currency_symbol)){$currency_symbol=currency_symbol;}

    // if (isset($rvi_ad_category)){$_SESSION[$session_form_id]['category']=$rvi_ad_category;}elseif(!isset($_SESSION[$session_form_id]['category'])){$_SESSION[$session_form_id]['category']=null;}

     // rotate an image
    if (isset($rvi_rotateimgl) || isset($rvi_rotateimgr)){
        // rotate left settings
        if (isset($rvi_rotateimgl)){
            $image_fn=$rvi_rotateimgl;
            $rotate_angle=90;
        }
        // rotate right settings
        if (isset($rvi_rotateimgr)){
            $image_fn=$rvi_rotateimgr;
            $rotate_angle=270;
        }
        if (isset($application_details['image'][$image_fn])){
            $image_fp=sys_data_dir.'/applications/'.$application_details['id'].'/'.$image_fn;
            if (file_exists($image_fp)){

                $image_fn_pieces=explode(".",$image_fn);
                $image_fn_pieces_count = count($image_fn_pieces);
                $image_fn_extension = ".".$image_fn_pieces[$image_fn_pieces_count-1];

                $saveimage_fn=strtolower(time().rand(100,999).$image_fn_extension);
                $saveimage_fp=sys_data_dir.'/applications/'.$application_details['id'].'/'.$saveimage_fn;

                if (RotateImage($image_fp,$saveimage_fp,$rotate_angle)){

                  	// store new size of uploaded image
                  	$image_size=getimagesize($saveimage_fp);
              		$application_details['image'][$saveimage_fn]['size_x']=$image_size[0];
              		$application_details['image'][$saveimage_fn]['size_y']=$image_size[1];
              		$application_details['image'][$saveimage_fn]['alt_tag']=$application_details['image'][$image_fn]['alt_tag'];

                    unset($application_details['image'][$image_fn]);

                    if (save_item_details($application_details)){
                        // don't need to update item list for new image fn
                         // update_item_list_file('applications',array($application_details['id']));
                        if (admin_level()>9){update_log('Application '.$application_details['id'].' modified by Admin');}
                        elseif (isset($_SESSION[cms_key]['reg_user'])){
                            update_item_log('user',$_SESSION[cms_key]['reg_user']->id,'Application '.$application_details['id'].' modified by '.$_SESSION[cms_key]['reg_user']->name.' '.$_SESSION[cms_key]['reg_user']->id);
                            update_admin_notify_log('Application '.$application_details['id'].' modified by '.$_SESSION[cms_key]['reg_user']->name.' '.$_SESSION[cms_key]['reg_user']->id);
                        }

                        // delete old image
                        unlink($image_fp);
                    }

                }

            }
            // use redirect to clear url from repeating rotate on page refresh
            if(cms_interface=="back"){header("Location: ?modify_application=".$application_details['id'],true,303);}
            else {header("Location: ".cms_url."?myaccount&modify_application=".$application_details['id'],true,303);}
        }
    }

    // process submitted data
    if (isset($rvi_address)){

        // sanitize user input
        $rvi_address=sanitize_text_input($rvi_address);
        $rvi_address_2=sanitize_text_input($rvi_address_2);
        $rvi_city=sanitize_text_input($rvi_city);
        $rvi_county=sanitize_text_input($rvi_county);
        $rvi_postcode=sanitize_text_input($rvi_postcode);
        $rvi_country=sanitize_text_input($rvi_country);

        $rvi_marital_status=sanitize_text_input($rvi_marital_status);
        $rvi_occupation=sanitize_text_input($rvi_occupation);
        $rvi_ppsnum=sanitize_text_input($rvi_ppsnum);
        $rvi_medical_card=sanitize_text_input($rvi_medical_card);

        // check values
        if (strlen($rvi_address)<3){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]="Please enter your address.";}
        if (strlen($rvi_city)<3){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]="Please enter your town/city.";}
        if (strlen($rvi_county)<3){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]="Please enter your county.";}
        if ($rvi_country=="---"){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]="Please select country.";}

        // check phone number
        if (strlen($rvi_phone)<5){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]='Please enter your phone number.';}
        else{
            $clearchars=array('-',',',' ','-','+','(',')');
            if (intval(str_replace($clearchars,'',$rvi_phone))<10000){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]='Please enter your phone number';}
            if (substr($rvi_phone,0,5)=='12345'){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]='Please enter your phone number';}
        }


        // store user input in session
        $_SESSION[$session_form_id]['address']=$rvi_address;
        $_SESSION[$session_form_id]['address_2']=$rvi_address_2;
        $_SESSION[$session_form_id]['city']=$rvi_city;
        $_SESSION[$session_form_id]['county']=$rvi_county;
        $_SESSION[$session_form_id]['postcode']=$rvi_postcode;
        $_SESSION[$session_form_id]['country']=$rvi_country;

        $_SESSION[$session_form_id]['dob_month']=$rvi_dob_month;
        $_SESSION[$session_form_id]['dob_day']=$rvi_dob_day;
        $_SESSION[$session_form_id]['dob_year']=$rvi_dob_year;

        $_SESSION[$session_form_id]['marital_status']=$rvi_marital_status;
        $_SESSION[$session_form_id]['occupation']=$rvi_occupation;
        $_SESSION[$session_form_id]['ppsnum']=$rvi_ppsnum;
        $_SESSION[$session_form_id]['medical_card']=$rvi_medical_card;

        if (isset($rvi_name)){
            $customer_details['name']=sanitize_text_input($rvi_name);
            $_SESSION[$session_form_id]['name']=$customer_details['name'];
        }
        if (isset($rvi_email)){
            $customer_details['email']=sanitize_text_input($rvi_email);
            $_SESSION[$session_form_id]['email']=$customer_details['email'];
        }
        if (isset($rvi_phone)){
            $customer_details['phone']=sanitize_text_input($rvi_phone);
            $_SESSION[$session_form_id]['phone']=$customer_details['phone'];
        }


        if(!isset($_SESSION[cms_key]['reg_user']) && strlen($rvi_name)<2){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]="Please enter your name.";}

        if (!isset($modify_application)){
            // check email address if not logged in
            if (!isset($_SESSION[cms_key]['reg_user'])){
                	require_once(cms_root_dir.'scripts/emailval.php');
                	if (strlen($rvi_email)<4 || strlen($rvi_email)>200 ||MailVal($rvi_email,2)){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]='Please enter your email address';}
                    elseif (email_registered($rvi_email)){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]='A registered account exists under this email address. Please enter the correct password below to login and use this account or <a href="'.cms_url.'?login">login here</a>.';}
        	}

            if (isset($rvi_terms)){$_SESSION[$session_form_id]['terms_agree']=1;}elseif(isset($_SESSION[$session_form_id]['terms_agree'])){unset($_SESSION[$session_form_id]['terms_agree']);}
            // check terms and conditions box
            if (!isset($rvi_terms)){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]="You must agree to the terms of service to submit an application.";}

            if (isset($rvi_remember_me)){$_SESSION[cms_key]['form']['login']['remember_me']=1;}

            if (isset($rvi_password) && strlen($rvi_password)>0){

                $_SESSION[cms_key]['password']=$rvi_password; // think about removing this from session or using $_SESSION[cms_key]['form']['login']['password']

                if (strlen($rvi_password)<4){$warning[]='Your password must be at least 4 characters long';}
                else{
                    $login_user=login_validate($rvi_email,$rvi_password);
                    if ($login_user['user_id']<1){sleep(2);} // anti-brute-force measure on failed login (or new user?)
                }

            }
        }

  		if (!isset($_SESSION[cms_key]['form'][$session_form_id]['warning'])){

            if (isset($modify_application)){

       		    // delete selected images
        		if (isset($rvi_delete_image)){
        			foreach ($rvi_delete_image as $del_image_fn){
        				if (isset($application_details['image'][$del_image_fn])){unset($application_details['image'][$del_image_fn]);}
                        $fn=sys_data_dir.'/applications/'.$application_details['id'].'/'.$del_image_fn;
                        if (file_exists($fn)){unlink($fn);}
        			}
                    if (isset($application_details['image']) && empty($application_details['image'])){unset($application_details['image']);}
        		}
                // delete selected files
        		if (isset($rvi_delete_file)){
        			foreach ($rvi_delete_file as $del_file_fn){
        				if (isset($application_details['file'][$del_file_fn])){unset($application_details['file'][$del_file_fn]);}
                        $fn=sys_data_dir.'/applications/'.$application_details['id'].'/'.$del_file_fn;
                        if (file_exists($fn)){unlink($fn);}
        			}
                    if (isset($application_details['file']) && empty($application_details['file'])){unset($application_details['file']);}
        		}

                // main image - rearrange array to put main image first
        		if (isset($rvi_main_image) && isset($application_details['image'][$rvi_main_image]) && isset($rvi_current_main_image) && $rvi_main_image!=$rvi_current_main_image){
                    $old_image_array=$application_details['image'];
                    unset($application_details['image']);
                    $application_details['image'][$rvi_main_image]=$old_image_array[$rvi_main_image];
        			foreach ($old_image_array as $image_fn => $value){
                        if ($image_fn!=$rvi_main_image){$application_details['image'][$image_fn]=$old_image_array[$image_fn];}
        			}
                    unset($rvi_main_image);
        		}

            }

            // check nesecary product options are selected
            if (isset($product_details['option'])){
                foreach ($product_details['option'] as $option_name => $value2){
                    // if no product option is selected select first option value as default
                    if (!isset($rvi_product_option[$option_name])){$rvi_product_option[$option_name]=key($value2);}
                }
            }

            $product_price=$product_details['price'];
			$options_text='';
			// process selected product options if any
			if (isset($rvi_product_option)){


				foreach ($rvi_product_option as $option => $value){

					// product options string for generating product option identifier
					$options_text=$options_text.$option.': '.$value.'<br />';

					// find option matches and apply option modifiers
                    $option_exists=0;
					foreach ($product_details['option'] as $option_name => $value2){
						if ($option_name==$option){
                            if (count($value2)==1 && key($value2)==''){$option_exists=1;break;}
							foreach ($product_details['option'][$option_name] as $option_value => $value3){
								if ($option_value==$value){
                                    $option_exists=1;
                                    // adjust price based on selected product option
                                    if ($product_details['option'][$option_name][$option_value]['price_mod_value']!=0){
                                        // if b2b is enabled treat product options as excl tax so ensure we add tax amount onto them here for order price
                                        if ($cmsSettings->b2b>0 && $product_details['option'][$option_name][$option_value]['price_mod_value']>0){
                                            $product_details['option'][$option_name][$option_value]['price_mod_value']=$product_details['option'][$option_name][$option_value]['price_mod_value']*(($product_details['tax_rate']/100)+1);
                                        }
                                        if ($product_details['option'][$option_name][$option_value]['price_mod']==0){
                                            $product_price=$product_price+$product_details['option'][$option_name][$option_value]['price_mod_value'];
                                        }else{$product_price=$product_details['option'][$option_name][$option_value]['price_mod_value'];}
                                    }
                                    // adjust weight based on selected product option
                                    if ($product_details['option'][$option_name][$option_value]['weight_mod_value']!=0){
                                        if ($product_details['option'][$option_name][$option_value]['weight_mod']==0){
                                            $product_details['weight']=$product_details['weight']+$product_details['option'][$option_name][$option_value]['weight_mod_value'];
                                        }else{$product_details['weight']=$product_details['option'][$option_name][$option_value]['weight_mod_value'];}
                                    }
                                    // adjust volume based on selected product option
                                    if ($product_details['option'][$option_name][$option_value]['volume_mod_value']!=0){
                                        if ($product_details['option'][$option_name][$option_value]['volume_mod']==0){
                                            $product_details['volume']=$product_details['volume']+$product_details['option'][$option_name][$option_value]['volume_mod_value'];
                                        }else{$product_details['volume']=$product_details['option'][$option_name][$option_value]['volume_mod_value'];}
                                    }
								}
							}
						}
					}
                    if ($option_exists<1){
                        return;
                    }
				}

			}



            $submit_time=time();

            $application_details['name']='Tax Rebate Application - '.$rvi_name;

            // if new application created
            if (!isset($application_details['id'])){

                $application_details['created_time']=$submit_time;
    	        $application_details['id']=$application_details['created_time'].rand(100,999);
                $application_details['subscription_start_time']=$application_details['created_time'];

            }
            $application_details['modified_time']=$submit_time;

            $application_details['applicant_name']=$rvi_name;
            $application_details['phone']=$rvi_phone;
            $application_details['dob_month']=$rvi_dob_month;
            $application_details['dob_day']=$rvi_dob_day;
            $application_details['dob_year']=$rvi_dob_year;
            $application_details['address']=$rvi_address;
            $application_details['address_2']=$rvi_address_2;
            $application_details['city']=$rvi_city;
            $application_details['county']=$rvi_county;
            $application_details['postcode']=$rvi_postcode;
            $application_details['country']=$rvi_country;
            $application_details['marital_status']=$rvi_marital_status;
            $application_details['occupation']=$rvi_occupation;
            $application_details['ppsnum']=$rvi_ppsnum;
            $application_details['medical_card']=$rvi_medical_card;

            // check if application id folder exists and create it if it doesn't
            $save_application_dir=sys_data_dir.'/applications/'.$application_details['id'];
            if (!file_exists($save_application_dir)){mkdir($save_application_dir);}

            // store images or resize and store if dimensionally too big
            $total_uploaded_img_qty=0;
            if (isset($application_details['image'])){
    			if (isset($_FILES['imagefile1']) && is_uploaded_file($_FILES['imagefile1']['tmp_name'])){
    				if ($application_details['image'][$image_fn]['size_x']>MAX_UPLOADED_IMAGE_SIZE_X || $application_details['image'][$image_fn]['size_y']>MAX_UPLOADED_IMAGE_SIZE_Y){
    					createthumb($_FILES['imagefile1']['tmp_name'],$save_application_dir."/".$image_fn,MAX_UPLOADED_IMAGE_SIZE_X,MAX_UPLOADED_IMAGE_SIZE_Y,1);
    					// get size of uploaded image
    					$image_size=getimagesize($save_application_dir.'/'.$image_fn);
    					$application_details['image'][$image_fn]['size_x']=$image_size[0];
    					$application_details['image'][$image_fn]['size_y']=$image_size[1];
                        $application_details['image'][$image_fn]['alt_tag']='';
    				}else{
    					move_uploaded_file($_FILES['imagefile1']['tmp_name'],$save_application_dir.'/'.$image_fn);
    				}
                    $total_uploaded_img_qty++;
    			}
            }

            // move pluploaded images
            $upload_dir=sys_image_dir.'/temp';
            $handle = opendir($upload_dir);
            $total_uploaded_file_qty=0;
    		 // scan through uploaded images and check move images with same image upload id
             if (isset($rvi_image_upload_id)){
                 while (FALSE !== ($file = readdir($handle))){

                    if (substr($file,0,20)=='upload_'.$rvi_image_upload_id){
                        $upload_fn=strtolower(substr($file,21));
                        rename($upload_dir.'/'.$file,$save_application_dir.'/'.$upload_fn);
                        $img_extensions=array('jpg','jpeg','gif','png');
                        $upload_file_type='file';
                        foreach ($img_extensions as $img_extension){
                            if (substr($upload_fn,-strlen($img_extension))==$img_extension){$upload_file_type='image';break;}
                        }
                        if ($upload_file_type=='image'){
                            if ($total_uploaded_img_qty>=$application_details['max_image_qty']){continue;}
                            $image_size=getimagesize($save_application_dir.'/'.$upload_fn);
            				$application_details['image'][$upload_fn]['size_x']=$image_size[0];
            				$application_details['image'][$upload_fn]['size_y']=$image_size[1];
                            $application_details['image'][$upload_fn]['alt_tag']='';
                            $total_uploaded_img_qty++;
                        }
                        else{
                            if ($total_uploaded_file_qty>=$application_details['max_file_qty']){continue;}
                            $application_details['file'][$upload_fn]['size']=filesize($save_application_dir.'/'.$upload_fn);
                            $total_uploaded_file_qty++;
                        }
                    }
                 }
             }

            if (!isset($modify_application)){

                // save unverified customer details if not logged in
    			if (!isset($_SESSION[cms_key]['reg_user']->id) && isset($customer_details['email'])){
                    // save customer details
                    $customer_details['item_type']='customer';
        			$customer_details['id']=$submit_time.rand(100,999);
                    $customer_details['verified']='0';

                    // generate a random password
                    if (isset($_SESSION[$session_form_id]['password']) && strlen($_SESSION[$session_form_id]['password'])>4){$password=$_SESSION[$session_form_id]['password'];}else{$password=generate_password();}
                    $customer_details['password']=encrypt_password($password,$customer_details['id']);

        			$customer_details['status']='1';
        			$customer_details['registered_timestamp']=$submit_time;
        			if (isset($_SESSION[cms_key]['referrer'])){$customer_details['referrer']=$_SESSION[cms_key]['referrer'];}
        			$customer_details['newsletterSub']=true;
                    $customer_details['dob_day']=$rvi_dob_day;
                    $customer_details['dob_month']=$rvi_dob_month;
                    $customer_details['dob_year']=$rvi_dob_year;
                    $customer_details['address']=$rvi_address;
                    $customer_details['address_2']=$rvi_address_2;
                    $customer_details['city']=$rvi_city;
                    $customer_details['postcode']=$rvi_postcode;
                    $customer_details['county']=$rvi_county;
                    $customer_details['country']=$rvi_country;

                    // store extra submitted data in users aboutme/bio
                    $customer_details['bio']="Marital Status: ".$rvi_marital_status;
                    $customer_details['bio'].="\n\nOccupation: ".$rvi_occupation;
                    $customer_details['bio'].="\n\nPPS Number: ".$rvi_ppsnum;
                    $customer_details['bio'].="\n\nMedical Card: ".$rvi_medical_card;

    				save_item_details($customer_details);
                    update_item_list_file('customers',array($customer_details['id']),'add');

                    update_item_log('user',$customer_details['id'],'New user account registered - '.$customer_details['id'].' - via add application');

                    $send_new_user_email=1;

                    $application_details['customer_id']=$customer_details['id'];
                }
                elseif (isset($_SESSION[cms_key]['reg_user']->id)){
                    $application_details['customer_id']=$_SESSION[cms_key]['reg_user']->id;
                }

            }
            else{

                if (admin_level()>0){

                    if ($rvi_owner!=$application_details['customer_id'] && $new_owner_details=get_item_details('customer',$rvi_owner)){
                        $application_details['customer_id']=$rvi_owner;
                    }

                    // update subscription start time if expired application made active
                    $old_sub_start_time=$application_details['subscription_start_time'];
                    if ($application_details['status']==5 && $rvi_status!=5){$application_details['subscription_start_time']=time();}
                    // update subscription start time if different one specified
                    if (strlen($rvi_subscription_start_time)>0){
                        $pieces=explode('/',$rvi_subscription_start_time);
                        if (count($pieces)==3){
                                $day=$pieces[0];
                                $month=$pieces[1];
                                $year=$pieces[2];
                                $sub_start_time=strtotime("$month/$day/$year");
                                $existing_time_as_date=date("d/m/Y",$old_sub_start_time);
                                $existing_time=strtotime($existing_time_as_date);
                                // update sub start time only if different one specified
                                if ($sub_start_time!=$existing_time)
                                {
                                    $application_details['subscription_start_time']=$sub_start_time;
                                }
                        }
                    }
                    if (!isset($application_details['subscription_start_time'])){$application_details['subscription_start_time']=0;}

                    $application_details['subscription']=intval($rvi_subscription);

                    $application_details['admin_note']=$rvi_admin_note;

                    /*
                    // sending user an email notifying that their application is live
                    if ($application_details['status']>1 && $rvi_status==1){$send_email_notification=1;}
                    */
                    $application_details['status']=$rvi_status;


                }
            }

            // save application details
            if (save_item_details($application_details)){
                if (isset($modify_application)){
                    update_item_list_file('applications',array($application_details['id']));
                }
                else{
                    update_item_list_file('applications',array($application_details['id']),'add');
                }

            }

            if (!isset($modify_application)){

                // save order if price is greater than zero
                if ($product_price>0){
                    $order_details['item_type']='order';
                    $order_details['customer']['id']=$customer_details['id'];
                    if (isset($_SESSION[cms_key]['reg_user']->id)){
                        $order_details['name']=$_SESSION[cms_key]['reg_user']->name;
                        $order_details['email']=$_SESSION[cms_key]['reg_user']->email;}
                    else{
                        $order_details['name']=$customer_details['name'];
                        $order_details['email']=$customer_details['email'];
                    }
                    $order_details['id']=$submit_time.rand(100,999);
        			// order status 0=unpaid, 1=paid, 2=paid and processed, 3=cancelled
        			$order_details['status']=0;
        			if (isset($_SESSION[cms_key]['referrer'])){
        				$order_details['referrer']=$_SESSION[cms_key]['referrer'];
        				$referrer_details=get_item_details('customer',$_SESSION[cms_key]['referrer']);
        				if (is_array($referrer_details)){
        					// write order number to referrers referred orders file
        					$fn=sys_data_dir.'/users/'.$referrer_details['id'].'/referrals.php';
        					$fo=fopen($fn,"a");
        					fwrite($fo,"order|".$order_details['id']."||\n");
        					fclose($fo);
        				}
        			}

                    // remove unesecary product data for checkout/order
                    if (isset($product_details['created_time'])){unset($product_details['created_time']);}
                    if (isset($product_details['modified_time'])){unset($product_details['modified_time']);}
                    if (isset($product_details['item_file_version'])){unset($product_details['item_file_version']);}
                    if (isset($product_details['slug'])){unset($product_details['slug']);}
                    if (isset($product_details['short_description'])){unset($product_details['short_description']);}
                    if (isset($product_details['keywords'])){unset($product_details['keywords']);}
                    if (isset($product_details['content'])){unset($product_details['content']);}
                    if (isset($product_details['youtube_video'])){unset($product_details['youtube_video']);}
                    if (isset($product_details['template'])){unset($product_details['template']);}
                    if (isset($product_details['enquiry_form_enabled'])){unset($product_details['enquiry_form_enabled']);}
                    if (isset($product_details['option'])){unset($product_details['option']);}

                    // save product details in order
                    $order_details['products']['product']=$product_details;
        			$order_details['products']['product']['order_price']=$product_price;
                    $order_details['products']['product']['order_qty']=1;
                    if (isset($rvi_product_option)){
                        foreach ($rvi_product_option as $option => $value){
                            $order_details['products']['product']['option'][$option]=$value;
                        }
                    }
                    $order_details['order_subtotal']=$product_price;
                    $order_details['shipping_total']=0;
                    $order_details['discount']=0;

                    save_item_details($order_details);
                    update_item_list_file('orders',array($order_details['id']),'add');
                    // update_order_file($_SESSION[cms_key]['checkout']);

                    if (admin_level()<10){
                        update_item_log('user',$customer_details['id'],'New order '.$order_details['id'].' added by user '.$customer_details['id']);
                        update_admin_notify_log('New order '.$order_details['id'].' added by user '.$customer_details['id']);
                    }

                    // keep order id in session for paynow page
                    $_SESSION[cms_key]['form'][$session_form_id]['order_id']=$order_details['id'];

                    $send_order_email=1;

                }

                // log new user in (still unvereified until user logs in with emailed password)
                if (isset($_SESSION[$session_form_id]['remember_me']) && $_SESSION[$session_form_id]['remember_me']>0){
                    login_user($customer_details,1);
                }

                $send_new_user_email=0; // temp line to block new user account emails
                if (isset($send_new_user_email) && $send_new_user_email>0){
                    // send customer registration email
                    // email customer order confirmation with payment link
                    require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

                    $mail = new PHPMailer();

                    // send mail via smtp if set in config file
                    if (smtp_host){
                        $mail->IsSMTP(); // send via SMTP
                        $mail->SMTPAuth = true; // turn on SMTP authentication
                        $mail->SMTPSecure = 'ssl';
                        $mail->Username = smtp_username; // SMTP username
                        $mail->Password = smtp_password; // SMTP password
                        $mail->Host       = smtp_host; // SMTP server
                        $mail->Port       = smtp_port; // SMTP server
                    }

                    // send confirmation email to user
                    $mail->From = $cmsSettings->config['site_email'];
                    $mail->FromName = cms_site_name;
                    $mail->AddAddress($rvi_email);

                    $mail->Subject = cms_site_name.' - New Account Registration';
                    $mail->Body    = "Hi $rvi_name,\n\nThank you for registering with ".cms_site_name." - Your new login password is ".$password."\n\nClick on the link below to login.\n\n".user_login_link($customer_details)."\n\n\n".cms_site_name."\n".cms_site_url;
                    $mail->IsHTML(FALSE);

                    if(!$mail->Send()){exit;}
                }

                $send_order_email=0; // temp line to block new user account emails
                if (isset($send_order_email) && $send_order_email>0){

                    // send customer registration email
                    // email customer order confirmation with payment link
                    require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

                    $mail = new PHPMailer();

                    // send mail via smtp if set in config file
                    if (smtp_host){
                            $mail->IsSMTP(); // send via SMTP
                            $mail->SMTPAuth = true; // turn on SMTP authentication
                            $mail->SMTPSecure = 'ssl';
                            $mail->Username = smtp_username; // SMTP username
                            $mail->Password = smtp_password; // SMTP password
                            $mail->Host       = smtp_host; // SMTP server
                            $mail->Port       = smtp_port; // SMTP server
                    }

                    // send pay now email to user
                    $mail->From = $cmsSettings->config['site_email'];
                    $mail->FromName = cms_site_name;
                    $mail->ClearAddresses();

                    if (isset($_SESSION[cms_key]['reg_user']->email)){$recipient_email=$_SESSION[cms_key]['reg_user']->email;}
                    elseif (isset($customer_details['email'])){$recipient_email=$customer_details['email'];}
                    if (isset($_SESSION[cms_key]['reg_user']->name)){$recipient_name=$_SESSION[cms_key]['reg_user']->name;}
                    elseif (isset($customer_details['name'])){$recipient_name=$customer_details['name'];}

                    $mail->AddAddress($recipient_email);
                    $mail->Subject = cms_site_name." - New Application";
                    //$mail->Body    = "Hi ".$recipient_name.",\n\nThank you for submitting your application on ".cms_site_name." - Your application has been submitted and will be processed within 24hrs of receiving payment.\n\nIf you have not yet paid go to ".cms_url."?paynow=".$order_details['id']." for payment options.\n\n\n".cms_site_name."\n".cms_site_url;
                    $mail->Body    = "Hi ".$recipient_name.",\n\nThank you for submitting your application on ".cms_site_name." - Your application has been submitted and will be processed shortly.\n\n\n".cms_site_name."\n".cms_site_url;
                    $mail->IsHTML(FALSE);
                    if(!$mail->Send()){exit;}
                }


                $_SESSION[cms_key]['form'][$session_form_id]['warning_green'][]="<h2>Thank You</h2><p>Your application has been submitted and will be processed shortly.</p>";
                //if (!isset($_SESSION[cms_key]['reg_user']->id)){$_SESSION[cms_key]['form'][$session_form_id]['warning_green'][]="<p>An email has been sent to your email address - <b>".$rvi_email."</b> - please follow the emailed instructions to verify your email address and activate your account. Once activated you will be able to login and manage your account.</p>";}

            }
            else{
                $_SESSION[cms_key]['form'][$session_form_id]['warning_green'][]="Application has been updated.";
            }

            unset($_SESSION[$session_form_id]);


  			$_SESSION[cms_key]['form'][$session_form_id]['processed']=1;

  		}

        // redirect after form submit so browser back and refresh work without browser resend form data warning
        //$query="ls=".$application_details['status'];
        $query="ls=1";
        if (!isset($modify_application)){
            if (isset($_SESSION[cms_key]['form'][$session_form_id]['processed']) && $application_details['status']==2)
                header("Location: ".cms_url."?paynow=".$application_details['order_id'],true,303);
            else
                header("Location: ".item_url('product',$product_details['id'],$product_details['slug'],$query,1)."#form",true,303);
        }
        elseif(cms_interface=="back")
            header("Location: ?modify_application=".$application_details['id'],true,303);
        else
            header("Location: ".cms_url."?myaccount&modify_application=".$application_details['id'],true,303);
        exit;

  	}


    if (!isset($modify_application)){
        $page_content['main'].="<div class=\"product_description\">".$product_details['content']['main']."</div>";
        //if ($display_price!=''){$page_content['main'].='<div class="product_price">'.$display_price.'</div>';}
    }

    $page_content['main'].="<a name=\"form\"></a>";

    // display warnings
    if (isset($_SESSION[cms_key]['form'][$session_form_id]['warning'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form'][$session_form_id]['warning']);}
    elseif (isset($_SESSION[cms_key]['form'][$session_form_id]['warning_green'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form'][$session_form_id]['warning_green'],'green');}


  	  if (isset($modify_application) || !isset($_SESSION[cms_key]['form'][$session_form_id]['processed'])){

      	// show hide javascript
      	$page->meta.="<script language=\"javascript\">
      	function open_win(page,name){toswindow=window.open(page,name,'width=420,height=420,scrollbars=1');
      	setTimeout(\"toswindow.focus();\",10);}
      	</script>";

        if (!isset($rvi_image_upload_id)){$rvi_image_upload_id=time().rand(100,999);}

           if ($application_details['max_image_qty']>0 || $application_details['max_file_qty']>0){
         $page->meta.='<script type="text/javascript" src="'.cms_root_url.'plugins/jquery/jquery-ui-1.8.14.custom/js/jquery-ui-1.8.14.custom.min.js"></script>
<link rel="stylesheet" href="'.cms_root_url.'plugins/jquery/jquery-ui-1.8.14.custom/css/ui-lightness/jquery-ui-1.8.14.custom.css" type="text/css" />

<link rel="stylesheet" href="'.cms_root_url.'plugins/plupload_1_5_4/js/jquery.ui.plupload/css/jquery.ui.plupload.css" type="text/css" />
<script type="text/javascript" src="http://bp.yahooapis.com/2.4.21/browserplus-min.js"></script>
<script type="text/javascript" src="'.cms_root_url.'plugins/plupload_1_5_4/js/plupload.js"></script>
<script type="text/javascript" src="'.cms_root_url.'plugins/plupload_1_5_4/js/plupload.gears.js"></script>
<script type="text/javascript" src="'.cms_root_url.'plugins/plupload_1_5_4/js/plupload.silverlight.js"></script>
<script type="text/javascript" src="'.cms_root_url.'plugins/plupload_1_5_4/js/plupload.flash.js"></script>
<script type="text/javascript" src="'.cms_root_url.'plugins/plupload_1_5_4/js/plupload.browserplus.js"></script>
<script type="text/javascript" src=".'.cms_root_url.'plugins/plupload_1_5_4/js/plupload.html4.js"></script>
<script type="text/javascript" src="'.cms_root_url.'plugins/plupload_1_5_4/js/plupload.html5.js"></script>
<script type="text/javascript" src="'.cms_root_url.'plugins/plupload_1_5_4/js/jquery.ui.plupload/jquery.ui.plupload.js"></script>';
}


$page->meta.='<script type="text/javascript">
    $(document).ready(function(){';

    if ($application_details['max_image_qty']>0 || $application_details['max_file_qty']>0){
    $page->meta.='$("#uploader").plupload({
    		// General settings
    		runtimes : \'html5,gears,flash,silverlight,browserplus\',
    		url : \''.cms_root_url.'plugins/plupload_1_5_4/examples/upload.php?id='.$rvi_image_upload_id.'\',
    		max_file_size : \'20mb\',
    		chunk_size : \'1mb\',
    		unique_names : false,
            max_file_count: '.($application_details['max_image_qty']+$application_details['max_file_qty']).',

    		// Resize images on clientside if we can
    		resize : {width : '.MAX_UPLOADED_IMAGE_SIZE_X.', height : '.MAX_UPLOADED_IMAGE_SIZE_Y.', quality : 90},

    		// Specify what files to browse for
    		filters : [
    			{title : "Image files", extensions : "jpeg,jpg,gif,png"}
    		],

    		// Flash settings
    		flash_swf_url : \''.cms_root_url.'plugins/plupload_1_5_4/js/plupload.flash.swf\',

    		// Silverlight settings
    		silverlight_xap_url : \''.cms_root_url.'plugins/plupload_1_5_4/js/plupload.silverlight.xap\',

            init : {

                    FilesAdded: function(up, files) {
                        while(up.files.length > '.($application_details['max_image_qty']+$application_details['max_file_qty']).') {
                            up.removeFile(up.files[0]);
                        }
                        up.refresh();
                    }

            }


    	});

        // hide start upload button
        $("#uploader_start").hide();
        $(".plupload_header_title").text("Select Files");
        $(".plupload_header_text").text(\'Click the Add Files button below to select the files you want to upload.\');

        // Client side form validation
    	$(\'#application_form\').submit(function(e) {
            $(\'#submit_application\').attr(\'disabled\', \'disabled\');
            $(\'#submit_application\').val(\'Submitting...\');

            var uploader = $(\'#uploader\').plupload(\'getUploader\');
    		// Validate number of uploaded files
    		if (uploader.total.uploaded == 0) {
    			// Files in queue upload them first
    			if (uploader.files.length > 0) {

                    // When all files are uploaded submit form
    	            uploader.bind(\'StateChanged\', function() {
    	                if (uploader.files.length === (uploader.total.uploaded + uploader.total.failed)) {
    	                    $(\'#application_form\').submit();
    	                }
    	            });

    				uploader.start();
    			} else {
                     $(\'#application_form\').submit();
    			    // alert(\'You must at least upload one file.\');
                }

    			e.preventDefault();
    		}
    	});';
        }

        if (!isset($modify_application)){

            if (!isset($_SESSION[$session_form_id]['terms_agree']) || $_SESSION[$session_form_id]['terms_agree']<1){$page->meta.='$(\'#submit_application\').attr(\'disabled\', \'disabled\')';}
            $page->meta.='
            // disable submit button if terms button not checked
            $(\'#agree_to_terms\').change(function(){
                if ($(\'#agree_to_terms\').attr(\'checked\')) {
                     $(\'#submit_application\').removeAttr(\'disabled\', \'disabled\');
                }else
                     $(\'#submit_application\').attr(\'disabled\', \'disabled\');
            });
            ';
        }

$page->meta.='
    });

</script>';


        $page_content['main'].="<form action=\"\" id=\"application_form\" method=\"post\" enctype=\"multipart/form-data\" >";

        if (!isset($modify_application) && $product_options!=""){$page_content['main'].="<fieldset><legend>Payment Option</legend>".$product_options."</fieldset>";}

        if (isset($modify_application)){
              if (admin_level()>0){

                  // populate fields with session data if availale but only if saved data not available
                  if (!isset($rvi_status)){
                      if (isset($application_details['status'])){$rvi_status=$application_details['status'];}
                  }

                  $page_content['main'].="<fieldset><legend>Admin Controls</legend>
                  <table width=\"100%\" border=\"0\" cellpadding=\"4\" cellspacing=\"0\">";

                   $page_content['main'].="<tr><td colspan=\"2\" class=\"small_note\">application created ".date("d/m/y H:i",$application_details['created_time'])." and last updated ".date("d/m/y H:i",$application_details['modified_time']);
                    if (admin_level()>9){
                        $page_content['main'].=" (<a href=\"?viewdata=application&amp;id=".$application_details['id']."\">view application data</a>)";
                    }
                    $page_content['main'].="</td></tr>";

                  $page_content['main'].="<tr><td colspan=\"2\" class=\"small_note\">Current owner of this application is <a href=\"?user=".$application_details_owner['id']."\">".$application_details_owner['name']."</a> e: <a href=\"?email_user&amp;application=".$application_details['id']."\">".$application_details_owner['email']."</a> - To assign this application to another user change the owner below.</td></tr>
                  <tr>
                  <td width=\"120\"><b>Owner:</b></td>
                  <td><select id=\"owner_select\" name=\"owner\">";
                  if ($users=get_items('users',null,null,null,null,null,null,null,array('name','email'))){

                        usort($users, 'compare_items_names');

                      $item_qty=count($users);
                      for ($item_num=0;$item_num<$item_qty;$item_num++){
                        if ($application_details_owner['id']==$users[$item_num]['id']){
                            $page_content['main'].="<option value=\"".$users[$item_num]['id']."\" selected>".$users[$item_num]['name']." (".$users[$item_num]['email'].")</option>";
                        }
                        else{
                            $page_content['main'].="<option value=\"".$users[$item_num]['id']."\">".$users[$item_num]['name']." (".$users[$item_num]['email'].")</option>";
                        }
                      }
                  }
                  $page_content['main'].="</select></td>
                  </tr>
                  <tr><td colspan=\"2\" class=\"small_note\"><hr />Changing status from Expired will reset any expiration time limit.</td></tr>
                  <tr>
                  <td><b>Status:</b></td>
                  <td><select name=\"status\">";
                  $options=array('Pending','Processed','Awaiting Payment','Awaiting Approval','Rejected','Expired');
                  $option_qty=count($options);
                  for ($option_num=0;$option_num<$option_qty;$option_num++){
                    if (isset($rvi_status) && $rvi_status==$option_num){
                        $page_content['main'].="<option value=\"".$option_num."\" selected>".$options[$option_num]."</option>";
                    }
                    else{
                        $page_content['main'].="<option value=\"".$option_num."\">".$options[$option_num]."</option>";
                    }
                  }
                  $page_content['main'].="</select></td>
                  </tr>";

                  if ($application_details['subscription_start_time']>0){$start_time=date("d/m/Y",$application_details['subscription_start_time']);}else{$start_time='NA';}
                  /*
                  $page_content['main'].="<tr><td colspan=\"2\"><hr /><p class=\"small_note\">This application will expire the specified number of days after the start date below. Set number of days to zero or blank to never expire.</p></td></tr>
                  <tr><td><b>Start Date:</b></td><td><input type=\"text\" name=\"subscription_start_time\" id=\"datepicker_subscription\" value=\"".$start_time."\" style=\"width: 100px\" />&nbsp;&nbsp;&nbsp;&nbsp;<b>No. of Days:</b> <input type=\"text\" name=\"subscription\" size=\"5\" value=\"".$application_details['subscription']."\" style=\"width: 40px\" /></td></tr>";
                  */
                  $page_content['main'].="<tr><td colspan=\"2\"><hr /><b>Admin Notes</b><br />
                  <textarea name=\"admin_note\" cols=\"80\" rows=\"3\">".(isset($application_details['admin_note']) ? $application_details['admin_note'] : "")."</textarea></td></tr>
                  </table></fieldset>";

              }


            // output product options if there are any
    		if (isset($product_details['option'])){
    			$option_num=1;
    			$page_content['main'].="<table cellspacing=\"3\" cellpadding=\"3\" style=\"margin: 5px 0 5px 0\">";
    			foreach ($product_details['option'] as $option_name => $value){

    				$page_content['main'].="<tr><td>".$option_name.":</td><td><select name=\"product_option[$option_name]\"> ";

    				foreach ($product_details['option'][$option_name] as $option_value => $value2){

    					$display_value=$option_value;

  	                    // displaying price modifiers beside the value
                        if  ($product_details['option'][$option_name][$option_value]['mod']==0){
                            if ($product_details['option'][$option_name][$option_value]['mod_type']==0){
  			                    if ($product_details['option'][$option_name][$option_value]['mod_value']>0){$display_value=$option_value." ( + ".$currency_symbol.number_format($product_details['option'][$option_name][$option_value]['mod_value'],2)." )";}
  			                    elseif ($product_details['option'][$option_name][$option_value]['mod_value']<0){$display_value=$option_value." ( - ".$currency_symbol.number_format(str_replace("-","",$product_details['option'][$option_name][$option_value]['mod_value']),2)." )";}
                            }
                            elseif($product_details['option'][$option_name][$option_value]['mod_type']=1 && $product_details['option'][$option_name][$option_value]['mod_value']>0){
                                $display_value=$option_value." ( ".$currency_symbol.number_format($product_details['option'][$option_name][$option_value]['mod_value'],2)." )";
                            }
                        }
    					if (isset($rvi_product_option) && in_array($option_value,$rvi_product_option)){$selected='selected="selected"';}else{$selected='';}
    				    $page_content['main'].='<option value="'.$option_value.'" '.$selected.'>'.$display_value.'</option>';
    				}


    				$page_content['main'].="</select></td></tr>";

    				$option_num++;

    			}
    			$page_content['main'].="</table>";
    		}

            // populate fields with session data if availale but only if saved data not available
            if (!isset($rvi_name)){
                if (isset($application_details['applicant_name'])){$rvi_name=$application_details['applicant_name'];}
            }
            if (!isset($rvi_email)){
                if (isset($application_details['email'])){$rvi_email=$application_details['email'];}
            }
            if (!isset($rvi_phone)){
                if (isset($application_details['phone'])){$rvi_phone=$application_details['phone'];}
            }
            if (!isset($rvi_address)){
                if (isset($application_details['address'])){$rvi_address=$application_details['address'];}
            }
            if (!isset($rvi_address_2)){
                if (isset($application_details['address_2'])){$rvi_address_2=$application_details['address_2'];}
            }
            if (!isset($rvi_city)){
                if (isset($application_details['city'])){$rvi_city=$application_details['city'];}
            }
            if (!isset($rvi_county)){
                if (isset($application_details['county'])){$rvi_county=$application_details['county'];}
            }
            if (!isset($rvi_postcode)){
                if (isset($application_details['postcode'])){$rvi_postcode=$application_details['postcode'];}
            }
            if (!isset($rvi_country)){
                if (isset($application_details['country'])){$rvi_country=$application_details['country'];}
            }
            if (!isset($rvi_dob_month)){
                if (isset($application_details['dob_month'])){$rvi_dob_month=$application_details['dob_month'];}
            }
            if (!isset($rvi_dob_day)){
                if (isset($application_details['dob_day'])){$rvi_dob_day=$application_details['dob_day'];}
            }
            if (!isset($rvi_dob_year)){
                if (isset($application_details['dob_year'])){$rvi_dob_year=$application_details['dob_year'];}
            }
            if (!isset($rvi_marital_status)){
                if (isset($application_details['marital_status'])){$rvi_marital_status=$application_details['marital_status'];}
            }
            if (!isset($rvi_occupation)){
                if (isset($application_details['occupation'])){$rvi_occupation=$application_details['occupation'];}
            }
            if (!isset($rvi_ppsnum)){
                if (isset($application_details['ppsnum'])){$rvi_ppsnum=$application_details['ppsnum'];}
            }
            if (!isset($rvi_medical_card)){
                if (isset($application_details['medical_card'])){$rvi_medical_card=$application_details['medical_card'];}
            }

        }
        else{

            // populate fields with session data if availale but only if saved data not available
            if (!isset($rvi_name)){
                if (isset($_SESSION[$session_form_id]['name'])){$rvi_name=$_SESSION[$session_form_id]['name'];}
            }
            if (!isset($rvi_email)){
                if (isset($_SESSION[$session_form_id]['email'])){$rvi_email=$_SESSION[$session_form_id]['email'];}
            }
            if (!isset($rvi_password)){
                if (isset($_SESSION[$session_form_id]['password'])){$rvi_password=$_SESSION[$session_form_id]['password'];}
            }
            if (!isset($rvi_phone)){
                if (isset($_SESSION[$session_form_id]['phone'])){$rvi_phone=$_SESSION[$session_form_id]['phone'];}
            }
            if (!isset($rvi_address)){
                if (isset($_SESSION[$session_form_id]['address'])){$rvi_address=$_SESSION[$session_form_id]['address'];}
            }
            if (!isset($rvi_address_2)){
                if (isset($_SESSION[$session_form_id]['address_2'])){$rvi_address_2=$_SESSION[$session_form_id]['address_2'];}
            }
            if (!isset($rvi_city)){
                if (isset($_SESSION[$session_form_id]['city'])){$rvi_city=$_SESSION[$session_form_id]['city'];}
            }
            if (!isset($rvi_county)){
                if (isset($_SESSION[$session_form_id]['county'])){$rvi_county=$_SESSION[$session_form_id]['county'];}
            }
            if (!isset($rvi_postcode)){
                if (isset($_SESSION[$session_form_id]['postcode'])){$rvi_postcode=$_SESSION[$session_form_id]['postcode'];}
            }
            if (!isset($rvi_country)){
                if (isset($_SESSION[$session_form_id]['country'])){$rvi_country=$_SESSION[$session_form_id]['country'];}
            }
            if (!isset($rvi_dob_month)){
                if (isset($_SESSION[$session_form_id]['dob_month'])){$rvi_dob_month=$_SESSION[$session_form_id]['dob_month'];}
            }
            if (!isset($rvi_dob_day)){
                if (isset($_SESSION[$session_form_id]['dob_day'])){$rvi_dob_day=$_SESSION[$session_form_id]['dob_day'];}
            }
            if (!isset($rvi_dob_year)){
                if (isset($_SESSION[$session_form_id]['dob_year'])){$rvi_dob_year=$_SESSION[$session_form_id]['dob_year'];}
            }
            if (!isset($rvi_marital_status)){
                if (isset($_SESSION[$session_form_id]['marital_status'])){$rvi_marital_status=$_SESSION[$session_form_id]['marital_status'];}
            }
            if (!isset($rvi_occupation)){
                if (isset($_SESSION[$session_form_id]['occupation'])){$rvi_occupation=$_SESSION[$session_form_id]['occupation'];}
            }
            if (!isset($rvi_ppsnum)){
                if (isset($_SESSION[$session_form_id]['ppsnum'])){$rvi_ppsnum=$_SESSION[$session_form_id]['ppsnum'];}
            }
            if (!isset($rvi_medical_card)){
                if (isset($_SESSION[$session_form_id]['medical_card'])){$rvi_medical_card=$_SESSION[$session_form_id]['medical_card'];}
            }

        }

        $page_content['main'].="<fieldset>";

        if (!isset($modify_application) || (isset($_SESSION[cms_key]['reg_user']->id) && $_SESSION[cms_key]['reg_user']->id==$application_details['customer_id'])){
             $page_content['main'].="<legend>Your Details</legend>";
        }
        else{
            $page_content['main'].="<legend>Application Details</legend>";
        }

        $page_content['main'].="<table width=\"100%\" border=\"0\" cellpadding=\"4\" cellspacing=\"0\">";

        if (!isset($modify_application)){
            if (isset($_SESSION[cms_key]['reg_user'])){
                $page_content['main'].="<tr><td colspan=\"2\"><p class=\"small_note\">Welcome back ".stripslashes($_SESSION[cms_key]['reg_user']->name)." (<a href=\"".cms_url."?logout\">Logout</a>).</p></td></tr>
                <tr>
                    <td width=\"80\"><b>Phone: </b></td>
                    <td><input name=\"phone\" type=\"text\" maxlength=\"128\" value=\"".(isset($_SESSION[$session_form_id]['phone']) ? stripslashes($_SESSION[$session_form_id]['phone']) : "")."\" /></td>
                </tr>";
            }
            else{
                $page_content['main'].="<tr><td colspan=\"2\"><p class=\"small_note\">Please enter your contact details carefully. Make sure your email address is correct so we can process your application.</p></td></tr>
                <tr><td width=\"100\"><b>Name: </b></td><td><input name=\"name\" type=\"text\" maxlength=\"128\" value=\"".(isset($rvi_name) ? stripslashes($rvi_name) : '')."\" /></td></tr>
                <tr><td><b>Email: </b></td><td><input type=\"text\" name=\"email\" maxlength=\"128\" value=\"".(isset($rvi_email) ? stripslashes($rvi_email) : '')."\" /></td></tr>
                <tr>
                  <td><b>Phone: </b></td>
                  <td><input name=\"phone\" type=\"text\" maxlength=\"128\" value=\"".(isset($rvi_phone) ? stripslashes($rvi_phone) : '')."\" /></td>
                </tr>
                <tr>
                  <td colspan=\"2\"><p class=\"small_note\"><b>New users:</b> Enter a password below (min 4 characters) or leave blank and one will be generated for you.<br /><b>Registered Users:</b> Login with your password below. <a href=\"".cms_url."?forgot_password\">Forgot Password</a></p></td>
                </tr>
                <tr>
                  <td><b>Password: </b></td><td><input type=\"password\" name=\"password\" value=\"".(isset($rvi_password) ? stripslashes($rvi_password) : '')."\" /> <input type=\"checkbox\" name=\"remember_me\"".(isset($_SESSION[$session_form_id]['remember_me']) && $_SESSION[$session_form_id]['remember_me']>0 ? ' checked="checked"' : '')." /> Remember Me</td>
                </tr>";
            }
        }
        else{
            $page_content['main'].="<tr><td width=\"100\"><b>Name: </b></td><td><input name=\"name\" type=\"text\" maxlength=\"128\" value=\"".(isset($rvi_name) ? stripslashes($rvi_name) : '')."\" /></td></tr>
            <tr>
            <td><b>Phone: </b></td>
            <td><input name=\"phone\" type=\"text\" maxlength=\"128\" value=\"".(isset($rvi_phone) ? stripslashes($rvi_phone) : '')."\" /></td>
            </tr>";

        }



        $page_content['main'].="<tr><td colspan=\"2\"><hr /></td></tr>

        <tr><td><b>Address:</b></td><td><input type=\"text\" name=\"address\"  value=\"".(isset($rvi_address) ? stripslashes($rvi_address) : "")."\"></td></tr>";

  		$page_content['main'].="<tr><td></td><td><input type=\"text\" name=\"address_2\" value=\"".(isset($rvi_address_2) ? stripslashes($rvi_address_2) : "")."\"></td></tr>";

  		$page_content['main'].="<tr><td><b>Town/City:</b></td><td><input type=\"text\" name=\"city\" value=\"".(isset($rvi_city) ? stripslashes($rvi_city) : "")."\"></td></tr>
  		<tr><td><b>County:</b></td><td><input type=\"text\" name=\"county\" value=\"".(isset($rvi_county) ? stripslashes($rvi_county) : "")."\"></td></tr>
  		<tr><td><b>Post Code:</b></td><td><input type=\"text\" name=\"postcode\" value=\"".(isset($rvi_postcode) ? stripslashes($rvi_postcode) : "")."\"></td></tr>
  		<tr><td><b>Country:</b></td><td><select style=\"max-width: 145px\" name=\"country\">";
    	$option=$country_list_billing;
    	$option_qty=count($option);
    	for ($option_num=0;$option_num<$option_qty;$option_num++){
            $option[$option_num]=trim($option[$option_num]);
          	if (isset($rvi_country) && $rvi_country==$option[$option_num]){
          		$page_content['main'].="<option selected>".$option[$option_num]."</option>";
          	}
          	else{
          		$page_content['main'].="<option>".$option[$option_num]."</option>";
          	}
        }
        $page_content['main'].="</select></td></tr>
        <tr><td colspan=\"2\"><hr /></td></tr>
                <tr>
                    <td><b>Marital Status:</b></td>
                    <td><select name=\"marital_status\">";
                    $page_content['main'].='<option>Please Select</option>';
                    $option=array('Single','Married','Other');
    		  $option_qty=count($option);
    		  for ($option_num=0;$option_num<$option_qty;$option_num++){
    				if (isset($rvi_marital_status) && $rvi_marital_status==$option[$option_num]){
    					$page_content['main'].='<option selected>'.$option[$option_num].'</option>';
    				}
    				else{
    					$page_content['main'].='<option>'.$option[$option_num].'</option>';
    				}
    			}
                  $page_content['main'].="</select></td>
                </tr>
                <tr>
                    <td><b>Occupation:</b></td>
                    <td><input name=\"occupation\" type=\"text\" id=\"occupation\" size=\"45\" maxlength=\"250\" value=\"".(isset($rvi_occupation) ? stripslashes($rvi_occupation) : "")."\" /></td>
                </tr>
                <tr>
                    <td><b>PPS Number:</b></td>
                    <td><input name=\"ppsnum\" type=\"text\" id=\"ppsnum\" size=\"45\" maxlength=\"250\" value=\"".(isset($rvi_ppsnum) ? stripslashes($rvi_ppsnum) : "")."\" /></td>
                </tr>";
    		$page_content['main'].="<tr><td><b>Date of Birth:</b></td><td><select name=\"dob_month\">";
    		  $option=array('---','Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
    		  $option_qty=count($option);
    		  for ($option_num=0;$option_num<$option_qty;$option_num++){
    				if (isset($rvi_dob_month) && $rvi_dob_month==$option[$option_num]){
    					$page_content['main'].='<option selected>'.$option[$option_num].'</option>';
    				}
    				else{
    					$page_content['main'].='<option>'.$option[$option_num].'</option>';
    				}
    			}
    			$page_content['main'].='</select>
    		<select name="dob_day">';
    		unset($option);
    		  $option[0]='---';
    		  for ($day=1; $day<=31; $day++){$option[]=$day;}
    		  $option_qty=count($option);
    		  for ($option_num=0;$option_num<$option_qty;$option_num++){
    				if (isset($rvi_dob_day) && $rvi_dob_day==$option[$option_num]){
    					$page_content['main'].="<option selected>".$option[$option_num]."</option>";
    				}
    				else{
    					$page_content['main'].="<option>".$option[$option_num]."</option>";
    				}
    			}
    			$page_content['main'].='</select>
    		  <select name="dob_year">';
    		  unset($option);
    		  $option[0]='---';
    		  for ($year=intval(date("Y",time())); $year>=1900; $year--){$option[]=$year;}
    		  $option_qty=count($option);
    		  for ($option_num=0;$option_num<$option_qty;$option_num++){
    				if (isset($rvi_dob_year) && $rvi_dob_year==$option[$option_num]){
    					$page_content['main'].="<option selected>".$option[$option_num]."</option>";
    				}
    				else{
    					$page_content['main'].="<option>".$option[$option_num]."</option>";
    				}
    			}
    			$page_content['main'].="</select></td></tr>
                                <tr>
                                        <td><b>Medical Card:</b></td>
                                        <td><select name=\"medical_card\">";
                                        $page_content['main'].='<option>Please Select</option>';
                                        $option=array('Yes','No');
        		  $option_qty=count($option);
        		  for ($option_num=0;$option_num<$option_qty;$option_num++){
        				if (isset($rvi_medical_card) && $rvi_medical_card==$option[$option_num]){
        					$page_content['main'].='<option selected>'.$option[$option_num].'</option>';
        				}
        				else{
        					$page_content['main'].='<option>'.$option[$option_num].'</option>';
        				}
        			}
                    $page_content['main'].="</select></td>
                                    </tr>";
                    if (!isset($modify_application)){
                        $page_content['main'].="<tr><td colspan=\"2\"><hr /><b>Please sign your name below (required):</b>
                        <div id=\"signature-pad\" class=\"m-signature-pad\">
                            <div class=\"m-signature-pad--body\">
                                <canvas></canvas>
                            </div>
                            <div class=\"m-signature-pad--footer\">
                                <div class=\"left\">
                                    <button type=\"button\" class=\"button clear\" data-action=\"clear\">Clear</button>
                                </div>
                            </div>
                        </div>";

                        $page->meta.="<link rel=\"stylesheet\" href=\"".display_theme_url."signature_pad/src2/css/signature-pad.css\">";

                        $page_content['main'].="<script src=\"".display_theme_url."signature_pad/src2/js/signature_pad.js\"></script>
                        <script src=\"".display_theme_url."signature_pad/src2/js/app.js\"></script>
                        </td></tr>";
                    }

                    $page_content['main'].="</table></fieldset>";

                            // display any image and file uploads when modifying application
    	if (isset($modify_application) && ((isset($application_details['image']) && !empty($application_details['image'])) || (isset($application_details['file']) && !empty($application_details['file'])))){

            $page_content['main'].="<fieldset><legend>Uploaded Files</legend>";

            if (isset($application_details['image']) && !empty($application_details['image'])){
        		$tn_size_x=160;
        		$tn_size_y=110;
        		$application_path=sys_data_dir.'/applications/'.$rvi_modify_application.'/';
                $page_content['main'].="<p class=\"small_note\">Manage images for this application below. You can also add a brief description of each image.</p>
                <table cellspacing=\"2\" cellpadding=\"3\" class=\"blue_table\">";
        		foreach($application_details['image'] as $image_fn => $value){
        			// check if correct size image exists and create one if it doesn't
                    $thumbnail_fn=$tn_size_x."x".$tn_size_y.'_l'.$application_details['id'].'_'.$image_fn;
        			if (!file_exists(sys_image_dir.'/'.$thumbnail_fn) || filemtime(sys_image_dir.'/'.$thumbnail_fn)<=filemtime($application_path.$image_fn)){createthumb($application_path.$image_fn,sys_image_dir.'/'.$thumbnail_fn,$tn_size_x,$tn_size_y,1);}
        			// get size of thumbnail image
        			$image_size=getimagesize(sys_image_dir.'/'.$thumbnail_fn);
                    if (!isset($rvi_main_image)){$rvi_main_image=$image_fn;$current_main_image="<input type=\"hidden\" name=\"current_main_image\" value=\"".$image_fn."\">";}else{$current_main_image='';}
                    if ($rvi_main_image==$image_fn){$main_image_selected=' checked';}else{$main_image_selected='';}
                    if (admin_level()>9){$rowspan=4;}else{$rowspan=3;}
                    $page_content['main'].="<tr><td rowspan=\"".$rowspan."\" align=\"center\">".$current_main_image."<input type=\"hidden\" name=\"application_image[]\" value=\"$image_fn\"><img src=\"".cms_image_url.$thumbnail_fn."\" alt=\"".$value['alt_tag']."\" width=\"".$image_size[0]."\" height=\"".$image_size[1]."\" vspace=\"6\"></td><td><b>Main Image:</b> </td><td><input type=\"radio\" name=\"main_image\" value=\"".$image_fn."\"".$main_image_selected."/></td></tr><tr><td><b>Description:</b> </td><td><input type=\"text\" name=\"img_alt_text[$image_fn]\" value=\"".$value['alt_tag']."\" size=\"25\" /></td></tr>";
                    if (admin_level()>0){$page_content['main'].="<tr><td><b>Rotate:</b> </td><td><a href=\"?modify_application=".$application_details['id']."&amp;rotateimgl=".$image_fn."\">Left</a> / <a href=\"?modify_application=".$application_details['id']."&amp;rotateimgr=".$image_fn."\">Right</a></td></tr>";}
                    //if (admin_level()>9){$page_content['main'].="<tr><td><b>Rotate:</b> </td><td><input type=\"submit\" name=\"rotateimgl\" value=\"left\" /> / <input type=\"submit\" name=\"rotateimgr\" value=\"Right\" /></td></tr>";}
                    $page_content['main'].="<tr><td><b>Delete:</b> </td><td><input type=\"checkbox\" name=\"delete_image[]\" value=\"$image_fn\" /></td></tr><tr><td colspan=\"3\"></td></tr>";
        		}
        		$page_content['main'].="</table>";
            }

            if (isset($application_details['file']) && !empty($application_details['file'])){
                $page_content['main'].="<p class=\"small_note\">Manage files for this application below.</p>
                <table cellspacing=\"2\" cellpadding=\"3\" class=\"blue_table\">";
        		foreach($application_details['file'] as $file_fn => $value){
        			$page_content['main'].="<tr><td rowspan=\"2\"><a href=\"".cms_url."?download=".$file_fn."&amp;list_id=".$application_details['id']."\">".$file_fn."</a><input type=\"hidden\" name=\"application_file[]\" value=\"$file_fn\"></td><td><b>Size:</b> </td><td>".number_format($value['size']/1024,1)."Kb</td></tr><tr><td><b>Delete:</b> </td><td><input type=\"checkbox\" name=\"delete_file[]\" value=\"$file_fn\" /></td></tr><tr><td colspan=\"3\"></td></tr>";
        		}
        		$page_content['main'].="</table>";
            }

            $page_content['main'].="</fieldset>";
        }

        if ($application_details['max_image_qty']>0 || $application_details['max_file_qty']>0){
            if ($application_details['max_image_qty']>0 && $application_details['max_file_qty']>0){$max_text=" You can also add more files later, up to a maximum of ".$application_details['max_image_qty']." photos and ".$application_details['max_file_qty']." other files.";}
            elseif ($application_details['max_image_qty']>0){$max_text=" You can also add more photos later, up to a maximum of ".$application_details['max_image_qty'].".";}
            else {$max_text="You can also add more files later, up to a maximum of ".$application_details['max_file_qty'].".";}
            $page_content['main'].="<fieldset>
    <legend>File Upload</legend><table width=\"100%\" border=\"0\" cellpadding=\"4\" cellspacing=\"0\">
    <tr><td colspan=\"2\"><input name=\"image_upload_id\" type=\"hidden\" value=\"".$rvi_image_upload_id."\" />";
           $page_content['main'].="<p class=\"small_note\">At least 1 photo must be uploaded with your application. ".$max_text." Each uploaded photo must have a unique filename. Only upload your own original photos, <b>do not</b> upload copyrighted photos or photos taken from other websites.</p>
           <div id=\"uploader\"><p class=\"small_note\">Please resize large images before uploading. Images should be no more than 1000x800 pixels in size.</p><b>Image File:</b> <input name=\"imagefile1\" type=\"file\" id=\"imagefile1\" size=\"18\" /></div></td></tr></table></fieldset>";
        }


        if (!isset($modify_application)){
            $page_content['main'].="<p><input type=\"checkbox\" name=\"terms\" id=\"agree_to_terms\" value=\"checkbox\" ";
		    if (isset($_SESSION[$session_form_id]['terms_agree']) && $_SESSION[$session_form_id]['terms_agree']>0){$page_content['main'].="checked";}
		    $page_content['main'].=" /> I confirm that the information given in this form is true and correct. No information requested or other material information has been omitted. I have read and agree to the <a href=\"javascript:open_win('".cms_root_url."sys/data/terms.html','Terms')\">terms &amp; conditions</a><br /><input type=\"submit\" name=\"submit_application\" id=\"submit_application\" value=\"Submit\" style=\"width: 120px; height: 30px\" /></p>";
        }else{ $page_content['main'].="<div style=\"margin-top: 8px\"><input type=\"submit\" name=\"submit_application\" value=\"Save Changes\" /></div>";}

        $page_content['main'].="</form>";

      }

?>
