<?php

    // this file is used for custom form application
    // it can create an order if product price not zero and register new user

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}
    //ini_set("memory_limit","64M");
    ini_set("max_execution_time","120");

    // load billing countries
    $fn=sys_data_dir.'/settings/country_list_billing.txt';
    $country_list_billing[]='---';
    if (file_exists($fn)){
    	$fc=file($fn);
    	if (count($fc)>1){$country_list_billing=array_merge($country_list_billing,$fc);}elseif (count($fc)==1){$country_list_billing=$fc;}
    }

    $session_form_id=$product_details['id'].'a';

    if (!isset($currency_symbol)){$currency_symbol=currency_symbol;}

    // if (isset($rvi_ad_category)){$_SESSION[$session_form_id]['category']=$rvi_ad_category;}elseif(!isset($_SESSION[$session_form_id]['category'])){$_SESSION[$session_form_id]['category']=null;}


      // process submitted data
      if (isset($rvi_address)){

        // sanitize user input
        $rvi_address=sanitize_text_input($rvi_address);
        $rvi_address_2=sanitize_text_input($rvi_address_2);
        $rvi_city=sanitize_text_input($rvi_city);
        $rvi_county=sanitize_text_input($rvi_county);
        $rvi_postcode=sanitize_text_input($rvi_postcode);
        $rvi_country=sanitize_text_input($rvi_country);

        $rvi_nationality=sanitize_text_input($rvi_nationality);
        $rvi_employment=sanitize_text_input($rvi_employment);
        $rvi_education=sanitize_text_input($rvi_education);
        $rvi_registrations=sanitize_text_input($rvi_registrations);
        $rvi_supervisor=sanitize_text_input($rvi_supervisor);

        // check values
        if (strlen($rvi_address)<3){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]="Please enter your address.";}
        if (strlen($rvi_city)<3){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]="Please enter your town/city.";}
        if (strlen($rvi_county)<3){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]="Please enter your county.";}
        if ($rvi_country=="---"){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]="Please select country.";}

        // check phone number
        if (strlen($rvi_phone)<5){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]='Please enter your phone number.';}
        else{
            $clearchars=array('-',',',' ','-','+','(',')');
            if (intval(str_replace($clearchars,'',$rvi_phone))<10000){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]='Please enter your phone number';}
            if (substr($rvi_phone,0,5)=='12345'){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]='Please enter your phone number';}
        }


        // store user input in session
        $_SESSION[$session_form_id]['address']=$rvi_address;
        $_SESSION[$session_form_id]['address_2']=$rvi_address_2;
        $_SESSION[$session_form_id]['city']=$rvi_city;
        $_SESSION[$session_form_id]['county']=$rvi_county;
        $_SESSION[$session_form_id]['postcode']=$rvi_postcode;
        $_SESSION[$session_form_id]['country']=$rvi_country;

        $_SESSION[$session_form_id]['dob_month']=$rvi_dob_month;
        $_SESSION[$session_form_id]['dob_day']=$rvi_dob_day;
        $_SESSION[$session_form_id]['dob_year']=$rvi_dob_year;

        $_SESSION[$session_form_id]['nationality']=$rvi_nationality;
        $_SESSION[$session_form_id]['employment']=$rvi_employment;
        $_SESSION[$session_form_id]['education']=$rvi_education;
        $_SESSION[$session_form_id]['registrations']=$rvi_registrations;
        $_SESSION[$session_form_id]['supervisor']=$rvi_supervisor;

        if (isset($rvi_name)){
            $customer_details['name']=sanitize_text_input($rvi_name);
            $_SESSION[$session_form_id]['name']=$customer_details['name'];
        }
        if (isset($rvi_email)){
            $customer_details['email']=sanitize_text_input($rvi_email);
            $_SESSION[$session_form_id]['email']=$customer_details['email'];
        }
        if (isset($rvi_phone)){
            $customer_details['phone']=sanitize_text_input($rvi_phone);
            $_SESSION[$session_form_id]['phone']=$customer_details['phone'];
        }

        if (isset($rvi_remember_me)){$_SESSION[$session_form_id]['remember_me']=1;}else{$_SESSION[$session_form_id]['remember_me']=0;}

        if (isset($rvi_password) && strlen($rvi_password)>0){

            $_SESSION[$session_form_id]['password']=$rvi_password;

            if (strlen($rvi_password)<4){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]='Your password must be at least 4 characters long';}
            else{
                // check for existing user login
                if (!isset($_SESSION[cms_key]['reg_user'])){
            		$users=get_items('users',null,null,null,null,null,null,null,array('email'));
            		if (is_array($users)){
            	        $customer_count=count($users);
                        for ($item_num=0; $item_num<$customer_count; $item_num++){
              				// if email matches load customer details and check password
              				if ($users[$item_num]['email']==$rvi_email){
              					// load customer details
              					$customer_details=get_item_details('customer',$users[$item_num]['id']);
              					// check password and login if matches
                                  if (check_password($customer_details['password'],$rvi_password,$customer_details['id'])){
                                      if ($customer_details['verified']<1){
                                        $customer_details['verified']=1;
                                        save_item_details($customer_details);
                                      }
                                      login_user($customer_details,$_SESSION[$session_form_id]['remember_me']);
                                  }
                              }
                        }
                    }
                  }
              }

        }

        if(!isset($_SESSION[cms_key]['reg_user']) && strlen($rvi_name)<2){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]="Please enter your name.";}
          // check email address if not logged in
          if (!isset($_SESSION[cms_key]['reg_user'])){
          	require_once(cms_root_dir.'scripts/emailval.php');
          	if (strlen($rvi_email)<4 || strlen($rvi_email)>200 ||MailVal($rvi_email,2)){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]='Please enter your email address';}
            elseif (email_registered($rvi_email)){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]='A registered account exists under this email address. Please enter the correct password below to login and use this account or <a href="'.cms_url.'?login">login here</a>.';}
      	}


        if (isset($rvi_terms)){$_SESSION[$session_form_id]['terms_agree']=1;}elseif(isset($_SESSION[$session_form_id]['terms_agree'])){unset($_SESSION[$session_form_id]['terms_agree']);}
        // check terms and conditions box
        if (!isset($rvi_terms)){$_SESSION[cms_key]['form'][$session_form_id]['warning'][]="You must agree to the terms of service to submit an application.";}

  		if (!isset($_SESSION[cms_key]['form'][$session_form_id]['warning'])){

            // check nesecary product options are selected
            if (isset($product_details['option'])){
                foreach ($product_details['option'] as $option_name => $value2){
                    // if no product option is selected select first option value as default
                    if (!isset($rvi_product_option[$option_name])){$rvi_product_option[$option_name]=key($value2);}
                }
            }

            $product_price=$product_details['price'];
			$options_text='';
			// process selected product options if any
			if (isset($rvi_product_option)){


				foreach ($rvi_product_option as $option => $value){

					// product options string for generating product option identifier
					$options_text=$options_text.$option.': '.$value.'<br />';

					// find option matches and apply option modifiers
                    $option_exists=0;
					foreach ($product_details['option'] as $option_name => $value2){
						if ($option_name==$option){
                            if (count($value2)==1 && key($value2)==''){$option_exists=1;break;}
							foreach ($product_details['option'][$option_name] as $option_value => $value3){
								if ($option_value==$value){
                                    $option_exists=1;
                                    // adjust price based on selected product option
                                    if ($product_details['option'][$option_name][$option_value]['price_mod_value']!=0){
                                        // if b2b is enabled treat product options as excl tax so ensure we add tax amount onto them here for order price
                                        if ($cmsSettings->b2b>0 && $product_details['option'][$option_name][$option_value]['price_mod_value']>0){
                                            $product_details['option'][$option_name][$option_value]['price_mod_value']=$product_details['option'][$option_name][$option_value]['price_mod_value']*(($product_details['tax_rate']/100)+1);
                                        }
                                        if ($product_details['option'][$option_name][$option_value]['price_mod']==0){
                                            $product_price=$product_price+$product_details['option'][$option_name][$option_value]['price_mod_value'];
                                        }else{$product_price=$product_details['option'][$option_name][$option_value]['price_mod_value'];}
                                    }
                                    // adjust weight based on selected product option
                                    if ($product_details['option'][$option_name][$option_value]['weight_mod_value']!=0){
                                        if ($product_details['option'][$option_name][$option_value]['weight_mod']==0){
                                            $product_details['weight']=$product_details['weight']+$product_details['option'][$option_name][$option_value]['weight_mod_value'];
                                        }else{$product_details['weight']=$product_details['option'][$option_name][$option_value]['weight_mod_value'];}
                                    }
                                    // adjust volume based on selected product option
                                    if ($product_details['option'][$option_name][$option_value]['volume_mod_value']!=0){
                                        if ($product_details['option'][$option_name][$option_value]['volume_mod']==0){
                                            $product_details['volume']=$product_details['volume']+$product_details['option'][$option_name][$option_value]['volume_mod_value'];
                                        }else{$product_details['volume']=$product_details['option'][$option_name][$option_value]['volume_mod_value'];}
                                    }
								}
							}
						}
					}
                    if ($option_exists<1){
                        return;
                    }
				}

			}

            $submit_time=time();

            if (isset($_SESSION[cms_key]['reg_user']->id)){
                $customer_details['id']=$_SESSION[cms_key]['reg_user']->id;
            }else{
                $customer_details['id']=$submit_time.rand(100,999);
            }

            // save unverified customer details if not logged in
			if (!isset($_SESSION[cms_key]['reg_user']->id) && isset($customer_details['email'])){
                // save customer details
                $customer_details['item_type']='customer';
    			//$customer_details['id']=$listing_details['customer_id'];
                $customer_details['verified']='0';

                // generate a random password
                if (isset($_SESSION[$session_form_id]['password']) && strlen($_SESSION[$session_form_id]['password'])>4){$password=$_SESSION[$session_form_id]['password'];}else{$password=generate_password();}
                $customer_details['password']=encrypt_password($password,$customer_details['id']);

    			$customer_details['status']='1';
    			$customer_details['registered_timestamp']=$submit_time;
    			if (isset($_SESSION[cms_key]['referrer'])){$customer_details['referrer']=$_SESSION[cms_key]['referrer'];}
    			$customer_details['newsletterSub']=true;
                $customer_details['dob_day']=$rvi_dob_day;
                $customer_details['dob_month']=$rvi_dob_month;
                $customer_details['dob_year']=$rvi_dob_year;
                $customer_details['address']=$rvi_address;
                $customer_details['address_2']=$rvi_address_2;
                $customer_details['city']=$rvi_city;
                $customer_details['postcode']=$rvi_postcode;
                $customer_details['county']=$rvi_county;
                $customer_details['country']=$rvi_country;

                // store extra submitted data in users aboutme/bio
                $customer_details['bio']="Nationality: ".$rvi_nationality;
                $customer_details['bio'].="\n\nEmployment: ".$rvi_employment;
                $customer_details['bio'].="\n\nEductation: ".$rvi_education;
                $customer_details['bio'].="\n\nRegistrations: ".$rvi_registrations;
                $customer_details['bio'].="\n\nSupervisor: ".$rvi_supervisor;

				save_item_details($customer_details);
                update_item_list_file('customers',array($customer_details['id']),'add');

                update_item_log('user',$customer_details['id'],'New user account registered - '.$customer_details['id'].' - via add listing');

                // log new user in (still unvereified until user logs in with emailed password)
                if (isset($_SESSION[$session_form_id]['remember_me']) && $_SESSION[$session_form_id]['remember_me']>0){
                    login_user($customer_details,1);
                }

                // send customer registration email
                // email customer order confirmation with payment link
			    require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

			    $mail = new PHPMailer();

                // send mail via smtp if set in config file
                if (smtp_host){
                    $mail->IsSMTP(); // send via SMTP
                    $mail->SMTPAuth = true; // turn on SMTP authentication
                    $mail->SMTPSecure = 'ssl';
                    $mail->Username = smtp_username; // SMTP username
                    $mail->Password = smtp_password; // SMTP password
                    $mail->Host       = smtp_host; // SMTP server
                    $mail->Port       = smtp_port; // SMTP server
                }

				// send confirmation email to user
				$mail->From = $cmsSettings->config['site_email'];
				$mail->FromName = cms_site_name;
				$mail->AddAddress($rvi_email);

				$mail->Subject = cms_site_name.' - New Account Registration';
                $mail->Body    = "Hi $rvi_name,\n\nThank you for registering with ".cms_site_name." - Your new login password is ".$password."\n\nClick on the link below to login.\n\n".user_login_link($customer_details)."\n\n\n".cms_site_name."\n".cms_site_url;
                $mail->IsHTML(FALSE);

				if(!$mail->Send()){exit;}

            }

            // save order if price is greater than zero
            if ($product_price>0){
                $order_details['item_type']='order';
                $order_details['customer']['id']=$customer_details['id'];
                if (isset($_SESSION[cms_key]['reg_user']->id)){
                    $order_details['name']=$_SESSION[cms_key]['reg_user']->name;
                    $order_details['email']=$_SESSION[cms_key]['reg_user']->email;}
                else{
                    $order_details['name']=$customer_details['name'];
                    $order_details['email']=$customer_details['email'];
                }
                $order_details['id']=$submit_time.rand(100,999);
    			// order status 0=unpaid, 1=paid, 2=paid and processed, 3=cancelled
    			$order_details['status']=0;
    			if (isset($_SESSION[cms_key]['referrer'])){
    				$order_details['referrer']=$_SESSION[cms_key]['referrer'];
    				$referrer_details=get_item_details('customer',$_SESSION[cms_key]['referrer']);
    				if (is_array($referrer_details)){
    					// write order number to referrers referred orders file
    					$fn=sys_data_dir.'/users/'.$referrer_details['id'].'/referrals.php';
    					$fo=fopen($fn,"a");
    					fwrite($fo,"order|".$order_details['id']."||\n");
    					fclose($fo);
    				}
    			}

                // remove unesecary product data for checkout/order
                if (isset($product_details['created_time'])){unset($product_details['created_time']);}
                if (isset($product_details['modified_time'])){unset($product_details['modified_time']);}
                if (isset($product_details['item_file_version'])){unset($product_details['item_file_version']);}
                if (isset($product_details['slug'])){unset($product_details['slug']);}
                if (isset($product_details['short_description'])){unset($product_details['short_description']);}
                if (isset($product_details['keywords'])){unset($product_details['keywords']);}
                if (isset($product_details['content'])){unset($product_details['content']);}
                if (isset($product_details['youtube_video'])){unset($product_details['youtube_video']);}
                if (isset($product_details['template'])){unset($product_details['template']);}
                if (isset($product_details['enquiry_form_enabled'])){unset($product_details['enquiry_form_enabled']);}
                if (isset($product_details['option'])){unset($product_details['option']);}

                // save product details in order
                $order_details['products']['product']=$product_details;
    			$order_details['products']['product']['order_price']=$product_price;
                $order_details['products']['product']['order_qty']=1;
                if (isset($rvi_product_option)){
				    foreach ($rvi_product_option as $option => $value){
                        $order_details['products']['product']['option'][$option]=$value;
                    }
                }
                $order_details['order_subtotal']=$product_price;
                $order_details['shipping_total']=0;
                $order_details['discount']=0;




                save_item_details($order_details);
                update_item_list_file('orders',array($order_details['id']),'add');
                // update_order_file($_SESSION[cms_key]['checkout']);

                if (admin_level()<10){
                    update_item_log('user',$customer_details['id'],'New order '.$order_details['id'].' added by user '.$customer_details['id']);
                    update_admin_notify_log('New order '.$order_details['id'].' added by user '.$customer_details['id']);
                }

                // keep order id in session for paynow page
                $_SESSION[cms_key]['form'][$session_form_id]['order_id']=$order_details['id'];

                if (!isset($rvi_no_email_payment)){

                    // send customer registration email
                    // email customer order confirmation with payment link
    			    require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

    			    $mail = new PHPMailer();

                    // send mail via smtp if set in config file
                    if (smtp_host){
                        $mail->IsSMTP(); // send via SMTP
                        $mail->SMTPAuth = true; // turn on SMTP authentication
                        $mail->SMTPSecure = 'ssl';
                        $mail->Username = smtp_username; // SMTP username
                        $mail->Password = smtp_password; // SMTP password
                        $mail->Host       = smtp_host; // SMTP server
                        $mail->Port       = smtp_port; // SMTP server
                    }

                    // send pay now email to user
          			$mail->From = $cmsSettings->config['site_email'];
          			$mail->FromName = cms_site_name;
                    $mail->ClearAddresses();

                    if (isset($_SESSION[cms_key]['reg_user']->email)){$recipient_email=$_SESSION[cms_key]['reg_user']->email;}
                    elseif (isset($customer_details['email'])){$recipient_email=$customer_details['email'];}
                    if (isset($_SESSION[cms_key]['reg_user']->name)){$recipient_name=$_SESSION[cms_key]['reg_user']->name;}
                    elseif (isset($customer_details['name'])){$recipient_name=$customer_details['name'];}

          			$mail->AddAddress($recipient_email);
                    $mail->Subject = cms_site_name." - New Application";
          			$mail->Body    = "Hi ".$recipient_name.",\n\nThank you for submitting your application on ".cms_site_name." - Your application has been submitted and will be processed within 24hrs of receiving payment.\n\nIf you have not yet paid go to ".cms_url."?paynow=".$order_details['id']." for payment options.\n\n\n".cms_site_name."\n".cms_site_url;
                    $mail->IsHTML(FALSE);
                    if(!$mail->Send()){exit;}
                }

            }

            $_SESSION[cms_key]['form'][$session_form_id]['warning_green'][]="<h2>Thank You</h2><p>Your application has been submitted.</p>";
            if (!isset($_SESSION[cms_key]['reg_user']->id)){$_SESSION[cms_key]['form'][$session_form_id]['warning_green'][]="<p>An email has been sent to your email address - <b>".$rvi_email."</b> - please follow the emailed instructions to verify your email address and activate your account. Once activated you will be able to login and manage your account.</p>";}

            unset($_SESSION[$session_form_id]);


  			$_SESSION[cms_key]['form'][$session_form_id]['processed']=1;

  		}

        // redirect after form submit so browser back and refresh work without browser resend form data warning
        //$query="ls=".$listing_details['status'];
        $query="ls=1";
        if (isset($_SESSION[cms_key]['form'][$session_form_id]['processed']) && $product_price>0)
            header("Location: ".cms_url."?paynow=".$order_details['id'],true,303);
        else
            header("Location: ".item_url('product',$product_details['id'],$product_details['slug'],$query,1)."#form",true,303);
        exit;

  	}

    $page_content['main'].="<div class=\"product_description\">".$product_details['content']['main']."</div>";
    //if ($display_price!=''){$page_content['main'].='<div class="product_price">'.$display_price.'</div>';}

    $page_content['main'].="<a name=\"form\"></a>";

    // display warnings
    if (isset($_SESSION[cms_key]['form'][$session_form_id]['warning'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form'][$session_form_id]['warning']);}
    elseif (isset($_SESSION[cms_key]['form'][$session_form_id]['warning_green'])){$page_content['main'].=display_warnings($_SESSION[cms_key]['form'][$session_form_id]['warning_green'],'green');}


  	  if (!isset($_SESSION[cms_key]['form'][$session_form_id]['processed'])){

      	// show hide javascript
      	$page->meta.="<script language=\"javascript\">
      	function open_win(page,name){toswindow=window.open(page,name,'width=350,height=380,scrollbars=1');
      	setTimeout(\"toswindow.focus();\",10);}
      	</script>";

        $page->meta.='<script type="text/javascript">
	    $(document).ready(function(){';

        if (!isset($_SESSION[$session_form_id]['terms_agree']) || $_SESSION[$session_form_id]['terms_agree']<1){$page->meta.='$(\'#submit_listing\').attr(\'disabled\', \'disabled\')';}
        $page->meta.='
        // disable submit button if terms button not checked
        $(\'#agree_to_terms\').change(function(){
            if ($(\'#agree_to_terms\').attr(\'checked\')) {
                 $(\'#submit_listing\').removeAttr(\'disabled\', \'disabled\');
            }else
                 $(\'#submit_listing\').attr(\'disabled\', \'disabled\');
        });
        ';

        $page->meta.='
            });

        </script>';

        $page_content['main'].="<form action=\"\" id=\"listing_form\" method=\"post\" enctype=\"multipart/form-data\" >";

        $page_content['main'].="<fieldset><legend>Payment Option</legend>".$product_options."</fieldset>";

        // populate fields with session data if availale but only if saved data not available
        if (!isset($rvi_name)){
            if (isset($_SESSION[$session_form_id]['name'])){$rvi_name=$_SESSION[$session_form_id]['name'];}
        }
        if (!isset($rvi_phone)){
            if (isset($_SESSION[$session_form_id]['phone'])){$rvi_phone=$_SESSION[$session_form_id]['phone'];}
        }
        if (!isset($rvi_address)){
            if (isset($_SESSION[$session_form_id]['address'])){$rvi_address=$_SESSION[$session_form_id]['address'];}
        }
        if (!isset($rvi_address_2)){
            if (isset($_SESSION[$session_form_id]['address_2'])){$rvi_address_2=$_SESSION[$session_form_id]['address_2'];}
        }
        if (!isset($rvi_city)){
            if (isset($_SESSION[$session_form_id]['city'])){$rvi_city=$_SESSION[$session_form_id]['city'];}
        }
        if (!isset($rvi_county)){
            if (isset($_SESSION[$session_form_id]['county'])){$rvi_county=$_SESSION[$session_form_id]['county'];}
        }
        if (!isset($rvi_postcode)){
            if (isset($_SESSION[$session_form_id]['postcode'])){$rvi_postcode=$_SESSION[$session_form_id]['postcode'];}
        }
        if (!isset($rvi_country)){
            if (isset($_SESSION[$session_form_id]['country'])){$rvi_country=$_SESSION[$session_form_id]['country'];}
        }
        if (!isset($rvi_dob_month)){
            if (isset($_SESSION[$session_form_id]['dob_month'])){$rvi_dob_month=$_SESSION[$session_form_id]['dob_month'];}
        }
        if (!isset($rvi_dob_day)){
            if (isset($_SESSION[$session_form_id]['dob_day'])){$rvi_dob_day=$_SESSION[$session_form_id]['dob_day'];}
        }
        if (!isset($rvi_dob_year)){
            if (isset($_SESSION[$session_form_id]['dob_year'])){$rvi_dob_year=$_SESSION[$session_form_id]['dob_year'];}
        }
        if (!isset($rvi_nationality)){
            if (isset($_SESSION[$session_form_id]['nationality'])){$rvi_nationality=$_SESSION[$session_form_id]['nationality'];}
        }
        if (!isset($rvi_employment)){
            if (isset($_SESSION[$session_form_id]['employment'])){$rvi_employment=$_SESSION[$session_form_id]['employment'];}
        }
        if (!isset($rvi_education)){
            if (isset($_SESSION[$session_form_id]['education'])){$rvi_education=$_SESSION[$session_form_id]['education'];}
        }
        if (!isset($rvi_registrations)){
            if (isset($_SESSION[$session_form_id]['registrations'])){$rvi_registrations=$_SESSION[$session_form_id]['registrations'];}
        }
        if (!isset($rvi_supervisor)){
            if (isset($_SESSION[$session_form_id]['supervisor'])){$rvi_supervisor=$_SESSION[$session_form_id]['supervisor'];}
        }

        $page_content['main'].="<fieldset>";
        $page_content['main'].="<legend>Your Details</legend>";

           $page_content['main'].="<table width=\"100%\" border=\"0\" cellpadding=\"4\" cellspacing=\"0\">";


            if (isset($_SESSION[cms_key]['reg_user'])){
                $page_content['main'].="<tr><td colspan=\"2\"><p class=\"small_note\">Welcome back ".stripslashes($_SESSION[cms_key]['reg_user']->name)." (<a href=\"".cms_url."?logout\">Logout</a>). To display a contact phone number on your listing please enter it below.</p></td></tr>
                <tr>
                    <td width=\"80\"><b>Phone: </b></td>
                    <td><input name=\"phone\" type=\"text\" maxlength=\"128\" value=\"".(isset($_SESSION[$session_form_id]['phone']) ? stripslashes($_SESSION[$session_form_id]['phone']) : "")."\" /></td>
                </tr>";
            }
            else{
                $page_content['main'].="<tr><td colspan=\"2\"><p class=\"small_note\">Please enter your contact details carefully. Make sure your email address is correct, you'll need it to login and manage your account.</p></td></tr>
                <tr><td width=\"100\"><b>Name: </b></td><td><input name=\"name\" type=\"text\" maxlength=\"128\" value=\"".(isset($_SESSION[$session_form_id]['name']) ? stripslashes($_SESSION[$session_form_id]['name']) : '')."\" /></td></tr>
                <tr><td><b>Email: </b></td><td><input type=\"text\" name=\"email\" maxlength=\"128\" value=\"".(isset($_SESSION[$session_form_id]['email']) ? stripslashes($_SESSION[$session_form_id]['email']) : '')."\" /></td></tr>
                <tr>
                  <td><b>Phone: </b></td>
                  <td><input name=\"phone\" type=\"text\" maxlength=\"128\" value=\"".(isset($_SESSION[$session_form_id]['phone']) ? stripslashes($_SESSION[$session_form_id]['phone']) : '')."\" /></td>
                </tr>
                <tr>
                  <td colspan=\"2\"><p class=\"small_note\"><b>New users:</b> Enter a password below (min 4 characters) or leave blank and one will be generated for you.<br /><b>Registered Users:</b> Login with your password below. <a href=\"".cms_url."?forgot_password\">Forgot Password</a></p></td>
                </tr>
                <tr>
                  <td><b>Password: </b></td><td><input type=\"password\" name=\"password\" value=\"".(isset($_SESSION[$session_form_id]['password']) ? $_SESSION[$session_form_id]['password'] : '')."\" /> <input type=\"checkbox\" name=\"remember_me\"".(isset($_SESSION[$session_form_id]['remember_me']) && $_SESSION[$session_form_id]['remember_me']>0 ? ' checked="checked"' : '')." /> Remember Me</td>
                </tr>";
            }



        $page_content['main'].="<tr><td colspan=\"2\"><hr /></td></tr>

        <tr><td><b>Address:</b></td><td><input type=\"text\" name=\"address\"  value=\"".(isset($rvi_address) ? stripslashes($rvi_address) : "")."\"></td></tr>";

  		$page_content['main'].="<tr><td></td><td><input type=\"text\" name=\"address_2\" value=\"".(isset($rvi_address_2) ? stripslashes($rvi_address_2) : "")."\"></td></tr>";

  		$page_content['main'].="<tr><td><b>Town/City:</b></td><td><input type=\"text\" name=\"city\" value=\"".(isset($rvi_city) ? stripslashes($rvi_city) : "")."\"></td></tr>
  		<tr><td><b>County:</b></td><td><input type=\"text\" name=\"county\" value=\"".(isset($rvi_county) ? stripslashes($rvi_county) : "")."\"></td></tr>
  		<tr><td><b>Post Code:</b></td><td><input type=\"text\" name=\"postcode\" value=\"".(isset($rvi_postcode) ? stripslashes($rvi_postcode) : "")."\"></td></tr>
  		<tr><td><b>Country:</b></td><td><select style=\"max-width: 145px\" name=\"country\">";
    	$option=$country_list_billing;
    	$option_qty=count($option);
    	for ($option_num=0;$option_num<$option_qty;$option_num++){
            $option[$option_num]=trim($option[$option_num]);
          	if (isset($rvi_country) && $rvi_country==$option[$option_num]){
          		$page_content['main'].="<option selected>".$option[$option_num]."</option>";
          	}
          	else{
          		$page_content['main'].="<option>".$option[$option_num]."</option>";
          	}
        }
        $page_content['main'].="</select></td></tr>
        <tr><td colspan=\"2\"><hr /></td></tr>";
    		$page_content['main'].="<tr><td><b>Date of Birth:</b></td><td><select name=\"dob_month\">";
    		  $option=array('---','Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
    		  $option_qty=count($option);
    		  for ($option_num=0;$option_num<$option_qty;$option_num++){
    				if (isset($rvi_dob_month) && $rvi_dob_month==$option[$option_num]){
    					$page_content['main'].='<option selected>'.$option[$option_num].'</option>';
    				}
    				else{
    					$page_content['main'].='<option>'.$option[$option_num].'</option>';
    				}
    			}
    			$page_content['main'].='</select>
    		<select name="dob_day">';
    		unset($option);
    		  $option[0]='---';
    		  for ($day=1; $day<=31; $day++){$option[]=$day;}
    		  $option_qty=count($option);
    		  for ($option_num=0;$option_num<$option_qty;$option_num++){
    				if (isset($rvi_dob_day) && $rvi_dob_day==$option[$option_num]){
    					$page_content['main'].="<option selected>".$option[$option_num]."</option>";
    				}
    				else{
    					$page_content['main'].="<option>".$option[$option_num]."</option>";
    				}
    			}
    			$page_content['main'].='</select>
    		  <select name="dob_year">';
    		  unset($option);
    		  $option[0]='---';
    		  for ($year=intval(date("Y",time())); $year>=1900; $year--){$option[]=$year;}
    		  $option_qty=count($option);
    		  for ($option_num=0;$option_num<$option_qty;$option_num++){
    				if (isset($rvi_dob_year) && $rvi_dob_year==$option[$option_num]){
    					$page_content['main'].="<option selected>".$option[$option_num]."</option>";
    				}
    				else{
    					$page_content['main'].="<option>".$option[$option_num]."</option>";
    				}
    			}
    			$page_content['main'].="</select></td></tr>

        <tr>
          <td><b>Nationality:</b></td>
          <td><input name=\"nationality\" type=\"text\" id=\"nationality\" size=\"45\" maxlength=\"250\" value=\"".(isset($rvi_nationality) ? stripslashes($rvi_nationality) : "")."\" /></td>
        </tr>
        <tr><td colspan=\"2\"><hr /><b>Current Employment:</b><br /><textarea name=\"employment\" cols=\"80\" rows=\"3\" id=\"employment\">".(isset($rvi_employment) ? stripslashes($rvi_employment) : '')."</textarea></td></tr>
  		<tr><td colspan=\"2\"><hr /><b>Core Education:</b> <span class=\"small_note\">Name of Institute &amp; Year Completed.</span><br /><textarea name=\"education\" cols=\"80\" rows=\"3\" id=\"education\">".(isset($rvi_education) ? stripslashes($rvi_education) : '')."</textarea></td></tr>
        <tr><td colspan=\"2\"><hr /><b>Professional Registrations:</b> <span class=\"small_note\">Please give details of Professional Registrations and year obtained or state if currently working toward Accreditation.</span><br /><textarea name=\"registrations\" cols=\"80\" rows=\"3\" id=\"registrations\">".(isset($rvi_registrations) ? stripslashes($rvi_registrations) : '')."</textarea></td></tr>
        <tr><td colspan=\"2\"><hr /><b>Are you currently in Supervision and name of Supervisor:</b> <span class=\"small_note\">Any statements on this form, which prove to be untrue or purposely misleading, may cause the application to be cancelled. Furthermore if inaccuracies are highlighted at a later stage, we retain the right to retract any offer made or terminate the training contract with no refund of fees.</span><br />
        <textarea name=\"supervisor\" cols=\"80\" rows=\"3\" id=\"supervisor\">".(isset($rvi_supervisor) ? stripslashes($rvi_supervisor) : '')."</textarea></td></tr>
        </table></fieldset>";


        $page_content['main'].="<p><input type=\"checkbox\" name=\"terms\" id=\"agree_to_terms\" value=\"checkbox\" ";
		if (isset($_SESSION[$session_form_id]['terms_agree']) && $_SESSION[$session_form_id]['terms_agree']>0){$page_content['main'].="checked";}
		$page_content['main'].=" /> I confirm that the information given in this form is true, complete and accurate. No information requested or other material information has been omitted. I have read and agree to the <a href=\"javascript:open_win('".cms_root_url."sys/data/tos.html','Terms')\">terms &amp; conditions</a> <input type=\"submit\" name=\"submit_listing\" id=\"submit_listing\" value=\"Submit\" style=\"width: 120px; height: 30px\" /></p>";

        $page_content['main'].="</form>";

      }

?>
